SET session wait_timeout=28800;

DROP TABLE IF EXISTS #__assets;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) AUTO_INCREMENT=416 DEFAULT CHARSET=utf8;

INSERT INTO `#__assets` VALUES 
('1','0','1','535','0','root.1','Root Asset','{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":[],"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('2','1','2','3','1','com_admin','com_admin','{}'),
('3','1','4','7','1','com_banners','com_banners','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('4','1','8','9','1','com_cache','com_cache','{"core.admin":{"7":1},"core.manage":{"7":1}}'),
('5','1','10','11','1','com_checkin','com_checkin','{"core.admin":{"7":1},"core.manage":{"7":1}}'),
('6','1','12','13','1','com_config','com_config','{}'),
('7','1','14','21','1','com_contact','com_contact','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
('8','1','22','145','1','com_content','com_content','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
('9','1','146','147','1','com_cpanel','com_cpanel','{}'),
('10','1','148','149','1','com_installer','com_installer','{"core.admin":[],"core.manage":{"7":0},"core.delete":{"7":0},"core.edit.state":{"7":0}}'),
('11','1','150','151','1','com_languages','com_languages','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('12','1','152','153','1','com_login','com_login','{}'),
('13','1','154','155','1','com_mailto','com_mailto','{}'),
('14','1','156','157','1','com_massmail','com_massmail','{}'),
('15','1','158','159','1','com_media','com_media','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1},"core.edit":[],"core.edit.state":[]}'),
('16','1','160','161','1','com_menus','com_menus','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('18','1','164','349','1','com_modules','com_modules','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('19','1','350','355','1','com_newsfeeds','com_newsfeeds','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('20','1','356','357','1','com_plugins','com_plugins','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('21','1','358','359','1','com_redirect','com_redirect','{"core.admin":{"7":1},"core.manage":[]}'),
('22','1','360','361','1','com_search','com_search','{"core.admin":{"7":1},"core.manage":{"6":1}}'),
('23','1','362','363','1','com_templates','com_templates','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('24','1','364','367','1','com_users','com_users','{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('25','1','368','375','1','com_weblinks','com_weblinks','{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1,"10":0,"12":0},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
('26','1','376','377','1','com_wrapper','com_wrapper','{}'),
('33','1','438','439','1','com_finder','com_finder','{"core.admin":{"7":1},"core.manage":{"6":1}}'),
('34','8','39','40','2','com_content.category.9','Uncategorised','{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('100','8','43','44','2','com_content.category.71','Milky Way','{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('169','24','365','366','2','com_users.category.77','Uncategorised',''),
('173','1','440','441','1','com_joomlaupdate','com_joomlaupdate','{"core.admin":[],"core.manage":[],"core.delete":[],"core.edit.state":[]}'),
('174','1','442','443','1','com_tags','com_tags','{"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('175','1','444','445','1','com_contenthistory','com_contenthistory','{}'),
('176','1','446','447','1','com_ajax','com_ajax','{}'),
('177','1','447','448','1','com_postinstall','com_postinstall','{}'),
('179','1','449','450','1','#__ucm_content.3','#__ucm_content.3','[]'),
('181','8','47','66','2','com_content.category.78','JM-Sample-Data','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('182','181','48','49','3','com_content.article.73','Subpage','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('183','18','165','166','2','com_modules.module.98','DJ-Menu','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('184','18','167','168','2','com_modules.module.99','Top-Bar1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('186','18','169','170','2','com_modules.module.101','Header','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('187','18','171','172','2','com_modules.module.102','Top1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('188','18','173','174','2','com_modules.module.103','Top1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('189','18','175','176','2','com_modules.module.104','Top1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('190','18','177','178','2','com_modules.module.105','Top1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('191','18','179','180','2','com_modules.module.106','Top2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('192','18','181','182','2','com_modules.module.107','Top2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('193','18','183','184','2','com_modules.module.108','Top2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('194','18','185','186','2','com_modules.module.109','Top2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('195','18','187','188','2','com_modules.module.110','Content-Top','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('196','18','189','190','2','com_modules.module.111','Content-Bottom','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}');
INSERT INTO `#__assets` VALUES 
('197','18','191','192','2','com_modules.module.112','Left-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('198','18','193','194','2','com_modules.module.113','Left-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('199','18','195','196','2','com_modules.module.114','Left-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('203','18','197','198','2','com_modules.module.118','Right-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('204','18','199','200','2','com_modules.module.119','Right-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('205','18','201','202','2','com_modules.module.120','Right-Column','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('209','18','203','204','2','com_modules.module.124','Bottom1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('210','18','205','206','2','com_modules.module.125','Bottom1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('211','18','207','208','2','com_modules.module.126','Bottom1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('212','18','209','210','2','com_modules.module.127','Bottom1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('213','18','211','212','2','com_modules.module.128','Bottom2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('214','18','213','214','2','com_modules.module.129','Bottom2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('215','18','215','216','2','com_modules.module.130','Bottom2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('216','18','217','218','2','com_modules.module.131','Bottom2','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('217','18','219','220','2','com_modules.module.132','Footer-Mod','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('218','18','221','222','2','com_modules.module.133','Footer-Mod','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('219','18','223','224','2','com_modules.module.134','Footer-Mod','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('220','18','225','226','2','com_modules.module.135','Footer-Mod','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('221','18','227','228','2','com_modules.module.136','Copyrights','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('222','18','229','230','2','com_modules.module.17','Breadcrumbs','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('223','18','231','232','2','com_modules.module.87','All Front End  Views','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('224','18','233','234','2','com_modules.module.88','All Modules','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('225','18','235','236','2','com_modules.module.44','Login','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('228','18','237','238','2','com_modules.module.23','A Deep Menu','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('234','18','239','240','2','com_modules.module.137','Top Contact','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('240','1','451','468','1','com_djimageslider','com_djimageslider','{}'),
('241','18','241','242','2','com_modules.module.138','Latest Projects','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('242','240','452','453','2','com_djimageslider.category.80','Header','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('243','240','454','455','2','com_djimageslider.category.81','Projects','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('244','18','243','244','2','com_modules.module.139','DJ-ImageSlider','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('247','18','245','246','2','com_modules.module.140','Time Machine','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('248','18','247','248','2','com_modules.module.141','Analytics','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('249','18','249','250','2','com_modules.module.142','Worldwide Service','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('250','18','251','252','2','com_modules.module.143','Just Few Words','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('251','240','456','457','2','com_djimageslider.category.82','Testimonials','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('252','18','253','254','2','com_modules.module.144','Testimonials','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
('272','18','255','256','2','com_modules.module.146','Popular Articles','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('273','18','257','258','2','com_modules.module.147','Tags','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('274','18','259','260','2','com_modules.module.148','Latest News','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('275','18','261','262','2','com_modules.module.149','Stay Connected','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('276','181','50','51','3','com_content.article.87','Typography','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('286','8','67','102','2','com_content.category.83','Blog','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('287','315','79','80','4','com_content.article.96','Lorem Ipsum','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('288','1','469','470','1','#__ucm_content.4','#__ucm_content.4','[]'),
('289','317','91','92','4','com_content.article.97','Consectetur Adipisc','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('290','1','471','472','1','#__ucm_content.5','#__ucm_content.5','[]'),
('291','316','87','88','4','com_content.article.98','Nulla Scelerisque','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('292','1','473','474','1','#__ucm_content.6','#__ucm_content.6','[]'),
('293','316','85','86','4','com_content.article.99','Aliquam Feugiat','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('294','1','475','476','1','#__ucm_content.7','#__ucm_content.7','[]');
INSERT INTO `#__assets` VALUES 
('295','317','93','94','4','com_content.article.100','Praesent Vehicula','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('296','1','477','478','1','#__ucm_content.8','#__ucm_content.8','[]'),
('297','318','97','98','4','com_content.article.101','Malesuada Ultricies','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('298','1','479','480','1','#__ucm_content.9','#__ucm_content.9','[]'),
('299','315','81','82','4','com_content.article.102','Nunc Placerat','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('300','1','481','482','1','#__ucm_content.10','#__ucm_content.10','[]'),
('301','318','99','100','4','com_content.article.103','Quisque Vestibulum','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('302','1','483','484','1','#__ucm_content.11','#__ucm_content.11','[]'),
('303','18','263','264','2','com_modules.module.150','Latest News','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('304','18','265','266','2','com_modules.module.151','Blog Archive','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('305','286','68','69','3','com_content.article.104','Cras Eleifend','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('306','1','485','486','1','#__ucm_content.12','#__ucm_content.12','[]'),
('307','286','70','71','3','com_content.article.105','Fusce Eu Risus','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('308','1','487','488','1','#__ucm_content.13','#__ucm_content.13','[]'),
('309','286','72','73','3','com_content.article.106','Pretium Pellentesque','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('310','1','489','490','1','#__ucm_content.14','#__ucm_content.14','[]'),
('311','286','74','75','3','com_content.article.107','Volutpat Vehicula','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('312','1','491','492','1','#__ucm_content.15','#__ucm_content.15','[]'),
('313','286','76','77','3','com_content.article.108','Auctor Justo','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('314','1','493','494','1','#__ucm_content.16','#__ucm_content.16','[]'),
('315','286','78','83','3','com_content.category.84','Blog Category 1','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('316','286','84','89','3','com_content.category.85','Blog Category 2','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('317','286','90','95','3','com_content.category.86','Blog Category 3','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('318','286','96','101','3','com_content.category.87','Blog Category 4','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('319','18','267','268','2','com_modules.module.152','Categories','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('320','8','103','108','2','com_content.category.88','Newsflash','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('321','320','104','105','3','com_content.article.109','Lorem Ipsum','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('322','1','495','496','1','#__ucm_content.17','#__ucm_content.17','[]'),
('323','320','106','107','3','com_content.article.110','Praesent Vehicula','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('324','1','497','498','1','#__ucm_content.18','#__ucm_content.18','[]'),
('325','18','269','270','2','com_modules.module.153','Main Menu','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('326','7','19','20','2','com_contact.category.89','Contact Category','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('327','18','271','272','2','com_modules.module.154','Map','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('328','181','52','53','3','com_content.article.111','Single Article','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('329','181','54','55','3','com_content.article.112','Tabs','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('330','18','273','274','2','com_modules.module.155','Content Component','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('331','18','275','276','2','com_modules.module.156','User Component','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('332','18','277','278','2','com_modules.module.157','Search Component','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('333','18','279','280','2','com_modules.module.158','Contact Component','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('334','8','109','126','2','com_content.category.90','List','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('335','334','110','111','3','com_content.article.113','Quisque Vestibulum',''),
('336','1','499','500','1','#__ucm_content.19','#__ucm_content.19','[]'),
('337','334','112','113','3','com_content.article.114','Nunc Placerat','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('338','1','501','502','1','#__ucm_content.20','#__ucm_content.20','[]'),
('339','334','114','115','3','com_content.article.115','Malesuada Ultricies','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('340','1','503','504','1','#__ucm_content.21','#__ucm_content.21','[]'),
('341','334','116','117','3','com_content.article.116','Praesent Vehicula',''),
('342','1','505','506','1','#__ucm_content.22','#__ucm_content.22','[]'),
('343','334','118','119','3','com_content.article.117','Aliquam Feugiat',''),
('344','1','507','508','1','#__ucm_content.23','#__ucm_content.23','[]');
INSERT INTO `#__assets` VALUES 
('345','334','120','121','3','com_content.article.118','Nulla Scelerisque','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('346','1','509','510','1','#__ucm_content.24','#__ucm_content.24','[]'),
('347','334','122','123','3','com_content.article.119','Consectetur Adipisc','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('348','1','511','512','1','#__ucm_content.25','#__ucm_content.25','[]'),
('349','334','124','125','3','com_content.article.120','Lorem Ipsum','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('350','1','513','514','1','#__ucm_content.26','#__ucm_content.26','[]'),
('351','181','56','57','3','com_content.article.121','Module Suffixes','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('352','18','281','282','2','com_modules.module.159','sample-block-1','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('353','18','283','284','2','com_modules.module.160','Popular Tags','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('354','18','285','286','2','com_modules.module.161','DJ-Menu Culinary','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('355','18','287','288','2','com_modules.module.162','DJ-ImageSlider Culinary','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('356','240','458','459','2','com_djimageslider.category.91','Header Culinary','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('357','18','289','290','2','com_modules.module.163','Dinner','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('358','18','291','292','2','com_modules.module.164','Cookie','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('359','18','293','294','2','com_modules.module.165','Dessert','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('360','240','460','461','2','com_djimageslider.category.92','Dishes','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('361','18','295','296','2','com_modules.module.166','Latest Recipes','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('362','8','127','144','2','com_content.category.93','Recipes','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('363','362','128','129','3','com_content.article.122','Vestibulum','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('364','1','515','516','1','#__ucm_content.27','#__ucm_content.27','[]'),
('365','362','130','131','3','com_content.article.123','Nunc Placerat','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('366','1','517','518','1','#__ucm_content.28','#__ucm_content.28','[]'),
('367','362','132','133','3','com_content.article.124','Males Ultricies','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('368','1','519','520','1','#__ucm_content.29','#__ucm_content.29','[]'),
('369','362','134','135','3','com_content.article.125','Praesent Vehicula','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('370','1','521','522','1','#__ucm_content.30','#__ucm_content.30','[]'),
('371','362','136','137','3','com_content.article.126','Aliquam Feugiat','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('372','1','523','524','1','#__ucm_content.31','#__ucm_content.31','[]'),
('373','362','138','139','3','com_content.article.127','Nulla Scelerisque','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('374','1','525','526','1','#__ucm_content.32','#__ucm_content.32','[]'),
('375','362','140','141','3','com_content.article.128','Consec Adipisc','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('376','1','527','528','1','#__ucm_content.33','#__ucm_content.33','[]'),
('377','362','142','143','3','com_content.article.129','Lorem Ipsum','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('378','1','529','530','1','#__ucm_content.34','#__ucm_content.34','[]'),
('379','18','297','298','2','com_modules.module.167','Popular Recipes','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('380','18','299','300','2','com_modules.module.168','Our Cooks','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('382','18','301','302','2','com_modules.module.169','DJ-Menu Dental','{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
('383','18','303','304','2','com_modules.module.170','Top Contact Dental','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('384','240','462','463','2','com_djimageslider.category.94','Header Dental','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('385','18','305','306','2','com_modules.module.171','DJ-ImageSlider Dental','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('386','18','307','308','2','com_modules.module.172','Treatment','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('387','18','309','310','2','com_modules.module.173','Whitening','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('388','18','311','312','2','com_modules.module.174','Implants','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('389','18','313','314','2','com_modules.module.175','Just Few Words','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('390','18','315','316','2','com_modules.module.176','Testimonials Dental','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
('391','240','464','465','2','com_djimageslider.category.95','Testimonials Dental','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('392','18','317','318','2','com_modules.module.177','Our Services','{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
('393','240','466','467','2','com_djimageslider.category.96','Services','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('394','18','319','320','2','com_modules.module.178','Popular Articles','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('395','181','58','59','3','com_content.article.130','All Template Positions','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}');
INSERT INTO `#__assets` VALUES 
('396','181','60','61','3','com_content.article.131','Error 404','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('397','18','321','322','2','com_modules.module.179','Search on Error 404 page','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('398','181','62','63','3','com_content.article.132','Offline Page','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('399','181','64','65','3','com_content.article.133','Examples','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('400','18','323','324','2','com_modules.module.180','Toggle Nav','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('401','18','325','326','2','com_modules.module.181','Analytics','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('402','18','327','328','2','com_modules.module.182','Tags','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('403','18','329','330','2','com_modules.module.183','Main Menu','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('404','18','331','332','2','com_modules.module.184','Offcanvas Info','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
('405','19','353','354','2','com_newsfeeds.category.97','JMSampleData','{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
('406','18','333','334','2','com_modules.module.185','Our site is coming soon','{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
('407','1','531','532','1','com_fields','com_fields','{}'),
('408','1','533','534','1','com_associations','com_associations','{}'),
('409','18','335','336','2','com_modules.module.186','DJ-MegaMenu','{}'),
('410','18','337','338','2','com_modules.module.187','DJ-MegaMenu - Mobile Menu Button','{}'),
('411','18','339','340','2','com_modules.module.188','Menu','{}'),
('412','18','341','342','2','com_modules.module.189','Test2','{}'),
('413','18','343','344','2','com_modules.module.190','JM Offcanvas Button Toggle','{}'),
('414','18','345','346','2','com_modules.module.191','DJ-MegaMenu Culinary','{}'),
('415','18','347','348','2','com_modules.module.192','DJ-MegaMenu Dental','{}');

DROP TABLE IF EXISTS #__associations;
CREATE TABLE `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__banner_clients;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` mediumtext NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`(100))
) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__banner_tracks;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__banners;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(400) NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` mediumtext NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` mediumtext NOT NULL,
  `params` mediumtext NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(400) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_metakey_prefix` (`metakey_prefix`(100))
) AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__categories;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(400) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(400) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL DEFAULT '' COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL DEFAULT '' COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL DEFAULT '' COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_path` (`path`(100)),
  KEY `idx_alias` (`alias`(100))
) AUTO_INCREMENT=98 DEFAULT CHARSET=utf8;

INSERT INTO `#__categories` VALUES 
('1','0','0','0','43','0','','system','ROOT','root','','','1','0','0000-00-00 00:00:00','1','{}','','','','936','2011-01-01 00:00:01','0','0000-00-00 00:00:00','0','*','1'),
('9','34','1','1','2','1','uncategorised','com_content','Uncategorised','uncategorised','','','1','0','0000-00-00 00:00:00','1','{"target":"","image":""}','','','{"page_title":"","author":"","robots":""}','936','2011-01-01 00:00:01','0','0000-00-00 00:00:00','0','*','1'),
('77','169','1','3','4','1','uncategorised','com_users','Uncategorised','uncategorised','','','1','0','0000-00-00 00:00:00','1','{"target":"","image":""}','','','{"page_title":"","author":"","robots":""}','936','2011-01-01 00:00:01','0','0000-00-00 00:00:00','0','*','1'),
('78','181','1','5','6','1','jm-sample-data','com_content','JM-Sample-Data','jm-sample-data','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-04-28 14:33:56','0','0000-00-00 00:00:00','0','*','1'),
('80','242','1','7','8','1','header','com_djimageslider','Header','header','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-09 08:29:10','0','0000-00-00 00:00:00','0','*','1'),
('81','243','1','9','10','1','projects','com_djimageslider','Projects','projects','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-09 08:29:19','0','0000-00-00 00:00:00','0','*','1'),
('82','251','1','11','12','1','testimonials','com_djimageslider','Testimonials','testimonials','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-11 13:20:38','0','0000-00-00 00:00:00','0','*','1'),
('83','286','1','13','22','1','blog','com_content','Blog','blog','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 12:32:13','0','0000-00-00 00:00:00','0','*','1'),
('84','315','83','14','15','2','blog/blog-category-1','com_content','Blog Category 1','blog-category-1','','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</p>','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 13:46:25','800','2014-07-07 14:16:47','0','*','1'),
('85','316','83','16','17','2','blog/blog-category-2','com_content','Blog Category 2','blog-category-2','','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</p>','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 13:46:29','800','2014-07-07 14:16:57','0','*','1'),
('86','317','83','18','19','2','blog/blog-category-3','com_content','Blog Category 3','blog-category-3','','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</p>','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 13:46:41','800','2014-07-07 14:17:07','0','*','1'),
('87','318','83','20','21','2','blog/blog-category-4','com_content','Blog Category 4','blog-category-4','','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</p>','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 13:46:53','800','2014-07-07 14:17:16','0','*','1'),
('88','320','1','23','24','1','newsflash','com_content','Newsflash','newsflash','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 14:00:02','0','0000-00-00 00:00:00','0','*','1'),
('89','326','1','25','26','1','contact-category','com_contact','Contact Category','contact-category','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-05-15 14:24:12','0','0000-00-00 00:00:00','0','*','1'),
('90','334','1','27','28','1','list','com_content','List','list','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-06-24 15:32:40','0','0000-00-00 00:00:00','0','*','1'),
('91','356','1','29','30','1','header-culinary','com_djimageslider','Header Culinary','header-culinary','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-07-08 10:45:52','0','0000-00-00 00:00:00','0','*','1'),
('92','360','1','31','32','1','dishes','com_djimageslider','Dishes','dishes','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-07-08 12:49:24','0','0000-00-00 00:00:00','0','*','1'),
('93','362','1','33','34','1','recipes','com_content','Recipes','recipes','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-07-08 13:08:18','0','0000-00-00 00:00:00','0','*','1'),
('94','384','1','35','36','1','header-dental','com_djimageslider','Header Dental','header-dental','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-09-04 12:30:34','0','0000-00-00 00:00:00','0','*','1'),
('95','391','1','37','38','1','testimonials-dental','com_djimageslider','Testimonials Dental','testimonials-dental','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-09-04 15:13:15','0','0000-00-00 00:00:00','0','*','1'),
('96','393','1','39','40','1','services','com_djimageslider','Services','services','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-09-05 14:29:13','0','0000-00-00 00:00:00','0','*','1'),
('97','405','1','41','42','1','jmsampledata','com_newsfeeds','JMSampleData','jmsampledata','','','1','0','0000-00-00 00:00:00','1','{"category_layout":"","image":""}','','','{"author":"","robots":""}','936','2014-11-28 12:55:32','0','0000-00-00 00:00:00','0','*','1');

DROP TABLE IF EXISTS #__contact_details;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(400) NOT NULL,
  `con_position` varchar(255) DEFAULT NULL,
  `address` mediumtext,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` longtext,
  `image` varchar(255) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` mediumtext NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL DEFAULT '',
  `sortname2` varchar(255) NOT NULL DEFAULT '',
  `sortname3` varchar(255) NOT NULL DEFAULT '',
  `language` varchar(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` mediumtext NOT NULL,
  `metadesc` mediumtext NOT NULL,
  `metadata` mediumtext NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL DEFAULT '' COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

INSERT INTO `#__contact_details` VALUES 
('9','Contact','contact','','7 Green Lane','Peterborough','','United Kingdom','PE13BA','0 123 456 789','','','','templates@joomla-monster.com','0','1','0','0000-00-00 00:00:00','3','{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"plain","show_tags":"0","show_name":"0","show_position":"0","show_email":"","show_street_address":"","show_suburb":"","show_state":"0","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"0","show_fax":"0","show_webpage":"0","show_misc":"0","show_image":"0","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linka":false,"linkb_name":"","linkb":false,"linkc_name":"","linkc":false,"linkd_name":"","linkd":false,"linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}','0','89','1','','','','','','*','2014-05-15 14:25:32','936','','2014-05-15 14:29:19','164','','','{"robots":"","rights":""}','0','','0000-00-00 00:00:00','0000-00-00 00:00:00','3','79'),
('10','Contact 2','contact-2','','7 Green Lane','Peterborough','','United Kingdom','PE13BA','0 123 456 789','','<p><span class="contact-misc">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula, nunc quis aliquet tincidunt, massa arcu eleifend velit, posuere gravida nisl mi et magna.</span></p>','','templates@joomla-monster.com','0','1','0','0000-00-00 00:00:00','4','{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_tags":"0","show_name":"0","show_position":"0","show_email":"","show_street_address":"","show_suburb":"","show_state":"0","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"0","show_fax":"0","show_webpage":"0","show_misc":"","show_image":"0","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"1","linka_name":"Facebook","linka":"https:\\/\\/www.facebook.com\\/JoomlaMonster","linkb_name":"Twitter","linkb":"https:\\/\\/twitter.com\\/Joomlamonster","linkc_name":"Google Plus","linkc":"https:\\/\\/plus.google.com\\/+Joomlamonstercom\\/posts","linkd_name":"","linkd":false,"linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}','0','89','1','','','','','','*','2014-06-24 15:03:23','936','','2014-06-24 15:07:22','800','','','{"robots":"","rights":""}','0','','0000-00-00 00:00:00','0000-00-00 00:00:00','4','8');

DROP TABLE IF EXISTS #__content;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(400) NOT NULL DEFAULT '',
  `introtext` longtext NOT NULL,
  `fulltext` longtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` mediumtext NOT NULL,
  `urls` mediumtext NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` mediumtext NOT NULL,
  `metadesc` mediumtext NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` mediumtext NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`),
  KEY `idx_alias` (`alias`(191))
) AUTO_INCREMENT=134 DEFAULT CHARSET=utf8;

INSERT INTO `#__content` VALUES 
('73','182','Subpage','subpage','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.yt</p>','','1','78','2014-04-28 14:34:25','936','','2017-05-15 07:11:03','936','0','0000-00-00 00:00:00','2014-04-28 14:34:25','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"article_layout":"","show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_associations":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_page_title":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','8','','','1','5039','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('87','276','Typography','typography','<h3 class="jm-typo-title">Image Borders</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;img class="img-rounded" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-rounded" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n<p></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;img class="img-circle" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-circle" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n<p></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;img class="img-polaroid" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-polaroid" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Headings</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<h1>This is Heading One (h1)</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h2>This is Heading Two (h2)</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h3>This is Heading Three (h3)</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n<div class="span6">\r\n<h4>This is Heading Four (h4)</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h5>This is Heading Five (h5)</h5>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h6>This is Heading Six (h6)</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Numered blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<pre>&lt;p class="jm-block"&gt;&lt;span class="jm"&gt;01&lt;/span&gt;Text goes here&lt;/p&gt;</pre>\r\n<p class="jm-block"><span class="jm">01</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block"><span class="jm">02</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block"><span class="jm">03</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n<div class="span6">\r\n<pre>&lt;p class="jm-block second"&gt;&lt;span class="jm"&gt;a&lt;/span&gt;Text goes here&lt;/p&gt;</pre>\r\n<p class="jm-block second"><span class="jm">a</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block second"><span class="jm">b</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block second"><span class="jm">c</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Colored Blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<div class="alert">&lt;div class="alert"&gt;Text goes here&lt;/div&gt;</div>\r\n<div class="alert alert-error">&lt;div class="alert alert-error"&gt;Text goes here&lt;/div&gt;</div>\r\n</div>\r\n<div class="span6">\r\n<div class="alert alert-success">&lt;div class="alert alert-success"&gt;Text goes here&lt;/div&gt;</div>\r\n<div class="alert alert-info">&lt;div class="alert alert-info"&gt;Text goes here&lt;/div&gt;</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Icon blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<p class="jm-badge">&lt;p class="jm-badge" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-calendar">&lt;p class="jm-calendar" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-chat">&lt;p class="jm-chat" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-check">&lt;p class="jm-check" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-cloud">&lt;p class="jm-cloud" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-direction">&lt;p class="jm-direction" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-divide">&lt;p class="jm-divide" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-error">&lt;p class="jm-error" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-fire">&lt;p class="jm-fire" &gt;Text goes here&lt;/p&gt;</p>\r\n</div>\r\n<div class="span6">\r\n<p class="jm-flag">&lt;p class="jm-flag" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-heart">&lt;p class="jm-heart" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-home">&lt;p class="jm-home" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-info">&lt;p class="jm-info" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-list">&lt;p class="jm-list" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-mail">&lt;p class="jm-mail" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-people">&lt;p class="jm-people" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-star">&lt;p class="jm-star" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-stat">&lt;p class="jm-stat" &gt;Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Blockquote</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;blockquote&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;/p&gt;<br />&lt;small&gt;John Doe&lt;/small&gt;<br />&lt;/blockquote&gt;</pre>\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n<small>John Doe</small></blockquote>\r\n</div>\r\n<div class="span12">\r\n<pre>&lt;blockquote class="pull-right"&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;/p&gt;<br />&lt;small&gt;John Doe&lt;/small&gt;<br />&lt;/blockquote&gt;</pre>\r\n<blockquote class="pull-right">\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n<small>John Doe</small></blockquote>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Unordered lists</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;ul&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ul class="jm-color-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-color-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ul class="jm-light-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-light-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<pre>&lt;ul class="jm-custom-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-custom-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span6">\r\n<pre>&lt;ul class="jm-custom-list green"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-custom-list green">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Ordered lists</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;ol&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ol class="jm-roman"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol class="jm-roman">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ol class="jm-alpha"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol class="jm-alpha">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Read More Button</h3>\r\n<pre>&lt;p class="readmore"&gt;&lt;a class="btn" href="#"&gt;Read more&lt;/a&gt;&lt;/p&gt;</pre>\r\n<p class="readmore"><a class="btn" href="#">Read more</a></p>\r\n<h3 class="jm-typo-title">Glyphicon Font</h3>\r\n<div>\r\n<pre>&lt;span class="icon-joomla"&gt;&amp;nbsp&lt;/span&gt;</pre>\r\n</div>\r\n<div class="row-fluid">\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-asterisk"> </span> icon-asterisk</div>\r\n<div style="padding: 2px 0;"><span class="icon-plus"> </span> icon-plus</div>\r\n<div style="padding: 2px 0;"><span class="icon-euro"> </span> icon-euro</div>\r\n<div style="padding: 2px 0;"><span class="icon-minus"> </span> icon-minus</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud"> </span> icon-cloud</div>\r\n<div style="padding: 2px 0;"><span class="icon-envelope"> </span> icon-envelope</div>\r\n<div style="padding: 2px 0;"><span class="icon-pencil"> </span> icon-pencil</div>\r\n<div style="padding: 2px 0;"><span class="icon-glass"> </span> icon-glass</div>\r\n<div style="padding: 2px 0;"><span class="icon-music"> </span> icon-music</div>\r\n<div style="padding: 2px 0;"><span class="icon-search"> </span> icon-search</div>\r\n<div style="padding: 2px 0;"><span class="icon-heart"> </span> icon-heart</div>\r\n<div style="padding: 2px 0;"><span class="icon-star"> </span> icon-star</div>\r\n<div style="padding: 2px 0;"><span class="icon-star-empty"> </span> icon-star-empty</div>\r\n<div style="padding: 2px 0;"><span class="icon-user"> </span> icon-user</div>\r\n<div style="padding: 2px 0;"><span class="icon-film"> </span> icon-film</div>\r\n<div style="padding: 2px 0;"><span class="icon-th-large"> </span> icon-th-large</div>\r\n<div style="padding: 2px 0;"><span class="icon-th"> </span> icon-th</div>\r\n<div style="padding: 2px 0;"><span class="icon-th-list"> </span> icon-th-list</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok"> </span> icon-ok</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove"> </span> icon-remove</div>\r\n<div style="padding: 2px 0;"><span class="icon-zoom-in"> </span> icon-zoom-in</div>\r\n<div style="padding: 2px 0;"><span class="icon-zoom-out"> </span> icon-zoom-out</div>\r\n<div style="padding: 2px 0;"><span class="icon-off"> </span> icon-off</div>\r\n<div style="padding: 2px 0;"><span class="icon-signal"> </span> icon-signal</div>\r\n<div style="padding: 2px 0;"><span class="icon-cog"> </span> icon-cog</div>\r\n<div style="padding: 2px 0;"><span class="icon-trash"> </span> icon-trash</div>\r\n<div style="padding: 2px 0;"><span class="icon-home"> </span> icon-home</div>\r\n<div style="padding: 2px 0;"><span class="icon-file"> </span> icon-file</div>\r\n<div style="padding: 2px 0;"><span class="icon-time"> </span> icon-time</div>\r\n<div style="padding: 2px 0;"><span class="icon-road"> </span> icon-road</div>\r\n<div style="padding: 2px 0;"><span class="icon-download-alt"> </span> icon-download-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-download"> </span> icon-download</div>\r\n<div style="padding: 2px 0;"><span class="icon-upload"> </span> icon-upload</div>\r\n<div style="padding: 2px 0;"><span class="icon-inbox"> </span> icon-inbox</div>\r\n<div style="padding: 2px 0;"><span class="icon-play-circle"> </span> icon-play-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-repeat"> </span> icon-repeat</div>\r\n<div style="padding: 2px 0;"><span class="icon-refresh"> </span> icon-refresh</div>\r\n<div style="padding: 2px 0;"><span class="icon-list-alt"> </span> icon-list-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-lock"> </span> icon-lock</div>\r\n<div style="padding: 2px 0;"><span class="icon-flag"> </span> icon-flag</div>\r\n<div style="padding: 2px 0;"><span class="icon-headphones"> </span> icon-headphones</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-off"> </span> icon-volume-off</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-down"> </span> icon-volume-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-up"> </span> icon-volume-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-qrcode"> </span> icon-qrcode</div>\r\n<div style="padding: 2px 0;"><span class="icon-barcode"> </span> icon-barcode</div>\r\n<div style="padding: 2px 0;"><span class="icon-tag"> </span> icon-tag</div>\r\n<div style="padding: 2px 0;"><span class="icon-tags"> </span> icon-tags</div>\r\n<div style="padding: 2px 0;"><span class="icon-book"> </span> icon-book</div>\r\n<div style="padding: 2px 0;"><span class="icon-bookmark"> </span> icon-bookmark</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-print"> </span> icon-print</div>\r\n<div style="padding: 2px 0;"><span class="icon-camera"> </span> icon-camera</div>\r\n<div style="padding: 2px 0;"><span class="icon-font"> </span> icon-font</div>\r\n<div style="padding: 2px 0;"><span class="icon-bold"> </span> icon-bold</div>\r\n<div style="padding: 2px 0;"><span class="icon-italic"> </span> icon-italic</div>\r\n<div style="padding: 2px 0;"><span class="icon-text-height"> </span> icon-text-height</div>\r\n<div style="padding: 2px 0;"><span class="icon-text-width"> </span> icon-text-width</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-left"> </span> icon-align-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-center"> </span> icon-align-center</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-right"> </span> icon-align-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-justify"> </span> icon-align-justify</div>\r\n<div style="padding: 2px 0;"><span class="icon-list"> </span> icon-list</div>\r\n<div style="padding: 2px 0;"><span class="icon-indent-left"> </span> icon-indent-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-indent-right"> </span> icon-indent-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-facetime-video"> </span> icon-facetime-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-picture"> </span> icon-picture</div>\r\n<div style="padding: 2px 0;"><span class="icon-map-marker"> </span> icon-map-marker</div>\r\n<div style="padding: 2px 0;"><span class="icon-adjust"> </span> icon-adjust</div>\r\n<div style="padding: 2px 0;"><span class="icon-tint"> </span> icon-tint</div>\r\n<div style="padding: 2px 0;"><span class="icon-edit"> </span> icon-edit</div>\r\n<div style="padding: 2px 0;"><span class="icon-share"> </span> icon-share</div>\r\n<div style="padding: 2px 0;"><span class="icon-check"> </span> icon-check</div>\r\n<div style="padding: 2px 0;"><span class="icon-move"> </span> icon-move</div>\r\n<div style="padding: 2px 0;"><span class="icon-step-backward"> </span> icon-step-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-fast-backward"> </span> icon-fast-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-backward"> </span> icon-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-play"> </span> icon-play</div>\r\n<div style="padding: 2px 0;"><span class="icon-pause"> </span> icon-pause</div>\r\n<div style="padding: 2px 0;"><span class="icon-stop"> </span> icon-stop</div>\r\n<div style="padding: 2px 0;"><span class="icon-forward"> </span> icon-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-fast-forward"> </span> icon-fast-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-step-forward"> </span> icon-step-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-eject"> </span> icon-eject</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-left"> </span> icon-chevron-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-right"> </span> icon-chevron-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-plus-sign"> </span> icon-plus-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-minus-sign"> </span> icon-minus-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove-sign"> </span> icon-remove-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok-sign"> </span> icon-ok-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-question-sign"> </span> icon-question-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-info-sign"> </span> icon-info-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-screenshot"> </span> icon-screenshot</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove-circle"> </span> icon-remove-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok-circle"> </span> icon-ok-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-ban-circle"> </span> icon-ban-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-left"> </span> icon-arrow-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-right"> </span> icon-arrow-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-up"> </span> icon-arrow-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-down"> </span> icon-arrow-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-share-alt"> </span> icon-share-alt</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-resize-full"> </span> icon-resize-full</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-small"> </span> icon-resize-small</div>\r\n<div style="padding: 2px 0;"><span class="icon-exclamation-sign"> </span> icon-exclamation-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-gift"> </span> icon-gift</div>\r\n<div style="padding: 2px 0;"><span class="icon-leaf"> </span> icon-leaf</div>\r\n<div style="padding: 2px 0;"><span class="icon-fire"> </span> icon-fire</div>\r\n<div style="padding: 2px 0;"><span class="icon-eye-open"> </span> icon-eye-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-eye-close"> </span> icon-eye-close</div>\r\n<div style="padding: 2px 0;"><span class="icon-warning-sign"> </span> icon-warning-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-plane"> </span> icon-plane</div>\r\n<div style="padding: 2px 0;"><span class="icon-calendar"> </span> icon-calendar</div>\r\n<div style="padding: 2px 0;"><span class="icon-random"> </span> icon-random</div>\r\n<div style="padding: 2px 0;"><span class="icon-comment"> </span> icon-comment</div>\r\n<div style="padding: 2px 0;"><span class="icon-magnet"> </span> icon-magnet</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-up"> </span> icon-chevron-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-down"> </span> icon-chevron-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-retweet"> </span> icon-retweet</div>\r\n<div style="padding: 2px 0;"><span class="icon-shopping-cart"> </span> icon-shopping-cart</div>\r\n<div style="padding: 2px 0;"><span class="icon-folder-close"> </span> icon-folder-close</div>\r\n<div style="padding: 2px 0;"><span class="icon-folder-open"> </span> icon-folder-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-vertical"> </span> icon-resize-vertical</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-horizontal"> </span> icon-resize-horizontal</div>\r\n<div style="padding: 2px 0;"><span class="icon-hdd"> </span> icon-hdd</div>\r\n<div style="padding: 2px 0;"><span class="icon-bullhorn"> </span> icon-bullhorn</div>\r\n<div style="padding: 2px 0;"><span class="icon-bell"> </span> icon-bell</div>\r\n<div style="padding: 2px 0;"><span class="icon-certificate"> </span> icon-certificate</div>\r\n<div style="padding: 2px 0;"><span class="icon-thumbs-up"> </span> icon-thumbs-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-thumbs-down"> </span> icon-thumbs-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-right"> </span> icon-hand-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-left"> </span> icon-hand-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-up"> </span> icon-hand-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-down"> </span> icon-hand-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-right"> </span> icon-circle-arrow-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-left"> </span> icon-circle-arrow-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-up"> </span> icon-circle-arrow-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-down"> </span> icon-circle-arrow-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-globe"> </span> icon-globe</div>\r\n<div style="padding: 2px 0;"><span class="icon-wrench"> </span> icon-wrench</div>\r\n<div style="padding: 2px 0;"><span class="icon-tasks"> </span> icon-tasks</div>\r\n<div style="padding: 2px 0;"><span class="icon-filter"> </span> icon-filter</div>\r\n<div style="padding: 2px 0;"><span class="icon-briefcase"> </span> icon-briefcase</div>\r\n<div style="padding: 2px 0;"><span class="icon-fullscreen"> </span> icon-fullscreen</div>\r\n<div style="padding: 2px 0;"><span class="icon-dashboard"> </span> icon-dashboard</div>\r\n<div style="padding: 2px 0;"><span class="icon-paperclip"> </span> icon-paperclip</div>\r\n<div style="padding: 2px 0;"><span class="icon-heart-empty"> </span> icon-heart-empty</div>\r\n<div style="padding: 2px 0;"><span class="icon-link"> </span> icon-link</div>\r\n<div style="padding: 2px 0;"><span class="icon-phone"> </span> icon-phone</div>\r\n<div style="padding: 2px 0;"><span class="icon-pushpin"> </span> icon-pushpin</div>\r\n<div style="padding: 2px 0;"><span class="icon-usd"> </span> icon-usd</div>\r\n<div style="padding: 2px 0;"><span class="icon-gbp"> </span> icon-gbp</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-sort"> </span> icon-sort</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-alphabet"> </span> icon-sort-by-alphabet</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-alphabet-alt"> </span> icon-sort-by-alphabet-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-order"> </span> icon-sort-by-order</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-order-alt"> </span> icon-sort-by-order-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-attributes"> </span> icon-sort-by-attributes</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-attributes-alt"> </span> icon-sort-by-attributes-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-unchecked"> </span> icon-unchecked</div>\r\n<div style="padding: 2px 0;"><span class="icon-expand"> </span> icon-expand</div>\r\n<div style="padding: 2px 0;"><span class="icon-collapse-down"> </span> icon-collapse-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-collapse-up"> </span> icon-collapse-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-log-in"> </span> icon-log-in</div>\r\n<div style="padding: 2px 0;"><span class="icon-flash"> </span> icon-flash</div>\r\n<div style="padding: 2px 0;"><span class="icon-log-out"> </span> icon-log-out</div>\r\n<div style="padding: 2px 0;"><span class="icon-new-window"> </span> icon-new-window</div>\r\n<div style="padding: 2px 0;"><span class="icon-record"> </span> icon-record</div>\r\n<div style="padding: 2px 0;"><span class="icon-save"> </span> icon-save</div>\r\n<div style="padding: 2px 0;"><span class="icon-open"> </span> icon-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-saved"> </span> icon-saved</div>\r\n<div style="padding: 2px 0;"><span class="icon-import"> </span> icon-import</div>\r\n<div style="padding: 2px 0;"><span class="icon-export"> </span> icon-export</div>\r\n<div style="padding: 2px 0;"><span class="icon-send"> </span> icon-send</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-disk"> </span> icon-floppy-disk</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-saved"> </span> icon-floppy-saved</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-remove"> </span> icon-floppy-remove</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-save"> </span> icon-floppy-save</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-open"> </span> icon-floppy-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-credit-card"> </span> icon-credit-card</div>\r\n<div style="padding: 2px 0;"><span class="icon-transfer"> </span> icon-transfer</div>\r\n<div style="padding: 2px 0;"><span class="icon-cutlery"> </span> icon-cutlery</div>\r\n<div style="padding: 2px 0;"><span class="icon-header"> </span> icon-header</div>\r\n<div style="padding: 2px 0;"><span class="icon-compressed"> </span> icon-compressed</div>\r\n<div style="padding: 2px 0;"><span class="icon-earphone"> </span> icon-earphone</div>\r\n<div style="padding: 2px 0;"><span class="icon-phone-alt"> </span> icon-phone-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-tower"> </span> icon-tower</div>\r\n<div style="padding: 2px 0;"><span class="icon-stats"> </span> icon-stats</div>\r\n<div style="padding: 2px 0;"><span class="icon-sd-video"> </span> icon-sd-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-hd-video"> </span> icon-hd-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-subtitles"> </span> icon-subtitles</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-stereo"> </span> icon-sound-stereo</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-dolby"> </span> icon-sound-dolby</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-5-1"> </span> icon-sound-5-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-6-1"> </span> icon-sound-6-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-7-1"> </span> icon-sound-7-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-copyright-mark"> </span> icon-copyright-mark</div>\r\n<div style="padding: 2px 0;"><span class="icon-registration-mark"> </span> icon-registration-mark</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud-download"> </span> icon-cloud-download</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud-upload"> </span> icon-cloud-upload</div>\r\n<div style="padding: 2px 0;"><span class="icon-tree-conifer"> </span> icon-tree-conifer</div>\r\n<div style="padding: 2px 0;"><span class="icon-tree-deciduous"> </span> icon-tree-deciduous</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Top Contact Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;ul class="jm-contact-icons"&gt;<br />&lt;li class="jm-direction"&gt;&lt;img src="images/modules/direction.png" alt="Direction" /&gt;&lt;a title="Contact" href="#"&gt;Peterborough, UK&lt;/a&gt;&lt;/li&gt;<br />&lt;li class="jm-email"&gt;&lt;img src="images/modules/email.png" alt="Email" /&gt;&lt;a title="Contact" href="#"&gt;Email&lt;/a&gt;&lt;/li&gt;<br />&lt;li class="jm-phone"&gt;&lt;img src="images/modules/phone.png" alt="Phone" /&gt;&lt;a title="Contact" href="#"&gt;+44 7837 383 484&lt;/a&gt;&lt;/li&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-contact-icons">\r\n<li class="jm-direction"><img src="images/modules/direction.png" alt="Direction" /><a title="Contact" href="#">Peterborough, UK</a></li>\r\n<li class="jm-email"><img src="images/modules/email.png" alt="Email" /><a title="Contact" href="#">Email</a></li>\r\n<li class="jm-phone"><img src="images/modules/phone.png" alt="Phone" /><a title="Contact" href="#">+44 7837 383 484</a></li>\r\n</ul>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Color Boxes</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box1 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />TIME MACHINE<br />&lt;/span&gt; <br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt; <br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt; <br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box1 text-center" href="#"> <span class="jm-icon-title">TIME MACHINE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box2 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />ANALYTICS<br />&lt;/span&gt;<br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt;<br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt;<br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">ANALYTICS</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box3 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />WORLDWIDE SERVICE<br />&lt;/span&gt;<br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt;<br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt;<br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box3 text-center" href="#"> <span class="jm-icon-title">WORLDWIDE SERVICE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Just Few Words Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;div class="pull-left visible-desktop"&gt;<br />&lt;img class="jm-image-margin" src="images/modules/custom1.jpg" alt="Custom" /&gt;<br />&lt;/div&gt;<br />&lt;div class="jm-table"&gt;<br />&lt;h3 class="jm-title" style="margin-bottom: 20px;"&gt;JUST FEW WORDS&lt;/h3&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;/p&gt;<br />&lt;ul class="jm-custom-list"&gt;<br />&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;/li&gt;<br />&lt;li&gt;Exercitation ullamco laboris nisi&lt;/li&gt;<br />&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;/li&gt;<br />&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;/li&gt;<br />&lt;/ul&gt;<br />&lt;p class="readmore text-right"&gt;&lt;a class="btn" href="#"&gt;read more&lt;/a&gt;&lt;/p&gt;<br />&lt;/div&gt;</pre>\r\n<div class="jm-module clearfix">\r\n<div class="pull-left visible-desktop"><img class="jm-image-margin" src="images/modules/custom1.jpg" alt="Custom" /></div>\r\n<div class="jm-table">\r\n<h3 class="jm-title" style="margin-bottom: 20px;">JUST FEW WORDS</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.</p>\r\n<ul class="jm-custom-list">\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi</li>\r\n<li>Ut aliquip ex ea commodo consequat.</li>\r\n<li>Duis aute irure dolor in reprehenderit</li>\r\n</ul>\r\n<p class="readmore text-right"><a class="btn" href="#"> read more </a></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Social Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<div class="jm-socials">\r\n<pre>&lt;div class="jm-socials"&gt;<br />&lt;a class="facebook" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="googleplus" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="twitter" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="linkedin" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="skype" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="vimeo" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;/div&gt;</pre>\r\n<a class="facebook" href="#"> </a> <a class="googleplus" href="#"> </a> <a class="twitter" href="#"> </a> <a class="linkedin" href="#"> </a> <a class="skype" href="#"> </a> <a class="vimeo" href="#"> </a></div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Our Cooks Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;div class="media"&gt;<br />&lt;a class="pull-left" href="#"&gt; &lt;img src="images/culinary/modules/cooks/cook1.png" alt="" /&gt; &lt;/a&gt;<br />&lt;div class="media-body"&gt;<br />&lt;h5 class="media-heading"&gt;&lt;a href="#"&gt;Greg Amaro&lt;/a&gt;&lt;/h5&gt;<br />&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;/p&gt;<br />&lt;/div&gt;<br />&lt;/div&gt;<br />&lt;div class="media"&gt;<br />&lt;a class="pull-left" href="#"&gt; &lt;img src="images/culinary/modules/cooks/cook2.png" alt="" /&gt; &lt;/a&gt;<br />&lt;div class="media-body"&gt;<br />&lt;h5 class="media-heading"&gt;&lt;a href="#"&gt;Jimmy Gessler&lt;/a&gt;&lt;/h5&gt;<br />&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;/p&gt;<br />&lt;/div&gt;<br />&lt;/div&gt;</pre>\r\n<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook1.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Greg Amaro</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>\r\n<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook2.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Jimmy Gessler</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>','','-2','78','2014-05-14 12:40:26','936','','2015-05-28 09:29:17','755','0','0000-00-00 00:00:00','2014-05-14 12:40:26','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','62','7','','','1','161','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('96','287','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','84','2014-05-15 12:44:15','936','','2014-07-07 15:18:49','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','11','12','','','1','13','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('97','289','Consectetur Adipisc','consectetur-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','86','2014-05-15 12:44:15','936','','2014-06-24 16:01:56','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','9','2','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('98','291','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','85','2014-05-15 12:44:15','936','','2014-07-07 15:19:06','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','10','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('99','293','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','85','2014-05-15 12:44:15','936','','2014-07-07 15:19:26','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','9','','','1','2','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('100','295','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','86','2014-05-15 12:44:15','936','','2014-07-07 15:19:43','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','1','','','1','5','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('101','297','Malesuada Ultricies','malesuada-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','87','2014-05-15 12:44:15','936','','2014-07-07 15:20:07','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','9','7','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('102','299','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','84','2014-05-15 12:44:15','936','','2014-07-04 10:12:32','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','6','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('103','301','Quisque Vestibulum','quisque-vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','87','2014-05-15 12:44:15','936','','2014-07-07 15:20:38','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','5','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('104','305','Cras Eleifend','cras-eleifend','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','2','83','2013-12-15 12:44:15','936','','2014-07-07 15:18:17','800','0','0000-00-00 00:00:00','2013-12-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','3','4','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('105','307','Fusce Eu Risus','fusce-eu-risus','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','2','83','2014-01-15 12:44:15','936','','2014-07-07 15:17:56','800','0','0000-00-00 00:00:00','2014-01-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','4','3','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('106','309','Pretium Pellentesque','pretium-pellentesque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','2','83','2014-02-15 12:44:15','936','','2014-07-07 15:17:19','800','0','0000-00-00 00:00:00','2014-02-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','4','2','','','1','4','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('107','311','Volutpat Vehicula','volutpat-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','2','83','2014-03-15 12:44:15','936','','2014-07-07 15:17:39','800','0','0000-00-00 00:00:00','2014-03-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','1','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('108','313','Auctor Justo','auctor-justo','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','2','83','2014-04-15 12:44:15','936','','2014-05-15 14:08:03','164','0','0000-00-00 00:00:00','2014-04-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','3','0','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('109','321','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.</p>\r\n','\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','88','2014-05-15 12:44:15','936','','2014-07-07 14:51:03','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','0','','','1','12','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('110','323','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.</p>\r\n','\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','88','2014-05-15 12:44:15','936','','2014-07-07 14:51:09','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','0','','','1','8','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('111','328','Single Article','single-article','<p><strong>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</strong></p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>\r\n<h4>Font Awesome example</h4>\r\n<p><span class="fa fa-joomla fa-5x" aria-hidden="true"></span> <span class="fa fa-html5 fa-5x" aria-hidden="true"></span> <span class="fa fa-css3 fa-5x" aria-hidden="true"></span></p>','','1','78','2014-06-24 13:38:25','936','','2016-08-18 10:08:46','936','0','0000-00-00 00:00:00','2014-06-24 13:38:25','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blog\\/blog1.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','3','6','','','1','42','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('112','329','Tabs','tabs','<hr title="Tab 1" class="system-pagebreak" />\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo.</p>\r\n<p>Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt. Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat.</p>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<hr title="Tab 2" class="system-pagebreak" />\r\n<p>Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<hr title="Tab 3" class="system-pagebreak" />\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus.</p>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec accumsan.</p>','','1','78','2014-06-24 14:46:59','936','','0000-00-00 00:00:00','0','0','0000-00-00 00:00:00','2014-06-24 14:46:59','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','1','5','','','1','12','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('113','335','Quisque Vestibulum','quisque-vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-05-15 14:10:42','164','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','6','5','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('114','337','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-06-24 16:00:34','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','7','6','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('115','339','Malesuada Ultricies','malesuada-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-07-07 14:49:56','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','7','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('116','341','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-05-15 14:10:22','164','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','6','1','','','1','5','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('117','343','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-05-15 14:10:02','164','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','8','9','','','1','2','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('118','345','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-07-07 14:50:34','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','7','10','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('119','347','Consectetur Adipisc','consectetur-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-07-07 14:50:26','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','2','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('120','349','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','90','2014-05-15 12:44:15','936','','2014-07-07 14:49:38','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','12','','','1','5','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('121','351','Module Suffixes','module-suffixes','<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br />Let\'s check them all.</p>\r\n<p>1. Available module designs</p>\r\n<p> </p>\r\n<p><img src="images/sample/module-suffixes.png" alt="Module Suffixes" /></p>\r\n<p> </p>\r\n<p>2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.</p>\r\n<p> </p>\r\n<p><strong>Suffix name:</strong> slider1-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes1.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n<p> </p>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<p><strong>Suffix name:</strong> testimonials-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes2.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n</div>\r\n<div class="span6">\r\n<p><strong>Suffix name:</strong> testimonials-ms alternative-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes3.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n</div>\r\n</div>','','-2','78','2014-06-25 09:42:57','936','','2014-09-09 12:55:04','800','0','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','9','4','','','1','14','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('122','363','Vestibulum','vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:19:33','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','5','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('123','365','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:19:19','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','6','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('124','367','Males Ultricies','males-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:19:06','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','11','7','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('125','369','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:18:47','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','1','','','1','5','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('126','371','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:18:34','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog6.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','12','9','','','1','2','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('127','373','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:18:21','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','10','10','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('128','375','Consec Adipisc','consec-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:20:37','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','11','2','','','1','0','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('129','377','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>','1','93','2014-05-15 12:44:15','936','','2014-07-08 13:21:02','800','0','0000-00-00 00:00:00','2014-05-15 12:44:15','0000-00-00 00:00:00','{"image_intro":"images\\/culinary\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','13','12','','','1','5','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('130','395','All Template Positions','all-template-positions','<p><a title="JM Services" href="http://www.joomla-monster.com/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-services&amp;cid=32:free&amp;Itemid=471" target="_blank">JM Services</a> Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br /><a title="EF4 Framework" href="http://www.joomla-monster.com/index.php?option=com_content&amp;id=137&amp;view=category&amp;Itemid=548" target="_blank">EF4 Framework</a> includes <a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Layout Builder</a> tool which allows you to customize template layout for different screen dimensions.</p>\r\n','\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for normal and large screen <small>usually desktop and tablet landscape (980px and higher)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for normal and large screen" src="images/sample/normal-positions.jpg" alt="Module positions for normal and large screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for medium screen <small>usually tablet (768px-979px)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for medium screen" src="images/sample/medium-positions.jpg" alt="Module positions for medium screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for small screen <small>usually tablet portrait and mobile landscape (481px-767px)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for small screen" src="images/sample/small-positions.jpg" alt="Module positions for small screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for extra small screen <small>usually mobile portrait (480px and smaller)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for extra small screen" src="images/sample/extrasmall-positions.jpg" alt="Module positions for extra small screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>','-2','78','2014-06-25 09:42:57','936','','2014-11-28 14:45:39','941','0','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','3','','','1','7','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('131','396','Error 404','error-404','<p> </p>\r\n<div class="jm-error-page">\r\n<h1>404 OOPS!</h1>\r\n<h2>Page not found!</h2>\r\n<p>"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br />Please try your luck again."</p>\r\n{loadposition error404-search} <a class="btn btn-large" href="index.php">Take me home</a>\r\n<p> </p>\r\n</div>\r\n<p>This is a Joomla! article displayed as custom 404 page.</p>\r\n<p><strong>How to modify this page?</strong><br /> <strong>Step 1:</strong> Go to Content -&gt; Article Manager.<br /> <strong>Step 2:</strong> Find and edit the "Error 404" article.</p>\r\n<p><strong>How is the search module displayed?</strong><br /> It is displayed using the "Content - Load Modules" plugin. It allows to display a module in a Joomla article.<br />The module is published on the following position: error404-search</p>\r\n<p><strong>How to display a different article as custom 404 page?</strong><br />If you want to display other article, you need to change the article ID in the following location: /templates/jm-services/error.php</p>','','1','78','2014-06-25 09:42:57','936','','2014-09-11 12:39:34','800','0','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','2','','','1','47','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('132','398','Offline Page','offline-page','<p style="text-align: center;"><img src="images/sample/offline.png" alt="Offline Page" /></p>\r\n<p> </p>\r\n<p>There is a possibility to disable access to the front of your site.</p>\r\n<p><strong>How to enable the offline page?</strong><br /> <strong>Step 1:</strong> Go to "System -&gt; Global Configuration -&gt; Site".<br /><strong>Step 2:</strong> Click on "Yes" for "Site Offline" option.<br /> <strong>Step 3:</strong> Fill in a text for "Offline Message" to give your visitors some explanation about why your website is unavailable.<br /> <strong>Step 4:</strong> Click on "Save" to save your settings.</p>\r\n<p><strong>How to customize the offline page?</strong><br /> You need to edit the following file: /templates/jm-services/offline.php</p>','','1','78','2014-06-25 09:42:57','936','','2014-09-11 14:02:52','800','0','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','5','1','','','1','6','{"robots":"","author":"","rights":"","xreference":""}','0','*',''),
('133','399','Examples','examples','<div class="row-fluid">\r\n<div class="span4">\r\n<h3>Business Theme</h3>\r\n<a title="JM-Services Business" href="index.php?option=com_content&amp;view=article&amp;id=73&amp;Itemid=435"><img src="images/sample/jm-services-business.jpg" alt="JM Services" /></a></div>\r\n<div class="span4">\r\n<h3>Culinary Theme</h3>\r\n<a title="JM-Services Culinary" href="index.php?option=com_content&amp;view=category&amp;layout=blog&amp;id=93&amp;Itemid=568"><img src="images/sample/jm-services-culinary.jpg" alt="JM Services" /></a></div>\r\n<div class="span4">\r\n<h3>Dental Theme</h3>\r\n<a title="JM-Services Dental" href="index.php?option=com_content&amp;view=article&amp;id=73&amp;Itemid=613"><img src="images/sample/jm-services-dental.jpg" alt="JM Services" /></a></div>\r\n</div>','','1','78','2014-09-17 13:16:51','936','','2014-09-17 13:20:12','800','0','0000-00-00 00:00:00','2014-09-17 13:16:51','0000-00-00 00:00:00','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','2','0','','','1','1','{"robots":"","author":"","rights":"","xreference":""}','0','*','');

DROP TABLE IF EXISTS #__content_frontpage;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__content_frontpage` VALUES 
('8','2'),
('24','1'),
('35','4'),
('50','3');

DROP TABLE IF EXISTS #__content_rating;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__content_types;
CREATE TABLE `#__content_types` (
  `type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_title` varchar(255) NOT NULL DEFAULT '',
  `type_alias` varchar(400) NOT NULL DEFAULT '',
  `table` varchar(255) NOT NULL DEFAULT '',
  `rules` mediumtext NOT NULL,
  `field_mappings` mediumtext NOT NULL,
  `router` varchar(255) NOT NULL DEFAULT '',
  `content_history_options` varchar(5120) DEFAULT NULL COMMENT 'JSON string for com_contenthistory options',
  PRIMARY KEY (`type_id`),
  KEY `idx_alias` (`type_alias`(100))
) AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8;

INSERT INTO `#__content_types` VALUES 
('1','Article','com_content.article','{"special":{"dbtable":"#__content","key":"id","type":"Content","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"introtext", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"attribs", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"asset_id"}, "special":{"fulltext":"fulltext"}}','ContentHelperRoute::getArticleRoute','{"formFile":"administrator\\/components\\/com_content\\/models\\/forms\\/article.xml", "hideFields":["asset_id","checked_out","checked_out_time","version"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"} ]}'),
('2','Weblink','com_weblinks.weblink','{"special":{"dbtable":"#__weblinks","key":"id","type":"Weblink","prefix":"WeblinksTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{}}','WeblinksHelperRoute::getWeblinkRoute','{"formFile":"administrator\\/components\\/com_weblinks\\/models\\/forms\\/weblink.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","featured","images"], "ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"], "convertToInt":["publish_up", "publish_down", "featured", "ordering"], "displayLookup":[{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"} ]}'),
('3','Contact','com_contact.contact','{"special":{"dbtable":"#__contact_details","key":"id","type":"Contact","prefix":"ContactTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"address", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"image", "core_urls":"webpage", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{"con_position":"con_position","suburb":"suburb","state":"state","country":"country","postcode":"postcode","telephone":"telephone","fax":"fax","misc":"misc","email_to":"email_to","default_con":"default_con","user_id":"user_id","mobile":"mobile","sortname1":"sortname1","sortname2":"sortname2","sortname3":"sortname3"}}','ContactHelperRoute::getContactRoute','{"formFile":"administrator\\/components\\/com_contact\\/models\\/forms\\/contact.xml","hideFields":["default_con","checked_out","checked_out_time","version","xreference"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"], "displayLookup":[ {"sourceColumn":"created_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"} ] }'),
('4','Newsfeed','com_newsfeeds.newsfeed','{"special":{"dbtable":"#__newsfeeds","key":"id","type":"Newsfeed","prefix":"NewsfeedsTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{"numarticles":"numarticles","cache_time":"cache_time","rtl":"rtl"}}','NewsfeedsHelperRoute::getNewsfeedRoute','{"formFile":"administrator\\/components\\/com_newsfeeds\\/models\\/forms\\/newsfeed.xml","hideFields":["asset_id","checked_out","checked_out_time","version"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"} ]}'),
('5','User','com_users.user','{"special":{"dbtable":"#__users","key":"id","type":"User","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"name","core_state":"null","core_alias":"username","core_created_time":"registerdate","core_modified_time":"lastvisitDate","core_body":"null", "core_hits":"null","core_publish_up":"null","core_publish_down":"null","access":"null", "core_params":"params", "core_featured":"null", "core_metadata":"null", "core_language":"null", "core_images":"null", "core_urls":"null", "core_version":"null", "core_ordering":"null", "core_metakey":"null", "core_metadesc":"null", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}, "special":{}}','UsersHelperRoute::getUserRoute',''),
('6','Article Category','com_content.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','ContentHelperRoute::getCategoryRoute','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}'),
('7','Contact Category','com_contact.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','ContactHelperRoute::getCategoryRoute','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}'),
('8','Newsfeeds Category','com_newsfeeds.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','NewsfeedsHelperRoute::getCategoryRoute','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}'),
('9','Weblinks Category','com_weblinks.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','WeblinksHelperRoute::getCategoryRoute','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}'),
('10','Tag','com_tags.tag','{"special":{"dbtable":"#__tags","key":"tag_id","type":"Tag","prefix":"TagsTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path"}}','TagsHelperRoute::getTagRoute','{"formFile":"administrator\\/components\\/com_tags\\/models\\/forms\\/tag.xml", "hideFields":["checked_out","checked_out_time","version", "lft", "rgt", "level", "path", "urls", "publish_up", "publish_down"],"ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}]}'),
('11','Banner','com_banners.banner','{"special":{"dbtable":"#__banners","key":"id","type":"Banner","prefix":"BannersTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"null","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"null", "asset_id":"null"}, "special":{"imptotal":"imptotal", "impmade":"impmade", "clicks":"clicks", "clickurl":"clickurl", "custombannercode":"custombannercode", "cid":"cid", "purchase_type":"purchase_type", "track_impressions":"track_impressions", "track_clicks":"track_clicks"}}','','{"formFile":"administrator\\/components\\/com_banners\\/models\\/forms\\/banner.xml", "hideFields":["checked_out","checked_out_time","version", "reset"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "imptotal", "impmade", "reset"], "convertToInt":["publish_up", "publish_down", "ordering"], "displayLookup":[{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"cid","targetTable":"#__banner_clients","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"created_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"modified_by","targetTable":"#__users","targetColumn":"id","displayColumn":"name"} ]}'),
('12','Banners Category','com_banners.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special": {"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"], "convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}'),
('13','Banner Client','com_banners.client','{"special":{"dbtable":"#__banner_clients","key":"id","type":"Client","prefix":"BannersTable"}}','','','','{"formFile":"administrator\\/components\\/com_banners\\/models\\/forms\\/client.xml", "hideFields":["checked_out","checked_out_time"], "ignoreChanges":["checked_out", "checked_out_time"], "convertToInt":[], "displayLookup":[]}'),
('14','User Notes','com_users.note','{"special":{"dbtable":"#__user_notes","key":"id","type":"Note","prefix":"UsersTable"}}','','','','{"formFile":"administrator\\/components\\/com_users\\/models\\/forms\\/note.xml", "hideFields":["checked_out","checked_out_time", "publish_up", "publish_down"],"ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time"], "convertToInt":["publish_up", "publish_down"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}]}'),
('15','User Notes Category','com_users.category','{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}','','{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}','','{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"], "convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"access","targetTable":"#__viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#__users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#__categories","targetColumn":"id","displayColumn":"title"}]}');

DROP TABLE IF EXISTS #__contentitem_tag_map;
CREATE TABLE `#__contentitem_tag_map` (
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `core_content_id` int(10) unsigned NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) unsigned NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table',
  UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`),
  KEY `idx_tag_type` (`tag_id`,`type_id`),
  KEY `idx_date_id` (`tag_date`,`tag_id`),
  KEY `idx_core_content_id` (`core_content_id`)
) DEFAULT CHARSET=utf8 COMMENT='Maps items from content tables to tags';

INSERT INTO `#__contentitem_tag_map` VALUES 
('com_content.article','4','96','8','2014-07-07 17:18:49','1'),
('com_content.article','4','96','9','2014-07-07 17:18:49','1'),
('com_content.article','4','96','10','2014-07-07 17:18:49','1'),
('com_content.article','5','97','7','2014-06-24 18:01:56','1'),
('com_content.article','5','97','8','2014-06-24 18:01:56','1'),
('com_content.article','5','97','9','2014-06-24 18:01:56','1'),
('com_content.article','5','97','10','2014-06-24 18:01:56','1'),
('com_content.article','6','98','8','2014-07-07 17:19:06','1'),
('com_content.article','6','98','9','2014-07-07 17:19:06','1'),
('com_content.article','6','98','10','2014-07-07 17:19:06','1'),
('com_content.article','7','99','9','2014-07-07 17:19:26','1'),
('com_content.article','7','99','10','2014-07-07 17:19:26','1'),
('com_content.article','7','99','11','2014-07-07 17:19:26','1'),
('com_content.article','7','99','12','2014-07-07 17:19:26','1'),
('com_content.article','8','100','8','2014-07-07 17:19:43','1'),
('com_content.article','8','100','9','2014-07-07 17:19:43','1'),
('com_content.article','8','100','10','2014-07-07 17:19:43','1'),
('com_content.article','9','101','10','2014-07-07 17:20:07','1'),
('com_content.article','10','102','9','2014-07-04 12:12:32','1'),
('com_content.article','10','102','10','2014-07-04 12:12:32','1'),
('com_content.article','11','103','7','2014-07-07 17:20:38','1'),
('com_content.article','12','104','7','2014-07-07 17:18:17','1'),
('com_content.article','12','104','8','2014-07-07 17:18:17','1'),
('com_content.article','12','104','9','2014-07-07 17:18:17','1'),
('com_content.article','12','104','10','2014-07-07 17:18:17','1'),
('com_content.article','13','105','7','2014-07-07 17:17:56','1'),
('com_content.article','13','105','8','2014-07-07 17:17:56','1'),
('com_content.article','13','105','9','2014-07-07 17:17:56','1'),
('com_content.article','13','105','10','2014-07-07 17:17:56','1'),
('com_content.article','14','106','7','2014-07-07 17:17:19','1'),
('com_content.article','14','106','8','2014-07-07 17:17:19','1'),
('com_content.article','14','106','9','2014-07-07 17:17:19','1'),
('com_content.article','14','106','10','2014-07-07 17:17:19','1'),
('com_content.article','15','107','7','2014-07-07 17:17:40','1'),
('com_content.article','15','107','8','2014-07-07 17:17:40','1'),
('com_content.article','15','107','9','2014-07-07 17:17:40','1'),
('com_content.article','15','107','10','2014-07-07 17:17:40','1'),
('com_content.article','16','108','7','2014-05-15 16:08:03','1'),
('com_content.article','16','108','8','2014-05-15 16:08:03','1'),
('com_content.article','16','108','9','2014-05-15 16:08:03','1'),
('com_content.article','16','108','10','2014-05-15 16:08:03','1'),
('com_content.article','17','109','7','2014-07-07 16:51:03','1'),
('com_content.article','17','109','8','2014-07-07 16:51:03','1'),
('com_content.article','17','109','9','2014-07-07 16:51:03','1'),
('com_content.article','17','109','10','2014-07-07 16:51:03','1'),
('com_content.article','17','109','11','2014-07-07 16:51:03','1'),
('com_content.article','18','110','7','2014-07-07 16:51:09','1'),
('com_content.article','18','110','8','2014-07-07 16:51:09','1'),
('com_content.article','18','110','9','2014-07-07 16:51:09','1'),
('com_content.article','18','110','10','2014-07-07 16:51:09','1');
INSERT INTO `#__contentitem_tag_map` VALUES 
('com_content.article','18','110','11','2014-07-07 16:51:09','1'),
('com_content.article','19','113','7','2014-06-24 17:33:42','1'),
('com_content.article','19','113','8','2014-06-24 17:33:42','1'),
('com_content.article','19','113','9','2014-06-24 17:33:42','1'),
('com_content.article','19','113','10','2014-06-24 17:33:42','1'),
('com_content.article','20','114','7','2014-06-24 18:00:34','1'),
('com_content.article','20','114','8','2014-06-24 18:00:34','1'),
('com_content.article','20','114','9','2014-06-24 18:00:34','1'),
('com_content.article','20','114','10','2014-06-24 18:00:34','1'),
('com_content.article','21','115','7','2014-07-07 16:49:56','1'),
('com_content.article','21','115','8','2014-07-07 16:49:56','1'),
('com_content.article','21','115','9','2014-07-07 16:49:56','1'),
('com_content.article','21','115','10','2014-07-07 16:49:56','1'),
('com_content.article','21','115','11','2014-07-07 16:49:56','1'),
('com_content.article','22','116','7','2014-06-24 17:33:42','1'),
('com_content.article','22','116','8','2014-06-24 17:33:42','1'),
('com_content.article','22','116','9','2014-06-24 17:33:42','1'),
('com_content.article','22','116','10','2014-06-24 17:33:42','1'),
('com_content.article','23','117','8','2014-06-24 17:33:42','1'),
('com_content.article','23','117','9','2014-06-24 17:33:42','1'),
('com_content.article','23','117','10','2014-06-24 17:33:42','1'),
('com_content.article','23','117','11','2014-06-24 17:33:42','1'),
('com_content.article','23','117','12','2014-06-24 17:33:42','1'),
('com_content.article','24','118','7','2014-07-07 16:50:34','1'),
('com_content.article','24','118','8','2014-07-07 16:50:34','1'),
('com_content.article','24','118','9','2014-07-07 16:50:34','1'),
('com_content.article','24','118','10','2014-07-07 16:50:34','1'),
('com_content.article','24','118','11','2014-07-07 16:50:34','1'),
('com_content.article','25','119','7','2014-07-07 16:50:26','1'),
('com_content.article','25','119','8','2014-07-07 16:50:26','1'),
('com_content.article','25','119','9','2014-07-07 16:50:26','1'),
('com_content.article','25','119','10','2014-07-07 16:50:26','1'),
('com_content.article','25','119','11','2014-07-07 16:50:26','1'),
('com_content.article','26','120','7','2014-07-07 16:49:38','1'),
('com_content.article','26','120','8','2014-07-07 16:49:38','1'),
('com_content.article','26','120','9','2014-07-07 16:49:38','1'),
('com_content.article','26','120','10','2014-07-07 16:49:38','1'),
('com_content.article','26','120','11','2014-07-07 16:49:38','1'),
('com_content.article','27','122','7','2014-07-08 15:19:33','1'),
('com_content.article','28','123','9','2014-07-08 15:19:19','1'),
('com_content.article','28','123','10','2014-07-08 15:19:19','1'),
('com_content.article','29','124','10','2014-07-08 15:19:06','1'),
('com_content.article','30','125','8','2014-07-08 15:18:47','1'),
('com_content.article','30','125','9','2014-07-08 15:18:47','1'),
('com_content.article','30','125','10','2014-07-08 15:18:47','1'),
('com_content.article','31','126','9','2014-07-08 15:18:34','1'),
('com_content.article','31','126','10','2014-07-08 15:18:34','1'),
('com_content.article','31','126','11','2014-07-08 15:18:34','1'),
('com_content.article','31','126','12','2014-07-08 15:18:34','1'),
('com_content.article','32','127','8','2014-07-08 15:18:21','1');
INSERT INTO `#__contentitem_tag_map` VALUES 
('com_content.article','32','127','9','2014-07-08 15:18:21','1'),
('com_content.article','32','127','10','2014-07-08 15:18:21','1'),
('com_content.article','33','128','7','2014-07-08 15:20:38','1'),
('com_content.article','33','128','8','2014-07-08 15:20:38','1'),
('com_content.article','33','128','9','2014-07-08 15:20:38','1'),
('com_content.article','33','128','10','2014-07-08 15:20:38','1'),
('com_content.article','34','129','8','2014-07-08 15:21:02','1'),
('com_content.article','34','129','9','2014-07-08 15:21:02','1'),
('com_content.article','34','129','10','2014-07-08 15:21:02','1');

DROP TABLE IF EXISTS #__core_log_searches;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__djimageslider;
CREATE TABLE `#__djimageslider` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `image` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `catid` (`catid`,`published`)
) AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;

INSERT INTO `#__djimageslider` VALUES 
('1','80','Microsoft Office Training','microsoft-office-training','images/djimageslider/header/header1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','2','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('2','80','Starting Your Own Business','starting-your-own-business','images/djimageslider/header/header2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','1','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('3','80','Android Development ','android-development','images/djimageslider/header/header3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','3','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('4','81','Project1','project1','images/djimageslider/projects/project1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','4','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('5','81','Project2','project2','images/djimageslider/projects/project2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','5','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('6','81','Project3','project3','images/djimageslider/projects/project3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','6','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('7','81','Project4','project4','images/djimageslider/projects/project4.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','7','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('8','81','Project5','project5','images/djimageslider/projects/project5.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','8','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('9','82','Testimonials1','testimonials1','images/djimageslider/testimonials/testimonials1.png','<div class="jm-testimonial-name">EMMA THOMSON</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','9','{"link_type":"","link_menu":"437","link_url":"","link_article":"","link_target":""}'),
('10','82','Testimonials2','testimonials2','images/djimageslider/testimonials/testimonials2.png','<div class="jm-testimonial-name">GINA DAVIES</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','10','{"link_type":"","link_menu":"437","link_url":"","link_article":"","link_target":""}'),
('11','82','Testimonials3','testimonials3','images/djimageslider/testimonials/testimonials3.png','<div class="jm-testimonial-name">RUBY DOLL</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','11','{"link_type":"","link_menu":"437","link_url":"","link_article":"","link_target":""}'),
('12','81','Project6','project6','images/djimageslider/projects/project6.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','12','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('13','91','Thin Crust Pizza Italiana','thin-crust-pizza-italiana','images/culinary/djimageslider/header/header1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','13','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('14','91','Tomato and Mozzarella Salad','tomato-and-mozzarella-salad','images/culinary/djimageslider/header/header2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','14','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('15','91','Pasta with Olives and Basil','pasta-with-olives-and-basil','images/culinary/djimageslider/header/header3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','15','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('16','92','Dish1','dish1','images/culinary/djimageslider/dishes/dish1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','16','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('17','92','Dish2','dish2','images/culinary/djimageslider/dishes/dish2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','17','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('18','92','Dish3','dish3','images/culinary/djimageslider/dishes/dish3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','18','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('19','92','Dish4','dish4','images/culinary/djimageslider/dishes/dish4.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','19','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('20','92','Dish5','dish5','images/culinary/djimageslider/dishes/dish5.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','20','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('21','92','Dish6','dish6','images/culinary/djimageslider/dishes/dish6.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','21','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('22','94','Teeth Whitening Gels ','teeth-whitening-gels','images/dental/djimageslider/header/header1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','22','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('23','94','How to Clean Teeth','how-to-clean-teeth','images/dental/djimageslider/header/header2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','23','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('24','94','Choosing a Toothbrush','choosing-a-toothbrush','images/dental/djimageslider/header/header3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi consectetur dui vel ligula tincidunt egestas. Aenean vitae adipiscing massa. Donec luctus libero vel metus ornare consequat.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','24','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('25','95','Testimonials1','testimonials1','images/dental/djimageslider/testimonials/testimonials1.png','<div class="jm-testimonial-name">BRENDA WALSH</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','25','{"link_type":"","link_menu":"561","link_url":"","link_article":"","link_target":""}'),
('26','95','Testimonials2','testimonials2','images/dental/djimageslider/testimonials/testimonials2.png','<div class="jm-testimonial-name">JESSICA SIMPSON</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','26','{"link_type":"","link_menu":"561","link_url":"","link_article":"","link_target":""}'),
('27','95','Testimonials3','testimonials3','images/dental/djimageslider/testimonials/testimonials3.png','<div class="jm-testimonial-name">PATRICIA BELL</div>\r\n<div class="jm-testimonial-subname">Happy Customer</div>\r\n<div class="jm-testimonial-desc">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore aliqua.”</div>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','27','{"link_type":"","link_menu":"561","link_url":"","link_article":"","link_target":""}'),
('28','96','Service1','service1','images/dental/djimageslider/services/service1.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','28','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('29','96','Service2','service2','images/dental/djimageslider/services/service2.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','29','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('30','96','Service3','service3','images/dental/djimageslider/services/service3.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','30','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('31','96','Service4','service4','images/dental/djimageslider/services/service4.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','31','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('32','96','Service5','service5','images/dental/djimageslider/services/service5.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','32','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}'),
('33','96','Service6','service6','images/dental/djimageslider/services/service6.jpg','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','0000-00-00 00:00:00','0000-00-00 00:00:00','0','0000-00-00 00:00:00','33','{"link_type":"menu","link_menu":"479","link_url":"","link_article":"","link_target":""}');

DROP TABLE IF EXISTS #__extensions;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Parent package ID for extensions installed as a package.',
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` mediumtext NOT NULL,
  `params` mediumtext NOT NULL,
  `custom_data` mediumtext NOT NULL,
  `system_data` mediumtext NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) AUTO_INCREMENT=10027 DEFAULT CHARSET=utf8;

INSERT INTO `#__extensions` VALUES 
('1','0','com_mailto','component','com_mailto','','0','1','1','1','{"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MAILTO_XML_DESCRIPTION","group":"","filename":"mailto"}','','','','0','0000-00-00 00:00:00','0','0'),
('2','0','com_wrapper','component','com_wrapper','','0','1','1','1','{"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":"","filename":"wrapper"}','','','','0','0000-00-00 00:00:00','0','0'),
('3','0','com_admin','component','com_admin','','1','1','1','1','{"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('4','0','com_banners','component','com_banners','','1','1','1','0','{"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_BANNERS_XML_DESCRIPTION","group":"","filename":"banners"}','{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":"","save_history":"1","history_limit":10}','','','0','0000-00-00 00:00:00','0','0'),
('5','0','com_cache','component','com_cache','','1','1','1','1','{"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('6','0','com_categories','component','com_categories','','1','1','1','1','{"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('7','0','com_checkin','component','com_checkin','','1','1','1','1','{"name":"com_checkin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('8','0','com_contact','component','com_contact','','1','1','1','0','{"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTACT_XML_DESCRIPTION","group":"","filename":"contact"}','{"contact_layout":"_:default","show_contact_category":"hide","save_history":"1","history_limit":10,"show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_tags":"1","contact_icons":"1","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"0","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_items":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_items_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_pagination":"2","show_pagination_results":"1","initial_sort":"ordering","captcha":"","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_feed_link":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('9','0','com_cpanel','component','com_cpanel','','1','1','1','1','{"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('10','0','com_installer','component','com_installer','','1','1','1','1','{"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('11','0','com_languages','component','com_languages','','1','1','1','1','{"name":"com_languages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}','{"administrator":"en-GB","site":"en-GB"}','','','0','0000-00-00 00:00:00','0','0'),
('12','0','com_login','component','com_login','','1','1','1','1','{"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('13','0','com_media','component','com_media','','1','1','0','1','{"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MEDIA_XML_DESCRIPTION","group":"","filename":"media"}','{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html"}','','','0','0000-00-00 00:00:00','0','0'),
('14','0','com_menus','component','com_menus','','1','1','1','1','{"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('15','0','com_messages','component','com_messages','','1','1','1','1','{"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('16','0','com_modules','component','com_modules','','1','1','1','1','{"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('17','0','com_newsfeeds','component','com_newsfeeds','','1','1','1','0','{"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}','{"newsfeed_layout":"_:default","save_history":"1","history_limit":5,"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_character_count":"0","feed_display_order":"des","float_first":"right","float_second":"right","show_tags":"1","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_items":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_items_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"1","show_articles":"0","show_link":"1","show_pagination":"1","show_pagination_results":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('18','0','com_plugins','component','com_plugins','','1','1','1','1','{"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('19','0','com_search','component','com_search','','1','1','1','0','{"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_SEARCH_XML_DESCRIPTION","group":"","filename":"search"}','{"enabled":"0","show_date":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('20','0','com_templates','component','com_templates','','1','1','1','1','{"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}','{"template_positions_display":"0","upload_limit":"2","image_formats":"gif,bmp,jpg,jpeg,png","source_formats":"txt,less,ini,xml,js,php,css","font_formats":"woff,ttf,otf","compressed_formats":"zip"}','','','0','0000-00-00 00:00:00','0','0'),
('21','801','com_weblinks','component','com_weblinks','','1','1','1','0','{"name":"com_weblinks","type":"component","creationDate":"2017-03-08","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}','{"target":"0","save_history":"1","history_limit":5,"count_clicks":"1","icons":1,"link_icons":"","float_first":"right","float_second":"right","show_tags":"1","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_num_links":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_links_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"0","show_link_description":"1","show_link_hits":"1","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('22','0','com_content','component','com_content','','1','1','0','1','{"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}','{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","info_block_position":"0","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"1","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_vote":"0","show_readmore":"1","show_readmore_title":"0","readmore_limit":"100","show_tags":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"0","urls_position":"0","show_publishing_options":"1","show_article_options":"1","save_history":"1","history_limit":10,"show_urls_images_frontend":"0","show_urls_images_backend":"1","targeta":0,"targetb":0,"targetc":0,"float_intro":"left","float_fulltext":"left","category_layout":"_:blog","show_category_heading_title_text":"1","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","feed_show_readmore":"0"}','','','0','0000-00-00 00:00:00','0','0'),
('23','0','com_config','component','com_config','','1','1','0','1','{"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}','{"filters":{"1":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"9":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}','','','0','0000-00-00 00:00:00','0','0'),
('24','0','com_redirect','component','com_redirect','','1','1','0','1','{"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('25','0','com_users','component','com_users','','1','1','0','1','{"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_USERS_XML_DESCRIPTION","group":"","filename":"users"}','{"allowUserRegistration":"1","new_usertype":"2","guest_usergroup":"13","sendpassword":"1","useractivation":"1","mail_to_admin":"0","captcha":"","frontend_userparams":"1","site_language":"0","change_login_name":"0","reset_count":"10","reset_time":"1","mailSubjectPrefix":"","mailBodySuffix":"","save_history":"1","history_limit":5}','','','0','0000-00-00 00:00:00','0','0'),
('27','0','com_finder','component','com_finder','','1','1','0','0','{"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_FINDER_XML_DESCRIPTION","group":"","filename":"finder"}','{"show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_advanced":"1","expand_advanced":"0","show_date_filters":"0","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stemmer":"snowball"}','','','0','0000-00-00 00:00:00','0','0'),
('28','0','com_joomlaupdate','component','com_joomlaupdate','','1','1','0','1','{"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.2","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('29','0','com_tags','component','com_tags','','1','1','1','1','{"name":"com_tags","type":"component","creationDate":"December 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"COM_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}','{"tag_layout":"_:default","save_history":"1","history_limit":5,"show_tag_title":"0","tag_list_show_tag_image":"0","tag_list_show_tag_description":"0","tag_list_image":"","show_tag_num_items":"0","tag_list_orderby":"title","tag_list_orderby_direction":"ASC","show_headings":"0","tag_list_show_date":"0","tag_list_show_item_image":"0","tag_list_show_item_description":"0","tag_list_item_maximum_characters":0,"return_any_or_all":"1","include_children":"0","maximum":200,"tag_list_language_filter":"all","tags_layout":"_:default","all_tags_orderby":"title","all_tags_orderby_direction":"ASC","all_tags_show_tag_image":"0","all_tags_show_tag_descripion":"0","all_tags_tag_maximum_characters":20,"all_tags_show_tag_hits":"0","filter_field":"1","show_pagination_limit":"1","show_pagination":"2","show_pagination_results":"1","tag_field_ajax_mode":"1","show_feed_link":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('30','0','com_contenthistory','component','com_contenthistory','','1','1','1','0','{"name":"com_contenthistory","type":"component","creationDate":"May 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_CONTENTHISTORY_XML_DESCRIPTION","group":"","filename":"contenthistory"}','','','','0','0000-00-00 00:00:00','0','0'),
('31','0','com_ajax','component','com_ajax','','1','1','1','1','{"name":"com_ajax","type":"component","creationDate":"August 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_AJAX_XML_DESCRIPTION","group":"","filename":"ajax"}','','','','0','0000-00-00 00:00:00','0','0'),
('32','0','com_postinstall','component','com_postinstall','','1','1','1','1','{"name":"com_postinstall","type":"component","creationDate":"September 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_POSTINSTALL_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('455','0','plg_installer_packageinstaller','plugin','packageinstaller','installer','0','1','1','1','{"name":"plg_installer_packageinstaller","type":"plugin","creationDate":"May 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PLG_INSTALLER_PACKAGEINSTALLER_PLUGIN_XML_DESCRIPTION","group":"","filename":"packageinstaller"}','','','','0','0000-00-00 00:00:00','1','0'),
('456','0','PLG_INSTALLER_FOLDERINSTALLER','plugin','folderinstaller','installer','0','1','1','1','{"name":"PLG_INSTALLER_FOLDERINSTALLER","type":"plugin","creationDate":"May 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PLG_INSTALLER_FOLDERINSTALLER_PLUGIN_XML_DESCRIPTION","group":"","filename":"folderinstaller"}','','','','0','0000-00-00 00:00:00','2','0'),
('457','0','PLG_INSTALLER_URLINSTALLER','plugin','urlinstaller','installer','0','1','1','1','{"name":"PLG_INSTALLER_URLINSTALLER","type":"plugin","creationDate":"May 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PLG_INSTALLER_URLINSTALLER_PLUGIN_XML_DESCRIPTION","group":"","filename":"urlinstaller"}','','','','0','0000-00-00 00:00:00','3','0'),
('102','0','LIB_PHPUTF8','library','phputf8','','0','1','1','1','{"name":"LIB_PHPUTF8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":"","filename":"phputf8"}','','','','0','0000-00-00 00:00:00','0','0'),
('103','0','LIB_JOOMLA','library','joomla','','0','1','1','1','{"name":"LIB_JOOMLA","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"https:\\/\\/www.joomla.org","version":"13.1","description":"LIB_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}','{"mediaversion":"0dd80c7acb54c675105df88d11963d11"}','','','0','0000-00-00 00:00:00','0','0'),
('104','0','LIB_IDNA','library','idna_convert','','0','1','1','1','{"name":"LIB_IDNA","type":"library","creationDate":"2004","author":"phlyLabs","copyright":"2004-2011 phlyLabs Berlin, http:\\/\\/phlylabs.de","authorEmail":"phlymail@phlylabs.de","authorUrl":"http:\\/\\/phlylabs.de","version":"0.8.0","description":"LIB_IDNA_XML_DESCRIPTION","group":"","filename":"idna_convert"}','','','','0','0000-00-00 00:00:00','0','0'),
('105','0','FOF','library','fof','','0','1','1','1','{"name":"FOF","type":"library","creationDate":"2015-04-22 13:15:32","author":"Nicholas K. Dionysopoulos \\/ Akeeba Ltd","copyright":"(C)2011-2015 Nicholas K. Dionysopoulos","authorEmail":"nicholas@akeebabackup.com","authorUrl":"https:\\/\\/www.akeebabackup.com","version":"2.4.3","description":"LIB_FOF_XML_DESCRIPTION","group":"","filename":"fof"}','','','','0','0000-00-00 00:00:00','0','0'),
('106','0','LIB_PHPASS','library','phpass','','0','1','1','1','{"name":"LIB_PHPASS","type":"library","creationDate":"2004-2006","author":"Solar Designer","copyright":"","authorEmail":"solar@openwall.com","authorUrl":"http:\\/\\/www.openwall.com\\/phpass\\/","version":"0.3","description":"LIB_PHPASS_XML_DESCRIPTION","group":"","filename":"phpass"}','','','','0','0000-00-00 00:00:00','0','0'),
('200','0','mod_articles_archive','module','mod_articles_archive','','0','1','1','0','{"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":"","filename":"mod_articles_archive"}','','','','0','0000-00-00 00:00:00','0','0'),
('201','0','mod_articles_latest','module','mod_articles_latest','','0','1','1','0','{"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":"","filename":"mod_articles_latest"}','','','','0','0000-00-00 00:00:00','0','0'),
('202','0','mod_articles_popular','module','mod_articles_popular','','0','1','1','0','{"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_articles_popular"}','','','','0','0000-00-00 00:00:00','0','0'),
('203','0','mod_banners','module','mod_banners','','0','1','1','0','{"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":"","filename":"mod_banners"}','','','','0','0000-00-00 00:00:00','0','0'),
('204','0','mod_breadcrumbs','module','mod_breadcrumbs','','0','1','1','1','{"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":"","filename":"mod_breadcrumbs"}','','','','0','0000-00-00 00:00:00','0','0'),
('205','0','mod_custom','module','mod_custom','','0','1','1','1','{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":"","filename":"mod_custom"}','','','','0','0000-00-00 00:00:00','0','0'),
('206','0','mod_feed','module','mod_feed','','0','1','1','0','{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":"","filename":"mod_feed"}','','','','0','0000-00-00 00:00:00','0','0'),
('207','0','mod_footer','module','mod_footer','','0','1','1','0','{"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":"","filename":"mod_footer"}','','','','0','0000-00-00 00:00:00','0','0'),
('208','0','mod_login','module','mod_login','','0','1','1','1','{"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":"","filename":"mod_login"}','','','','0','0000-00-00 00:00:00','0','0'),
('209','0','mod_menu','module','mod_menu','','0','1','1','1','{"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":"","filename":"mod_menu"}','','','','0','0000-00-00 00:00:00','0','0'),
('210','0','mod_articles_news','module','mod_articles_news','','0','1','1','0','{"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":"","filename":"mod_articles_news"}','','','','0','0000-00-00 00:00:00','0','0');
INSERT INTO `#__extensions` VALUES 
('211','0','mod_random_image','module','mod_random_image','','0','1','1','0','{"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":"","filename":"mod_random_image"}','','','','0','0000-00-00 00:00:00','0','0'),
('212','0','mod_related_items','module','mod_related_items','','0','1','1','0','{"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RELATED_XML_DESCRIPTION","group":"","filename":"mod_related_items"}','','','','0','0000-00-00 00:00:00','0','0'),
('213','0','mod_search','module','mod_search','','0','1','1','0','{"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":"","filename":"mod_search"}','','','','0','0000-00-00 00:00:00','0','0'),
('214','0','mod_stats','module','mod_stats','','0','1','1','0','{"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":"","filename":"mod_stats"}','','','','0','0000-00-00 00:00:00','0','0'),
('215','0','mod_syndicate','module','mod_syndicate','','0','1','1','1','{"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":"","filename":"mod_syndicate"}','','','','0','0000-00-00 00:00:00','0','0'),
('216','0','mod_users_latest','module','mod_users_latest','','0','1','1','0','{"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":"","filename":"mod_users_latest"}','','','','0','0000-00-00 00:00:00','0','0'),
('217','801','mod_weblinks','module','mod_weblinks','','0','1','1','0','{"name":"mod_weblinks","type":"module","creationDate":"2017-03-08","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":"","filename":"mod_weblinks"}','','','','0','0000-00-00 00:00:00','0','0'),
('218','0','mod_whosonline','module','mod_whosonline','','0','1','1','0','{"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":"","filename":"mod_whosonline"}','','','','0','0000-00-00 00:00:00','0','0'),
('219','0','mod_wrapper','module','mod_wrapper','','0','1','1','0','{"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":"","filename":"mod_wrapper"}','','','','0','0000-00-00 00:00:00','0','0'),
('220','0','mod_articles_category','module','mod_articles_category','','0','1','1','0','{"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":"","filename":"mod_articles_category"}','','','','0','0000-00-00 00:00:00','0','0'),
('221','0','mod_articles_categories','module','mod_articles_categories','','0','1','1','0','{"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":"","filename":"mod_articles_categories"}','','','','0','0000-00-00 00:00:00','0','0'),
('222','0','mod_languages','module','mod_languages','','0','1','1','1','{"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.5.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":"","filename":"mod_languages"}','','','','0','0000-00-00 00:00:00','0','0'),
('223','0','mod_finder','module','mod_finder','','0','1','0','0','{"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FINDER_XML_DESCRIPTION","group":"","filename":"mod_finder"}','','','','0','0000-00-00 00:00:00','0','0'),
('300','0','mod_custom','module','mod_custom','','1','1','1','1','{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":"","filename":"mod_custom"}','','','','0','0000-00-00 00:00:00','0','0'),
('301','0','mod_feed','module','mod_feed','','1','1','1','0','{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":"","filename":"mod_feed"}','','','','0','0000-00-00 00:00:00','0','0'),
('302','0','mod_latest','module','mod_latest','','1','1','1','0','{"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_XML_DESCRIPTION","group":"","filename":"mod_latest"}','','','','0','0000-00-00 00:00:00','0','0'),
('303','0','mod_logged','module','mod_logged','','1','1','1','0','{"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":"","filename":"mod_logged"}','','','','0','0000-00-00 00:00:00','0','0'),
('304','0','mod_login','module','mod_login','','1','1','1','1','{"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":"","filename":"mod_login"}','','','','0','0000-00-00 00:00:00','0','0'),
('305','0','mod_menu','module','mod_menu','','1','1','1','0','{"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":"","filename":"mod_menu"}','','','','0','0000-00-00 00:00:00','0','0'),
('307','0','mod_popular','module','mod_popular','','1','1','1','0','{"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_popular"}','','','','0','0000-00-00 00:00:00','0','0'),
('308','0','mod_quickicon','module','mod_quickicon','','1','1','1','1','{"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":"","filename":"mod_quickicon"}','','','','0','0000-00-00 00:00:00','0','0'),
('309','0','mod_status','module','mod_status','','1','1','1','0','{"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATUS_XML_DESCRIPTION","group":"","filename":"mod_status"}','','','','0','0000-00-00 00:00:00','0','0'),
('310','0','mod_submenu','module','mod_submenu','','1','1','1','0','{"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":"","filename":"mod_submenu"}','','','','0','0000-00-00 00:00:00','0','0'),
('311','0','mod_title','module','mod_title','','1','1','1','0','{"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TITLE_XML_DESCRIPTION","group":"","filename":"mod_title"}','','','','0','0000-00-00 00:00:00','0','0'),
('312','0','mod_toolbar','module','mod_toolbar','','1','1','1','1','{"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":"","filename":"mod_toolbar"}','','','','0','0000-00-00 00:00:00','0','0'),
('313','0','mod_multilangstatus','module','mod_multilangstatus','','1','1','1','0','{"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":"","filename":"mod_multilangstatus"}','{"cache":"0"}','','','0','0000-00-00 00:00:00','0','0'),
('314','0','mod_version','module','mod_version','','1','1','1','0','{"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_VERSION_XML_DESCRIPTION","group":"","filename":"mod_version"}','{"format":"short","product":"1","cache":"0"}','','','0','0000-00-00 00:00:00','0','0'),
('315','0','mod_stats_admin','module','mod_stats_admin','','1','1','1','0','{"name":"mod_stats_admin","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":"","filename":"mod_stats_admin"}','{"serverinfo":"0","siteinfo":"0","counter":"0","increase":"0","cache":"1","cache_time":"900","cachemode":"static"}','','','0','0000-00-00 00:00:00','0','0'),
('316','0','mod_tags_popular','module','mod_tags_popular','','0','1','1','0','{"name":"mod_tags_popular","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_tags_popular"}','{"maximum":"5","timeframe":"alltime","owncache":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('317','0','mod_tags_similar','module','mod_tags_similar','','0','1','1','0','{"name":"mod_tags_similar","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_SIMILAR_XML_DESCRIPTION","group":"","filename":"mod_tags_similar"}','{"maximum":"5","matchtype":"any","owncache":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('400','0','plg_authentication_gmail','plugin','gmail','authentication','0','0','1','0','{"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":"","filename":"gmail"}','{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}','','','0','0000-00-00 00:00:00','1','0'),
('401','0','plg_authentication_joomla','plugin','joomla','authentication','0','1','1','1','{"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}','','','','0','0000-00-00 00:00:00','0','0'),
('402','0','plg_authentication_ldap','plugin','ldap','authentication','0','0','1','0','{"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LDAP_XML_DESCRIPTION","group":"","filename":"ldap"}','{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}','','','0','0000-00-00 00:00:00','3','0'),
('403','0','plg_content_contact','plugin','contact','content','0','1','1','0','{"name":"plg_content_contact","type":"plugin","creationDate":"January 2014","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.2","description":"PLG_CONTENT_CONTACT_XML_DESCRIPTION","group":"","filename":"contact"}','','','','0','0000-00-00 00:00:00','1','0'),
('404','0','plg_content_emailcloak','plugin','emailcloak','content','0','1','1','0','{"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":"","filename":"emailcloak"}','{"mode":"1"}','','','0','0000-00-00 00:00:00','1','0'),
('406','0','plg_content_loadmodule','plugin','loadmodule','content','0','1','1','0','{"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":"","filename":"loadmodule"}','{"style":"xhtml"}','','','0','2011-09-18 15:22:50','0','0'),
('407','0','plg_content_pagebreak','plugin','pagebreak','content','0','1','1','0','{"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":"","filename":"pagebreak"}','{"title":"1","article_index":"1","article_index_text":"","multipage_toc":"1","showall":"1","style":"tabs"}','','','0','0000-00-00 00:00:00','4','0'),
('408','0','plg_content_pagenavigation','plugin','pagenavigation','content','0','1','1','0','{"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":"","filename":"pagenavigation"}','{"position":"1"}','','','0','0000-00-00 00:00:00','5','0'),
('409','0','plg_content_vote','plugin','vote','content','0','1','1','0','{"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_VOTE_XML_DESCRIPTION","group":"","filename":"vote"}','','','','0','0000-00-00 00:00:00','6','0'),
('410','0','plg_editors_codemirror','plugin','codemirror','editors','0','1','1','1','{"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"Copyright (C) 2014 - 2017 by Marijn Haverbeke <marijnh@gmail.com> and others","authorEmail":"marijnh@gmail.com","authorUrl":"http:\\/\\/codemirror.net\\/","version":"5.30.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":"","filename":"codemirror"}','{"lineNumbers":"1","lineWrapping":"1","matchTags":"1","matchBrackets":"1","marker-gutter":"1","autoCloseTags":"1","autoCloseBrackets":"1","autoFocus":"1","theme":"default","tabmode":"indent"}','','','0','0000-00-00 00:00:00','1','0'),
('411','0','plg_editors_none','plugin','none','editors','0','1','1','1','{"name":"plg_editors_none","type":"plugin","creationDate":"September 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_NONE_XML_DESCRIPTION","group":"","filename":"none"}','','','','0','0000-00-00 00:00:00','2','0'),
('412','0','plg_editors_tinymce','plugin','tinymce','editors','0','1','1','0','{"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2017","author":"Ephox Corporation","copyright":"Ephox Corporation","authorEmail":"N\\/A","authorUrl":"http:\\/\\/www.tinymce.com","version":"4.5.8","description":"PLG_TINY_XML_DESCRIPTION","group":"","filename":"tinymce"}','{"mode":"1","skin":"0","mobile":"0","entity_encoding":"raw","lang_mode":"1","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"dummy","valid_elements":"","extended_elements":"span[*],a[*],p[*],div[*]","html_height":"550","html_width":"750","resizing":"1","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","colors":"1","table":"1","smilies":"1","hr":"1","link":"1","media":"1","print":"1","directionality":"1","fullscreen":"1","alignment":"1","visualchars":"1","visualblocks":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","image_advtab":"1","advlist":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","custom_plugin":"","custom_button":""}','','','0','0000-00-00 00:00:00','3','0'),
('413','0','plg_editors-xtd_article','plugin','article','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":"","filename":"article"}','','','','0','0000-00-00 00:00:00','1','0'),
('414','0','plg_editors-xtd_image','plugin','image','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":"","filename":"image"}','','','','0','0000-00-00 00:00:00','2','0'),
('415','0','plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":"","filename":"pagebreak"}','','','','0','0000-00-00 00:00:00','3','0'),
('416','0','plg_editors-xtd_readmore','plugin','readmore','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_READMORE_XML_DESCRIPTION","group":"","filename":"readmore"}','','','','0','0000-00-00 00:00:00','4','0'),
('417','0','plg_search_categories','plugin','categories','search','0','1','1','0','{"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":"","filename":"categories"}','{"search_limit":"50","search_content":"1","search_archived":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('418','0','plg_search_contacts','plugin','contacts','search','0','1','1','0','{"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":"","filename":"contacts"}','{"search_limit":"50","search_content":"1","search_archived":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('419','0','plg_search_content','plugin','content','search','0','1','1','0','{"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}','{"search_limit":"50","search_content":"1","search_archived":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('420','0','plg_search_newsfeeds','plugin','newsfeeds','search','0','1','1','0','{"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}','{"search_limit":"50","search_content":"1","search_archived":"1"}','','','0','0000-00-00 00:00:00','0','0');
INSERT INTO `#__extensions` VALUES 
('421','801','plg_search_weblinks','plugin','weblinks','search','0','1','1','0','{"name":"plg_search_weblinks","type":"plugin","creationDate":"2017-03-08","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}','{"search_limit":"50","search_content":"1","search_archived":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('422','0','plg_system_languagefilter','plugin','languagefilter','system','0','0','1','1','{"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":"","filename":"languagefilter"}','','','','0','0000-00-00 00:00:00','1','0'),
('423','0','plg_system_p3p','plugin','p3p','system','0','1','1','0','{"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_P3P_XML_DESCRIPTION","group":"","filename":"p3p"}','{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}','','','0','0000-00-00 00:00:00','2','0'),
('424','0','plg_system_cache','plugin','cache','system','0','0','1','1','{"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CACHE_XML_DESCRIPTION","group":"","filename":"cache"}','{"browsercache":"0","cachetime":"15"}','','','0','0000-00-00 00:00:00','9','0'),
('425','0','plg_system_debug','plugin','debug','system','0','1','1','0','{"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":"","filename":"debug"}','{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}','','','0','0000-00-00 00:00:00','4','0'),
('426','0','plg_system_log','plugin','log','system','0','1','1','1','{"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOG_XML_DESCRIPTION","group":"","filename":"log"}','','','','0','0000-00-00 00:00:00','5','0'),
('427','0','plg_system_redirect','plugin','redirect','system','0','0','1','1','{"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_REDIRECT_XML_DESCRIPTION","group":"","filename":"redirect"}','','','','0','0000-00-00 00:00:00','6','0'),
('428','0','plg_system_remember','plugin','remember','system','0','1','1','1','{"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":"","filename":"remember"}','','','','0','0000-00-00 00:00:00','7','0'),
('429','0','plg_system_sef','plugin','sef','system','0','1','1','0','{"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEF_XML_DESCRIPTION","group":"","filename":"sef"}','','','','0','0000-00-00 00:00:00','8','0'),
('430','0','plg_system_logout','plugin','logout','system','0','1','1','1','{"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":"","filename":"logout"}','','','','0','0000-00-00 00:00:00','3','0'),
('431','0','plg_user_contactcreator','plugin','contactcreator','user','0','0','1','0','{"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":"","filename":"contactcreator"}','{"autowebpage":"","category":"34","autopublish":"0"}','','','0','0000-00-00 00:00:00','1','0'),
('432','0','plg_user_joomla','plugin','joomla','user','0','1','1','0','{"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}','{"strong_passwords":"1","autoregister":"1"}','','','0','0000-00-00 00:00:00','2','0'),
('433','0','plg_user_profile','plugin','profile','user','0','1','1','0','{"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":"","filename":"profile"}','{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('434','0','plg_extension_joomla','plugin','joomla','extension','0','1','1','1','{"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}','','','','0','0000-00-00 00:00:00','1','0'),
('435','0','plg_content_joomla','plugin','joomla','content','0','1','1','0','{"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}','','','','0','0000-00-00 00:00:00','0','0'),
('436','0','plg_system_languagecode','plugin','languagecode','system','0','0','1','0','{"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":"","filename":"languagecode"}','','','','0','0000-00-00 00:00:00','10','0'),
('437','0','plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon','0','1','1','1','{"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":"","filename":"joomlaupdate"}','','','','0','0000-00-00 00:00:00','0','0'),
('438','0','plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon','0','1','1','1','{"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":"","filename":"extensionupdate"}','','','','0','0000-00-00 00:00:00','0','0'),
('439','0','plg_captcha_recaptcha','plugin','recaptcha','captcha','0','0','1','0','{"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":"","filename":"recaptcha"}','{"public_key":"","private_key":"","theme":"clean"}','','','0','0000-00-00 00:00:00','0','0'),
('440','0','plg_system_highlight','plugin','highlight','system','0','1','1','0','{"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":"","filename":"highlight"}','','','','0','0000-00-00 00:00:00','7','0'),
('441','0','plg_content_finder','plugin','finder','content','0','1','1','0','{"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":"","filename":"finder"}','','','','0','0000-00-00 00:00:00','0','0'),
('442','0','plg_finder_categories','plugin','categories','finder','0','1','1','0','{"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":"","filename":"categories"}','','','','0','0000-00-00 00:00:00','1','0'),
('443','0','plg_finder_contacts','plugin','contacts','finder','0','1','1','0','{"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":"","filename":"contacts"}','','','','0','0000-00-00 00:00:00','2','0'),
('444','0','plg_finder_content','plugin','content','finder','0','1','1','0','{"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}','','','','0','0000-00-00 00:00:00','3','0'),
('445','0','plg_finder_newsfeeds','plugin','newsfeeds','finder','0','1','1','0','{"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}','','','','0','0000-00-00 00:00:00','4','0'),
('446','801','plg_finder_weblinks','plugin','weblinks','finder','0','1','1','0','{"name":"plg_finder_weblinks","type":"plugin","creationDate":"2017-03-08","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}','','','','0','0000-00-00 00:00:00','5','0'),
('447','0','plg_finder_tags','plugin','tags','finder','0','1','1','0','{"name":"plg_finder_tags","type":"plugin","creationDate":"February 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}','','','','0','0000-00-00 00:00:00','0','0'),
('448','0','plg_twofactorauth_totp','plugin','totp','twofactorauth','0','0','1','0','{"name":"plg_twofactorauth_totp","type":"plugin","creationDate":"August 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"PLG_TWOFACTORAUTH_TOTP_XML_DESCRIPTION","group":"","filename":"totp"}','','','','0','0000-00-00 00:00:00','0','0'),
('449','0','plg_authentication_cookie','plugin','cookie','authentication','0','1','1','0','{"name":"plg_authentication_cookie","type":"plugin","creationDate":"July 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_COOKIE_XML_DESCRIPTION","group":"","filename":"cookie"}','','','','0','0000-00-00 00:00:00','0','0'),
('450','0','plg_twofactorauth_yubikey','plugin','yubikey','twofactorauth','0','0','1','0','{"name":"plg_twofactorauth_yubikey","type":"plugin","creationDate":"September 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"PLG_TWOFACTORAUTH_YUBIKEY_XML_DESCRIPTION","group":"","filename":"yubikey"}','','','','0','0000-00-00 00:00:00','0','0'),
('451','0','plg_search_tags','plugin','tags','search','0','0','1','0','{"name":"plg_search_tags","type":"plugin","creationDate":"March 2014","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}','{"search_limit":"50","show_tagged_items":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('503','0','beez3','template','beez3','','0','1','1','0','{"name":"beez3","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"3.1.0","description":"TPL_BEEZ3_XML_DESCRIPTION","group":"","filename":"templateDetails"}','{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}','','','0','0000-00-00 00:00:00','0','0'),
('504','0','hathor','template','hathor','','1','1','1','0','{"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"3.0.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":"","filename":"templateDetails"}','{"showSiteName":"0","colourChoice":"0","boldText":"0"}','','','0','0000-00-00 00:00:00','0','0'),
('506','0','protostar','template','protostar','','0','1','1','0','{"name":"protostar","type":"template","creationDate":"4\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_PROTOSTAR_XML_DESCRIPTION","group":"","filename":"templateDetails"}','{"templateColor":"","logoFile":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}','','','0','0000-00-00 00:00:00','0','0'),
('507','0','isis','template','isis','','1','1','1','0','{"name":"isis","type":"template","creationDate":"3\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_ISIS_XML_DESCRIPTION","group":"","filename":"templateDetails"}','{"templateColor":"","logoFile":""}','','','0','0000-00-00 00:00:00','0','0'),
('600','802','English (en-GB)','language','en-GB','','0','1','1','1','{"name":"English (en-GB)","type":"language","creationDate":"December 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.3","description":"en-GB site language","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('601','802','English (en-GB)','language','en-GB','','1','1','1','1','{"name":"English (en-GB)","type":"language","creationDate":"December 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.3","description":"en-GB administrator language","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('700','0','files_joomla','file','joomla','','0','1','1','1','{"name":"files_joomla","type":"file","creationDate":"December 2017","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.3","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('10000','0','jm-services','template','jm-services','','0','1','1','0','{"name":"jm-services","type":"template","creationDate":"20\\/12\\/2017","author":"joomla-monster.com","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"contact@joomla-monster.com","authorUrl":"joomla-monster.com","version":"1.05","description":"\\n\\t\\n\\t<div class=\\"jm-description clearfix\\">\\n\\t\\t<div class=\\"pull-left\\" style=\\"max-width: 35.69%;\\">\\n\\t\\t\\t<img style=\\"max-width: 100%; box-sizing: border-box; -webkit-box-sizing: border-box; padding: 10px; background: #fff; border: 1px solid #e1e1e1;\\" src=\\"http:\\/\\/www.joomla-monster.com\\/images\\/templates\\/jmservices.png\\" \\/>\\n\\t\\t<\\/div>\\n\\t\\t<div class=\\"pull-left\\" style=\\"max-width: 64.31%; box-sizing: border-box; -webkit-box-sizing: border-box; padding: 0 30px;\\">\\n\\t\\t\\t<div style=\\"margin-bottom: 20px;\\">\\n\\t\\t\\t\\t<h2 style=\\"font-size: 33px; line-height: 40px; font-weight: 600; color: #393939; margin-top: 0;\\">JM Services<\\/h2>\\n\\t\\t\\t\\t<div style=\\"margin: 20px 0 0;\\">\\n\\t\\t\\t\\t\\t<a style=\\"text-decoration: none !important; outline: none;\\" target=\\"_blank\\" href=\\"https:\\/\\/www.joomla-monster.com\\/documentation\\/template-frameworks\\/ef4-framework\\">\\n\\t\\t\\t\\t\\t\\t<img src=\\"http:\\/\\/joomla-monster.com\\/images\\/templates\\/ef4.png\\" \\/>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div style=\\"margin-bottom: 20px;\\">\\n\\t\\t\\t\\t<a style=\\"text-decoration: none !important; display: block; outline: none;\\" target=\\"_blank\\" href=\\"http:\\/\\/www.joomla-monster.com\\/\\">\\n\\t\\t\\t\\t\\t<img src=\\"http:\\/\\/joomla-monster.com\\/images\\/templates\\/monster.png\\" \\/>\\n\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div style=\\"margin: 0 -20px;\\">\\n\\t\\t\\t\\t<div style=\\"display: inline-block; margin: 0 20px 20px;\\">\\n\\t\\t\\t\\t\\t<span style=\\"display: block; color: #a0a0a0;\\">Templates for Joomla!<\\/span>\\n\\t\\t\\t\\t\\t<a style=\\"font-size: 15px; color: #3ea5ea;\\" target=\\"_blank\\" href=\\"http:\\/\\/www.joomla-monster.com\\">www.joomla-monster.com<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\\t<div style=\\"display: inline-block; margin: 0 20px 20px;\\">\\n\\t\\t\\t\\t\\t<span style=\\"display: block; color: #a0a0a0;\\">Extensions for Joomla!<\\/span>\\n\\t\\t\\t\\t\\t<a style=\\"font-size: 15px; color: #3ea5ea;\\" target=\\"_blank\\" href=\\"http:\\/\\/www.dj-extensions.com\\">www.dj-extensions.com<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\\t<div style=\\"display: inline-block; margin: 0 20px 20px;\\">\\n\\t\\t\\t\\t\\t<span style=\\"display: block; color: #a0a0a0;\\">Custom Joomla! Services<\\/span>\\n\\t\\t\\t\\t\\t<a style=\\"font-size: 15px; color: #3ea5ea;\\" target=\\"_blank\\" href=\\"http:\\/\\/www.design-joomla.eu\\">www.design-joomla.eu<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t\\n\\t","group":"jmf-ef4","filename":"templateDetails"}','{}','','','0','0000-00-00 00:00:00','0','0'),
('10026','0','mod_jm_offcanvas_button','module','mod_jm_offcanvas_button','','0','1','0','0','{"name":"mod_jm_offcanvas_button","type":"module","creationDate":"16\\/02\\/2017","author":"Joomla-Monster.com","copyright":"Copyright (C) 2017 Joomla-Monster.com, All rights reserved.","authorEmail":"artur.kaczmarek@joomla-monster.com","authorUrl":"https:\\/\\/joomla-monster.com","version":"1.02","description":"MOD_JM_OFFCANVAS_BUTTON_DESC","group":"","filename":"mod_jm_offcanvas_button"}','{"icon":"","moduleclass_sfx":" visible-desktop","cache":"1","cache_time":"900","cachemode":"static"}','','','0','0000-00-00 00:00:00','0','0'),
('10002','0','DJ-Menu','module','mod_djmenu','','0','1','0','0','{"name":"DJ-Menu","type":"module","creationDate":"April 2014","author":"DJ-Extensions.com","copyright":"Copyright (C) 2012-2014 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"2.0.2","description":"MOD_DJMENU_MODULE_DESC","group":"","filename":"mod_djmenu"}','{"menu":"mainmenu","endLevel":"0","css":"1","moo":"1","wrapper":"","select":"0","width":"800","height_fx":"1","width_fx":"1","opacity_fx":"1","height_fx_sub":"1","width_fx_sub":"1","opacity_fx_sub":"1","effect":"cubic","duration":"","delay":"","cache":"1","cache_time":"900","cachemode":"itemid"}','','','0','0000-00-00 00:00:00','0','0'),
('10003','10005','com_djimageslider','component','com_djimageslider','','1','1','0','0','{"name":"com_djimageslider","type":"component","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2017 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.2.3","description":"DJ-ImageSlider component","group":""}','{}','','','0','0000-00-00 00:00:00','0','0'),
('10004','10005','DJ-ImageSlider','module','mod_djimageslider','','0','1','0','0','{"name":"DJ-ImageSlider","type":"module","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2017 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.2.3","description":"DJ-ImageSlider Module","group":"","filename":"mod_djimageslider"}','{"slider_source":"0","slider_type":"0","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","show_title":"1","show_desc":"1","show_readmore":"0","readmore_text":"","link_title":"1","link_desc":"0","limit_desc":"","image_width":"240","image_height":"180","fit_to":"0","visible_images":"3","space_between_images":"10","max_images":"20","sort_by":"1","effect":"Expo","autoplay":"1","show_buttons":"1","show_arrows":"1","show_custom_nav":"0","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"","right_arrow":"","play_button":"","pause_button":"","arrows_top":"30","arrows_horizontal":"5","effect_type":"0","duration":"","delay":"","preload":"800","cache":"1","cache_time":"900"}','','','0','0000-00-00 00:00:00','0','0'),
('10005','0','DJ-ImageSlider Package','package','pkg_dj-imageslider','','0','1','1','0','{"name":"DJ-ImageSlider Package","type":"package","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2017 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.2.3","description":"\\n\\t\\t<style type=\\"text\\/css\\">\\n\\t\\t\\t.djex-info { padding: 20px 30px 10px; margin: 0 0 20px 0; background: #ac00d4; color: #fff; border: 1px solid #81009f; font-family: Arial, Helvetica, sans-serif; font-size: 13px; font-weight: normal; -webkit-border-radius: 4px; border-radius: 4px; }\\n\\t\\t\\t.djex-title { text-transform: uppercase; font-weight: bold; font-size: 14px; }\\n\\t\\t\\t.djex-info a:link, .djex-info a:visited, .djex-info a:hover { color:#fff; text-decoration:underline; font-weight: 600; }\\t\\n\\t\\t\\t.djex-info img { float: left; margin: 0 30px 10px 0; }\\n\\t\\t<\\/style>\\n\\t\\t<div class=\\"djex-info\\">\\n\\t\\t\\t<a href=\\"index.php?option=com_djimageslider\\"><img src=\\"components\\/com_djimageslider\\/assets\\/ex_slider.png\\" \\/><\\/a>\\n\\t\\t\\t<p class=\\"djex-title\\">Thank you for installing DJ-ImageSlider!<\\/p>\\n\\t\\t\\t<p>The DJ-ImageSlider extension allows you to display slideshows containing slides with title and short description linked to any menu item, article or custom url address. \\n\\t\\t\\tIf you want to learn how to use DJ-ImageSlider please read <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\/documentation\\">Documentation<\\/a> and <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\/faq\\">FAQ section<\\/a><\\/p>\\n\\t\\t\\t<p>Check out our other extensions at <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\">DJ-Extensions.com<\\/a><\\/p>\\n\\t\\t\\t<div style=\\"clear:both\\"><\\/div>\\n\\t\\t<\\/div>\\n\\t\\t","group":"","filename":"pkg_dj-imageslider"}','{}','','','0','0000-00-00 00:00:00','0','0'),
('801','0','pkg_weblinks','package','pkg_weblinks','','0','1','1','0','{"name":"pkg_weblinks","type":"package","creationDate":"2017-03-08","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.6.0","description":"PKG_WEBLINKS_XML_DESCRIPTION","group":"","filename":"pkg_weblinks"}','','','','0','0000-00-00 00:00:00','0','0'),
('10020','0','plg_system_ef4_jmframework','plugin','ef4_jmframework','system','0','1','1','0','{"name":"plg_system_ef4_jmframework","type":"plugin","creationDate":"14\\/12\\/2017","author":"DJ-Extensions.com LTD","copyright":"Copyright (C) 2010-2017 DJ-Extensions.com LTD, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"4.8.2","description":"PLG_SYSTEM_JMFRAMEWORK_DESC","group":"","filename":"ef4_jmframework"}','','','','0','0000-00-00 00:00:00','0','0'),
('453','0','plg_editors-xtd_module','plugin','module','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_module","type":"plugin","creationDate":"October 2015","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.5.0","description":"PLG_MODULE_XML_DESCRIPTION","group":"","filename":"module"}','','','','0','0000-00-00 00:00:00','0','0'),
('452','0','plg_system_updatenotification','plugin','updatenotification','system','0','1','1','0','{"name":"plg_system_updatenotification","type":"plugin","creationDate":"May 2015","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.5.0","description":"PLG_SYSTEM_UPDATENOTIFICATION_XML_DESCRIPTION","group":"","filename":"updatenotification"}','{"lastrun":1514370958}','','','0','0000-00-00 00:00:00','0','0'),
('454','0','plg_system_stats','plugin','stats','system','0','1','1','0','{"name":"plg_system_stats","type":"plugin","creationDate":"November 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.5.0","description":"PLG_SYSTEM_STATS_XML_DESCRIPTION","group":"","filename":"stats"}','{"mode":3,"lastrun":"","unique_id":"d24856d4b7ea5e05acb40020cf0c342ba3608c7e","interval":12}','','','0','0000-00-00 00:00:00','0','0'),
('10021','0','plg_system_djjquerymonster','plugin','djjquerymonster','system','0','1','1','0','{"name":"plg_system_djjquerymonster","type":"plugin","creationDate":"July 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2017 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"1.3.4","description":"PLG_SYSTEM_DJJQUERYMONSTER_DESCRIPTION","group":"","filename":"djjquerymonster"}','{"jquery":"1","version":"joomla","customver":"","custompath":"","jqueryui":"0","uiversion":"1.9.2","customuiver":"","customuipath":"","uitheme":"smoothness","uithemecustom":"","compression":"1","protocol":"none","protectscripts":"","removescripts":"","remove_mootools":"0","remove_modal":"1","debug":"0"}','','','0','0000-00-00 00:00:00','-1','0');
INSERT INTO `#__extensions` VALUES 
('802','0','English (en-GB) Language Pack','package','pkg_en-GB','','0','1','1','1','{"name":"English (en-GB) Language Pack","type":"package","creationDate":"December 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.3.1","description":"en-GB language pack","group":"","filename":"pkg_en-GB"}','','','','0','0000-00-00 00:00:00','0','0'),
('458','0','plg_quickicon_phpversioncheck','plugin','phpversioncheck','quickicon','0','1','1','1','{"name":"plg_quickicon_phpversioncheck","type":"plugin","creationDate":"August 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_QUICKICON_PHPVERSIONCHECK_XML_DESCRIPTION","group":"","filename":"phpversioncheck"}','','','','0','0000-00-00 00:00:00','0','0'),
('459','0','plg_editors-xtd_menu','plugin','menu','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_menu","type":"plugin","creationDate":"August 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_EDITORS-XTD_MENU_XML_DESCRIPTION","group":"","filename":"menu"}','','','','0','0000-00-00 00:00:00','0','0'),
('33','0','com_fields','component','com_fields','','1','1','1','0','{"name":"com_fields","type":"component","creationDate":"March 2016","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"COM_FIELDS_XML_DESCRIPTION","group":"","filename":"fields"}','','','','0','0000-00-00 00:00:00','0','0'),
('461','0','plg_system_fields','plugin','fields','system','0','1','1','0','{"name":"plg_system_fields","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_SYSTEM_FIELDS_XML_DESCRIPTION","group":"","filename":"fields"}','','','','0','0000-00-00 00:00:00','0','0'),
('462','0','plg_fields_calendar','plugin','calendar','fields','0','1','1','0','{"name":"plg_fields_calendar","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_CALENDAR_XML_DESCRIPTION","group":"","filename":"calendar"}','','','','0','0000-00-00 00:00:00','0','0'),
('463','0','plg_fields_checkboxes','plugin','checkboxes','fields','0','1','1','0','{"name":"plg_fields_checkboxes","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_CHECKBOXES_XML_DESCRIPTION","group":"","filename":"checkboxes"}','','','','0','0000-00-00 00:00:00','0','0'),
('464','0','plg_fields_color','plugin','color','fields','0','1','1','0','{"name":"plg_fields_color","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_COLOR_XML_DESCRIPTION","group":"","filename":"color"}','','','','0','0000-00-00 00:00:00','0','0'),
('465','0','plg_fields_editor','plugin','editor','fields','0','1','1','0','{"name":"plg_fields_editor","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_EDITOR_XML_DESCRIPTION","group":"","filename":"editor"}','','','','0','0000-00-00 00:00:00','0','0'),
('466','0','plg_fields_imagelist','plugin','imagelist','fields','0','1','1','0','{"name":"plg_fields_imagelist","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_IMAGELIST_XML_DESCRIPTION","group":"","filename":"imagelist"}','','','','0','0000-00-00 00:00:00','0','0'),
('467','0','plg_fields_integer','plugin','integer','fields','0','1','1','0','{"name":"plg_fields_integer","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_INTEGER_XML_DESCRIPTION","group":"","filename":"integer"}','{"multiple":"0","first":"1","last":"100","step":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('468','0','plg_fields_list','plugin','list','fields','0','1','1','0','{"name":"plg_fields_list","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_LIST_XML_DESCRIPTION","group":"","filename":"list"}','','','','0','0000-00-00 00:00:00','0','0'),
('469','0','plg_fields_media','plugin','media','fields','0','1','1','0','{"name":"plg_fields_media","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_MEDIA_XML_DESCRIPTION","group":"","filename":"media"}','','','','0','0000-00-00 00:00:00','0','0'),
('470','0','plg_fields_radio','plugin','radio','fields','0','1','1','0','{"name":"plg_fields_radio","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_RADIO_XML_DESCRIPTION","group":"","filename":"radio"}','','','','0','0000-00-00 00:00:00','0','0'),
('471','0','plg_fields_sql','plugin','sql','fields','0','1','1','0','{"name":"plg_fields_sql","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_SQL_XML_DESCRIPTION","group":"","filename":"sql"}','','','','0','0000-00-00 00:00:00','0','0'),
('472','0','plg_fields_text','plugin','text','fields','0','1','1','0','{"name":"plg_fields_text","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_TEXT_XML_DESCRIPTION","group":"","filename":"text"}','','','','0','0000-00-00 00:00:00','0','0'),
('473','0','plg_fields_textarea','plugin','textarea','fields','0','1','1','0','{"name":"plg_fields_textarea","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_TEXTAREA_XML_DESCRIPTION","group":"","filename":"textarea"}','','','','0','0000-00-00 00:00:00','0','0'),
('474','0','plg_fields_url','plugin','url','fields','0','1','1','0','{"name":"plg_fields_url","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_URL_XML_DESCRIPTION","group":"","filename":"url"}','','','','0','0000-00-00 00:00:00','0','0'),
('475','0','plg_fields_user','plugin','user','fields','0','1','1','0','{"name":"plg_fields_user","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_USER_XML_DESCRIPTION","group":"","filename":"user"}','','','','0','0000-00-00 00:00:00','0','0'),
('476','0','plg_fields_usergrouplist','plugin','usergrouplist','fields','0','1','1','0','{"name":"plg_fields_usergrouplist","type":"plugin","creationDate":"March 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_FIELDS_USERGROUPLIST_XML_DESCRIPTION","group":"","filename":"usergrouplist"}','','','','0','0000-00-00 00:00:00','0','0'),
('460','0','plg_editors-xtd_contact','plugin','contact','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_contact","type":"plugin","creationDate":"October 2016","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_EDITORS-XTD_CONTACT_XML_DESCRIPTION","group":"","filename":"contact"}','','','','0','0000-00-00 00:00:00','0','0'),
('34','0','com_associations','component','com_associations','','1','1','1','0','{"name":"com_associations","type":"component","creationDate":"Januar 2017","author":"Joomla! Project","copyright":"(C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"COM_ASSOCIATIONS_XML_DESCRIPTION","group":""}','','','','0','0000-00-00 00:00:00','0','0'),
('477','0','plg_content_fields','plugin','fields','content','0','1','1','0','{"name":"plg_content_fields","type":"plugin","creationDate":"February 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_CONTENT_FIELDS_XML_DESCRIPTION","group":"","filename":"fields"}','','','','0','0000-00-00 00:00:00','0','0'),
('478','0','plg_editors-xtd_fields','plugin','fields','editors-xtd','0','1','1','0','{"name":"plg_editors-xtd_fields","type":"plugin","creationDate":"February 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.7.0","description":"PLG_EDITORS-XTD_FIELDS_XML_DESCRIPTION","group":"","filename":"fields"}','','','','0','0000-00-00 00:00:00','0','0'),
('318','0','mod_sampledata','module','mod_sampledata','','1','0','1','0','{"name":"mod_sampledata","type":"module","creationDate":"July 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.0","description":"MOD_SAMPLEDATA_XML_DESCRIPTION","group":"","filename":"mod_sampledata"}','{}','','','0','0000-00-00 00:00:00','0','0'),
('479','0','plg_sampledata_blog','plugin','blog','sampledata','0','0','1','0','{"name":"plg_sampledata_blog","type":"plugin","creationDate":"July 2017","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.8.0","description":"PLG_SAMPLEDATA_BLOG_XML_DESCRIPTION","group":"","filename":"blog"}','','','','0','0000-00-00 00:00:00','0','0'),
('10022','10025','plg_system_djmegamenu','plugin','djmegamenu','system','0','1','1','0','{"name":"plg_system_djmegamenu","type":"plugin","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2013-2016 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.5.0","description":"PLG_SYSTEM_DJMEGAMENU_DESCRIPTION","group":"","filename":"djmegamenu"}','{"wrappers":"1"}','','','0','0000-00-00 00:00:00','0','0'),
('10023','10025','DJ-MegaMenu','module','mod_djmegamenu','','0','1','0','0','{"name":"DJ-MegaMenu","type":"module","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2012-2016 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.5.4","description":"MOD_DJMEGAMENU_LIGHT_MODULE_DESC","group":"","filename":"mod_djmegamenu"}','{"menu":"mainmenu","startLevel":"1","endLevel":"0","icons":"2","subtitles":"2","usenote":"1","fa":"1","theme":"default","megabg":"#383838","megacolor":"#ffffff","megastcolor":"#999999","megabg_a":"#1681d1","megacolor_a":"#ffffff","megastcolor_a":"#a4c4f5","megasubbg":"#303030","megasubcolor":"#c3c3c3","megasubstcolor":"#666666","megasubbg_a":"#1681d1","megasubcolor_a":"#ffffff","megasubstcolor_a":"#a4c4f5","megamodcolor":"#d2d2d2","expand":"dropdown","dropdown_dir":"","column_width":"200","percent_width":"25","moo":"1","animation_in":"fadeInUp","animation_out":"zoomOut","animation_speed":"normal","openDelay":"250","closeDelay":"500","event":"mouseenter","wrapper":"","fixed":"0","fixed_offset":"0","fixed_logo":"","fixed_logo_align":"right","wcag":"1","select":"0","mobiletheme":"dark","width":"979","mobilebtnbg":"#434343","mobilebtncolor":"#e4e4e4","mobilebg":"#393939","mobilecolor":"#f8f8f8","mobilestcolor":"#888888","mobilebg_a":"#333333","mobilecolor_a":"#ffffff","mobilestcolor_a":"#aaaaaa","mobilesubbg":"#333333","mobilesubcolor":"#aeaeae","mobilesubstcolor":"#666666","mobilesubbg_a":"#2e2e2e","mobilesubcolor_a":"#e4e4e4","mobilesubstcolor_a":"#888888","mobilemodcolor":"#aeaeae","select_type":"button","accordion_pos":"static","accordion_align":"right","offcanvas_logo":"","offcanvas_pos":"left","offcanvas_effect":"3","offcanvas_topmod_style":"System-xhtml","offcanvas_botmod_style":"System-xhtml","accordion_collapsed":"0","cache":"1","cache_time":"900","cachemode":"itemid"}','','','0','0000-00-00 00:00:00','0','0'),
('10024','10025','DJ-MegaMenu - Mobile Menu Button','module','mod_djmegamenu_button','','0','1','0','0','{"name":"DJ-MegaMenu - Mobile Menu Button","type":"module","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2015 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"1.0.1","description":"Place the Mobile Menu Button in any module position of your template.","group":"","filename":"mod_djmegamenu_button"}','{"module":""}','','','0','0000-00-00 00:00:00','0','0'),
('10025','0','DJ-MegaMenu Light Package','package','pkg_dj-megamenu','','0','1','1','0','{"name":"DJ-MegaMenu Light Package","type":"package","creationDate":"August 2017","author":"DJ-Extensions.com","copyright":"Copyright (C) 2017 DJ-Extensions.com, All rights reserved.","authorEmail":"contact@dj-extensions.com","authorUrl":"http:\\/\\/dj-extensions.com","version":"3.5.4","description":"\\n\\t\\t<style type=\\"text\\/css\\">\\n\\t\\t\\t.djex-info { padding: 20px 30px 10px; margin: 0 0 20px 0; background: #5c14a6; color: #fff; border: 1px solid #400e74; font-family: Arial, Helvetica, sans-serif; font-size: 13px; font-weight: normal; -webkit-border-radius: 4px; border-radius: 4px; }\\n\\t\\t\\t.djex-title { text-transform: uppercase; font-weight: bold; font-size: 14px; }\\n\\t\\t\\t.djex-info a:link, .djex-info a:visited, .djex-info a:hover { color:#fff; text-decoration:underline; font-weight: 600; }\\t\\n\\t\\t\\t.djex-info img { float: left; margin: 0 30px 10px 0; }\\n\\t\\t<\\/style>\\n\\t\\t<div class=\\"djex-info\\">\\n\\t\\t\\t<img src=\\"..\\/modules\\/mod_djmegamenu\\/assets\\/images\\/ex_megamenu.png\\" \\/>\\n\\t\\t\\t<p class=\\"djex-title\\">Thank you for installing DJ-MegaMenu Ligth Edition!<\\/p>\\n\\t\\t\\t<p>The DJ-MegaMenu is an advanced menu system for your Joomla! and it\'s ready for mobiles providing Offcanvas Menu, Acordion Menu or simple Select Menu opened with well know mobile menu icon.\\n\\t\\t\\tIf you want to learn how to use DJ-MegaMenu please read <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\/documentation\\">Documentation<\\/a> and visit our <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\/faq\\">FAQ Section<\\/a><\\/p>\\n\\t\\t\\t<p>Check out our other extensions at <a target=\\"_blank\\" href=\\"http:\\/\\/dj-extensions.com\\">DJ-Extensions.com<\\/a><\\/p>\\n\\t\\t\\t<div style=\\"clear:both\\"><\\/div>\\n\\t\\t<\\/div>\\n\\t\\t","group":"","filename":"pkg_dj-megamenu"}','{}','','','0','0000-00-00 00:00:00','0','0');

DROP TABLE IF EXISTS #__fields;
CREATE TABLE `#__fields` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  `context` varchar(255) NOT NULL DEFAULT '',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `name` varchar(255) NOT NULL DEFAULT '',
  `label` varchar(255) NOT NULL DEFAULT '',
  `default_value` text NOT NULL,
  `type` varchar(255) NOT NULL DEFAULT 'text',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `required` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `fieldparams` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_created_user_id` (`created_user_id`),
  KEY `idx_access` (`access`),
  KEY `idx_context` (`context`(191)),
  KEY `idx_language` (`language`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__fields_categories;
CREATE TABLE `#__fields_categories` (
  `field_id` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`field_id`,`category_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__fields_groups;
CREATE TABLE `#__fields_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  `context` varchar(255) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_created_by` (`created_by`),
  KEY `idx_access` (`access`),
  KEY `idx_context` (`context`(191)),
  KEY `idx_language` (`language`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__fields_values;
CREATE TABLE `#__fields_values` (
  `field_id` int(10) unsigned NOT NULL,
  `item_id` varchar(255) NOT NULL COMMENT 'Allow references to items which have strings as ids, eg. none db systems.',
  `value` text NOT NULL,
  KEY `idx_field_id` (`field_id`),
  KEY `idx_item_id` (`item_id`(191))
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_filters;
CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` mediumtext NOT NULL,
  `params` longtext,
  PRIMARY KEY (`filter_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_links;
CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(400) DEFAULT NULL,
  `description` text,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`),
  KEY `idx_title` (`title`(100))
) AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links` VALUES 
('8','index.php?option=com_content&view=article&id=87','index.php?option=com_content&view=article&id=87:typography&catid=78','Typography',' Image Borders Headings This is Heading One (h1) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Two (h2) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Three (h3) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Four (h4) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Five (h5) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Six (h6) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. Numered blocks 01 Text goes here 01 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodalestellus. Aenean quis sapien suscipit mauris. 02 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. 03 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. a Text goes here a Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. b Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. c Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. Colored Blocks Text goes here Text goes here Text goes here Text goes here Icon blocks Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Blockquote Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsumdolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Unordered lists Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Ordered lists Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum  Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Read More Button Read more Read more Glyphicon Font &nbsp icon-asterisk icon-plus icon-euro icon-minus icon-cloud icon-envelope icon-pencil icon-glass icon-music icon-search icon-heart icon-star icon-star-empty icon-user icon-film icon-th-large icon-th icon-th-list icon-ok icon-remove icon-zoom-in icon-zoom-out icon-off icon-signal icon-cog icon-trash icon-home icon-file icon-time icon-road icon-download-alt icon-download icon-upload icon-inbox icon-play-circle icon-repeat icon-refresh icon-list-alt icon-lock icon-flag icon-headphones icon-volume-off icon-volume-down icon-volume-up icon-qrcode icon-barcode icon-tag icon-tags icon-book icon-bookmark icon-print icon-camera icon-font icon-bold icon-italic icon-text-height icon-text-width icon-align-left icon-align-center icon-align-right icon-align-justify icon-list icon-indent-left icon-indent-right icon-facetime-video icon-picture icon-map-marker icon-adjust icon-tint icon-edit icon-share icon-check icon-move icon-step-backward icon-fast-backward icon-backward icon-play icon-pause icon-stop icon-forward icon-fast-forward icon-step-forward icon-eject icon-chevron-left icon-chevron-right icon-plus-sign icon-minus-sign icon-remove-sign icon-ok-sign icon-question-sign icon-info-sign icon-screenshot icon-remove-circle icon-ok-circle icon-ban-circle icon-arrow-left icon-arrow-right icon-arrow-up icon-arrow-down icon-share-alt icon-resize-full icon-resize-small icon-exclamation-sign icon-gift icon-leaf icon-fire icon-eye-open icon-eye-close icon-warning-sign icon-plane icon-calendar icon-random icon-comment icon-magnet icon-chevron-up icon-chevron-down icon-retweet icon-shopping-cart icon-folder-close icon-folder-open icon-resize-vertical icon-resize-horizontal icon-hdd icon-bullhorn icon-bell icon-certificate icon-thumbs-up icon-thumbs-down icon-hand-right icon-hand-left icon-hand-up icon-hand-down icon-circle-arrow-right icon-circle-arrow-left icon-circle-arrow-up icon-circle-arrow-down icon-globe icon-wrench icon-tasks icon-filter icon-briefcase icon-fullscreen icon-dashboard icon-paperclip icon-heart-empty icon-link icon-phone icon-pushpin icon-usd icon-gbp icon-sort icon-sort-by-alphabet icon-sort-by-alphabet-alt icon-sort-by-order icon-sort-by-order-alt icon-sort-by-attributes icon-sort-by-attributes-alt icon-unchecked icon-expand icon-collapse-down icon-collapse-up icon-log-in icon-flash icon-log-out icon-new-window icon-record icon-save icon-open icon-saved icon-import icon-export icon-send icon-floppy-disk icon-floppy-saved icon-floppy-remove icon-floppy-save icon-floppy-open icon-credit-card icon-transfer icon-cutlery icon-header icon-compressed icon-earphone icon-phone-alt icon-tower icon-stats icon-sd-video icon-hd-video icon-subtitles icon-sound-stereo icon-sound-dolby icon-sound-5-1 icon-sound-6-1 icon-sound-7-1 icon-copyright-mark icon-registration-mark icon-cloud-download icon-cloud-upload icon-tree-conifer icon-tree-deciduous Top Contact Module Peterborough, UK Email +44 7837 383 484 Peterborough, UK Email +44 7837 383 484 Color Boxes TIME MACHINE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. TIME MACHINE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ANALYTICS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ANALYTICS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. WORLDWIDE SERVICE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. WORLDWIDE SERVICE Lorem ipsum dolor sit amet,consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Just Few Words Module JUST FEW WORDS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore. Ut enim ad minim veniam, quis nostrud Exercitation ullamco laboris nisi Ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit read more JUST FEW WORDS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore. Ut enim ad minim veniam, quis nostrud Exercitation ullamco laboris nisi Ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit read more Social Module Our Cooks Module Greg Amaro Consectetur adipisicing elit sed do eimod tempor. Jimmy Gessler Consectetur adipisicing elit sed do eimod tempor. Greg Amaro Consectetur adipisicing elit sed do eimod tempor. Jimmy Gessler Consectetur adipisicing elit sed do eimod tempor. ','2017-12-27 12:36:39','8add74670141bd01416ba3ed3de869e8','1','0','1','*','2014-05-14 12:40:26','0000-00-00 00:00:00','2014-05-14 12:40:26','0000-00-00 00:00:00','0','0','4','O:19:"FinderIndexerResult":19:{s:11:"\0*\0elements";a:25:{s:2:"id";s:2:"87";s:5:"alias";s:10:"typography";s:7:"summary";s:37401:"<h3 class="jm-typo-title">Image Borders</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;img class="img-rounded" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-rounded" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n<p></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;img class="img-circle" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-circle" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n<p></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;img class="img-polaroid" src="image.jpg" /&gt;</pre>\r\n<div style="text-align: center;"><img class="img-polaroid" src="images/bootstrap_sample/sample140x140.png" alt="Typography" border="0" /></div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Headings</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<h1>This is Heading One (h1)</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h2>This is Heading Two (h2)</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h3>This is Heading Three (h3)</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n<div class="span6">\r\n<h4>This is Heading Four (h4)</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h5>This is Heading Five (h5)</h5>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h6>This is Heading Six (h6)</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Numered blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<pre>&lt;p class="jm-block"&gt;&lt;span class="jm"&gt;01&lt;/span&gt;Text goes here&lt;/p&gt;</pre>\r\n<p class="jm-block"><span class="jm">01</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block"><span class="jm">02</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block"><span class="jm">03</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n<div class="span6">\r\n<pre>&lt;p class="jm-block second"&gt;&lt;span class="jm"&gt;a&lt;/span&gt;Text goes here&lt;/p&gt;</pre>\r\n<p class="jm-block second"><span class="jm">a</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block second"><span class="jm">b</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class="jm-block second"><span class="jm">c</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Colored Blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<div class="alert">&lt;div class="alert"&gt;Text goes here&lt;/div&gt;</div>\r\n<div class="alert alert-error">&lt;div class="alert alert-error"&gt;Text goes here&lt;/div&gt;</div>\r\n</div>\r\n<div class="span6">\r\n<div class="alert alert-success">&lt;div class="alert alert-success"&gt;Text goes here&lt;/div&gt;</div>\r\n<div class="alert alert-info">&lt;div class="alert alert-info"&gt;Text goes here&lt;/div&gt;</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Icon blocks</h3>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<p class="jm-badge">&lt;p class="jm-badge" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-calendar">&lt;p class="jm-calendar" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-chat">&lt;p class="jm-chat" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-check">&lt;p class="jm-check" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-cloud">&lt;p class="jm-cloud" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-direction">&lt;p class="jm-direction" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-divide">&lt;p class="jm-divide" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-error">&lt;p class="jm-error" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-fire">&lt;p class="jm-fire" &gt;Text goes here&lt;/p&gt;</p>\r\n</div>\r\n<div class="span6">\r\n<p class="jm-flag">&lt;p class="jm-flag" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-heart">&lt;p class="jm-heart" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-home">&lt;p class="jm-home" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-info">&lt;p class="jm-info" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-list">&lt;p class="jm-list" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-mail">&lt;p class="jm-mail" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-people">&lt;p class="jm-people" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-star">&lt;p class="jm-star" &gt;Text goes here&lt;/p&gt;</p>\r\n<p class="jm-stat">&lt;p class="jm-stat" &gt;Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Blockquote</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;blockquote&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;/p&gt;<br />&lt;small&gt;John Doe&lt;/small&gt;<br />&lt;/blockquote&gt;</pre>\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n<small>John Doe</small></blockquote>\r\n</div>\r\n<div class="span12">\r\n<pre>&lt;blockquote class="pull-right"&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;/p&gt;<br />&lt;small&gt;John Doe&lt;/small&gt;<br />&lt;/blockquote&gt;</pre>\r\n<blockquote class="pull-right">\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n<small>John Doe</small></blockquote>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Unordered lists</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;ul&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ul class="jm-color-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-color-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ul class="jm-light-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-light-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<pre>&lt;ul class="jm-custom-list"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-custom-list">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n<div class="span6">\r\n<pre>&lt;ul class="jm-custom-list green"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-custom-list green">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Ordered lists</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;ol&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ol class="jm-roman"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol class="jm-roman">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;ol class="jm-alpha"&gt;<br />&lt;-- list goes here --&gt;<br />&lt;/ol&gt;</pre>\r\n<ol class="jm-alpha">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</li>\r\n</ol>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Read More Button</h3>\r\n<pre>&lt;p class="readmore"&gt;&lt;a class="btn" href="#"&gt;Read more&lt;/a&gt;&lt;/p&gt;</pre>\r\n<p class="readmore"><a class="btn" href="#">Read more</a></p>\r\n<h3 class="jm-typo-title">Glyphicon Font</h3>\r\n<div>\r\n<pre>&lt;span class="icon-joomla"&gt;&amp;nbsp&lt;/span&gt;</pre>\r\n</div>\r\n<div class="row-fluid">\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-asterisk"> </span> icon-asterisk</div>\r\n<div style="padding: 2px 0;"><span class="icon-plus"> </span> icon-plus</div>\r\n<div style="padding: 2px 0;"><span class="icon-euro"> </span> icon-euro</div>\r\n<div style="padding: 2px 0;"><span class="icon-minus"> </span> icon-minus</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud"> </span> icon-cloud</div>\r\n<div style="padding: 2px 0;"><span class="icon-envelope"> </span> icon-envelope</div>\r\n<div style="padding: 2px 0;"><span class="icon-pencil"> </span> icon-pencil</div>\r\n<div style="padding: 2px 0;"><span class="icon-glass"> </span> icon-glass</div>\r\n<div style="padding: 2px 0;"><span class="icon-music"> </span> icon-music</div>\r\n<div style="padding: 2px 0;"><span class="icon-search"> </span> icon-search</div>\r\n<div style="padding: 2px 0;"><span class="icon-heart"> </span> icon-heart</div>\r\n<div style="padding: 2px 0;"><span class="icon-star"> </span> icon-star</div>\r\n<div style="padding: 2px 0;"><span class="icon-star-empty"> </span> icon-star-empty</div>\r\n<div style="padding: 2px 0;"><span class="icon-user"> </span> icon-user</div>\r\n<div style="padding: 2px 0;"><span class="icon-film"> </span> icon-film</div>\r\n<div style="padding: 2px 0;"><span class="icon-th-large"> </span> icon-th-large</div>\r\n<div style="padding: 2px 0;"><span class="icon-th"> </span> icon-th</div>\r\n<div style="padding: 2px 0;"><span class="icon-th-list"> </span> icon-th-list</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok"> </span> icon-ok</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove"> </span> icon-remove</div>\r\n<div style="padding: 2px 0;"><span class="icon-zoom-in"> </span> icon-zoom-in</div>\r\n<div style="padding: 2px 0;"><span class="icon-zoom-out"> </span> icon-zoom-out</div>\r\n<div style="padding: 2px 0;"><span class="icon-off"> </span> icon-off</div>\r\n<div style="padding: 2px 0;"><span class="icon-signal"> </span> icon-signal</div>\r\n<div style="padding: 2px 0;"><span class="icon-cog"> </span> icon-cog</div>\r\n<div style="padding: 2px 0;"><span class="icon-trash"> </span> icon-trash</div>\r\n<div style="padding: 2px 0;"><span class="icon-home"> </span> icon-home</div>\r\n<div style="padding: 2px 0;"><span class="icon-file"> </span> icon-file</div>\r\n<div style="padding: 2px 0;"><span class="icon-time"> </span> icon-time</div>\r\n<div style="padding: 2px 0;"><span class="icon-road"> </span> icon-road</div>\r\n<div style="padding: 2px 0;"><span class="icon-download-alt"> </span> icon-download-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-download"> </span> icon-download</div>\r\n<div style="padding: 2px 0;"><span class="icon-upload"> </span> icon-upload</div>\r\n<div style="padding: 2px 0;"><span class="icon-inbox"> </span> icon-inbox</div>\r\n<div style="padding: 2px 0;"><span class="icon-play-circle"> </span> icon-play-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-repeat"> </span> icon-repeat</div>\r\n<div style="padding: 2px 0;"><span class="icon-refresh"> </span> icon-refresh</div>\r\n<div style="padding: 2px 0;"><span class="icon-list-alt"> </span> icon-list-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-lock"> </span> icon-lock</div>\r\n<div style="padding: 2px 0;"><span class="icon-flag"> </span> icon-flag</div>\r\n<div style="padding: 2px 0;"><span class="icon-headphones"> </span> icon-headphones</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-off"> </span> icon-volume-off</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-down"> </span> icon-volume-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-volume-up"> </span> icon-volume-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-qrcode"> </span> icon-qrcode</div>\r\n<div style="padding: 2px 0;"><span class="icon-barcode"> </span> icon-barcode</div>\r\n<div style="padding: 2px 0;"><span class="icon-tag"> </span> icon-tag</div>\r\n<div style="padding: 2px 0;"><span class="icon-tags"> </span> icon-tags</div>\r\n<div style="padding: 2px 0;"><span class="icon-book"> </span> icon-book</div>\r\n<div style="padding: 2px 0;"><span class="icon-bookmark"> </span> icon-bookmark</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-print"> </span> icon-print</div>\r\n<div style="padding: 2px 0;"><span class="icon-camera"> </span> icon-camera</div>\r\n<div style="padding: 2px 0;"><span class="icon-font"> </span> icon-font</div>\r\n<div style="padding: 2px 0;"><span class="icon-bold"> </span> icon-bold</div>\r\n<div style="padding: 2px 0;"><span class="icon-italic"> </span> icon-italic</div>\r\n<div style="padding: 2px 0;"><span class="icon-text-height"> </span> icon-text-height</div>\r\n<div style="padding: 2px 0;"><span class="icon-text-width"> </span> icon-text-width</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-left"> </span> icon-align-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-center"> </span> icon-align-center</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-right"> </span> icon-align-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-align-justify"> </span> icon-align-justify</div>\r\n<div style="padding: 2px 0;"><span class="icon-list"> </span> icon-list</div>\r\n<div style="padding: 2px 0;"><span class="icon-indent-left"> </span> icon-indent-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-indent-right"> </span> icon-indent-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-facetime-video"> </span> icon-facetime-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-picture"> </span> icon-picture</div>\r\n<div style="padding: 2px 0;"><span class="icon-map-marker"> </span> icon-map-marker</div>\r\n<div style="padding: 2px 0;"><span class="icon-adjust"> </span> icon-adjust</div>\r\n<div style="padding: 2px 0;"><span class="icon-tint"> </span> icon-tint</div>\r\n<div style="padding: 2px 0;"><span class="icon-edit"> </span> icon-edit</div>\r\n<div style="padding: 2px 0;"><span class="icon-share"> </span> icon-share</div>\r\n<div style="padding: 2px 0;"><span class="icon-check"> </span> icon-check</div>\r\n<div style="padding: 2px 0;"><span class="icon-move"> </span> icon-move</div>\r\n<div style="padding: 2px 0;"><span class="icon-step-backward"> </span> icon-step-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-fast-backward"> </span> icon-fast-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-backward"> </span> icon-backward</div>\r\n<div style="padding: 2px 0;"><span class="icon-play"> </span> icon-play</div>\r\n<div style="padding: 2px 0;"><span class="icon-pause"> </span> icon-pause</div>\r\n<div style="padding: 2px 0;"><span class="icon-stop"> </span> icon-stop</div>\r\n<div style="padding: 2px 0;"><span class="icon-forward"> </span> icon-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-fast-forward"> </span> icon-fast-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-step-forward"> </span> icon-step-forward</div>\r\n<div style="padding: 2px 0;"><span class="icon-eject"> </span> icon-eject</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-left"> </span> icon-chevron-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-right"> </span> icon-chevron-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-plus-sign"> </span> icon-plus-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-minus-sign"> </span> icon-minus-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove-sign"> </span> icon-remove-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok-sign"> </span> icon-ok-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-question-sign"> </span> icon-question-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-info-sign"> </span> icon-info-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-screenshot"> </span> icon-screenshot</div>\r\n<div style="padding: 2px 0;"><span class="icon-remove-circle"> </span> icon-remove-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-ok-circle"> </span> icon-ok-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-ban-circle"> </span> icon-ban-circle</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-left"> </span> icon-arrow-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-right"> </span> icon-arrow-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-up"> </span> icon-arrow-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-arrow-down"> </span> icon-arrow-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-share-alt"> </span> icon-share-alt</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-resize-full"> </span> icon-resize-full</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-small"> </span> icon-resize-small</div>\r\n<div style="padding: 2px 0;"><span class="icon-exclamation-sign"> </span> icon-exclamation-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-gift"> </span> icon-gift</div>\r\n<div style="padding: 2px 0;"><span class="icon-leaf"> </span> icon-leaf</div>\r\n<div style="padding: 2px 0;"><span class="icon-fire"> </span> icon-fire</div>\r\n<div style="padding: 2px 0;"><span class="icon-eye-open"> </span> icon-eye-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-eye-close"> </span> icon-eye-close</div>\r\n<div style="padding: 2px 0;"><span class="icon-warning-sign"> </span> icon-warning-sign</div>\r\n<div style="padding: 2px 0;"><span class="icon-plane"> </span> icon-plane</div>\r\n<div style="padding: 2px 0;"><span class="icon-calendar"> </span> icon-calendar</div>\r\n<div style="padding: 2px 0;"><span class="icon-random"> </span> icon-random</div>\r\n<div style="padding: 2px 0;"><span class="icon-comment"> </span> icon-comment</div>\r\n<div style="padding: 2px 0;"><span class="icon-magnet"> </span> icon-magnet</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-up"> </span> icon-chevron-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-chevron-down"> </span> icon-chevron-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-retweet"> </span> icon-retweet</div>\r\n<div style="padding: 2px 0;"><span class="icon-shopping-cart"> </span> icon-shopping-cart</div>\r\n<div style="padding: 2px 0;"><span class="icon-folder-close"> </span> icon-folder-close</div>\r\n<div style="padding: 2px 0;"><span class="icon-folder-open"> </span> icon-folder-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-vertical"> </span> icon-resize-vertical</div>\r\n<div style="padding: 2px 0;"><span class="icon-resize-horizontal"> </span> icon-resize-horizontal</div>\r\n<div style="padding: 2px 0;"><span class="icon-hdd"> </span> icon-hdd</div>\r\n<div style="padding: 2px 0;"><span class="icon-bullhorn"> </span> icon-bullhorn</div>\r\n<div style="padding: 2px 0;"><span class="icon-bell"> </span> icon-bell</div>\r\n<div style="padding: 2px 0;"><span class="icon-certificate"> </span> icon-certificate</div>\r\n<div style="padding: 2px 0;"><span class="icon-thumbs-up"> </span> icon-thumbs-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-thumbs-down"> </span> icon-thumbs-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-right"> </span> icon-hand-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-left"> </span> icon-hand-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-up"> </span> icon-hand-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-hand-down"> </span> icon-hand-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-right"> </span> icon-circle-arrow-right</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-left"> </span> icon-circle-arrow-left</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-up"> </span> icon-circle-arrow-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-circle-arrow-down"> </span> icon-circle-arrow-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-globe"> </span> icon-globe</div>\r\n<div style="padding: 2px 0;"><span class="icon-wrench"> </span> icon-wrench</div>\r\n<div style="padding: 2px 0;"><span class="icon-tasks"> </span> icon-tasks</div>\r\n<div style="padding: 2px 0;"><span class="icon-filter"> </span> icon-filter</div>\r\n<div style="padding: 2px 0;"><span class="icon-briefcase"> </span> icon-briefcase</div>\r\n<div style="padding: 2px 0;"><span class="icon-fullscreen"> </span> icon-fullscreen</div>\r\n<div style="padding: 2px 0;"><span class="icon-dashboard"> </span> icon-dashboard</div>\r\n<div style="padding: 2px 0;"><span class="icon-paperclip"> </span> icon-paperclip</div>\r\n<div style="padding: 2px 0;"><span class="icon-heart-empty"> </span> icon-heart-empty</div>\r\n<div style="padding: 2px 0;"><span class="icon-link"> </span> icon-link</div>\r\n<div style="padding: 2px 0;"><span class="icon-phone"> </span> icon-phone</div>\r\n<div style="padding: 2px 0;"><span class="icon-pushpin"> </span> icon-pushpin</div>\r\n<div style="padding: 2px 0;"><span class="icon-usd"> </span> icon-usd</div>\r\n<div style="padding: 2px 0;"><span class="icon-gbp"> </span> icon-gbp</div>\r\n</div>\r\n<div class="span3">\r\n<div style="padding: 2px 0;"><span class="icon-sort"> </span> icon-sort</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-alphabet"> </span> icon-sort-by-alphabet</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-alphabet-alt"> </span> icon-sort-by-alphabet-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-order"> </span> icon-sort-by-order</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-order-alt"> </span> icon-sort-by-order-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-attributes"> </span> icon-sort-by-attributes</div>\r\n<div style="padding: 2px 0;"><span class="icon-sort-by-attributes-alt"> </span> icon-sort-by-attributes-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-unchecked"> </span> icon-unchecked</div>\r\n<div style="padding: 2px 0;"><span class="icon-expand"> </span> icon-expand</div>\r\n<div style="padding: 2px 0;"><span class="icon-collapse-down"> </span> icon-collapse-down</div>\r\n<div style="padding: 2px 0;"><span class="icon-collapse-up"> </span> icon-collapse-up</div>\r\n<div style="padding: 2px 0;"><span class="icon-log-in"> </span> icon-log-in</div>\r\n<div style="padding: 2px 0;"><span class="icon-flash"> </span> icon-flash</div>\r\n<div style="padding: 2px 0;"><span class="icon-log-out"> </span> icon-log-out</div>\r\n<div style="padding: 2px 0;"><span class="icon-new-window"> </span> icon-new-window</div>\r\n<div style="padding: 2px 0;"><span class="icon-record"> </span> icon-record</div>\r\n<div style="padding: 2px 0;"><span class="icon-save"> </span> icon-save</div>\r\n<div style="padding: 2px 0;"><span class="icon-open"> </span> icon-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-saved"> </span> icon-saved</div>\r\n<div style="padding: 2px 0;"><span class="icon-import"> </span> icon-import</div>\r\n<div style="padding: 2px 0;"><span class="icon-export"> </span> icon-export</div>\r\n<div style="padding: 2px 0;"><span class="icon-send"> </span> icon-send</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-disk"> </span> icon-floppy-disk</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-saved"> </span> icon-floppy-saved</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-remove"> </span> icon-floppy-remove</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-save"> </span> icon-floppy-save</div>\r\n<div style="padding: 2px 0;"><span class="icon-floppy-open"> </span> icon-floppy-open</div>\r\n<div style="padding: 2px 0;"><span class="icon-credit-card"> </span> icon-credit-card</div>\r\n<div style="padding: 2px 0;"><span class="icon-transfer"> </span> icon-transfer</div>\r\n<div style="padding: 2px 0;"><span class="icon-cutlery"> </span> icon-cutlery</div>\r\n<div style="padding: 2px 0;"><span class="icon-header"> </span> icon-header</div>\r\n<div style="padding: 2px 0;"><span class="icon-compressed"> </span> icon-compressed</div>\r\n<div style="padding: 2px 0;"><span class="icon-earphone"> </span> icon-earphone</div>\r\n<div style="padding: 2px 0;"><span class="icon-phone-alt"> </span> icon-phone-alt</div>\r\n<div style="padding: 2px 0;"><span class="icon-tower"> </span> icon-tower</div>\r\n<div style="padding: 2px 0;"><span class="icon-stats"> </span> icon-stats</div>\r\n<div style="padding: 2px 0;"><span class="icon-sd-video"> </span> icon-sd-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-hd-video"> </span> icon-hd-video</div>\r\n<div style="padding: 2px 0;"><span class="icon-subtitles"> </span> icon-subtitles</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-stereo"> </span> icon-sound-stereo</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-dolby"> </span> icon-sound-dolby</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-5-1"> </span> icon-sound-5-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-6-1"> </span> icon-sound-6-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-sound-7-1"> </span> icon-sound-7-1</div>\r\n<div style="padding: 2px 0;"><span class="icon-copyright-mark"> </span> icon-copyright-mark</div>\r\n<div style="padding: 2px 0;"><span class="icon-registration-mark"> </span> icon-registration-mark</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud-download"> </span> icon-cloud-download</div>\r\n<div style="padding: 2px 0;"><span class="icon-cloud-upload"> </span> icon-cloud-upload</div>\r\n<div style="padding: 2px 0;"><span class="icon-tree-conifer"> </span> icon-tree-conifer</div>\r\n<div style="padding: 2px 0;"><span class="icon-tree-deciduous"> </span> icon-tree-deciduous</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Top Contact Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;ul class="jm-contact-icons"&gt;<br />&lt;li class="jm-direction"&gt;&lt;img src="images/modules/direction.png" alt="Direction" /&gt;&lt;a title="Contact" href="#"&gt;Peterborough, UK&lt;/a&gt;&lt;/li&gt;<br />&lt;li class="jm-email"&gt;&lt;img src="images/modules/email.png" alt="Email" /&gt;&lt;a title="Contact" href="#"&gt;Email&lt;/a&gt;&lt;/li&gt;<br />&lt;li class="jm-phone"&gt;&lt;img src="images/modules/phone.png" alt="Phone" /&gt;&lt;a title="Contact" href="#"&gt;+44 7837 383 484&lt;/a&gt;&lt;/li&gt;<br />&lt;/ul&gt;</pre>\r\n<ul class="jm-contact-icons">\r\n<li class="jm-direction"><img src="images/modules/direction.png" alt="Direction" /><a title="Contact" href="#">Peterborough, UK</a></li>\r\n<li class="jm-email"><img src="images/modules/email.png" alt="Email" /><a title="Contact" href="#">Email</a></li>\r\n<li class="jm-phone"><img src="images/modules/phone.png" alt="Phone" /><a title="Contact" href="#">+44 7837 383 484</a></li>\r\n</ul>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Color Boxes</h3>\r\n<div class="row-fluid">\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box1 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />TIME MACHINE<br />&lt;/span&gt; <br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt; <br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt; <br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box1 text-center" href="#"> <span class="jm-icon-title">TIME MACHINE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box2 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />ANALYTICS<br />&lt;/span&gt;<br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt;<br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt;<br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">ANALYTICS</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n<div class="span4">\r\n<pre>&lt;p style="margin: 0;"&gt;<br />&lt;a class="jm-color-box3 text-center" href="#"&gt;<br />&lt;span class="jm-icon-title"&gt;<br />WORLDWIDE SERVICE<br />&lt;/span&gt;<br />&lt;span class="jm-icon-image"&gt;&amp;nbsp;&lt;/span&gt;<br />&lt;span class="jm-icon-desc"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;/span&gt;<br />&lt;/a&gt;<br />&lt;/p&gt;</pre>\r\n<p style="margin: 0;"><a class="jm-color-box3 text-center" href="#"> <span class="jm-icon-title">WORLDWIDE SERVICE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Just Few Words Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;div class="pull-left visible-desktop"&gt;<br />&lt;img class="jm-image-margin" src="images/modules/custom1.jpg" alt="Custom" /&gt;<br />&lt;/div&gt;<br />&lt;div class="jm-table"&gt;<br />&lt;h3 class="jm-title" style="margin-bottom: 20px;"&gt;JUST FEW WORDS&lt;/h3&gt;<br />&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;/p&gt;<br />&lt;ul class="jm-custom-list"&gt;<br />&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;/li&gt;<br />&lt;li&gt;Exercitation ullamco laboris nisi&lt;/li&gt;<br />&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;/li&gt;<br />&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;/li&gt;<br />&lt;/ul&gt;<br />&lt;p class="readmore text-right"&gt;&lt;a class="btn" href="#"&gt;read more&lt;/a&gt;&lt;/p&gt;<br />&lt;/div&gt;</pre>\r\n<div class="jm-module clearfix">\r\n<div class="pull-left visible-desktop"><img class="jm-image-margin" src="images/modules/custom1.jpg" alt="Custom" /></div>\r\n<div class="jm-table">\r\n<h3 class="jm-title" style="margin-bottom: 20px;">JUST FEW WORDS</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.</p>\r\n<ul class="jm-custom-list">\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi</li>\r\n<li>Ut aliquip ex ea commodo consequat.</li>\r\n<li>Duis aute irure dolor in reprehenderit</li>\r\n</ul>\r\n<p class="readmore text-right"><a class="btn" href="#"> read more </a></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Social Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<div class="jm-socials">\r\n<pre>&lt;div class="jm-socials"&gt;<br />&lt;a class="facebook" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="googleplus" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="twitter" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="linkedin" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="skype" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;a class="vimeo" href="#"&gt;&amp;nbsp;&lt;/a&gt;<br />&lt;/div&gt;</pre>\r\n<a class="facebook" href="#"> </a> <a class="googleplus" href="#"> </a> <a class="twitter" href="#"> </a> <a class="linkedin" href="#"> </a> <a class="skype" href="#"> </a> <a class="vimeo" href="#"> </a></div>\r\n</div>\r\n</div>\r\n<h3 class="jm-typo-title">Our Cooks Module</h3>\r\n<div class="row-fluid">\r\n<div class="span12">\r\n<pre>&lt;div class="media"&gt;<br />&lt;a class="pull-left" href="#"&gt; &lt;img src="images/culinary/modules/cooks/cook1.png" alt="" /&gt; &lt;/a&gt;<br />&lt;div class="media-body"&gt;<br />&lt;h5 class="media-heading"&gt;&lt;a href="#"&gt;Greg Amaro&lt;/a&gt;&lt;/h5&gt;<br />&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;/p&gt;<br />&lt;/div&gt;<br />&lt;/div&gt;<br />&lt;div class="media"&gt;<br />&lt;a class="pull-left" href="#"&gt; &lt;img src="images/culinary/modules/cooks/cook2.png" alt="" /&gt; &lt;/a&gt;<br />&lt;div class="media-body"&gt;<br />&lt;h5 class="media-heading"&gt;&lt;a href="#"&gt;Jimmy Gessler&lt;/a&gt;&lt;/h5&gt;<br />&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;/p&gt;<br />&lt;/div&gt;<br />&lt;/div&gt;</pre>\r\n<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook1.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Greg Amaro</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>\r\n<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook2.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Jimmy Gessler</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>";s:4:"body";s:0:"";s:5:"catid";s:2:"78";s:10:"created_by";s:3:"936";s:16:"created_by_alias";s:0:"";s:8:"modified";s:19:"2015-05-28 09:29:17";s:11:"modified_by";s:3:"755";s:6:"params";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":73:{s:14:"article_layout";s:9:"_:default";s:10:"show_title";s:1:"1";s:11:"link_titles";s:1:"1";s:10:"show_intro";s:1:"1";s:19:"info_block_position";s:1:"0";s:13:"show_category";s:1:"1";s:13:"link_category";s:1:"1";s:20:"show_parent_category";s:1:"0";s:20:"link_parent_category";s:1:"1";s:11:"show_author";s:1:"0";s:11:"link_author";s:1:"0";s:16:"show_create_date";s:1:"0";s:16:"show_modify_date";s:1:"0";s:17:"show_publish_date";s:1:"0";s:20:"show_item_navigation";s:1:"1";s:9:"show_vote";s:1:"0";s:13:"show_readmore";s:1:"1";s:19:"show_readmore_title";s:1:"0";s:14:"readmore_limit";s:3:"100";s:9:"show_tags";s:1:"0";s:10:"show_icons";s:1:"0";s:15:"show_print_icon";s:1:"0";s:15:"show_email_icon";s:1:"0";s:9:"show_hits";s:1:"0";s:11:"show_noauth";s:1:"0";s:13:"urls_position";s:1:"0";s:23:"show_publishing_options";s:1:"1";s:20:"show_article_options";s:1:"1";s:12:"save_history";s:1:"1";s:13:"history_limit";i:10;s:25:"show_urls_images_frontend";s:1:"0";s:24:"show_urls_images_backend";s:1:"1";s:7:"targeta";i:0;s:7:"targetb";i:0;s:7:"targetc";i:0;s:11:"float_intro";s:4:"left";s:14:"float_fulltext";s:4:"left";s:15:"category_layout";s:6:"_:blog";s:32:"show_category_heading_title_text";s:1:"1";s:19:"show_category_title";s:1:"0";s:16:"show_description";s:1:"0";s:22:"show_description_image";s:1:"0";s:8:"maxLevel";s:1:"1";s:21:"show_empty_categories";s:1:"0";s:16:"show_no_articles";s:1:"1";s:16:"show_subcat_desc";s:1:"1";s:21:"show_cat_num_articles";s:1:"0";s:21:"show_base_description";s:1:"1";s:11:"maxLevelcat";s:2:"-1";s:25:"show_empty_categories_cat";s:1:"0";s:20:"show_subcat_desc_cat";s:1:"1";s:25:"show_cat_num_articles_cat";s:1:"1";s:20:"num_leading_articles";s:1:"1";s:18:"num_intro_articles";s:1:"4";s:11:"num_columns";s:1:"2";s:9:"num_links";s:1:"4";s:18:"multi_column_order";s:1:"0";s:24:"show_subcategory_content";s:1:"0";s:21:"show_pagination_limit";s:1:"1";s:12:"filter_field";s:4:"hide";s:13:"show_headings";s:1:"1";s:14:"list_show_date";s:1:"0";s:11:"date_format";s:0:"";s:14:"list_show_hits";s:1:"1";s:16:"list_show_author";s:1:"1";s:11:"orderby_pri";s:5:"order";s:11:"orderby_sec";s:5:"rdate";s:10:"order_date";s:9:"published";s:15:"show_pagination";s:1:"2";s:23:"show_pagination_results";s:1:"1";s:14:"show_feed_link";s:1:"1";s:12:"feed_summary";s:1:"0";s:18:"feed_show_readmore";s:1:"0";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"metakey";s:0:"";s:8:"metadesc";s:0:"";s:8:"metadata";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":4:{s:6:"robots";s:0:"";s:6:"author";s:0:"";s:6:"rights";s:0:"";s:10:"xreference";s:0:"";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"version";s:2:"62";s:8:"ordering";s:1:"7";s:8:"category";s:14:"JM-Sample-Data";s:9:"cat_state";s:1:"1";s:10:"cat_access";s:1:"1";s:4:"slug";s:13:"87:typography";s:7:"catslug";s:17:"78:jm-sample-data";s:6:"author";s:10:"Super User";s:6:"layout";s:7:"article";s:7:"context";s:19:"com_content.article";s:4:"path";s:41:"index.php/78-jm-sample-data/87-typography";s:10:"metaauthor";N;}s:15:"\0*\0instructions";a:5:{i:1;a:3:{i:0;s:5:"title";i:1;s:8:"subtitle";i:2;s:2:"id";}i:2;a:2:{i:0;s:7:"summary";i:1;s:4:"body";}i:3;a:8:{i:0;s:4:"meta";i:1;s:10:"list_price";i:2;s:10:"sale_price";i:3;s:7:"metakey";i:4;s:8:"metadesc";i:5;s:10:"metaauthor";i:6;s:6:"author";i:7;s:16:"created_by_alias";}i:4;a:2:{i:0;s:4:"path";i:1;s:5:"alias";}i:5;a:1:{i:0;s:8:"comments";}}s:11:"\0*\0taxonomy";a:4:{s:4:"Type";a:1:{s:7:"Article";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:7:"Article";s:5:"state";i:1;s:6:"access";i:1;}}s:6:"Author";a:1:{s:10:"Super User";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:10:"Super User";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Category";a:1:{s:14:"JM-Sample-Data";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:14:"JM-Sample-Data";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Language";a:1:{s:1:"*";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:1:"*";s:5:"state";i:1;s:6:"access";i:1;}}}s:3:"url";s:47:"index.php?option=com_content&view=article&id=87";s:5:"route";s:67:"index.php?option=com_content&view=article&id=87:typography&catid=78";s:5:"title";s:10:"Typography";s:11:"description";s:10676:" Image Borders Headings This is Heading One (h1) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Two (h2) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Three (h3) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Four (h4) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Five (h5) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. This is Heading Six (h6) Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis. Numered blocks 01 Text goes here 01 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodalestellus. Aenean quis sapien suscipit mauris. 02 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. 03 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. a Text goes here a Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. b Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. c Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris. Colored Blocks Text goes here Text goes here Text goes here Text goes here Icon blocks Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Text goes here Blockquote Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Lorem ipsumdolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante. John Doe Unordered lists Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Ordered lists Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum  Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Duis tincidunt nunc sit amet ipsum Read More Button Read more Read more Glyphicon Font &nbsp icon-asterisk icon-plus icon-euro icon-minus icon-cloud icon-envelope icon-pencil icon-glass icon-music icon-search icon-heart icon-star icon-star-empty icon-user icon-film icon-th-large icon-th icon-th-list icon-ok icon-remove icon-zoom-in icon-zoom-out icon-off icon-signal icon-cog icon-trash icon-home icon-file icon-time icon-road icon-download-alt icon-download icon-upload icon-inbox icon-play-circle icon-repeat icon-refresh icon-list-alt icon-lock icon-flag icon-headphones icon-volume-off icon-volume-down icon-volume-up icon-qrcode icon-barcode icon-tag icon-tags icon-book icon-bookmark icon-print icon-camera icon-font icon-bold icon-italic icon-text-height icon-text-width icon-align-left icon-align-center icon-align-right icon-align-justify icon-list icon-indent-left icon-indent-right icon-facetime-video icon-picture icon-map-marker icon-adjust icon-tint icon-edit icon-share icon-check icon-move icon-step-backward icon-fast-backward icon-backward icon-play icon-pause icon-stop icon-forward icon-fast-forward icon-step-forward icon-eject icon-chevron-left icon-chevron-right icon-plus-sign icon-minus-sign icon-remove-sign icon-ok-sign icon-question-sign icon-info-sign icon-screenshot icon-remove-circle icon-ok-circle icon-ban-circle icon-arrow-left icon-arrow-right icon-arrow-up icon-arrow-down icon-share-alt icon-resize-full icon-resize-small icon-exclamation-sign icon-gift icon-leaf icon-fire icon-eye-open icon-eye-close icon-warning-sign icon-plane icon-calendar icon-random icon-comment icon-magnet icon-chevron-up icon-chevron-down icon-retweet icon-shopping-cart icon-folder-close icon-folder-open icon-resize-vertical icon-resize-horizontal icon-hdd icon-bullhorn icon-bell icon-certificate icon-thumbs-up icon-thumbs-down icon-hand-right icon-hand-left icon-hand-up icon-hand-down icon-circle-arrow-right icon-circle-arrow-left icon-circle-arrow-up icon-circle-arrow-down icon-globe icon-wrench icon-tasks icon-filter icon-briefcase icon-fullscreen icon-dashboard icon-paperclip icon-heart-empty icon-link icon-phone icon-pushpin icon-usd icon-gbp icon-sort icon-sort-by-alphabet icon-sort-by-alphabet-alt icon-sort-by-order icon-sort-by-order-alt icon-sort-by-attributes icon-sort-by-attributes-alt icon-unchecked icon-expand icon-collapse-down icon-collapse-up icon-log-in icon-flash icon-log-out icon-new-window icon-record icon-save icon-open icon-saved icon-import icon-export icon-send icon-floppy-disk icon-floppy-saved icon-floppy-remove icon-floppy-save icon-floppy-open icon-credit-card icon-transfer icon-cutlery icon-header icon-compressed icon-earphone icon-phone-alt icon-tower icon-stats icon-sd-video icon-hd-video icon-subtitles icon-sound-stereo icon-sound-dolby icon-sound-5-1 icon-sound-6-1 icon-sound-7-1 icon-copyright-mark icon-registration-mark icon-cloud-download icon-cloud-upload icon-tree-conifer icon-tree-deciduous Top Contact Module Peterborough, UK Email +44 7837 383 484 Peterborough, UK Email +44 7837 383 484 Color Boxes TIME MACHINE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. TIME MACHINE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ANALYTICS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ANALYTICS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. WORLDWIDE SERVICE Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. WORLDWIDE SERVICE Lorem ipsum dolor sit amet,consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Just Few Words Module JUST FEW WORDS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore. Ut enim ad minim veniam, quis nostrud Exercitation ullamco laboris nisi Ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit read more JUST FEW WORDS Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore. Ut enim ad minim veniam, quis nostrud Exercitation ullamco laboris nisi Ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit read more Social Module Our Cooks Module Greg Amaro Consectetur adipisicing elit sed do eimod tempor. Jimmy Gessler Consectetur adipisicing elit sed do eimod tempor. Greg Amaro Consectetur adipisicing elit sed do eimod tempor. Jimmy Gessler Consectetur adipisicing elit sed do eimod tempor. ";s:9:"published";N;s:5:"state";i:0;s:6:"access";s:1:"1";s:8:"language";s:1:"*";s:18:"publish_start_date";s:19:"2014-05-14 12:40:26";s:16:"publish_end_date";s:19:"0000-00-00 00:00:00";s:10:"start_date";s:19:"2014-05-14 12:40:26";s:8:"end_date";s:19:"0000-00-00 00:00:00";s:10:"list_price";N;s:10:"sale_price";N;s:7:"type_id";i:4;s:15:"defaultLanguage";s:5:"en-GB";}'),
('3','index.php?option=com_content&view=article&id=111','index.php?option=com_content&view=article&id=111:single-article&catid=78&Itemid=527','Single Article',' Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis au','2016-08-18 12:08:46','f699c74a300ceda4ae97b0549c8fcd09','1','1','1','*','2014-06-24 13:38:25','0000-00-00 00:00:00','2014-06-24 13:38:25','0000-00-00 00:00:00','0','0','4','O:19:"FinderIndexerResult":19:{s:11:"\0*\0elements";a:24:{s:2:"id";s:3:"111";s:5:"alias";s:14:"single-article";s:7:"summary";s:5062:"<p><strong>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</strong></p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.</p>\r\n<h4>Lorem ipsum dolor</h4>\r\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.</p>\r\n<p class="jm-block second"><span class="jm">1</span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.</p>\r\n<p class="jm-block second"><span class="jm">2</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.</p>\r\n<p class="jm-block second"><span class="jm">3</span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.</p>\r\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.</p>\r\n<h4>Consectetur adipiscing elit</h4>\r\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.</p>\r\n<p class="jmpeople">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.</p>\r\n<p class="jmmail">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.</p>\r\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.</p>\r\n<h4>Font Awesome example</h4>\r\n<p><span class="fa fa-joomla fa-5x" aria-hidden="true"></span> <span class="fa fa-html5 fa-5x" aria-hidden="true"></span> <span class="fa fa-css3 fa-5x" aria-hidden="true"></span></p>";s:4:"body";s:0:"";s:5:"catid";s:2:"78";s:10:"created_by";s:3:"936";s:16:"created_by_alias";s:0:"";s:8:"modified";s:19:"2016-08-18 10:08:46";s:11:"modified_by";s:3:"936";s:6:"params";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\0*\0data";O:8:"stdClass":73:{s:14:"article_layout";s:9:"_:default";s:10:"show_title";s:1:"1";s:11:"link_titles";s:1:"1";s:10:"show_intro";s:1:"1";s:19:"info_block_position";s:1:"0";s:13:"show_category";s:1:"1";s:13:"link_category";s:1:"1";s:20:"show_parent_category";s:1:"0";s:20:"link_parent_category";s:1:"1";s:11:"show_author";s:1:"0";s:11:"link_author";s:1:"0";s:16:"show_create_date";s:1:"0";s:16:"show_modify_date";s:1:"0";s:17:"show_publish_date";s:1:"0";s:20:"show_item_navigation";s:1:"1";s:9:"show_vote";s:1:"0";s:13:"show_readmore";s:1:"1";s:19:"show_readmore_title";s:1:"0";s:14:"readmore_limit";s:3:"100";s:9:"show_tags";s:1:"0";s:10:"show_icons";s:1:"0";s:15:"show_print_icon";s:1:"0";s:15:"show_email_icon";s:1:"0";s:9:"show_hits";s:1:"0";s:11:"show_noauth";s:1:"0";s:13:"urls_position";s:1:"0";s:23:"show_publishing_options";s:1:"1";s:20:"show_article_options";s:1:"1";s:12:"save_history";s:1:"1";s:13:"history_limit";i:10;s:25:"show_urls_images_frontend";s:1:"0";s:24:"show_urls_images_backend";s:1:"1";s:7:"targeta";i:0;s:7:"targetb";i:0;s:7:"targetc";i:0;s:11:"float_intro";s:4:"left";s:14:"float_fulltext";s:4:"left";s:15:"category_layout";s:6:"_:blog";s:32:"show_category_heading_title_text";s:1:"1";s:19:"show_category_title";s:1:"0";s:16:"show_description";s:1:"0";s:22:"show_description_image";s:1:"0";s:8:"maxLevel";s:1:"1";s:21:"show_empty_categories";s:1:"0";s:16:"show_no_articles";s:1:"1";s:16:"show_subcat_desc";s:1:"1";s:21:"show_cat_num_articles";s:1:"0";s:21:"show_base_description";s:1:"1";s:11:"maxLevelcat";s:2:"-1";s:25:"show_empty_categories_cat";s:1:"0";s:20:"show_subcat_desc_cat";s:1:"1";s:25:"show_cat_num_articles_cat";s:1:"1";s:20:"num_leading_articles";s:1:"1";s:18:"num_intro_articles";s:1:"4";s:11:"num_columns";s:1:"2";s:9:"num_links";s:1:"4";s:18:"multi_column_order";s:1:"0";s:24:"show_subcategory_content";s:1:"0";s:21:"show_pagination_limit";s:1:"1";s:12:"filter_field";s:4:"hide";s:13:"show_headings";s:1:"1";s:14:"list_show_date";s:1:"0";s:11:"date_format";s:0:"";s:14:"list_show_hits";s:1:"1";s:16:"list_show_author";s:1:"1";s:11:"orderby_pri";s:5:"order";s:11:"orderby_sec";s:5:"rdate";s:10:"order_date";s:9:"published";s:15:"show_pagination";s:1:"2";s:23:"show_pagination_results";s:1:"1";s:14:"show_feed_link";s:1:"1";s:12:"feed_summary";s:1:"0";s:18:"feed_show_readmore";s:1:"0";}s:9:"separator";s:1:".";}s:7:"metakey";s:0:"";s:8:"metadesc";s:0:"";s:8:"metadata";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\0*\0data";O:8:"stdClass":4:{s:6:"robots";s:0:"";s:6:"author";s:0:"";s:6:"rights";s:0:"";s:10:"xreference";s:0:"";}s:9:"separator";s:1:".";}s:7:"version";s:1:"3";s:8:"ordering";s:1:"6";s:8:"category";s:14:"JM-Sample-Data";s:9:"cat_state";s:1:"1";s:10:"cat_access";s:1:"1";s:4:"slug";s:18:"111:single-article";s:7:"catslug";s:17:"78:jm-sample-data";s:6:"author";s:10:"Super User";s:6:"layout";s:7:"article";s:4:"path";s:45:"index.php/pages/joomla-content/single-article";s:10:"metaauthor";N;}s:15:"\0*\0instructions";a:5:{i:1;a:3:{i:0;s:5:"title";i:1;s:8:"subtitle";i:2;s:2:"id";}i:2;a:2:{i:0;s:7:"summary";i:1;s:4:"body";}i:3;a:8:{i:0;s:4:"meta";i:1;s:10:"list_price";i:2;s:10:"sale_price";i:3;s:7:"metakey";i:4;s:8:"metadesc";i:5;s:10:"metaauthor";i:6;s:6:"author";i:7;s:16:"created_by_alias";}i:4;a:2:{i:0;s:4:"path";i:1;s:5:"alias";}i:5;a:1:{i:0;s:8:"comments";}}s:11:"\0*\0taxonomy";a:4:{s:4:"Type";a:1:{s:7:"Article";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:7:"Article";s:5:"state";i:1;s:6:"access";i:1;}}s:6:"Author";a:1:{s:10:"Super User";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:10:"Super User";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Category";a:1:{s:14:"JM-Sample-Data";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:14:"JM-Sample-Data";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Language";a:1:{s:1:"*";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:1:"*";s:5:"state";i:1;s:6:"access";i:1;}}}s:3:"url";s:48:"index.php?option=com_content&view=article&id=111";s:5:"route";s:83:"index.php?option=com_content&view=article&id=111:single-article&catid=78&Itemid=527";s:5:"title";s:14:"Single Article";s:11:"description";s:4562:" Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Lorem ipsum dolor Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat. 1 Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. 2 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. 3 Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sedcongue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Consectetur adipiscing elit Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan. Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitaenulla ac. Nulla porttitor commodo velit nec rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt. Font Awesome example ";s:9:"published";N;s:5:"state";i:1;s:6:"access";s:1:"1";s:8:"language";s:1:"*";s:18:"publish_start_date";s:19:"2014-06-24 13:38:25";s:16:"publish_end_date";s:19:"0000-00-00 00:00:00";s:10:"start_date";s:19:"2014-06-24 13:38:25";s:8:"end_date";s:19:"0000-00-00 00:00:00";s:10:"list_price";N;s:10:"sale_price";N;s:7:"type_id";i:4;s:15:"defaultLanguage";s:5:"en-GB";}'),
('5','index.php?option=com_content&view=article&id=73','index.php?option=com_content&view=article&id=73:subpage&catid=78','Subpage',' Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.yt ','2017-05-15 09:11:04','9bedfee823e38b7425b10d4986b614e0','1','1','1','*','2014-04-28 14:34:25','0000-00-00 00:00:00','2014-04-28 14:34:25','0000-00-00 00:00:00','0','0','4','O:19:"FinderIndexerResult":19:{s:11:"\0*\0elements";a:24:{s:2:"id";s:2:"73";s:5:"alias";s:7:"subpage";s:7:"summary";s:1040:"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.yt</p>";s:4:"body";s:0:"";s:5:"catid";s:2:"78";s:10:"created_by";s:3:"936";s:16:"created_by_alias";s:0:"";s:8:"modified";s:19:"2017-05-15 07:11:03";s:11:"modified_by";s:3:"936";s:6:"params";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":73:{s:14:"article_layout";s:9:"_:default";s:10:"show_title";s:1:"1";s:11:"link_titles";s:1:"1";s:10:"show_intro";s:1:"1";s:19:"info_block_position";s:1:"0";s:13:"show_category";s:1:"1";s:13:"link_category";s:1:"1";s:20:"show_parent_category";s:1:"0";s:20:"link_parent_category";s:1:"1";s:11:"show_author";s:1:"0";s:11:"link_author";s:1:"0";s:16:"show_create_date";s:1:"0";s:16:"show_modify_date";s:1:"0";s:17:"show_publish_date";s:1:"0";s:20:"show_item_navigation";s:1:"1";s:9:"show_vote";s:1:"0";s:13:"show_readmore";s:1:"1";s:19:"show_readmore_title";s:1:"0";s:14:"readmore_limit";s:3:"100";s:9:"show_tags";s:1:"0";s:10:"show_icons";s:1:"0";s:15:"show_print_icon";s:1:"0";s:15:"show_email_icon";s:1:"0";s:9:"show_hits";s:1:"0";s:11:"show_noauth";s:1:"0";s:13:"urls_position";s:1:"0";s:23:"show_publishing_options";s:1:"1";s:20:"show_article_options";s:1:"1";s:12:"save_history";s:1:"1";s:13:"history_limit";i:10;s:25:"show_urls_images_frontend";s:1:"0";s:24:"show_urls_images_backend";s:1:"1";s:7:"targeta";i:0;s:7:"targetb";i:0;s:7:"targetc";i:0;s:11:"float_intro";s:4:"left";s:14:"float_fulltext";s:4:"left";s:15:"category_layout";s:6:"_:blog";s:32:"show_category_heading_title_text";s:1:"1";s:19:"show_category_title";s:1:"0";s:16:"show_description";s:1:"0";s:22:"show_description_image";s:1:"0";s:8:"maxLevel";s:1:"1";s:21:"show_empty_categories";s:1:"0";s:16:"show_no_articles";s:1:"1";s:16:"show_subcat_desc";s:1:"1";s:21:"show_cat_num_articles";s:1:"0";s:21:"show_base_description";s:1:"1";s:11:"maxLevelcat";s:2:"-1";s:25:"show_empty_categories_cat";s:1:"0";s:20:"show_subcat_desc_cat";s:1:"1";s:25:"show_cat_num_articles_cat";s:1:"1";s:20:"num_leading_articles";s:1:"1";s:18:"num_intro_articles";s:1:"4";s:11:"num_columns";s:1:"2";s:9:"num_links";s:1:"4";s:18:"multi_column_order";s:1:"0";s:24:"show_subcategory_content";s:1:"0";s:21:"show_pagination_limit";s:1:"1";s:12:"filter_field";s:4:"hide";s:13:"show_headings";s:1:"1";s:14:"list_show_date";s:1:"0";s:11:"date_format";s:0:"";s:14:"list_show_hits";s:1:"1";s:16:"list_show_author";s:1:"1";s:11:"orderby_pri";s:5:"order";s:11:"orderby_sec";s:5:"rdate";s:10:"order_date";s:9:"published";s:15:"show_pagination";s:1:"2";s:23:"show_pagination_results";s:1:"1";s:14:"show_feed_link";s:1:"1";s:12:"feed_summary";s:1:"0";s:18:"feed_show_readmore";s:1:"0";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"metakey";s:0:"";s:8:"metadesc";s:0:"";s:8:"metadata";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":4:{s:6:"robots";s:0:"";s:6:"author";s:0:"";s:6:"rights";s:0:"";s:10:"xreference";s:0:"";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"version";s:1:"8";s:8:"ordering";s:1:"8";s:8:"category";s:14:"JM-Sample-Data";s:9:"cat_state";s:1:"1";s:10:"cat_access";s:1:"1";s:4:"slug";s:10:"73:subpage";s:7:"catslug";s:17:"78:jm-sample-data";s:6:"author";s:10:"Super User";s:6:"layout";s:7:"article";s:4:"path";s:9:"index.php";s:10:"metaauthor";N;}s:15:"\0*\0instructions";a:5:{i:1;a:3:{i:0;s:5:"title";i:1;s:8:"subtitle";i:2;s:2:"id";}i:2;a:2:{i:0;s:7:"summary";i:1;s:4:"body";}i:3;a:8:{i:0;s:4:"meta";i:1;s:10:"list_price";i:2;s:10:"sale_price";i:3;s:7:"metakey";i:4;s:8:"metadesc";i:5;s:10:"metaauthor";i:6;s:6:"author";i:7;s:16:"created_by_alias";}i:4;a:2:{i:0;s:4:"path";i:1;s:5:"alias";}i:5;a:1:{i:0;s:8:"comments";}}s:11:"\0*\0taxonomy";a:4:{s:4:"Type";a:1:{s:7:"Article";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:7:"Article";s:5:"state";i:1;s:6:"access";i:1;}}s:6:"Author";a:1:{s:10:"Super User";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:10:"Super User";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Category";a:1:{s:14:"JM-Sample-Data";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:14:"JM-Sample-Data";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Language";a:1:{s:1:"*";O:7:"JObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:1:"*";s:5:"state";i:1;s:6:"access";i:1;}}}s:3:"url";s:47:"index.php?option=com_content&view=article&id=73";s:5:"route";s:64:"index.php?option=com_content&view=article&id=73:subpage&catid=78";s:5:"title";s:7:"Subpage";s:11:"description";s:1035:" Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.yt ";s:9:"published";N;s:5:"state";i:1;s:6:"access";s:1:"1";s:8:"language";s:1:"*";s:18:"publish_start_date";s:19:"2014-04-28 14:34:25";s:16:"publish_end_date";s:19:"0000-00-00 00:00:00";s:10:"start_date";s:19:"2014-04-28 14:34:25";s:8:"end_date";s:19:"0000-00-00 00:00:00";s:10:"list_price";N;s:10:"sale_price";N;s:7:"type_id";i:4;s:15:"defaultLanguage";s:5:"en-GB";}'),
('6','index.php?option=com_content&view=article&id=130','index.php?option=com_content&view=article&id=130:all-template-positions&catid=78','All Template Positions',' JM Services Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles. EF4 Framework includes Layout Builder tool which allows you to customize template layout for different screen dimensions. ','2017-12-27 12:36:38','9cb6e87654fe4014c6ad109caaec9b38','1','0','1','*','2014-06-25 09:42:57','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','0','0','4','O:19:"FinderIndexerResult":19:{s:11:"\0*\0elements";a:25:{s:2:"id";s:3:"130";s:5:"alias";s:22:"all-template-positions";s:7:"summary";s:764:"<p><a title="JM Services" href="http://www.joomla-monster.com/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-services&amp;cid=32:free&amp;Itemid=471" target="_blank">JM Services</a> Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br /><a title="EF4 Framework" href="http://www.joomla-monster.com/index.php?option=com_content&amp;id=137&amp;view=category&amp;Itemid=548" target="_blank">EF4 Framework</a> includes <a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Layout Builder</a> tool which allows you to customize template layout for different screen dimensions.</p>\r\n";s:4:"body";s:3217:"\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for normal and large screen <small>usually desktop and tablet landscape (980px and higher)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for normal and large screen" src="images/sample/normal-positions.jpg" alt="Module positions for normal and large screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for medium screen <small>usually tablet (768px-979px)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for medium screen" src="images/sample/medium-positions.jpg" alt="Module positions for medium screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for small screen <small>usually tablet portrait and mobile landscape (481px-767px)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for small screen" src="images/sample/small-positions.jpg" alt="Module positions for small screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>\r\n<p> </p>\r\n<h3 style="text-align: center;">Module positions for extra small screen <small>usually mobile portrait (480px and smaller)</small></h3>\r\n<p> </p>\r\n<p style="text-align: center;"><a title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank"><img title="Module positions for extra small screen" src="images/sample/extrasmall-positions.jpg" alt="Module positions for extra small screen" border="0" /></a></p>\r\n<p class="readmore" style="text-align: center;"><a class="btn" title="Layout Builder" href="http://www.joomla-monster.com/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034" target="_blank">Check out more details about layout customization!</a></p>";s:5:"catid";s:2:"78";s:10:"created_by";s:3:"936";s:16:"created_by_alias";s:0:"";s:8:"modified";s:19:"2014-11-28 14:45:39";s:11:"modified_by";s:3:"941";s:6:"params";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":73:{s:14:"article_layout";s:9:"_:default";s:10:"show_title";s:1:"1";s:11:"link_titles";s:1:"1";s:10:"show_intro";s:1:"1";s:19:"info_block_position";s:1:"0";s:13:"show_category";s:1:"1";s:13:"link_category";s:1:"1";s:20:"show_parent_category";s:1:"0";s:20:"link_parent_category";s:1:"1";s:11:"show_author";s:1:"0";s:11:"link_author";s:1:"0";s:16:"show_create_date";s:1:"0";s:16:"show_modify_date";s:1:"0";s:17:"show_publish_date";s:1:"0";s:20:"show_item_navigation";s:1:"1";s:9:"show_vote";s:1:"0";s:13:"show_readmore";s:1:"1";s:19:"show_readmore_title";s:1:"0";s:14:"readmore_limit";s:3:"100";s:9:"show_tags";s:1:"0";s:10:"show_icons";s:1:"0";s:15:"show_print_icon";s:1:"0";s:15:"show_email_icon";s:1:"0";s:9:"show_hits";s:1:"0";s:11:"show_noauth";s:1:"0";s:13:"urls_position";s:1:"0";s:23:"show_publishing_options";s:1:"1";s:20:"show_article_options";s:1:"1";s:12:"save_history";s:1:"1";s:13:"history_limit";i:10;s:25:"show_urls_images_frontend";s:1:"0";s:24:"show_urls_images_backend";s:1:"1";s:7:"targeta";i:0;s:7:"targetb";i:0;s:7:"targetc";i:0;s:11:"float_intro";s:4:"left";s:14:"float_fulltext";s:4:"left";s:15:"category_layout";s:6:"_:blog";s:32:"show_category_heading_title_text";s:1:"1";s:19:"show_category_title";s:1:"0";s:16:"show_description";s:1:"0";s:22:"show_description_image";s:1:"0";s:8:"maxLevel";s:1:"1";s:21:"show_empty_categories";s:1:"0";s:16:"show_no_articles";s:1:"1";s:16:"show_subcat_desc";s:1:"1";s:21:"show_cat_num_articles";s:1:"0";s:21:"show_base_description";s:1:"1";s:11:"maxLevelcat";s:2:"-1";s:25:"show_empty_categories_cat";s:1:"0";s:20:"show_subcat_desc_cat";s:1:"1";s:25:"show_cat_num_articles_cat";s:1:"1";s:20:"num_leading_articles";s:1:"1";s:18:"num_intro_articles";s:1:"4";s:11:"num_columns";s:1:"2";s:9:"num_links";s:1:"4";s:18:"multi_column_order";s:1:"0";s:24:"show_subcategory_content";s:1:"0";s:21:"show_pagination_limit";s:1:"1";s:12:"filter_field";s:4:"hide";s:13:"show_headings";s:1:"1";s:14:"list_show_date";s:1:"0";s:11:"date_format";s:0:"";s:14:"list_show_hits";s:1:"1";s:16:"list_show_author";s:1:"1";s:11:"orderby_pri";s:5:"order";s:11:"orderby_sec";s:5:"rdate";s:10:"order_date";s:9:"published";s:15:"show_pagination";s:1:"2";s:23:"show_pagination_results";s:1:"1";s:14:"show_feed_link";s:1:"1";s:12:"feed_summary";s:1:"0";s:18:"feed_show_readmore";s:1:"0";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"metakey";s:0:"";s:8:"metadesc";s:0:"";s:8:"metadata";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":4:{s:6:"robots";s:0:"";s:6:"author";s:0:"";s:6:"rights";s:0:"";s:10:"xreference";s:0:"";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"version";s:1:"5";s:8:"ordering";s:1:"3";s:8:"category";s:14:"JM-Sample-Data";s:9:"cat_state";s:1:"1";s:10:"cat_access";s:1:"1";s:4:"slug";s:26:"130:all-template-positions";s:7:"catslug";s:17:"78:jm-sample-data";s:6:"author";s:10:"Super User";s:6:"layout";s:7:"article";s:7:"context";s:19:"com_content.article";s:4:"path";s:54:"index.php/78-jm-sample-data/130-all-template-positions";s:10:"metaauthor";N;}s:15:"\0*\0instructions";a:5:{i:1;a:3:{i:0;s:5:"title";i:1;s:8:"subtitle";i:2;s:2:"id";}i:2;a:2:{i:0;s:7:"summary";i:1;s:4:"body";}i:3;a:8:{i:0;s:4:"meta";i:1;s:10:"list_price";i:2;s:10:"sale_price";i:3;s:7:"metakey";i:4;s:8:"metadesc";i:5;s:10:"metaauthor";i:6;s:6:"author";i:7;s:16:"created_by_alias";}i:4;a:2:{i:0;s:4:"path";i:1;s:5:"alias";}i:5;a:1:{i:0;s:8:"comments";}}s:11:"\0*\0taxonomy";a:4:{s:4:"Type";a:1:{s:7:"Article";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:7:"Article";s:5:"state";i:1;s:6:"access";i:1;}}s:6:"Author";a:1:{s:10:"Super User";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:10:"Super User";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Category";a:1:{s:14:"JM-Sample-Data";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:14:"JM-Sample-Data";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Language";a:1:{s:1:"*";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:1:"*";s:5:"state";i:1;s:6:"access";i:1;}}}s:3:"url";s:48:"index.php?option=com_content&view=article&id=130";s:5:"route";s:80:"index.php?option=com_content&view=article&id=130:all-template-positions&catid=78";s:5:"title";s:22:"All Template Positions";s:11:"description";s:247:" JM Services Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles. EF4 Framework includes Layout Builder tool which allows you to customize template layout for different screen dimensions. ";s:9:"published";N;s:5:"state";i:0;s:6:"access";s:1:"1";s:8:"language";s:1:"*";s:18:"publish_start_date";s:19:"2014-06-25 09:42:57";s:16:"publish_end_date";s:19:"0000-00-00 00:00:00";s:10:"start_date";s:19:"2014-06-25 09:42:57";s:8:"end_date";s:19:"0000-00-00 00:00:00";s:10:"list_price";N;s:10:"sale_price";N;s:7:"type_id";i:4;s:15:"defaultLanguage";s:5:"en-GB";}'),
('7','index.php?option=com_content&view=article&id=121','index.php?option=com_content&view=article&id=121:module-suffixes&catid=78','Module Suffixes',' There are additional module designs available that you can control by entering a correct suffix name as a module parameter. Let\'s check them all. 1. Available module designs 2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles. Suffix name: slider1-ms Suffix name: testimonials-ms Suffix name: testimonials-ms alternative-ms ','2017-12-27 12:36:38','b079b4a320de97bfc0851127abd02253','1','0','1','*','2014-06-25 09:42:57','0000-00-00 00:00:00','2014-06-25 09:42:57','0000-00-00 00:00:00','0','0','4','O:19:"FinderIndexerResult":19:{s:11:"\0*\0elements";a:25:{s:2:"id";s:3:"121";s:5:"alias";s:15:"module-suffixes";s:7:"summary";s:1059:"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br />Let\'s check them all.</p>\r\n<p>1. Available module designs</p>\r\n<p> </p>\r\n<p><img src="images/sample/module-suffixes.png" alt="Module Suffixes" /></p>\r\n<p> </p>\r\n<p>2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.</p>\r\n<p> </p>\r\n<p><strong>Suffix name:</strong> slider1-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes1.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n<p> </p>\r\n<div class="row-fluid">\r\n<div class="span6">\r\n<p><strong>Suffix name:</strong> testimonials-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes2.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n</div>\r\n<div class="span6">\r\n<p><strong>Suffix name:</strong> testimonials-ms alternative-ms</p>\r\n<p> </p>\r\n<p><img src="images/sample/djimageslider-suffixes3.jpg" alt="DJ-ImageSlider Suffixes" /></p>\r\n</div>\r\n</div>";s:4:"body";s:0:"";s:5:"catid";s:2:"78";s:10:"created_by";s:3:"936";s:16:"created_by_alias";s:0:"";s:8:"modified";s:19:"2014-09-09 12:55:04";s:11:"modified_by";s:3:"800";s:6:"params";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":73:{s:14:"article_layout";s:9:"_:default";s:10:"show_title";s:1:"1";s:11:"link_titles";s:1:"1";s:10:"show_intro";s:1:"1";s:19:"info_block_position";s:1:"0";s:13:"show_category";s:1:"1";s:13:"link_category";s:1:"1";s:20:"show_parent_category";s:1:"0";s:20:"link_parent_category";s:1:"1";s:11:"show_author";s:1:"0";s:11:"link_author";s:1:"0";s:16:"show_create_date";s:1:"0";s:16:"show_modify_date";s:1:"0";s:17:"show_publish_date";s:1:"0";s:20:"show_item_navigation";s:1:"1";s:9:"show_vote";s:1:"0";s:13:"show_readmore";s:1:"1";s:19:"show_readmore_title";s:1:"0";s:14:"readmore_limit";s:3:"100";s:9:"show_tags";s:1:"0";s:10:"show_icons";s:1:"0";s:15:"show_print_icon";s:1:"0";s:15:"show_email_icon";s:1:"0";s:9:"show_hits";s:1:"0";s:11:"show_noauth";s:1:"0";s:13:"urls_position";s:1:"0";s:23:"show_publishing_options";s:1:"1";s:20:"show_article_options";s:1:"1";s:12:"save_history";s:1:"1";s:13:"history_limit";i:10;s:25:"show_urls_images_frontend";s:1:"0";s:24:"show_urls_images_backend";s:1:"1";s:7:"targeta";i:0;s:7:"targetb";i:0;s:7:"targetc";i:0;s:11:"float_intro";s:4:"left";s:14:"float_fulltext";s:4:"left";s:15:"category_layout";s:6:"_:blog";s:32:"show_category_heading_title_text";s:1:"1";s:19:"show_category_title";s:1:"0";s:16:"show_description";s:1:"0";s:22:"show_description_image";s:1:"0";s:8:"maxLevel";s:1:"1";s:21:"show_empty_categories";s:1:"0";s:16:"show_no_articles";s:1:"1";s:16:"show_subcat_desc";s:1:"1";s:21:"show_cat_num_articles";s:1:"0";s:21:"show_base_description";s:1:"1";s:11:"maxLevelcat";s:2:"-1";s:25:"show_empty_categories_cat";s:1:"0";s:20:"show_subcat_desc_cat";s:1:"1";s:25:"show_cat_num_articles_cat";s:1:"1";s:20:"num_leading_articles";s:1:"1";s:18:"num_intro_articles";s:1:"4";s:11:"num_columns";s:1:"2";s:9:"num_links";s:1:"4";s:18:"multi_column_order";s:1:"0";s:24:"show_subcategory_content";s:1:"0";s:21:"show_pagination_limit";s:1:"1";s:12:"filter_field";s:4:"hide";s:13:"show_headings";s:1:"1";s:14:"list_show_date";s:1:"0";s:11:"date_format";s:0:"";s:14:"list_show_hits";s:1:"1";s:16:"list_show_author";s:1:"1";s:11:"orderby_pri";s:5:"order";s:11:"orderby_sec";s:5:"rdate";s:10:"order_date";s:9:"published";s:15:"show_pagination";s:1:"2";s:23:"show_pagination_results";s:1:"1";s:14:"show_feed_link";s:1:"1";s:12:"feed_summary";s:1:"0";s:18:"feed_show_readmore";s:1:"0";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"metakey";s:0:"";s:8:"metadesc";s:0:"";s:8:"metadata";O:24:"Joomla\\Registry\\Registry":3:{s:7:"\0*\0data";O:8:"stdClass":4:{s:6:"robots";s:0:"";s:6:"author";s:0:"";s:6:"rights";s:0:"";s:10:"xreference";s:0:"";}s:14:"\0*\0initialized";b:1;s:9:"separator";s:1:".";}s:7:"version";s:1:"9";s:8:"ordering";s:1:"4";s:8:"category";s:14:"JM-Sample-Data";s:9:"cat_state";s:1:"1";s:10:"cat_access";s:1:"1";s:4:"slug";s:19:"121:module-suffixes";s:7:"catslug";s:17:"78:jm-sample-data";s:6:"author";s:10:"Super User";s:6:"layout";s:7:"article";s:7:"context";s:19:"com_content.article";s:4:"path";s:47:"index.php/78-jm-sample-data/121-module-suffixes";s:10:"metaauthor";N;}s:15:"\0*\0instructions";a:5:{i:1;a:3:{i:0;s:5:"title";i:1;s:8:"subtitle";i:2;s:2:"id";}i:2;a:2:{i:0;s:7:"summary";i:1;s:4:"body";}i:3;a:8:{i:0;s:4:"meta";i:1;s:10:"list_price";i:2;s:10:"sale_price";i:3;s:7:"metakey";i:4;s:8:"metadesc";i:5;s:10:"metaauthor";i:6;s:6:"author";i:7;s:16:"created_by_alias";}i:4;a:2:{i:0;s:4:"path";i:1;s:5:"alias";}i:5;a:1:{i:0;s:8:"comments";}}s:11:"\0*\0taxonomy";a:4:{s:4:"Type";a:1:{s:7:"Article";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:7:"Article";s:5:"state";i:1;s:6:"access";i:1;}}s:6:"Author";a:1:{s:10:"Super User";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:10:"Super User";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Category";a:1:{s:14:"JM-Sample-Data";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:14:"JM-Sample-Data";s:5:"state";i:1;s:6:"access";i:1;}}s:8:"Language";a:1:{s:1:"*";O:27:"Joomla\\CMS\\Object\\CMSObject":4:{s:10:"\0*\0_errors";a:0:{}s:5:"title";s:1:"*";s:5:"state";i:1;s:6:"access";i:1;}}}s:3:"url";s:48:"index.php?option=com_content&view=article&id=121";s:5:"route";s:73:"index.php?option=com_content&view=article&id=121:module-suffixes&catid=78";s:5:"title";s:15:"Module Suffixes";s:11:"description";s:430:" There are additional module designs available that you can control by entering a correct suffix name as a module parameter. Let\'s check them all. 1. Available module designs 2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles. Suffix name: slider1-ms Suffix name: testimonials-ms Suffix name: testimonials-ms alternative-ms ";s:9:"published";N;s:5:"state";i:0;s:6:"access";s:1:"1";s:8:"language";s:1:"*";s:18:"publish_start_date";s:19:"2014-06-25 09:42:57";s:16:"publish_end_date";s:19:"0000-00-00 00:00:00";s:10:"start_date";s:19:"2014-06-25 09:42:57";s:8:"end_date";s:19:"0000-00-00 00:00:00";s:10:"list_price";N;s:10:"sale_price";N;s:7:"type_id";i:4;s:15:"defaultLanguage";s:5:"en-GB";}');

DROP TABLE IF EXISTS #__finder_links_terms0;
CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms0` VALUES 
('3','47','0.23345'),
('3','54','0.09331'),
('3','55','0.88669'),
('3','56','1.05'),
('3','57','1.40007'),
('3','58','2.1'),
('3','61','0.51331'),
('3','62','1.07331'),
('3','63','1.16669'),
('3','64','0.56'),
('3','67','0.28'),
('3','76','0.32669'),
('3','77','0.93331'),
('3','78','1.00331'),
('3','82','3.17373'),
('3','85','2.14662'),
('3','86','1.33'),
('3','87','1.35331'),
('3','95','0.18669'),
('3','98','2.28683'),
('3','99','0.18669'),
('3','100','0.93331'),
('3','101','1.07331'),
('3','1063','0.28'),
('3','1066','2.24'),
('3','1067','0.84'),
('3','1069','1.02669'),
('3','1075','2.38'),
('3','1076','15.0737'),
('3','1078','2.33338'),
('3','1086','0.32669'),
('3','1094','0.79992'),
('3','1095','3.19992'),
('3','1096','0.37331'),
('3','2021','1.82'),
('3','2022','2.05338'),
('3','2023','2.66007'),
('3','2024','3.00993'),
('3','2025','1.02641'),
('3','2026','0.93331'),
('3','2027','1.09669'),
('3','2028','0.84'),
('3','2029','1.02669'),
('3','2030','0.88669'),
('3','2031','1.12'),
('3','2032','3.92'),
('3','2033','4.85324'),
('3','2034','1.77338'),
('3','2035','1.02669'),
('3','2036','1.12');
INSERT INTO `#__finder_links_terms0` VALUES 
('3','2037','1.82'),
('3','2038','2.14662'),
('3','2039','0.37331'),
('3','2040','1.16669'),
('3','2041','1.19'),
('3','2042','1.07331'),
('3','2043','1.19'),
('3','2044','2.14662'),
('3','2045','2.52'),
('3','2046','0.91'),
('3','2047','1.02669'),
('3','2048','1.63345'),
('3','2049','0.98'),
('3','2050','1.19'),
('3','2051','1.05'),
('3','2052','1.16669'),
('3','2053','1.96'),
('3','2054','2.24'),
('3','2055','1.00331'),
('3','2056','1.14331'),
('3','2057','0.98007'),
('3','2058','1.05'),
('3','2059','1.33'),
('3','2060','1.86662'),
('3','2061','2.00662'),
('3','2062','1.96'),
('3','2063','2.52'),
('3','2064','1.00331'),
('3','2065','1.07331'),
('3','2066','0.93331'),
('3','2067','1.09669'),
('3','2068','0.93331'),
('3','2069','1.14331'),
('3','2070','5.46'),
('3','2071','5.01655'),
('3','2072','1.02669'),
('3','2073','3.00993'),
('3','2074','3.84993'),
('3','2075','1.00331'),
('3','2076','1.21331'),
('3','2077','0.93331'),
('3','2078','1.00331'),
('3','2079','0.74676'),
('3','2080','0.98'),
('3','2081','1.09669'),
('3','2082','2.66007'),
('3','2083','1.09669'),
('3','2084','1.00331'),
('3','2085','0.95669'),
('3','2086','0.37324');
INSERT INTO `#__finder_links_terms0` VALUES 
('3','2087','3.73324'),
('3','2088','4.94676'),
('3','2089','0.56'),
('3','2090','1.96'),
('3','2091','2.14662'),
('3','2092','1.63317'),
('3','2093','4.9'),
('3','2094','5.83345'),
('3','2095','1.82'),
('3','2096','2.05338'),
('3','2097','0.32669'),
('3','2098','1.05'),
('3','2641','1.86655'),
('3','2642','2.05338'),
('3','2643','2.38'),
('3','2644','2.38'),
('3','2645','2.8'),
('3','2646','1.09669'),
('3','2647','1.30669'),
('3','2648','0.95669'),
('3','2649','1.09669'),
('3','2650','3.59317'),
('3','2651','1.09669'),
('3','2652','1.19'),
('3','2653','1.09669'),
('3','2654','1.16669'),
('3','2655','2.14662'),
('3','2656','2.24'),
('3','2657','1.23669'),
('3','2658','1.37669'),
('3','2659','2.38'),
('3','2660','2.66'),
('3','2661','2.79993'),
('3','2662','3.29007'),
('3','2663','1.68'),
('3','2664','2.24'),
('3','2665','1.00331'),
('3','2666','1.14331'),
('3','2667','0.95669'),
('3','2668','1.07331'),
('3','2669','3.00993'),
('3','2670','3.42993'),
('3','2671','0.95669'),
('3','2672','1.09669'),
('3','2673','0.84'),
('3','2674','1.12'),
('3','2675','0.88669'),
('3','2676','1.00331'),
('3','2677','0.93331'),
('3','2678','1.05');
INSERT INTO `#__finder_links_terms0` VALUES 
('3','2679','0.98'),
('3','2680','1.09669'),
('3','2681','1.68'),
('3','2682','3.21993'),
('3','2683','3.50007'),
('3','2684','3.00993'),
('3','2685','3.15'),
('3','2686','1.48'),
('3','2687','5.42679'),
('3','2688','2.14662'),
('3','2689','1.09669'),
('3','2690','1.02669'),
('3','2691','1.02669'),
('3','2692','6.01986'),
('3','2693','3.29007'),
('3','2694','1.09669'),
('3','2695','1.02669'),
('3','2696','1.09669'),
('3','2697','1.00331'),
('3','2698','1.12'),
('3','2699','1.53993'),
('3','2700','2.05338'),
('3','2701','2.38'),
('3','2702','1.02669'),
('3','2703','1.28331'),
('5','47','0.09338'),
('5','57','0.93338'),
('5','58','2.1'),
('5','82','0.37338'),
('5','85','2.14662'),
('5','86','2.66'),
('5','98','0.56004'),
('5','1063','0.28'),
('5','1066','0.56'),
('5','1075','0.28'),
('5','1076','1.77338'),
('5','1078','2.33338'),
('5','1086','0.32669'),
('5','1094','0.79992'),
('5','1095','3.19992'),
('5','2025','0.55986'),
('5','2039','0.37331'),
('5','2048','0.65338'),
('5','2057','0.98007'),
('5','2086','0.09331'),
('5','2089','0.28'),
('5','2092','0.93324'),
('5','2681','1.12'),
('5','3089','0.88669'),
('5','3090','0.95669');
INSERT INTO `#__finder_links_terms0` VALUES 
('5','3091','0.98'),
('5','3092','1.05'),
('5','3093','2.79993'),
('5','3094','3.29007'),
('5','3095','0.84'),
('5','3096','0.98'),
('5','3097','0.93331'),
('5','3098','1.07331'),
('5','3099','0.95669'),
('5','3100','1.09669'),
('5','3101','1.07331'),
('5','3102','1.16669'),
('5','3103','2.42662'),
('5','3104','1.07331'),
('5','3105','1.21331'),
('5','3106','0.95669'),
('5','3107','1.09669'),
('5','3108','3.08007'),
('5','3109','3.84993'),
('5','3110','0.86331'),
('5','3111','1.05'),
('5','3112','0.98'),
('5','3113','1.09669'),
('5','3114','1.02669'),
('5','3115','1.21331'),
('5','3116','2.94'),
('5','3117','3.42993'),
('5','3259','0.93331'),
('5','3260','1.09669'),
('5','3261','0.81669'),
('5','3262','0.98'),
('5','3263','0.93331'),
('5','3264','1.07331'),
('5','3265','0.93331'),
('5','3266','1.14331'),
('5','3267','0.88669'),
('5','3268','0.95669'),
('5','3269','0.14'),
('5','3270','0.93331'),
('5','3271','1.09669'),
('5','3272','2.79993'),
('5','3273','3.00993'),
('5','3274','0.98'),
('5','3275','1.02669'),
('5','3276','1.00331'),
('5','3277','1.16669'),
('5','3278','1.72679'),
('6','98','0.56004'),
('6','1094','0.79992'),
('6','1095','3.19992');
INSERT INTO `#__finder_links_terms0` VALUES 
('6','3347','0.93324'),
('6','3348','3.92'),
('6','3349','5.22676'),
('6','3350','0.32669'),
('6','3351','0.93331'),
('6','3352','1.12'),
('6','3353','0.74'),
('6','3354','5.18'),
('6','3355','6.41321'),
('6','3356','0.28'),
('6','3357','0.93331'),
('6','3358','1.00331'),
('6','3359','0.7'),
('6','3360','0.93331'),
('6','3361','1.07331'),
('6','3362','0.91'),
('6','3363','1.07331'),
('6','3364','0.93331'),
('6','3365','1.16669'),
('6','3366','0.95669'),
('6','3367','1.09669'),
('6','3368','0.93331'),
('6','3369','1.16669'),
('6','3487','1.4'),
('6','3488','1.09669'),
('6','3489','4.10676'),
('6','3490','1.21331'),
('6','3491','1.19'),
('6','3492','2.38'),
('6','3493','0.32669'),
('6','3494','1.07331'),
('6','3495','1.26'),
('6','3496','0.37331'),
('6','3497','1.05'),
('6','3498','1.26'),
('6','3499','0.46662'),
('6','3500','1.96'),
('6','3501','2.33338'),
('6','3502','0.32669'),
('6','3503','1.00331'),
('6','3504','1.09669'),
('7','47','0.14007'),
('7','98','0.56004'),
('7','1094','0.79992'),
('7','1095','3.19992'),
('7','3353','0.14'),
('7','3557','0.91'),
('7','3558','1.07331'),
('7','3559','1.77338'),
('7','3560','1.12');
INSERT INTO `#__finder_links_terms0` VALUES 
('7','3561','1.00331'),
('7','3562','0.46669'),
('7','3563','1.09669'),
('7','3564','1.28331'),
('7','3565','0.81669'),
('7','3566','1.05'),
('7','3567','0.65331'),
('7','3568','0.14'),
('7','3569','1.02669'),
('7','3570','1.19'),
('7','3571','0.09331'),
('7','3572','0.79331'),
('7','3573','0.95669'),
('7','3574','0.84'),
('7','3575','1.07331'),
('7','3576','1.26'),
('7','3577','1.02669'),
('7','3578','1.12'),
('7','3652','0.46669'),
('7','3653','1.09669'),
('7','3654','1.21331'),
('7','3655','0.28'),
('7','3656','1.07331'),
('7','3657','1.12'),
('7','3658','0.28'),
('7','3659','1.00331'),
('7','3660','1.12'),
('7','3661','1.12'),
('7','3662','3.82676'),
('7','3663','1.02669'),
('7','3664','1.21331'),
('7','3665','2.66'),
('7','3666','2.34652'),
('7','3667','0.98'),
('7','3668','1.33'),
('8','47','0.28014'),
('8','54','0.18662'),
('8','55','1.77338'),
('8','56','2.1'),
('8','57','7.46704'),
('8','58','16.8'),
('8','61','6.15972'),
('8','62','12.8797'),
('8','63','14.0003'),
('8','64','3.36'),
('8','67','1.68'),
('8','76','0.65338'),
('8','77','1.86662'),
('8','78','2.00662'),
('8','82','18.1089');
INSERT INTO `#__finder_links_terms0` VALUES 
('8','85','25.7594'),
('8','86','21.28'),
('8','87','10.8265'),
('8','95','0.74676'),
('8','98','0.56004'),
('8','99','0.37338'),
('8','100','1.86662'),
('8','101','2.14662'),
('8','1063','3.36'),
('8','1066','3.36'),
('8','1067','10.08'),
('8','1069','8.21352'),
('8','1075','13.58'),
('8','1076','86.0089'),
('8','1078','28.0006'),
('8','1086','3.59359'),
('8','1094','0.79992'),
('8','1095','3.19992'),
('8','1096','8.95944'),
('8','3733','3.36'),
('8','3734','3.82676'),
('8','3735','0.86331'),
('8','3736','1.00331'),
('8','3737','0.84'),
('8','3738','0.95669'),
('8','3739','14.0003'),
('8','3740','4.94676'),
('8','3741','11.4803'),
('8','3742','13.44'),
('8','3743','2.14662'),
('8','3744','2.42662'),
('8','3745','0.95669'),
('8','3746','1.05'),
('8','3747','0.95669'),
('8','3748','1.14331'),
('8','3749','2.14662'),
('8','3750','2.52'),
('8','3751','0.46662'),
('8','3752','2.19338'),
('8','3753','2.75338'),
('8','3754','12.8797'),
('8','3755','14.28'),
('8','3756','56.9319'),
('8','3757','61.95'),
('8','3758','1.12'),
('8','3759','1.05'),
('8','3760','0.84'),
('8','3761','2.1'),
('8','3762','2.38'),
('8','3763','3.64');
INSERT INTO `#__finder_links_terms0` VALUES 
('8','3764','4.01324'),
('8','4649','12.6'),
('8','4650','14.5597'),
('8','4651','3.92'),
('8','4652','11.1997'),
('8','4653','14.0003'),
('8','4654','0.65338'),
('8','4655','2.00662'),
('8','4656','2.28662'),
('8','4657','14.0003'),
('8','4658','62.6281'),
('8','4659','0.14'),
('8','4660','0.84'),
('8','4661','0.98'),
('8','4662','0.28'),
('8','4663','1.00331'),
('8','4664','1.09669'),
('8','4665','11.2936'),
('8','4666','13.09'),
('8','4667','0.60669'),
('8','4668','1.16669'),
('8','4669','1.28331'),
('8','4670','12.6'),
('8','4671','1.12'),
('8','4672','1.12'),
('8','4673','1.09669'),
('8','4674','1.09669'),
('8','4675','1.09669'),
('8','4676','1.23669'),
('8','4677','7.69986'),
('8','4678','12.0397'),
('8','4679','13.44');

DROP TABLE IF EXISTS #__finder_links_terms1;
CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_links_terms2;
CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms2` VALUES 
('3','933','0.28'),
('3','934','0.91'),
('3','935','1.07331'),
('3','938','0.32669'),
('3','941','0.32669'),
('3','950','1.39986'),
('3','951','2.87007'),
('3','952','3.29007'),
('3','2298','3.78'),
('3','2299','2.14662'),
('3','2300','2.42662'),
('3','2301','1.00331'),
('3','2302','1.23669'),
('3','2303','2.05338'),
('3','2304','2.42662'),
('3','2305','1.00331'),
('3','2306','1.21331'),
('3','2307','3.15'),
('3','2308','3.78'),
('3','2353','0.95669'),
('3','2354','1.07331'),
('3','2355','1.00331'),
('3','2356','1.09669'),
('3','2357','0.46662'),
('3','2358','1.09669'),
('3','2359','1.21331'),
('3','2360','0.95669'),
('3','2361','1.19'),
('3','2362','0.98007'),
('3','2363','2.05338'),
('3','2364','2.24'),
('3','2365','1.02669'),
('3','2366','1.16669'),
('3','2367','3.08'),
('3','2368','3.92'),
('3','2369','4.29324'),
('3','2370','3.92'),
('3','2371','4.85324'),
('3','2372','0.91'),
('3','2373','1.09669'),
('3','2374','1.96'),
('3','2375','2.52'),
('3','2376','3.36'),
('3','2377','2.66007'),
('3','2378','3.15'),
('3','2379','1.82'),
('3','2380','2.14662'),
('3','2381','1.82'),
('3','2382','2.14662'),
('3','2383','5.13345');
INSERT INTO `#__finder_links_terms2` VALUES 
('3','2384','5.83345'),
('3','2385','1.96'),
('3','2386','2.14662'),
('3','2387','2.47338'),
('3','2388','1.07331'),
('3','2389','1.30669'),
('3','2390','0.95669'),
('3','2391','1.19'),
('3','2392','1.07331'),
('3','2393','1.30669'),
('3','2394','1.86662'),
('3','2395','2.42662'),
('3','2396','0.37331'),
('3','2397','1.02669'),
('3','2398','1.30669'),
('3','2399','0.98'),
('3','2400','1.21331'),
('3','2401','1.86662'),
('3','2402','2.19338'),
('3','2403','1.4'),
('3','2404','2.87007'),
('3','2405','3.29007'),
('3','2406','1.91338'),
('3','2407','2.14662'),
('5','941','0.32669'),
('5','950','0.46662'),
('5','951','1.91338'),
('5','952','2.19338'),
('5','2357','0.46662'),
('5','2367','0.28'),
('5','2376','0.28'),
('5','2385','0.28'),
('5','2403','0.28'),
('5','3191','1.02669'),
('5','3192','1.21331'),
('5','3193','0.93331'),
('5','3194','1.09669'),
('5','3195','0.98'),
('5','3196','1.16669'),
('5','3197','1.02669'),
('5','3198','1.19'),
('5','3199','0.91'),
('5','3200','0.98'),
('5','3201','0.93331'),
('5','3202','1.12'),
('5','3203','1.00331'),
('5','3204','1.09669'),
('6','3418','0.28'),
('6','3419','0.98'),
('6','3420','1.07331');
INSERT INTO `#__finder_links_terms2` VALUES 
('6','3432','0.84'),
('6','3433','1.19'),
('6','3434','1.33'),
('6','3435','1.05'),
('6','3436','1.14331'),
('6','3437','0.23331'),
('6','3438','0.98'),
('6','3439','1.16669'),
('6','3440','1.96'),
('6','3441','1.02669'),
('6','3442','1.14331'),
('6','3443','4.66676'),
('6','3444','3.99'),
('6','3445','0.93331'),
('6','3446','1.16669'),
('6','3447','0.95669'),
('6','3448','1.14331'),
('7','3625','0.23331'),
('7','3626','0.95669'),
('7','3627','1.07331'),
('8','933','2.24'),
('8','934','5.46'),
('8','935','6.43986'),
('8','938','0.65338'),
('8','941','1.96014'),
('8','950','5.59944'),
('8','951','22.0039'),
('8','952','25.2239'),
('8','3706','0.42'),
('8','3707','1.77338'),
('8','3708','1.96'),
('8','3869','0.09331'),
('8','3870','0.88669'),
('8','3871','1.02669'),
('8','3872','0.09331'),
('8','3873','0.88669'),
('8','3874','1.02669'),
('8','3875','0.09331'),
('8','3876','0.88669'),
('8','3877','1.02669'),
('8','3878','0.09331'),
('8','3879','0.88669'),
('8','3880','1.02669'),
('8','3881','0.09331'),
('8','3882','0.88669'),
('8','3883','1.02669'),
('8','3884','0.09331'),
('8','3885','0.88669'),
('8','3886','1.02669'),
('8','3887','1.96014');
INSERT INTO `#__finder_links_terms2` VALUES 
('8','3888','0.98'),
('8','3889','1.05'),
('8','3890','0.98'),
('8','3891','1.05'),
('8','3892','0.95669'),
('8','3893','1.02669'),
('8','3894','0.95669'),
('8','3895','1.02669'),
('8','3896','1.00331'),
('8','3897','1.07331'),
('8','3898','0.95669'),
('8','3899','1.02669'),
('8','3900','0.37331'),
('8','3901','1.00331'),
('8','3902','1.07331'),
('8','3903','4.48056'),
('8','3904','0.86331'),
('8','3905','1.00331'),
('8','3906','0.84'),
('8','3907','0.98'),
('8','3908','1.05'),
('8','3909','1.19'),
('8','3910','0.91'),
('8','3911','1.07331'),
('8','3912','18.2'),
('8','3913','20.5338'),
('8','4550','1.82'),
('8','4551','2.05338'),
('8','4552','1.96'),
('8','4553','2.1'),
('8','4554','6.43986'),
('8','4555','7.27986'),
('8','4556','1.68'),
('8','4557','10.3597'),
('8','4558','12.3203'),
('8','4559','0.46662'),
('8','4560','1.86662'),
('8','4561','2.33338'),
('8','4562','1.07331'),
('8','4563','1.16669');

DROP TABLE IF EXISTS #__finder_links_terms3;
CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms3` VALUES 
('3','925','1.11996'),
('3','2341','0.28'),
('3','2342','0.95669'),
('3','2343','1.16669'),
('3','2344','1.63317'),
('3','2345','1.05'),
('3','2346','1.14331'),
('3','2347','0.95669'),
('3','2348','1.05'),
('3','2349','2.73'),
('3','2350','3.08007'),
('3','2351','1.82'),
('3','2352','2.24'),
('5','925','1.11996'),
('6','925','1.11996'),
('6','3426','0.09331'),
('6','3427','0.95669'),
('6','3428','1.12'),
('6','3429','0.28'),
('6','3430','1.05'),
('6','3431','1.12'),
('7','925','1.11996'),
('8','925','1.11996'),
('8','4540','0.46662'),
('8','4541','2.00662'),
('8','4542','2.56662'),
('8','4543','0.74676'),
('8','4544','3.54676'),
('8','4545','3.08007'),
('8','4546','1.12'),
('8','4547','0.56007'),
('8','4548','2.66007'),
('8','4549','3.08007');

DROP TABLE IF EXISTS #__finder_links_terms4;
CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms4` VALUES 
('3','129','0.23331'),
('3','140','1.63345'),
('3','141','1.09669'),
('3','142','1.21331'),
('3','143','0.51331'),
('3','146','5.1331'),
('3','147','2.42662'),
('3','148','2.66'),
('3','149','1.23669'),
('3','150','1.35331'),
('3','151','2.1'),
('3','152','1.02669'),
('3','153','1.14331'),
('3','157','0.84'),
('3','1060','0.60669'),
('3','2102','0.28'),
('3','2103','1.00331'),
('3','2104','1.07331'),
('3','2105','0.98'),
('3','2106','1.09669'),
('3','2107','4.01324'),
('3','2108','4.38676'),
('3','2109','1.07331'),
('3','2110','1.14331'),
('3','2111','0.84'),
('3','2112','3.00993'),
('3','2113','3.71007'),
('3','2114','1.14331'),
('3','2115','1.33'),
('3','2116','1.07331'),
('3','2117','1.21331'),
('3','2118','1.23669'),
('3','2119','1.4'),
('3','2120','2.24'),
('3','2121','2.38'),
('3','2122','2.33338'),
('3','2123','2.70662'),
('3','2124','3.00993'),
('3','2125','3.57'),
('3','2126','1.00331'),
('3','2127','1.12'),
('3','2128','1.09669'),
('3','2129','1.35331'),
('3','2130','1.02669'),
('3','2131','1.14331'),
('3','2132','0.74676'),
('3','2133','3.00993'),
('3','2134','3.57'),
('3','2135','0.86331'),
('3','2136','0.98');
INSERT INTO `#__finder_links_terms4` VALUES 
('3','2137','0.28'),
('3','2138','1.09669'),
('3','2139','1.23669'),
('3','2622','1.07331'),
('3','2623','1.30669'),
('3','2624','1.96014'),
('3','2625','0.91'),
('3','2626','1.05'),
('3','2627','1.00331'),
('3','2628','1.09669'),
('3','2629','1.86662'),
('3','2630','2.19338'),
('3','2631','2.1'),
('3','2632','2.47338'),
('3','2633','0.69993'),
('3','2634','1.77338'),
('3','2635','2.24'),
('3','2636','0.91'),
('3','2637','1.02669'),
('3','2638','0.56'),
('3','2639','2.1'),
('3','2640','2.28662'),
('5','140','0.65338'),
('5','146','1.02662'),
('5','147','2.42662'),
('5','148','2.66'),
('5','2111','0.28'),
('5','2137','0.28'),
('5','2633','0.23331'),
('5','2638','0.28'),
('5','3120','1.02669'),
('5','3121','1.12'),
('5','3122','0.95669'),
('5','3123','1.00331'),
('5','3124','0.95669'),
('5','3125','1.05'),
('5','3126','1.00331'),
('5','3127','1.19'),
('5','3255','0.98'),
('5','3256','1.21331'),
('5','3257','0.98'),
('5','3258','1.05'),
('5','3333','0.09331'),
('6','3344','0.23331'),
('6','3345','0.91'),
('6','3346','1.07331'),
('6','3373','0.93324'),
('6','3374','3.64'),
('6','3375','4.10676'),
('6','3376','2.42676');
INSERT INTO `#__finder_links_terms4` VALUES 
('6','3377','3.50007'),
('6','3378','4.2'),
('6','3379','0.42'),
('6','3380','1.12'),
('6','3381','1.28331'),
('6','3484','0.46669'),
('6','3485','1.09669'),
('6','3486','1.21331'),
('6','3549','0.14'),
('6','3550','0.84'),
('6','3551','1.07331'),
('7','3373','0.23331'),
('7','3549','0.28'),
('7','3582','0.14'),
('7','3583','0.95669'),
('7','3584','1.02669'),
('7','3585','0.93331'),
('7','3586','1.02669'),
('7','3587','0.32669'),
('7','3588','0.93331'),
('7','3589','1.14331'),
('7','3590','0.32669'),
('7','3591','1.02669'),
('7','3592','1.14331'),
('7','3593','0.14'),
('7','3594','0.93331'),
('7','3595','1.09669'),
('7','3702','0.86331'),
('7','3703','1.05'),
('7','3704','0.88669'),
('7','3705','0.95669'),
('8','140','0.65338'),
('8','141','2.19338'),
('8','142','2.42662'),
('8','143','6.15972'),
('8','146','14.3727'),
('8','147','19.413'),
('8','148','21.28'),
('8','149','14.8403'),
('8','150','16.2397'),
('8','151','0.84'),
('8','152','2.05338'),
('8','153','2.28662'),
('8','157','7.56'),
('8','1060','1.21338'),
('8','3788','0.04669'),
('8','3789','0.86331'),
('8','3790','1.00331'),
('8','3791','0.23331'),
('8','3792','0.95669');
INSERT INTO `#__finder_links_terms4` VALUES 
('8','3793','1.07331'),
('8','3794','0.32669'),
('8','3795','1.02669'),
('8','3796','1.14331'),
('8','3797','12.8797'),
('8','3798','15.3997'),
('8','3799','0.32669'),
('8','3800','1.02669'),
('8','3801','1.33'),
('8','3802','6.3'),
('8','3803','7.42014'),
('8','3804','12.0397'),
('8','3805','13.44'),
('8','3806','0.23331'),
('8','3807','0.98'),
('8','3808','1.09669'),
('8','4640','0.93345'),
('8','4641','4.55'),
('8','4642','1.07331'),
('8','4643','1.14331'),
('8','4644','1.02669'),
('8','4645','1.02669'),
('8','4646','1.07331'),
('8','4647','2.24'),
('8','4648','2.47338');

DROP TABLE IF EXISTS #__finder_links_terms5;
CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_links_terms6;
CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms6` VALUES 
('3','956','0.69993'),
('3','957','0.98'),
('3','965','0.56'),
('3','980','0.23331'),
('3','981','0.98'),
('3','982','1.09669'),
('3','992','1.63317'),
('3','2408','0.74662'),
('3','2409','2.14662'),
('3','2410','2.47338'),
('3','2411','1.05'),
('3','2412','0.98'),
('3','2413','1.23669'),
('3','2414','0.88669'),
('3','2415','1.00331'),
('3','2416','2.1'),
('3','2417','1.14331'),
('3','2418','1.23669'),
('3','2419','4.57324'),
('3','2420','5.13324'),
('3','2421','0.69993'),
('3','2422','0.88669'),
('3','2423','1.07331'),
('3','2424','0.95669'),
('3','2425','1.16669'),
('3','2426','1.00331'),
('3','2427','1.26'),
('3','2428','0.56'),
('3','2429','1.82'),
('3','2430','1.05'),
('3','2431','1.21331'),
('3','2432','2.14662'),
('3','2433','2.38'),
('3','2434','0.69993'),
('3','2435','1.96'),
('3','2436','2.42662'),
('3','2437','1.02669'),
('3','2438','1.23669'),
('3','2439','0.18662'),
('3','2440','0.88669'),
('3','2441','1.02669'),
('3','2442','1.02669'),
('3','2443','1.30669'),
('3','2444','4.78345'),
('3','2445','5.6'),
('3','2446','0.88669'),
('3','2447','1.16669'),
('3','2448','0.91'),
('3','2449','1.12'),
('5','956','0.23331');
INSERT INTO `#__finder_links_terms6` VALUES 
('5','965','1.96'),
('5','2408','0.37331'),
('5','2434','0.46662'),
('5','2435','0.98'),
('5','2439','0.09331'),
('5','3205','0.95669'),
('5','3206','1.14331'),
('5','3207','0.98'),
('5','3208','1.23669'),
('5','3209','1.02669'),
('5','3210','1.23669'),
('5','3211','0.91'),
('5','3212','1.02669'),
('5','3213','2.73'),
('5','3214','3.15'),
('5','3215','1.05'),
('5','3216','1.12'),
('5','3217','0.98'),
('5','3218','1.19'),
('5','3219','1.05'),
('5','3220','1.02669'),
('5','3221','1.12'),
('5','3222','0.81669'),
('5','3223','0.88669'),
('5','3224','0.84'),
('5','3225','3.00993'),
('5','3226','3.29007'),
('6','983','1.12'),
('6','995','0.74676'),
('6','3449','0.28'),
('6','3450','1.00331'),
('6','3451','1.19'),
('6','3452','0.56'),
('6','3453','1.07331'),
('6','3454','1.35331'),
('6','3455','1.05'),
('6','3456','1.19'),
('6','3457','0.32669'),
('6','3458','0.95669'),
('6','3459','1.19'),
('6','3460','4.29324'),
('6','3461','4.66676'),
('6','3462','3.92'),
('6','3463','4.48'),
('7','983','2.88'),
('7','3628','2.05338'),
('7','3629','1.07331'),
('7','3630','1.26'),
('7','3631','0.91'),
('7','3632','1.00331');
INSERT INTO `#__finder_links_terms6` VALUES 
('7','3633','1.07331'),
('7','3634','1.21331'),
('7','3635','5.55'),
('7','3636','0.95669'),
('7','3637','1.05'),
('8','956','1.39986'),
('8','957','5.88'),
('8','965','3.36'),
('8','980','0.46662'),
('8','981','1.96'),
('8','982','2.19338'),
('8','983','1.12'),
('8','992','2.79972'),
('8','995','0.93345'),
('8','4564','0.65338'),
('8','4565','2.00662'),
('8','4566','2.28662'),
('8','4567','2.42662'),
('8','4568','1.09669'),
('8','4569','1.09669'),
('8','4570','2.42662'),
('8','4571','0.91'),
('8','4572','1.05'),
('8','4573','0.91'),
('8','4574','1.05'),
('8','4575','0.88669'),
('8','4576','1.00331'),
('8','4577','0.88669'),
('8','4578','1.02669'),
('8','4579','0.88669'),
('8','4580','1.02669'),
('8','4581','1.02669'),
('8','4582','1.19'),
('8','4583','6.43986'),
('8','4584','7.27986'),
('8','4585','0.95669'),
('8','4586','1.09669'),
('8','4587','0.95669'),
('8','4588','1.05'),
('8','4589','0.93331'),
('8','4590','1.07331'),
('8','4591','1.14331'),
('8','4592','1.21331'),
('8','4593','12.3203'),
('8','4594','13.7197'),
('8','4595','0.95669'),
('8','4596','1.07331'),
('8','4597','1.02669'),
('8','4598','1.14331'),
('8','4599','0.91');
INSERT INTO `#__finder_links_terms6` VALUES 
('8','4600','1.00331'),
('8','4601','0.91'),
('8','4602','1.02669'),
('8','4603','0.95669'),
('8','4604','1.12');

DROP TABLE IF EXISTS #__finder_links_terms7;
CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms7` VALUES 
('3','1007','1.68'),
('3','1010','0.93345'),
('3','1011','0.86331'),
('3','1012','1.05'),
('3','1013','0.56007'),
('3','1016','0.32669'),
('3','1017','1.16669'),
('3','1018','1.35331'),
('3','1022','0.74676'),
('3','1049','0.93345'),
('3','1050','0.98'),
('3','1051','1.28331'),
('3','1145','0.32669'),
('3','1146','1.05'),
('3','1151','0.64008'),
('3','1152','1.30634'),
('3','1153','0.93331'),
('3','1154','1.00331'),
('3','1155','0.86331'),
('3','1156','0.93331'),
('3','1157','0.91'),
('3','1158','0.98'),
('3','2450','0.98'),
('3','2451','2.79993'),
('3','2452','3.21993'),
('3','2453','0.84'),
('3','2454','1.02669'),
('3','2455','2.87007'),
('3','2456','3.36'),
('3','2457','0.98'),
('3','2458','0.88669'),
('3','2459','0.95669'),
('3','2460','3.54676'),
('3','2461','3.82676'),
('3','2462','1.00331'),
('3','2463','1.09669'),
('3','2464','3.82676'),
('3','2465','1.09669'),
('3','2466','1.02669'),
('3','2467','2.28662'),
('3','2468','0.84'),
('3','2469','1.00331'),
('3','2470','1.63317'),
('3','2471','2.87007'),
('3','2472','3.21993'),
('3','2473','2.79993'),
('3','2474','3.08007'),
('3','2475','1.02669'),
('3','2476','1.23669'),
('3','2477','1.49352');
INSERT INTO `#__finder_links_terms7` VALUES 
('3','2478','1.86662'),
('3','2479','2.05338'),
('3','2480','4.43345'),
('3','2481','5.13345'),
('3','2482','0.91'),
('3','2483','0.98'),
('3','2484','1.68'),
('3','2485','2.05338'),
('3','2486','1.96'),
('3','2487','2.1'),
('3','2488','1.02669'),
('3','2489','1.12'),
('3','2490','0.86331'),
('3','2491','1.12'),
('3','2492','0.86331'),
('3','2493','1.02669'),
('3','2494','0.42'),
('3','2495','1.05'),
('3','2496','1.23669'),
('3','2497','0.93331'),
('3','2498','1.16669'),
('3','2499','0.98'),
('3','2500','1.12'),
('3','2501','4.6662'),
('3','2502','4.43345'),
('3','2503','4.48'),
('3','2504','1.02669'),
('3','2505','3.08007'),
('3','2506','3.36'),
('3','2507','3.08007'),
('3','2508','3.57'),
('3','2509','0.95669'),
('3','2510','1.02669'),
('3','2511','1.02669'),
('3','2512','1.09669'),
('3','2513','4.2'),
('3','2514','4.94676'),
('3','2515','1.09669'),
('3','2516','1.23669'),
('3','2517','2.14662'),
('3','2518','2.56662'),
('3','2519','0.86331'),
('3','2520','1.00331'),
('3','2521','0.93331'),
('3','2522','1.07331'),
('3','2523','0.88669'),
('3','2524','0.95669'),
('3','2525','1.00331'),
('3','2526','1.19'),
('3','2604','0.74676');
INSERT INTO `#__finder_links_terms7` VALUES 
('3','2605','1.72662'),
('3','2606','2.14662'),
('3','2607','0.91'),
('3','2608','1.12'),
('3','2609','0.93331'),
('3','2610','1.07331'),
('3','2611','0.93331'),
('3','2612','1.07331'),
('3','2613','0.86331'),
('3','2614','1.00331'),
('3','2615','0.91'),
('3','2616','0.98'),
('3','2617','1.00331'),
('3','2618','1.05'),
('3','2619','0.65338'),
('3','2620','2.24'),
('3','2621','2.56662'),
('3','2733','1.14331'),
('3','2734','0.51331'),
('3','2735','1.09669'),
('3','2736','1.28331'),
('3','2737','1.49324'),
('3','2738','2.05338'),
('3','2739','2.24'),
('3','2740','1.96'),
('3','2741','2.1'),
('3','2742','3.36'),
('3','2743','2.19338'),
('3','2744','2.56662'),
('3','2745','2.1'),
('3','2746','2.33338'),
('3','2747','4.2'),
('3','2748','3.57'),
('3','2749','1.26'),
('3','2750','1.49352'),
('3','2751','1.02669'),
('3','2752','1.12'),
('3','2753','0.91'),
('3','2754','1.02669'),
('3','2755','1.72662'),
('3','2756','2.14662'),
('3','2757','1.91338'),
('3','2758','2.14662'),
('3','2759','1.91338'),
('3','2760','2.05338'),
('3','2761','1.96'),
('3','2762','2.19338'),
('3','2763','3.64'),
('3','2764','4.2'),
('3','2765','0.88669');
INSERT INTO `#__finder_links_terms7` VALUES 
('3','2766','0.95669'),
('3','2767','0.91'),
('3','2768','1.02669'),
('3','2769','1.63338'),
('3','2770','2.1'),
('3','2771','1.00331'),
('3','2772','1.16669'),
('5','1007','0.28'),
('5','1010','0.37338'),
('5','1011','0.86331'),
('5','1151','0.64008'),
('5','1152','0.55986'),
('5','2477','0.18669'),
('5','2494','0.14'),
('5','2501','0.46662'),
('5','2737','0.37331'),
('5','3227','0.93331'),
('5','3228','1.05'),
('5','3229','0.91'),
('5','3230','1.07331'),
('5','3231','1.00331'),
('5','3232','1.19'),
('5','3233','0.88669'),
('5','3234','1.05'),
('5','3235','0.98'),
('5','3236','0.95669'),
('5','3237','1.19'),
('5','3238','0.95669'),
('5','3239','1.02669'),
('5','3240','1.05'),
('5','3241','1.12'),
('5','3242','0.28'),
('5','3243','0.93331'),
('5','3244','1.07331'),
('5','3294','0.98'),
('5','3295','1.21331'),
('5','3296','2.79993'),
('5','3297','3.21993'),
('5','3298','0.81669'),
('5','3299','0.95669'),
('5','3300','0.86331'),
('5','3301','1.07331'),
('5','3302','0.91'),
('5','3303','1.05'),
('6','1151','0.64008'),
('6','3464','0.28'),
('6','3465','0.93331'),
('6','3466','1.07331'),
('6','3532','0.23331'),
('6','3533','0.95669');
INSERT INTO `#__finder_links_terms7` VALUES 
('6','3534','1.21331'),
('6','3535','1.30676'),
('6','3536','1.05'),
('6','3537','1.14331'),
('6','3538','1.02669'),
('6','3539','1.23669'),
('6','3540','2.05338'),
('6','3541','1.30669'),
('6','3542','1.23669'),
('7','1151','0.64008'),
('7','3638','0.74676'),
('7','3639','0.86331'),
('7','3640','0.91'),
('7','3641','1.05'),
('7','3642','1.21331'),
('7','3643','2.33338'),
('7','3644','1.4'),
('7','3645','1.33'),
('7','3689','0.28'),
('7','3690','1.72662'),
('7','3691','1.05'),
('7','3692','1.09669'),
('8','1007','1.68'),
('8','1010','0.37338'),
('8','1011','1.72662'),
('8','1012','2.1'),
('8','1013','2.24028'),
('8','1016','0.65338'),
('8','1017','2.33338'),
('8','1018','2.70662'),
('8','1022','11.3881'),
('8','1049','2.61366'),
('8','1050','1.96'),
('8','1051','2.56662'),
('8','1145','0.65338'),
('8','1146','2.1'),
('8','1151','0.64008'),
('8','1152','1.11972'),
('8','1153','1.86662'),
('8','1154','2.00662'),
('8','1155','1.72662'),
('8','1156','1.86662'),
('8','1157','7.28'),
('8','1158','5.88'),
('8','4605','0.18669'),
('8','4606','1.12'),
('8','4607','1.35331'),
('8','4608','10.5236'),
('8','4609','12.32'),
('8','4610','1.09669');
INSERT INTO `#__finder_links_terms7` VALUES 
('8','4611','1.26'),
('8','4612','10.92'),
('8','4613','12.0397'),
('8','4614','0.32669'),
('8','4615','1.02669'),
('8','4616','1.09669'),
('8','4617','54.0881'),
('8','4618','61.2019'),
('8','4638','11.4803'),
('8','4639','14.0003'),
('8','4709','0.18662'),
('8','4710','1.77338'),
('8','4711','1.96'),
('8','4712','2.33338'),
('8','4713','0.42'),
('8','4714','1.05'),
('8','4715','1.16669'),
('8','4716','1.96');

DROP TABLE IF EXISTS #__finder_links_terms8;
CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms8` VALUES 
('3','168','0.09331'),
('3','171','0.93331'),
('3','172','1.09669'),
('3','178','1.16655'),
('3','179','0.88669'),
('3','180','1.21331'),
('3','181','1.82'),
('3','182','2.05338'),
('3','183','0.56'),
('3','184','0.98'),
('3','185','1.14331'),
('3','186','0.56007'),
('3','187','0.91'),
('3','188','1.05'),
('3','228','2.09979'),
('3','240','0.18669'),
('3','889','0.83979'),
('3','890','1.07331'),
('3','892','0.46669'),
('3','893','1.00331'),
('3','894','1.16669'),
('3','895','0.6666'),
('3','899','0.69993'),
('3','900','2.87007'),
('3','901','2.1'),
('3','908','0.23331'),
('3','909','0.95669'),
('3','910','1.02669'),
('3','1043','0.23331'),
('3','2140','1.30676'),
('3','2141','1.02669'),
('3','2142','1.09669'),
('3','2143','3.42993'),
('3','2144','2.42662'),
('3','2145','1.21331'),
('3','2146','1.12'),
('3','2147','2.94'),
('3','2148','3.21993'),
('3','2149','1.07331'),
('3','2150','1.19'),
('3','2151','0.91'),
('3','2152','1.19'),
('3','2153','0.93331'),
('3','2154','1.14331'),
('3','2155','0.91'),
('3','2156','1.07331'),
('3','2157','2.3331'),
('3','2158','2.79993'),
('3','2159','3.21993'),
('3','2160','1.00331');
INSERT INTO `#__finder_links_terms8` VALUES 
('3','2161','1.09669'),
('3','2162','4.55'),
('3','2163','5.13345'),
('3','2164','0.91'),
('3','2165','1.02669'),
('3','2166','0.14'),
('3','2167','0.95669'),
('3','2168','1.14331'),
('3','2169','1.72662'),
('3','2170','0.98'),
('3','2255','1.11993'),
('3','2256','2.94'),
('3','2257','3.42993'),
('3','2258','2.1'),
('3','2259','4.01324'),
('3','2260','4.48'),
('3','2261','1.00331'),
('3','2262','1.12'),
('3','2263','0.37331'),
('3','2264','0.95669'),
('3','2265','1.09669'),
('3','2266','4.2'),
('3','2267','4.57324'),
('3','2268','0.88669'),
('3','2269','1.05'),
('3','2270','1.91338'),
('3','2271','2.33338'),
('3','2272','1.82'),
('3','2273','2.05338'),
('3','2274','0.42'),
('3','2275','1.05'),
('3','2276','1.14331'),
('3','2277','1.30676'),
('3','2278','0.91'),
('3','2279','1.05'),
('3','2280','0.98'),
('3','2281','1.05'),
('3','2282','2.14662'),
('3','2283','2.47338'),
('3','2284','0.98'),
('3','2285','1.16669'),
('3','2286','0.42'),
('3','2287','1.05'),
('3','2288','1.14331'),
('3','2289','0.28'),
('3','2290','0.98'),
('3','2291','1.19'),
('3','2292','0.23331'),
('3','2293','0.88669'),
('3','2294','1.02669');
INSERT INTO `#__finder_links_terms8` VALUES 
('3','2309','0.98007'),
('3','2310','3.00993'),
('3','2311','3.29007'),
('3','2312','0.37324'),
('3','2313','0.86331'),
('3','2314','0.98'),
('3','2315','1.82'),
('3','2316','2.1'),
('3','2317','2.1'),
('3','2318','2.05338'),
('3','2319','2.38'),
('3','2320','2.1'),
('3','2321','2.28662'),
('3','2322','1.00331'),
('3','2323','1.16669'),
('3','2324','0.93331'),
('3','2325','1.09669'),
('3','2326','0.91'),
('3','2327','1.02669'),
('3','2328','1.14331'),
('3','2329','1.96'),
('3','2330','2.19338'),
('3','2331','1.00331'),
('3','2332','1.07331'),
('3','2333','0.98'),
('3','2334','1.12'),
('3','2335','1.91338'),
('3','2336','2.24'),
('3','2337','1.11993'),
('3','2338','3.15'),
('3','2339','3.50007'),
('3','2340','1.07331'),
('3','2539','0.37331'),
('3','2540','0.95669'),
('3','2541','1.12'),
('3','2542','3.92'),
('3','2543','2.42662'),
('3','2544','2.70662'),
('3','2545','4.57324'),
('3','2546','5.13324'),
('3','2547','1.14331'),
('3','2548','1.26'),
('3','2549','0.74662'),
('3','2550','2.1'),
('3','2551','2.38'),
('3','2552','0.42'),
('3','2553','1.14331'),
('3','2554','1.21331'),
('3','2555','1.86655'),
('3','2556','3.50007');
INSERT INTO `#__finder_links_terms8` VALUES 
('3','2557','1.4'),
('3','2558','2.75338'),
('3','2559','1.07331'),
('3','2560','1.28331'),
('3','2561','1.00331'),
('3','2562','1.07331'),
('3','2563','0.91'),
('3','2564','1.07331'),
('3','2565','2.52'),
('3','2566','4.38676'),
('3','2567','4.94676'),
('3','2568','1.02669'),
('3','2569','1.12'),
('3','2570','1.19'),
('3','2571','1.33'),
('3','2572','0.74662'),
('3','2573','2.19338'),
('3','2574','2.52'),
('3','2575','3.59359'),
('3','2576','1.00331'),
('3','2577','1.09669'),
('3','2578','4.66676'),
('3','2579','5.32'),
('3','2580','0.95669'),
('3','2581','1.07331'),
('3','2582','5.01655'),
('3','2583','5.71655'),
('3','2584','0.46662'),
('3','2585','1.00331'),
('3','2586','1.19'),
('3','2587','1.05'),
('3','2588','1.19'),
('3','2589','1.86655'),
('3','2590','0.93331'),
('3','2591','1.05'),
('3','2592','2.19338'),
('3','2593','2.8'),
('3','2594','2.1'),
('3','2595','2.42662'),
('3','2596','1.63317'),
('3','2597','3.64'),
('3','2598','3.42993'),
('3','2599','0.98'),
('3','2600','0.91'),
('3','2601','1.02669'),
('3','2602','1.82'),
('3','2603','2.19338'),
('5','178','1.16655'),
('5','181','1.82'),
('5','182','2.05338');
INSERT INTO `#__finder_links_terms8` VALUES 
('5','228','0.46662'),
('5','889','0.65317'),
('5','895','0.6666'),
('5','899','0.69993'),
('5','900','1.91338'),
('5','901','2.1'),
('5','1046','0.65338'),
('5','2140','0.98007'),
('5','2146','0.28'),
('5','2263','0.37331'),
('5','2309','0.65338'),
('5','2552','0.42'),
('5','2575','0.32669'),
('5','3088','0.34'),
('5','3128','3.00993'),
('5','3129','1.16669'),
('5','3130','1.26'),
('5','3131','1.07331'),
('5','3132','0.95669'),
('5','3133','1.09669'),
('5','3134','0.98'),
('5','3135','1.05'),
('5','3136','1.07331'),
('5','3137','1.26'),
('5','3138','0.88669'),
('5','3169','1.02669'),
('5','3170','1.16669'),
('5','3171','0.86331'),
('5','3172','1.12'),
('5','3173','0.93331'),
('5','3174','1.02669'),
('5','3175','1.02669'),
('5','3176','1.09669'),
('5','3177','1.09669'),
('5','3178','1.21331'),
('5','3179','2.66007'),
('5','3180','3.15'),
('5','3181','0.86331'),
('5','3182','1.00331'),
('5','3183','0.91'),
('5','3184','1.05'),
('5','3185','0.93331'),
('5','3186','1.16669'),
('5','3187','0.81669'),
('5','3188','0.98'),
('5','3189','0.88669'),
('5','3190','1.00331'),
('5','3247','1.00331'),
('5','3248','1.12'),
('5','3249','0.93331');
INSERT INTO `#__finder_links_terms8` VALUES 
('5','3250','1.09669'),
('5','3251','1.09669'),
('5','3252','1.28331'),
('5','3253','1.02669'),
('5','3254','1.14331'),
('6','895','0.6666'),
('6','911','0.09331'),
('6','3341','0.51331'),
('6','3342','1.09669'),
('6','3343','1.19'),
('6','3382','0.32669'),
('6','3383','0.95669'),
('6','3384','1.12'),
('6','3385','0.37331'),
('6','3386','1.07331'),
('6','3387','1.14331'),
('6','3388','1.30676'),
('6','3389','4.01324'),
('6','3390','4.66676'),
('6','3391','0.42'),
('6','3392','1.07331'),
('6','3393','1.33'),
('6','3394','0.46669'),
('6','3401','0.7'),
('6','3402','1.00331'),
('6','3403','1.16669'),
('6','3404','0.91'),
('6','3405','1.05'),
('6','3406','0.93331'),
('6','3407','1.09669'),
('6','3408','0.93331'),
('6','3409','1.02669'),
('6','3410','0.91'),
('6','3411','1.07331'),
('6','3412','0.42'),
('6','3413','1.12'),
('6','3414','1.28331'),
('6','3415','0.23331'),
('6','3416','1.07331'),
('6','3417','1.23669'),
('6','3421','0.37331'),
('6','3422','1.05'),
('6','3423','1.23669'),
('6','3424','0.88669'),
('6','3425','1.02669'),
('6','3473','0.74662'),
('6','3474','1.02669'),
('6','3475','1.12'),
('6','3476','0.98'),
('6','3477','1.14331');
INSERT INTO `#__finder_links_terms8` VALUES 
('6','3478','3.9'),
('6','3479','4.01324'),
('6','3480','1.14331'),
('6','3481','1.16669'),
('6','3482','1.16669'),
('6','3483','1.14331'),
('7','895','0.6666'),
('7','3401','0.28'),
('7','3596','0.32669'),
('7','3597','0.95669'),
('7','3598','1.12'),
('7','3599','0.65338'),
('7','3600','0.91'),
('7','3601','1.00331'),
('7','3602','1.09669'),
('7','3603','1.21331'),
('7','3604','0.65331'),
('7','3605','1.19'),
('7','3606','1.26'),
('7','3610','0.84'),
('7','3611','1.12'),
('7','3612','1.21331'),
('7','3613','1.02669'),
('7','3614','1.12'),
('7','3615','1.12'),
('7','3616','1.28331'),
('7','3617','0.93331'),
('7','3618','1.16669'),
('7','3622','0.09331'),
('7','3623','0.84'),
('7','3624','0.95669'),
('7','3649','0.42'),
('7','3650','1.05'),
('7','3651','1.19'),
('8','168','1.11972'),
('8','171','7.46648'),
('8','172','8.77352'),
('8','178','5.83275'),
('8','179','1.77338'),
('8','180','2.42662'),
('8','181','20.93'),
('8','182','23.6139'),
('8','183','1.68'),
('8','184','5.88'),
('8','185','6.85986'),
('8','186','14.0017'),
('8','187','1.82'),
('8','188','2.1'),
('8','228','1.39986'),
('8','240','0.18669');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','889','0.18662'),
('8','890','2.14662'),
('8','892','3.73352'),
('8','893','8.02648'),
('8','894','9.33352'),
('8','895','0.6666'),
('8','899','19.598'),
('8','900','22.0039'),
('8','901','24.15'),
('8','908','0.46662'),
('8','909','1.91338'),
('8','910','2.05338'),
('8','911','0.55986'),
('8','1043','1.39986'),
('8','1046','1.30676'),
('8','3729','0.56'),
('8','3730','1.77338'),
('8','3731','1.96'),
('8','3809','2.24028'),
('8','3810','12.0397'),
('8','3811','13.7197'),
('8','3812','3.54676'),
('8','3813','4.2'),
('8','3814','0.56'),
('8','3815','2.73'),
('8','3816','2.1'),
('8','3817','1.16669'),
('8','3818','1.00331'),
('8','3819','1.14331'),
('8','3820','62.6281'),
('8','3821','69.7419'),
('8','3822','11.76'),
('8','3823','12.8797'),
('8','3837','1.00331'),
('8','3838','1.16669'),
('8','3839','4.66655'),
('8','3840','5.01655'),
('8','3841','0.42'),
('8','3842','2.73'),
('8','3843','2.1'),
('8','3844','1.07331'),
('8','3845','0.18669'),
('8','3846','0.86331'),
('8','3847','1.00331'),
('8','3848','0.91'),
('8','3849','1.23669'),
('8','3850','0.18669'),
('8','3851','0.86331'),
('8','3852','1.00331'),
('8','3914','0.18669');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','3915','0.95669'),
('8','3916','1.07331'),
('8','3917','0.51331'),
('8','3918','1.19'),
('8','3919','1.4'),
('8','3920','0.7'),
('8','3921','1.4'),
('8','3922','1.4'),
('8','3923','0.7'),
('8','3924','1.35331'),
('8','3925','1.4'),
('8','3926','0.7'),
('8','3927','1.4'),
('8','3928','1.4'),
('8','3929','0.7'),
('8','3930','1.4'),
('8','3931','1.4'),
('8','3932','0.7'),
('8','3933','1.4'),
('8','3934','1.4'),
('8','3935','0.7'),
('8','3936','1.4'),
('8','3937','1.4'),
('8','3938','0.7'),
('8','3939','1.4'),
('8','3940','1.4'),
('8','3941','0.60669'),
('8','3942','1.37669'),
('8','3943','1.4'),
('8','3944','0.60669'),
('8','3945','1.23669'),
('8','3946','1.4'),
('8','3947','0.60669'),
('8','3948','1.23669'),
('8','3949','1.4'),
('8','3950','0.7'),
('8','3951','1.4'),
('8','3952','1.4'),
('8','3953','0.56'),
('8','3954','1.19'),
('8','3955','1.4'),
('8','3956','0.42'),
('8','3957','1.30669'),
('8','3958','1.4'),
('8','3959','0.42'),
('8','3960','1.19'),
('8','3961','1.4'),
('8','3962','0.42'),
('8','3963','1.23669'),
('8','3964','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','3965','0.60669'),
('8','3966','1.26'),
('8','3967','1.4'),
('8','3968','0.65331'),
('8','3969','1.4'),
('8','3970','1.4'),
('8','3971','0.60669'),
('8','3972','1.23669'),
('8','3973','1.4'),
('8','3974','0.60669'),
('8','3975','1.28331'),
('8','3976','1.4'),
('8','3977','0.51331'),
('8','3978','1.19'),
('8','3979','1.4'),
('8','3980','0.7'),
('8','3981','1.4'),
('8','3982','1.4'),
('8','3983','0.46669'),
('8','3984','1.16669'),
('8','3985','1.4'),
('8','3986','0.7'),
('8','3987','1.4'),
('8','3988','1.4'),
('8','3989','0.7'),
('8','3990','1.4'),
('8','3991','1.4'),
('8','3992','0.7'),
('8','3993','1.4'),
('8','3994','1.4'),
('8','3995','0.7'),
('8','3996','1.4'),
('8','3997','1.4'),
('8','3998','0.7'),
('8','3999','1.4'),
('8','4000','1.4'),
('8','4001','0.7'),
('8','4002','1.4'),
('8','4003','1.4'),
('8','4004','0.7'),
('8','4005','1.4'),
('8','4006','1.4'),
('8','4007','0.7'),
('8','4008','1.4'),
('8','4009','1.4'),
('8','4010','0.46669'),
('8','4011','1.26'),
('8','4012','1.4'),
('8','4013','0.7'),
('8','4014','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4015','1.4'),
('8','4016','0.7'),
('8','4017','1.4'),
('8','4018','1.4'),
('8','4019','0.37331'),
('8','4020','1.14331'),
('8','4021','1.37669'),
('8','4022','0.7'),
('8','4023','1.4'),
('8','4024','1.4'),
('8','4025','0.7'),
('8','4026','1.35331'),
('8','4027','1.4'),
('8','4028','0.56'),
('8','4029','1.26'),
('8','4030','1.4'),
('8','4031','0.7'),
('8','4032','1.37669'),
('8','4033','1.4'),
('8','4034','0.7'),
('8','4035','1.4'),
('8','4036','1.4'),
('8','4037','0.7'),
('8','4038','1.4'),
('8','4039','1.4'),
('8','4040','0.56'),
('8','4041','1.26'),
('8','4042','1.4'),
('8','4043','0.65331'),
('8','4044','1.37669'),
('8','4045','1.4'),
('8','4046','0.60669'),
('8','4047','1.28331'),
('8','4048','1.4'),
('8','4049','0.7'),
('8','4050','1.4'),
('8','4051','1.4'),
('8','4052','0.60669'),
('8','4053','1.35331'),
('8','4054','1.4'),
('8','4055','0.42'),
('8','4056','1.16669'),
('8','4057','1.4'),
('8','4058','0.46669'),
('8','4059','1.35331'),
('8','4060','1.4'),
('8','4061','0.60669'),
('8','4062','1.28331'),
('8','4063','1.4'),
('8','4064','0.42');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4065','1.16669'),
('8','4066','1.4'),
('8','4067','0.7'),
('8','4068','1.4'),
('8','4069','1.4'),
('8','4070','0.51331'),
('8','4071','1.4'),
('8','4072','1.4'),
('8','4073','0.51331'),
('8','4074','1.19'),
('8','4075','1.4'),
('8','4076','0.65331'),
('8','4077','1.4'),
('8','4078','1.4'),
('8','4079','0.60669'),
('8','4080','1.35331'),
('8','4081','1.4'),
('8','4082','0.7'),
('8','4083','1.4'),
('8','4084','1.4'),
('8','4085','0.7'),
('8','4086','1.4'),
('8','4087','1.4'),
('8','4088','0.7'),
('8','4089','1.4'),
('8','4090','1.4'),
('8','4091','0.42'),
('8','4092','1.14331'),
('8','4093','1.37669'),
('8','4094','0.42'),
('8','4095','1.23669'),
('8','4096','1.4'),
('8','4097','0.51331'),
('8','4098','1.30669'),
('8','4099','1.4'),
('8','4100','0.42'),
('8','4101','1.23669'),
('8','4102','1.4'),
('8','4103','0.42'),
('8','4104','1.28331'),
('8','4105','1.4'),
('8','4106','0.46669'),
('8','4107','1.23669'),
('8','4108','1.4'),
('8','4109','0.7'),
('8','4110','1.4'),
('8','4111','1.4'),
('8','4112','0.7'),
('8','4113','1.4'),
('8','4114','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4115','0.7'),
('8','4116','1.4'),
('8','4117','1.4'),
('8','4118','0.7'),
('8','4119','1.4'),
('8','4120','1.4'),
('8','4121','0.7'),
('8','4122','1.4'),
('8','4123','1.4'),
('8','4124','0.7'),
('8','4125','1.4'),
('8','4126','1.4'),
('8','4127','0.7'),
('8','4128','1.4'),
('8','4129','1.4'),
('8','4130','0.42'),
('8','4131','1.14331'),
('8','4132','1.4'),
('8','4133','0.56'),
('8','4134','1.4'),
('8','4135','1.4'),
('8','4136','0.7'),
('8','4137','1.4'),
('8','4138','1.4'),
('8','4139','0.37331'),
('8','4140','1.12'),
('8','4141','1.4'),
('8','4142','0.42'),
('8','4143','1.14331'),
('8','4144','1.37669'),
('8','4145','0.46669'),
('8','4146','1.19'),
('8','4147','1.4'),
('8','4148','0.46669'),
('8','4149','1.21331'),
('8','4150','1.4'),
('8','4151','0.65331'),
('8','4152','1.4'),
('8','4153','1.4'),
('8','4154','0.65331'),
('8','4155','1.33'),
('8','4156','1.4'),
('8','4157','0.7'),
('8','4158','1.4'),
('8','4159','1.4'),
('8','4160','0.56'),
('8','4161','1.33'),
('8','4162','1.4'),
('8','4163','0.60669'),
('8','4164','1.35331');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4165','1.4'),
('8','4166','0.37331'),
('8','4167','1.21331'),
('8','4168','1.4'),
('8','4169','0.51331'),
('8','4170','1.33'),
('8','4171','1.4'),
('8','4172','0.7'),
('8','4173','1.4'),
('8','4174','1.4'),
('8','4175','0.46669'),
('8','4176','1.16669'),
('8','4177','1.4'),
('8','4178','0.7'),
('8','4179','1.30669'),
('8','4180','1.4'),
('8','4181','0.42'),
('8','4182','1.14331'),
('8','4183','1.37669'),
('8','4184','0.51331'),
('8','4185','1.23669'),
('8','4186','1.4'),
('8','4187','0.46669'),
('8','4188','1.33'),
('8','4189','1.4'),
('8','4190','0.7'),
('8','4191','1.4'),
('8','4192','1.4'),
('8','4193','0.7'),
('8','4194','1.4'),
('8','4195','1.4'),
('8','4196','0.65331'),
('8','4197','1.4'),
('8','4198','1.4'),
('8','4199','0.51331'),
('8','4200','1.35331'),
('8','4201','1.4'),
('8','4202','0.42'),
('8','4203','1.14331'),
('8','4204','1.4'),
('8','4205','0.42'),
('8','4206','1.16669'),
('8','4207','1.4'),
('8','4208','0.42'),
('8','4209','1.30669'),
('8','4210','1.4'),
('8','4211','0.60669'),
('8','4212','1.23669'),
('8','4213','1.4'),
('8','4214','0.42');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4215','1.14331'),
('8','4216','1.4'),
('8','4217','0.51331'),
('8','4218','1.21331'),
('8','4219','1.4'),
('8','4220','0.56'),
('8','4221','1.35331'),
('8','4222','1.4'),
('8','4223','0.51331'),
('8','4224','1.33'),
('8','4225','1.4'),
('8','4226','0.7'),
('8','4227','1.33'),
('8','4228','1.4'),
('8','4229','0.46669'),
('8','4230','1.19'),
('8','4231','1.4'),
('8','4232','0.7'),
('8','4233','1.4'),
('8','4234','1.4'),
('8','4235','0.42'),
('8','4236','1.35331'),
('8','4237','1.4'),
('8','4238','0.46669'),
('8','4239','1.21331'),
('8','4240','1.4'),
('8','4241','0.7'),
('8','4242','1.33'),
('8','4243','1.4'),
('8','4244','0.37331'),
('8','4245','1.16669'),
('8','4246','1.37669'),
('8','4247','0.32669'),
('8','4248','1.14331'),
('8','4249','1.4'),
('8','4250','0.65331'),
('8','4251','1.4'),
('8','4252','1.4'),
('8','4253','0.56'),
('8','4254','1.4'),
('8','4255','1.4'),
('8','4256','0.42'),
('8','4257','1.16669'),
('8','4258','1.4'),
('8','4259','0.65331'),
('8','4260','1.4'),
('8','4261','1.4'),
('8','4262','0.46669'),
('8','4263','1.16669'),
('8','4264','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4265','0.51331'),
('8','4266','1.21331'),
('8','4267','1.4'),
('8','4268','0.46669'),
('8','4269','1.23669'),
('8','4270','1.4'),
('8','4271','0.65331'),
('8','4272','1.28331'),
('8','4273','1.4'),
('8','4274','0.56'),
('8','4275','1.35331'),
('8','4276','1.4'),
('8','4277','0.46669'),
('8','4278','1.26'),
('8','4279','1.4'),
('8','4280','0.42'),
('8','4281','1.16669'),
('8','4282','1.4'),
('8','4283','0.7'),
('8','4284','1.35331'),
('8','4285','1.4'),
('8','4286','0.42'),
('8','4287','1.14331'),
('8','4288','1.4'),
('8','4289','0.65331'),
('8','4290','1.4'),
('8','4291','1.4'),
('8','4292','0.46669'),
('8','4293','1.21331'),
('8','4294','1.4'),
('8','4295','0.56'),
('8','4296','1.19'),
('8','4297','1.4'),
('8','4298','0.51331'),
('8','4299','1.26'),
('8','4300','1.4'),
('8','4301','0.7'),
('8','4302','1.4'),
('8','4303','1.4'),
('8','4304','0.51331'),
('8','4305','1.26'),
('8','4306','1.4'),
('8','4307','0.51331'),
('8','4308','1.19'),
('8','4309','1.4'),
('8','4310','0.56'),
('8','4311','1.30669'),
('8','4312','1.4'),
('8','4313','0.7'),
('8','4314','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4315','1.4'),
('8','4316','0.51331'),
('8','4317','1.26'),
('8','4318','1.4'),
('8','4319','0.7'),
('8','4320','1.4'),
('8','4321','1.4'),
('8','4322','0.7'),
('8','4323','1.37669'),
('8','4324','1.4'),
('8','4325','0.51331'),
('8','4326','1.26'),
('8','4327','1.4'),
('8','4328','0.7'),
('8','4329','1.4'),
('8','4330','1.4'),
('8','4331','0.7'),
('8','4332','1.4'),
('8','4333','1.4'),
('8','4334','0.7'),
('8','4335','1.4'),
('8','4336','1.4'),
('8','4337','0.7'),
('8','4338','1.4'),
('8','4339','1.4'),
('8','4340','0.56'),
('8','4341','1.4'),
('8','4342','1.4'),
('8','4343','0.42'),
('8','4344','1.33'),
('8','4345','1.4'),
('8','4346','0.42'),
('8','4347','1.14331'),
('8','4348','1.4'),
('8','4349','0.46669'),
('8','4350','1.21331'),
('8','4351','1.4'),
('8','4352','0.7'),
('8','4353','1.4'),
('8','4354','1.4'),
('8','4355','0.60669'),
('8','4356','1.33'),
('8','4357','1.4'),
('8','4358','0.51331'),
('8','4359','1.21331'),
('8','4360','1.4'),
('8','4361','0.42'),
('8','4362','1.30669'),
('8','4363','1.4'),
('8','4364','0.46669');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4365','1.19'),
('8','4366','1.4'),
('8','4367','0.65331'),
('8','4368','1.4'),
('8','4369','1.4'),
('8','4370','0.7'),
('8','4371','1.4'),
('8','4372','1.4'),
('8','4373','0.51331'),
('8','4374','1.16669'),
('8','4375','1.4'),
('8','4376','0.42'),
('8','4377','1.4'),
('8','4378','1.4'),
('8','4379','0.7'),
('8','4380','1.4'),
('8','4381','1.4'),
('8','4382','0.7'),
('8','4383','1.4'),
('8','4384','1.4'),
('8','4385','0.7'),
('8','4386','1.4'),
('8','4387','1.4'),
('8','4388','0.7'),
('8','4389','1.4'),
('8','4390','1.4'),
('8','4391','0.7'),
('8','4392','1.4'),
('8','4393','1.4'),
('8','4394','0.7'),
('8','4395','1.4'),
('8','4396','1.4'),
('8','4397','0.65331'),
('8','4398','1.37669'),
('8','4399','1.4'),
('8','4400','0.65331'),
('8','4401','1.37669'),
('8','4402','1.4'),
('8','4403','0.65331'),
('8','4404','1.4'),
('8','4405','1.4'),
('8','4406','0.7'),
('8','4407','1.4'),
('8','4408','1.4'),
('8','4409','0.7'),
('8','4410','1.4'),
('8','4411','1.4'),
('8','4412','0.42'),
('8','4413','1.28331'),
('8','4414','1.4');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4415','0.7'),
('8','4416','1.28331'),
('8','4417','1.4'),
('8','4418','0.46669'),
('8','4419','1.26'),
('8','4420','1.4'),
('8','4421','0.7'),
('8','4422','1.4'),
('8','4423','1.4'),
('8','4424','0.7'),
('8','4425','1.35331'),
('8','4426','1.4'),
('8','4427','0.42'),
('8','4428','1.21331'),
('8','4429','1.4'),
('8','4430','0.65331'),
('8','4431','1.4'),
('8','4432','1.4'),
('8','4433','0.37331'),
('8','4434','1.12'),
('8','4435','1.35331'),
('8','4436','0.42'),
('8','4437','1.14331'),
('8','4438','1.4'),
('8','4439','0.46669'),
('8','4440','1.21331'),
('8','4441','1.4'),
('8','4442','0.7'),
('8','4443','1.4'),
('8','4444','1.4'),
('8','4445','0.7'),
('8','4446','1.4'),
('8','4447','1.4'),
('8','4448','0.32669'),
('8','4449','1.16669'),
('8','4450','1.35331'),
('8','4451','0.60669'),
('8','4452','1.19'),
('8','4453','1.4'),
('8','4454','0.56'),
('8','4455','1.16669'),
('8','4456','1.4'),
('8','4457','0.7'),
('8','4458','1.4'),
('8','4459','1.4'),
('8','4460','0.65331'),
('8','4461','1.4'),
('8','4462','1.4'),
('8','4463','0.42'),
('8','4464','1.14331');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4465','1.4'),
('8','4466','0.42'),
('8','4467','1.14331'),
('8','4468','1.4'),
('8','4469','0.46669'),
('8','4470','1.19'),
('8','4471','1.4'),
('8','4472','0.60669'),
('8','4473','1.30669'),
('8','4474','1.4'),
('8','4475','0.46669'),
('8','4476','1.16669'),
('8','4477','1.4'),
('8','4478','0.7'),
('8','4479','1.4'),
('8','4480','1.4'),
('8','4481','0.7'),
('8','4482','1.23669'),
('8','4483','1.4'),
('8','4484','0.65331'),
('8','4485','1.30669'),
('8','4486','1.4'),
('8','4487','0.51331'),
('8','4488','1.21331'),
('8','4489','1.4'),
('8','4490','0.37331'),
('8','4491','1.09669'),
('8','4492','1.33'),
('8','4493','0.42'),
('8','4494','1.14331'),
('8','4495','1.4'),
('8','4496','0.7'),
('8','4497','1.4'),
('8','4498','1.4'),
('8','4499','0.7'),
('8','4500','1.4'),
('8','4501','1.4'),
('8','4502','0.65331'),
('8','4503','1.30669'),
('8','4504','1.4'),
('8','4505','0.7'),
('8','4506','1.35331'),
('8','4507','1.4'),
('8','4508','0.51331'),
('8','4509','1.21331'),
('8','4510','1.4'),
('8','4511','0.56'),
('8','4512','1.30669'),
('8','4513','1.4'),
('8','4514','0.60669');
INSERT INTO `#__finder_links_terms8` VALUES 
('8','4515','1.21331'),
('8','4516','1.4'),
('8','4517','0.23331'),
('8','4518','1.00331'),
('8','4519','1.21331'),
('8','4520','2.38'),
('8','4521','1.30676'),
('8','4522','4.2'),
('8','4523','4.66676'),
('8','4524','55.0653'),
('8','4525','68.8347'),
('8','4526','1.00331'),
('8','4527','1.14331'),
('8','4528','0.93331'),
('8','4529','1.05'),
('8','4530','0.46669'),
('8','4531','1.02669'),
('8','4532','1.14331'),
('8','4533','5.59986'),
('8','4534','1.05'),
('8','4535','1.05'),
('8','4536','1.02669'),
('8','4537','1.02669'),
('8','4538','1.07331'),
('8','4539','1.02669'),
('8','4631','1.12'),
('8','4632','2.1'),
('8','4633','2.38'),
('8','4634','6.01986'),
('8','4635','7.27986'),
('8','4636','3.92'),
('8','4637','4.10676');

DROP TABLE IF EXISTS #__finder_links_terms9;
CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_terms9` VALUES 
('3','1160','1.49324'),
('3','1163','0.28'),
('3','1164','0.95669'),
('3','1165','1.14331'),
('3','1166','0.98007'),
('3','2099','0.65338'),
('3','2100','2.05338'),
('3','2101','2.33338'),
('3','2773','1.96'),
('3','2774','2.00662'),
('3','2775','2.47338'),
('3','2776','2.87007'),
('3','2777','3.15'),
('3','2778','1.96'),
('3','2779','1.12'),
('3','2780','1.16669'),
('3','2781','1.02669'),
('3','2782','1.09669'),
('3','2783','2.1'),
('3','2784','2.24'),
('3','2785','1.12'),
('3','2786','1.23669'),
('3','2787','1.54'),
('3','2788','0.88669'),
('3','2789','1.05'),
('3','2790','1.91338'),
('3','2791','2.33338'),
('3','2792','0.98'),
('3','2793','1.09669'),
('3','2794','1.96'),
('3','2795','2.24'),
('3','2796','2.1'),
('3','2797','2.56662'),
('3','2798','0.93331'),
('3','2799','1.02669'),
('3','2800','1.77338'),
('3','2801','1.91338'),
('3','2802','2.09979'),
('3','2803','0.95669'),
('3','2804','1.14331'),
('3','2805','0.93331'),
('3','2806','1.09669'),
('3','2807','3.64'),
('3','2808','4.38676'),
('3','2809','0.91'),
('3','2810','1.07331'),
('3','2811','2.19338'),
('3','2812','2.42662'),
('3','2813','2.80014'),
('3','2814','1.09669');
INSERT INTO `#__finder_links_terms9` VALUES 
('3','2815','1.19'),
('3','2816','2.19338'),
('3','2817','2.47338'),
('3','2818','2.28662'),
('3','2819','2.56662'),
('3','2820','1.00331'),
('3','2821','1.14331'),
('3','2822','1.39986'),
('3','2823','0.95669'),
('3','2824','1.12'),
('3','2825','4.78345'),
('3','2826','5.13345'),
('3','2827','0.65338'),
('3','2828','2.1'),
('3','2829','2.42662'),
('3','2830','3.08007'),
('3','2831','3.57'),
('3','2832','0.42'),
('3','2833','1.05'),
('3','2834','1.16669'),
('3','2835','1.49324'),
('3','2836','1.00331'),
('3','2837','1.07331'),
('3','2838','2.1'),
('3','2839','2.24'),
('3','2840','1.09669'),
('3','2841','1.33'),
('3','2842','0.42'),
('3','2843','0.98'),
('3','2844','1.07331'),
('5','105','0.37331'),
('5','2787','0.42'),
('5','2802','0.46662'),
('5','2813','2.80014'),
('5','2820','3.00993'),
('5','2822','0.23331'),
('5','2827','0.32669'),
('5','2835','0.37331'),
('5','2842','0.84'),
('5','3118','1.07331'),
('5','3119','1.14331'),
('5','3304','0.91'),
('5','3305','1.05'),
('5','3306','2.00662'),
('5','3307','1.12'),
('5','3308','1.09669'),
('5','3309','0.88669'),
('5','3310','1.02669'),
('5','3311','0.95669'),
('5','3312','1.12');
INSERT INTO `#__finder_links_terms9` VALUES 
('5','3313','0.42'),
('5','3314','1.09669'),
('5','3315','1.26'),
('5','3316','1.12'),
('5','3317','1.28331'),
('5','3318','1.00331'),
('5','3319','1.07331'),
('5','3320','1.09669'),
('5','3321','1.23669'),
('5','3322','3.57'),
('5','3323','0.98'),
('5','3324','1.14331'),
('5','3325','1.02669'),
('5','3326','1.14331'),
('5','3327','1.02669'),
('5','3328','1.09669'),
('5','3329','1.02669'),
('5','3330','1.09669'),
('5','3331','1.00331'),
('5','3332','1.16669'),
('6','3370','0.32669'),
('6','3371','0.98'),
('6','3372','1.12'),
('6','3543','0.32669'),
('6','3544','1.05'),
('6','3545','1.26'),
('7','3579','0.09331'),
('7','3580','0.95669'),
('7','3581','1.00331'),
('7','3693','0.18669'),
('7','3694','0.88669'),
('7','3695','1.05'),
('8','105','2.23986'),
('8','1160','4.47972'),
('8','1163','0.56'),
('8','1164','1.91338'),
('8','1165','2.28662'),
('8','1166','3.92028'),
('8','3765','0.04669'),
('8','3766','0.86331'),
('8','3767','1.00331'),
('8','3768','6.16014'),
('8','3769','1.21331'),
('8','3770','5.71655'),
('8','3771','0.46669'),
('8','3772','1.07331'),
('8','3773','1.21331'),
('8','3774','0.84'),
('8','3775','0.91'),
('8','3776','1.02669');
INSERT INTO `#__finder_links_terms9` VALUES 
('8','3777','1.91338'),
('8','3778','2.14662'),
('8','3779','0.32669'),
('8','3780','1.07331'),
('8','3781','1.19'),
('8','3782','0.23331'),
('8','3783','0.93331'),
('8','3784','1.12'),
('8','3785','0.28'),
('8','3786','0.95669'),
('8','3787','1.07331'),
('8','4717','12.3203'),
('8','4718','14.8403'),
('8','4719','11.4803'),
('8','4720','12.6');

DROP TABLE IF EXISTS #__finder_links_termsa;
CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termsa` VALUES 
('6','3335','0.23331'),
('6','3336','0.91'),
('6','3337','1.09669'),
('6','3338','0.51331'),
('6','3339','1.09669'),
('6','3340','1.19'),
('8','3724','0.42'),
('8','3725','0.91'),
('8','3726','1.05'),
('8','3727','1.07331'),
('8','3728','1.14331');

DROP TABLE IF EXISTS #__finder_links_termsb;
CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termsb` VALUES 
('3','2295','0.32669'),
('3','2296','0.98'),
('3','2297','1.16669'),
('7','3619','0.14'),
('7','3620','0.86331'),
('7','3621','1.09669'),
('8','3853','0.65338'),
('8','3854','2.28662'),
('8','3855','2.8'),
('8','3856','0.42'),
('8','3857','1.02669'),
('8','3858','1.14331'),
('8','3859','4.48056'),
('8','3860','21.84'),
('8','3861','0.98'),
('8','3862','0.95669'),
('8','3863','1.16669'),
('8','3864','1.02669'),
('8','3865','20.5338'),
('8','3866','0.37338'),
('8','3867','1.86662'),
('8','3868','2.42662');

DROP TABLE IF EXISTS #__finder_links_termsc;
CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termsc` VALUES 
('3','2011','0.07'),
('3','2012','0.86331'),
('3','2013','1.12'),
('3','2014','0.51'),
('3','2015','0.07'),
('3','2016','0.86331'),
('3','2017','1.00331'),
('6','3334','0.51'),
('7','2011','0.07'),
('7','2015','0.07'),
('7','3552','0.95669'),
('7','3553','1.12'),
('7','3554','0.51'),
('7','3555','0.81669'),
('7','3556','0.91'),
('8','3709','0.28'),
('8','3710','0.88669'),
('8','3711','1.02669'),
('8','3712','0.86331'),
('8','3713','0.98'),
('8','3714','0.14'),
('8','3715','0.88669'),
('8','3716','1.02669'),
('8','3717','0.14'),
('8','3718','0.88669'),
('8','3719','1.02669'),
('8','3732','0.34');

DROP TABLE IF EXISTS #__finder_links_termsd;
CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termsd` VALUES 
('3','1','0'),
('3','1025','0.56007'),
('3','2527','1.82'),
('3','2528','2.28662'),
('3','2529','0.88669'),
('3','2530','1.07331'),
('3','2531','0.56007'),
('3','2532','1.02669'),
('3','2533','1.30669'),
('3','2534','1.91338'),
('3','2535','2.05338'),
('3','2536','0.28'),
('3','2537','0.95669'),
('3','2538','1.19'),
('5','1','0'),
('5','2531','0.18669'),
('5','3245','0.98'),
('5','3246','1.14331'),
('6','1','0'),
('6','3467','0.09331'),
('6','3468','0.93331'),
('6','3469','1.02669'),
('6','3470','0.56'),
('6','3471','3.54676'),
('6','3472','4.29324'),
('7','1','0'),
('7','3646','0.42'),
('7','3647','0.95669'),
('7','3648','1.12'),
('8','1','0'),
('8','1025','2.24028'),
('8','4619','10.6403'),
('8','4620','11.8064'),
('8','4621','1.21331'),
('8','4622','0.14'),
('8','4623','0.84'),
('8','4624','0.98'),
('8','4625','0.32669'),
('8','4626','1.00331'),
('8','4627','1.12'),
('8','4628','0.14'),
('8','4629','0.91'),
('8','4630','1.07331');

DROP TABLE IF EXISTS #__finder_links_termse;
CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termse` VALUES 
('3','193','0.09331'),
('3','194','0.93331'),
('3','195','1.16669'),
('3','200','0.32669'),
('3','201','1.02669'),
('3','202','1.28331'),
('3','203','0.74676'),
('3','208','1.77338'),
('3','209','0.95669'),
('3','213','0.56007'),
('3','214','0.86331'),
('3','215','1.00331'),
('3','216','2.05359'),
('3','219','0.83979'),
('3','220','0.91'),
('3','221','1.05'),
('3','222','0.09331'),
('3','223','0.81669'),
('3','224','1.00331'),
('3','225','0.56'),
('3','226','1.16669'),
('3','227','1.35331'),
('3','1107','2.52'),
('3','1110','0.84'),
('3','1113','1.09669'),
('3','1114','1.16669'),
('3','1129','1.26'),
('3','2018','0.07'),
('3','2019','0.84'),
('3','2020','1.05'),
('3','2171','0.32669'),
('3','2172','1.07331'),
('3','2173','1.21331'),
('3','2174','0.93345'),
('3','2175','2.05338'),
('3','2176','1.21331'),
('3','2177','1.14331'),
('3','2178','2.79993'),
('3','2179','3.15'),
('3','2180','1.11993'),
('3','2181','3.21993'),
('3','2182','3.63993'),
('3','2183','0.91'),
('3','2184','1.12'),
('3','2185','0.93331'),
('3','2186','1.21331'),
('3','2187','1.12'),
('3','2188','0.95669'),
('3','2189','1.19'),
('3','2190','0.93331');
INSERT INTO `#__finder_links_termse` VALUES 
('3','2191','1.02669'),
('3','2192','3.45324'),
('3','2193','4.2'),
('3','2194','2.66007'),
('3','2195','3.15'),
('3','2196','1.82'),
('3','2197','1.05'),
('3','2198','1.00331'),
('3','2199','0.91'),
('3','2200','1.05'),
('3','2201','1.00331'),
('3','2202','1.12'),
('3','2203','0.56007'),
('3','2204','2.79993'),
('3','2205','3.50007'),
('3','2206','0.18669'),
('3','2207','0.95669'),
('3','2208','1.12'),
('3','2209','0.7'),
('3','2210','4.55'),
('3','2211','5.25'),
('3','2212','1.02669'),
('3','2213','1.14331'),
('3','2214','1.96'),
('3','2215','2.19338'),
('3','2216','1.82'),
('3','2217','2.28662'),
('3','2218','0.86331'),
('3','2219','1.09669'),
('3','2220','1.91338'),
('3','2221','2.24'),
('3','2222','0.46662'),
('3','2223','0.88669'),
('3','2224','1.07331'),
('3','2225','0.93331'),
('3','2226','1.00331'),
('3','2227','1.11972'),
('3','2228','0.93331'),
('3','2229','1.07331'),
('3','2230','2.05338'),
('3','2231','2.38'),
('3','2232','0.93331'),
('3','2233','0.98'),
('3','2234','0.91'),
('3','2235','1.05'),
('3','2236','0.88669'),
('3','2237','1.14331'),
('3','2238','1.05'),
('3','2239','1.21331'),
('3','2240','1.91338');
INSERT INTO `#__finder_links_termse` VALUES 
('3','2241','2.33338'),
('3','2242','0.86331'),
('3','2243','1.00331'),
('3','2244','0.88669'),
('3','2245','0.98'),
('3','2246','0.93331'),
('3','2247','1.09669'),
('3','2248','0.98007'),
('3','2249','1.05'),
('3','2250','1.19'),
('3','2251','2.1'),
('3','2252','1.09669'),
('3','2253','1.12'),
('3','2254','0.32669'),
('3','2704','1.82'),
('3','2705','2.24'),
('3','2706','1.82'),
('3','2707','2.28662'),
('3','2708','1.96'),
('3','2709','2.1'),
('3','2710','2.00662'),
('3','2711','2.42662'),
('3','2712','0.93331'),
('3','2713','1.12'),
('3','2714','0.98'),
('3','2715','1.05'),
('3','2716','0.95669'),
('3','2717','1.05'),
('3','2718','0.84'),
('3','2719','1.96'),
('3','2720','2.24'),
('3','2721','0.93331'),
('3','2722','1.14331'),
('3','2723','1.02669'),
('3','2724','1.21331'),
('3','2725','2.05338'),
('3','2726','2.19338'),
('3','2727','0.28'),
('3','2728','0.91'),
('3','2729','1.09669'),
('3','2730','0.84'),
('3','2731','2.05338'),
('3','2732','2.38'),
('5','203','0.37338'),
('5','216','0.74676'),
('5','219','0.27993'),
('5','1107','0.56'),
('5','1110','0.28'),
('5','1135','0.84'),
('5','2174','0.37338');
INSERT INTO `#__finder_links_termse` VALUES 
('5','2203','0.18669'),
('5','2209','0.56'),
('5','2222','0.23331'),
('5','2227','0.09331'),
('5','2718','0.28'),
('5','2727','0.28'),
('5','2728','0.91'),
('5','2730','0.84'),
('5','3139','0.93331'),
('5','3140','1.05'),
('5','3141','0.93331'),
('5','3142','1.07331'),
('5','3143','1.91338'),
('5','3144','2.05338'),
('5','3145','0.86331'),
('5','3146','1.00331'),
('5','3147','0.95669'),
('5','3148','1.05'),
('5','3149','0.88669'),
('5','3150','1.05'),
('5','3151','0.88669'),
('5','3152','1.12'),
('5','3153','0.86331'),
('5','3154','1.05'),
('5','3155','2.52'),
('5','3156','3.08007'),
('5','3157','0.91'),
('5','3158','1.07331'),
('5','3159','0.88669'),
('5','3160','1.09669'),
('5','3161','0.88669'),
('5','3162','1.05'),
('5','3163','0.88669'),
('5','3164','1.12'),
('5','3165','0.88669'),
('5','3166','0.98'),
('5','3167','0.93331'),
('5','3168','1.09669'),
('5','3279','1.02669'),
('5','3280','1.12'),
('5','3281','1.09669'),
('5','3282','1.26'),
('5','3283','1.07331'),
('5','3284','1.16669'),
('5','3285','0.95669'),
('5','3286','1.02669'),
('5','3287','1.12'),
('5','3288','0.98'),
('5','3289','1.16669'),
('5','3290','1.02669');
INSERT INTO `#__finder_links_termse` VALUES 
('5','3291','1.12'),
('5','3292','3.29007'),
('5','3293','3.50007'),
('6','3395','0.14'),
('6','3396','1.00331'),
('6','3397','1.21331'),
('6','3398','0.23331'),
('6','3399','0.95669'),
('6','3400','1.12'),
('6','3505','0.84'),
('6','3506','1.12'),
('6','3507','1.26'),
('6','3508','1.07331'),
('6','3509','1.21331'),
('6','3510','1.05'),
('6','3511','1.14331'),
('6','3512','0.32669'),
('6','3513','0.93331'),
('6','3514','1.12'),
('6','3515','2.71983'),
('6','3516','0.95669'),
('6','3517','1.09669'),
('6','3518','1.05'),
('6','3519','1.14331'),
('6','3520','5.92'),
('6','3521','0.18669'),
('6','3522','0.98'),
('6','3523','1.05'),
('6','3524','0.18662'),
('6','3525','0.98'),
('6','3526','1.19'),
('6','3527','0.93331'),
('6','3528','1.12'),
('6','3529','0.18669'),
('6','3530','0.93331'),
('6','3531','1.09669'),
('7','3521','0.18669'),
('7','3524','0.09331'),
('7','3607','0.37331'),
('7','3608','0.93331'),
('7','3609','1.12'),
('7','3669','1.4'),
('7','3670','1.4'),
('7','3671','1.21331'),
('7','3672','1.33'),
('7','3673','0.88669'),
('7','3674','0.98'),
('7','3675','0.42'),
('7','3676','0.95669'),
('7','3677','1.05');
INSERT INTO `#__finder_links_termse` VALUES 
('7','3678','2.00662'),
('7','3679','1.21331'),
('7','3680','1.12'),
('7','3681','0.18669'),
('7','3682','0.88669'),
('7','3683','0.93331'),
('7','3684','0.23331'),
('7','3685','0.91'),
('7','3686','1.16669'),
('7','3687','0.84'),
('7','3688','0.93331'),
('8','193','0.18662'),
('8','194','1.86662'),
('8','195','2.33338'),
('8','200','2.61352'),
('8','201','8.21352'),
('8','202','10.2665'),
('8','203','5.22732'),
('8','208','10.6403'),
('8','209','11.4803'),
('8','213','0.37338'),
('8','214','1.72662'),
('8','215','2.00662'),
('8','216','0.74676'),
('8','219','0.55986'),
('8','220','5.46'),
('8','221','6.3'),
('8','222','0.18662'),
('8','223','1.63338'),
('8','224','2.00662'),
('8','225','1.12'),
('8','226','2.33338'),
('8','227','2.70662'),
('8','1107','3.08'),
('8','1110','3.36'),
('8','1113','8.77352'),
('8','1114','9.33352'),
('8','1129','25.62'),
('8','1135','3.36'),
('8','3720','0.42'),
('8','3721','1.72662'),
('8','3722','1.00331'),
('8','3723','1.16669'),
('8','3824','0.93324'),
('8','3825','3.92'),
('8','3826','1.09669'),
('8','3827','2.24'),
('8','3828','10.92'),
('8','3829','13.1603'),
('8','3830','3.92');
INSERT INTO `#__finder_links_termse` VALUES 
('8','3831','4.66676'),
('8','3832','0.46662'),
('8','3833','1.82'),
('8','3834','2.05338'),
('8','3835','3.36'),
('8','3836','3.82676'),
('8','4680','11.0364'),
('8','4681','12.32'),
('8','4682','0.95669'),
('8','4683','1.09669'),
('8','4684','1.96'),
('8','4685','2.33338'),
('8','4686','4.48056'),
('8','4687','21.84'),
('8','4688','24.6406'),
('8','4689','1.12014'),
('8','4690','5.17986'),
('8','4691','6.3'),
('8','4692','0.23331'),
('8','4693','0.88669'),
('8','4694','1.02669'),
('8','4695','0.37338'),
('8','4696','1.96'),
('8','4697','2.24'),
('8','4698','62.6281'),
('8','4699','68.32'),
('8','4700','0.14'),
('8','4701','0.95669'),
('8','4702','1.12'),
('8','4703','12.8797'),
('8','4704','14.0003'),
('8','4705','0.14'),
('8','4706','0.84'),
('8','4707','0.98'),
('8','4708','2.46679');

DROP TABLE IF EXISTS #__finder_links_termsf;
CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_links_termsf` VALUES 
('6','3546','0.23331'),
('6','3547','0.98'),
('6','3548','1.07331'),
('7','3696','0.18669'),
('7','3697','0.86331'),
('7','3698','0.95669'),
('7','3699','0.18669'),
('7','3700','0.88669'),
('7','3701','0.98'),
('8','4721','0.69993'),
('8','4722','1.91338'),
('8','4723','2.19338'),
('8','4724','0.98'),
('8','4725','1.09669'),
('8','4726','0.84'),
('8','4727','2.19338'),
('8','4728','2.47338');

DROP TABLE IF EXISTS #__finder_taxonomy;
CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) AUTO_INCREMENT=99 DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_taxonomy` VALUES 
('91','1','Type','1','1','0'),
('92','91','Article','1','1','0'),
('93','1','Author','1','1','0'),
('94','93','Super User','1','1','0'),
('95','1','Category','1','1','0'),
('96','95','JM-Sample-Data','1','1','0'),
('97','1','Language','1','1','0'),
('98','97','*','1','1','0');

DROP TABLE IF EXISTS #__finder_taxonomy_map;
CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_taxonomy_map` VALUES 
('3','92'),
('3','94'),
('3','96'),
('3','98'),
('5','92'),
('5','94'),
('5','96'),
('5','98'),
('6','92'),
('6','94'),
('6','96'),
('6','98'),
('7','92'),
('7','94'),
('7','96'),
('7','98'),
('8','92'),
('8','94'),
('8','96'),
('8','98');

DROP TABLE IF EXISTS #__finder_terms;
CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) AUTO_INCREMENT=4729 DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_terms` VALUES 
('1','','','0','0','0','','5','*'),
('4451','icon-th-large','icon-th-large','0','0','0.8667','I253462','1','*'),
('4450','icon-th icon-th-list icon-ok','icon-th icon-th-list icon-ok','0','1','1.9333','I253253423252','1','*'),
('4449','icon-th icon-th-list','icon-th icon-th-list','0','1','1.6667','I253253423','1','*'),
('4448','icon-th','icon-th','0','0','0.4667','I253','1','*'),
('4447','icon-text-width icon-align-left icon-align-center','icon-text-width icon-align-left icon-align-center','0','1','2','I2532325425413254252536','1','*'),
('4446','icon-text-width icon-align-left','icon-text-width icon-align-left','0','1','2','I2532325425413','1','*'),
('4445','icon-text-width','icon-text-width','0','0','1','I25323','1','*'),
('4444','icon-text-height icon-text-width icon-align-left','icon-text-height icon-text-width icon-align-left','0','1','2','I25323232532325425413','1','*'),
('4443','icon-text-height icon-text-width','icon-text-height icon-text-width','0','1','2','I253232325323','1','*'),
('4442','icon-text-height','icon-text-height','0','0','1','I2532323','1','*'),
('4441','icon-tasks icon-filter icon-briefcase','icon-tasks icon-filter icon-briefcase','0','1','2','I253251436251612','1','*'),
('4440','icon-tasks icon-filter','icon-tasks icon-filter','0','1','1.7333','I253251436','1','*'),
('4439','icon-tasks','icon-tasks','0','0','0.6667','I2532','1','*'),
('4438','icon-tags icon-book icon-bookmark','icon-tags icon-book icon-bookmark','0','1','2','I2532512512562','1','*'),
('4437','icon-tags icon-book','icon-tags icon-book','0','1','1.6333','I2532512','1','*'),
('4436','icon-tags','icon-tags','0','0','0.6','I2532','1','*'),
('4435','icon-tag icon-tags icon-book','icon-tag icon-tags icon-book','0','1','1.9333','I2532532512','1','*'),
('4434','icon-tag icon-tags','icon-tag icon-tags','0','1','1.6','I2532532','1','*'),
('4433','icon-tag','icon-tag','0','0','0.5333','I2532','1','*'),
('47','a','a','0','0','0.0667','A000','4','*'),
('4432','icon-subtitles icon-sound-stereo icon-sound-dolby','icon-subtitles icon-sound-stereo icon-sound-dolby','0','1','2','I252134252532362525341','1','*'),
('4431','icon-subtitles icon-sound-stereo','icon-subtitles icon-sound-stereo','0','1','2','I25213425253236','1','*'),
('54','ad','ad','0','0','0.1333','A300','2','*'),
('55','ad minim','ad minim','0','1','1.2667','A350','2','*'),
('56','ad minim veniam','ad minim veniam','0','1','1.5','A3515','2','*'),
('57','adipiscing','adipiscing','0','0','0.6667','A31252','3','*'),
('58','adipiscing elit','adipiscing elit','0','1','1.5','A3125243','3','*'),
('4430','icon-subtitles','icon-subtitles','0','0','0.9333','I2521342','1','*'),
('61','adipisicing','adipisicing','0','0','0.7333','A31252','2','*'),
('62','adipisicing elit','adipisicing elit','0','1','1.5333','A3125243','2','*'),
('63','adipisicing elit sed','adipisicing elit sed','0','1','1.6667','A312524323','2','*'),
('64','aenean','aenean','0','0','0.4','A500','2','*'),
('4429','icon-stop icon-forward icon-fast-forward','icon-stop icon-forward icon-fast-forward','0','1','2','I252312516325123163','1','*'),
('67','aliqua','aliqua','0','0','0.4','A420','2','*'),
('4428','icon-stop icon-forward','icon-stop icon-forward','0','1','1.7333','I2523125163','1','*'),
('4427','icon-stop','icon-stop','0','0','0.6','I25231','1','*'),
('4426','icon-step-forward icon-eject icon-chevron-left','icon-step-forward icon-eject icon-chevron-left','0','1','2','I25231632523252165413','1','*'),
('4425','icon-step-forward icon-eject','icon-step-forward icon-eject','0','1','1.9333','I25231632523','1','*'),
('76','aliquip','aliquip','0','0','0.4667','A421','2','*'),
('77','aliquip ex','aliquip ex','0','1','1.3333','A4212','2','*'),
('78','aliquip ex ea','aliquip ex ea','0','1','1.4333','A4212','2','*'),
('4424','icon-step-forward','icon-step-forward','0','0','1','I2523163','1','*'),
('4423','icon-step-backward icon-fast-backward icon-backward','icon-step-backward icon-fast-backward icon-backward','0','1','2','I25231263251231263251263','1','*'),
('82','amet','amet','0','0','0.2667','A530','3','*'),
('4422','icon-step-backward icon-fast-backward','icon-step-backward icon-fast-backward','0','1','2','I25231263251231263','1','*'),
('85','amet consectetur','amet consectetur','0','1','1.5333','A5325236','3','*'),
('86','amet consectetur adipiscing','amet consectetur adipiscing','0','1','1.9','A532523631252','3','*'),
('87','amet consectetur adipisicing','amet consectetur adipisicing','0','1','1.9333','A532523631252','2','*'),
('4421','icon-step-backward','icon-step-backward','0','0','1','I25231263','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4420','icon-stats icon-sd-video icon-hd-video','icon-stats icon-sd-video icon-hd-video','0','1','2','I252325231325313','1','*'),
('4419','icon-stats icon-sd-video','icon-stats icon-sd-video','0','1','1.8','I2523252313','1','*'),
('4418','icon-stats','icon-stats','0','0','0.6667','I25232','1','*'),
('95','ante','ante','0','0','0.2667','A530','2','*'),
('98','article','article','0','0','0.4667','A6324','5','*'),
('99','aute','aute','0','0','0.2667','A300','2','*'),
('100','aute irure','aute irure','0','1','1.3333','A360','2','*'),
('101','aute irure dolor','aute irure dolor','0','1','1.5333','A36346','2','*'),
('4417','icon-star-empty icon-user icon-film','icon-star-empty icon-user icon-film','0','1','2','I25236513252625145','1','*'),
('4416','icon-star-empty icon-user','icon-star-empty icon-user','0','1','1.8333','I252365132526','1','*'),
('105','bibendum','bibendum','0','0','0.5333','B535','2','*'),
('4415','icon-star-empty','icon-star-empty','0','0','1','I25236513','1','*'),
('4414','icon-star icon-star-empty icon-user','icon-star icon-star-empty icon-user','0','1','2','I25236252365132526','1','*'),
('4413','icon-star icon-star-empty','icon-star icon-star-empty','0','1','1.8333','I2523625236513','1','*'),
('4412','icon-star','icon-star','0','0','0.6','I25236','1','*'),
('4411','icon-sound-stereo icon-sound-dolby icon-sound-5-1','icon-sound-stereo icon-sound-dolby icon-sound-5-1','0','1','2','I25253236252534125253','1','*'),
('4410','icon-sound-stereo icon-sound-dolby','icon-sound-stereo icon-sound-dolby','0','1','2','I252532362525341','1','*'),
('4409','icon-sound-stereo','icon-sound-stereo','0','0','1','I25253236','1','*'),
('4408','icon-sound-dolby icon-sound-5-1 icon-sound-6-1','icon-sound-dolby icon-sound-5-1 icon-sound-6-1','0','1','2','I25253412525325253','1','*'),
('4407','icon-sound-dolby icon-sound-5-1','icon-sound-dolby icon-sound-5-1','0','1','2','I252534125253','1','*'),
('4406','icon-sound-dolby','icon-sound-dolby','0','0','1','I2525341','1','*'),
('129','class','class','0','0','0.3333','C420','1','*'),
('4405','icon-sound-7-1 icon-copyright-mark icon-registration-mark','icon-sound-7-1 icon-copyright-mark icon-registration-mark','0','1','2','I252532521623562562363562','1','*'),
('4404','icon-sound-7-1 icon-copyright-mark','icon-sound-7-1 icon-copyright-mark','0','1','2','I252532521623562','1','*'),
('4403','icon-sound-7-1','icon-sound-7-1','0','0','0.9333','I25253','1','*'),
('140','commodo','commodo','0','0','0.4667','C530','3','*'),
('141','commodo consequat','commodo consequat','0','1','1.5667','C532523','2','*'),
('142','commodo consequat duis','commodo consequat duis','0','1','1.7333','C5325232','2','*'),
('143','condimentum','condimentum','0','0','0.7333','C53535','2','*'),
('4402','icon-sound-6-1 icon-sound-7-1 icon-copyright-mark','icon-sound-6-1 icon-sound-7-1 icon-copyright-mark','0','1','2','I25253252532521623562','1','*'),
('146','consectetur','consectetur','0','0','0.7333','C5236','3','*'),
('147','consectetur adipiscing','consectetur adipiscing','0','1','1.7333','C523631252','3','*'),
('148','consectetur adipiscing elit','consectetur adipiscing elit','0','1','1.9','C52363125243','3','*'),
('149','consectetur adipisicing','consectetur adipisicing','0','1','1.7667','C523631252','2','*'),
('150','consectetur adipisicing elit','consectetur adipisicing elit','0','1','1.9333','C52363125243','2','*'),
('151','consequat','consequat','0','0','0.6','C523','2','*'),
('152','consequat duis','consequat duis','0','1','1.4667','C5232','2','*'),
('153','consequat duis aute','consequat duis aute','0','1','1.6333','C52323','2','*'),
('4401','icon-sound-6-1 icon-sound-7-1','icon-sound-6-1 icon-sound-7-1','0','1','1.9667','I2525325253','1','*'),
('4400','icon-sound-6-1','icon-sound-6-1','0','0','0.9333','I25253','1','*'),
('157','convallis','convallis','0','0','0.6','C5142','2','*'),
('4399','icon-sound-5-1 icon-sound-6-1 icon-sound-7-1','icon-sound-5-1 icon-sound-6-1 icon-sound-7-1','0','1','2','I252532525325253','1','*'),
('4398','icon-sound-5-1 icon-sound-6-1','icon-sound-5-1 icon-sound-6-1','0','1','1.9667','I2525325253','1','*'),
('4397','icon-sound-5-1','icon-sound-5-1','0','0','0.9333','I25253','1','*'),
('4396','icon-sort-by-order-alt icon-sort-by-attributes icon-sort-by-attributes-alt','icon-sort-by-order-alt icon-sort-by-attributes icon-sort-by-attributes-alt','0','1','2','I2526316364325263136132526313613243','1','*'),
('168','do','do','0','0','0.1333','D000','2','*'),
('171','do eiusmod','do eiusmod','0','1','1.3333','D253','2','*'),
('172','do eiusmod tempor','do eiusmod tempor','0','1','1.5667','D253516','2','*'),
('4395','icon-sort-by-order-alt icon-sort-by-attributes','icon-sort-by-order-alt icon-sort-by-attributes','0','1','2','I2526316364325263136132','1','*'),
('4394','icon-sort-by-order-alt','icon-sort-by-order-alt','0','0','1','I25263163643','1','*');
INSERT INTO `#__finder_terms` VALUES 
('178','dolor','dolor','0','0','0.3333','D460','3','*'),
('179','dolor in','dolor in','0','1','1.2667','D465','2','*'),
('180','dolor in reprehenderit','dolor in reprehenderit','0','1','1.7333','D4656165363','2','*'),
('181','dolor sit','dolor sit','0','1','1.3','D4623','3','*'),
('182','dolor sit amet','dolor sit amet','0','1','1.4667','D462353','3','*'),
('183','dolore','dolore','0','0','0.4','D460','2','*'),
('184','dolore magna','dolore magna','0','1','1.4','D46525','2','*'),
('185','dolore magna aliqua','dolore magna aliqua','0','1','1.6333','D4652542','2','*'),
('186','duis','duis','0','0','0.2667','D200','2','*'),
('187','duis aute','duis aute','0','1','1.3','D230','2','*'),
('188','duis aute irure','duis aute irure','0','1','1.5','D236','2','*'),
('4393','icon-sort-by-order icon-sort-by-order-alt icon-sort-by-attributes','icon-sort-by-order icon-sort-by-order-alt icon-sort-by-attributes','0','1','2','I2526316362526316364325263136132','1','*'),
('193','ea','ea','0','0','0.1333','E000','2','*'),
('194','ea commodo','ea commodo','0','1','1.3333','E253','2','*'),
('195','ea commodo consequat','ea commodo consequat','0','1','1.6667','E2532523','2','*'),
('4392','icon-sort-by-order icon-sort-by-order-alt','icon-sort-by-order icon-sort-by-order-alt','0','1','2','I25263163625263163643','1','*'),
('4391','icon-sort-by-order','icon-sort-by-order','0','0','1','I252631636','1','*'),
('200','eiusmod','eiusmod','0','0','0.4667','E253','2','*'),
('201','eiusmod tempor','eiusmod tempor','0','1','1.4667','E253516','2','*'),
('202','eiusmod tempor incididunt','eiusmod tempor incididunt','0','1','1.8333','E25351652353','2','*'),
('203','elit','elit','0','0','0.2667','E430','3','*'),
('4390','icon-sort-by-attributes-alt icon-unchecked icon-expand','icon-sort-by-attributes-alt icon-unchecked icon-expand','0','1','2','I25263136132432523252153','1','*'),
('208','elit sed','elit sed','0','1','1.2667','E4323','2','*'),
('209','elit sed do','elit sed do','0','1','1.3667','E4323','2','*'),
('4389','icon-sort-by-attributes-alt icon-unchecked','icon-sort-by-attributes-alt icon-unchecked','0','1','2','I25263136132432523','1','*'),
('213','enim','enim','0','0','0.2667','E500','2','*'),
('214','enim ad','enim ad','0','1','1.2333','E530','2','*'),
('215','enim ad minim','enim ad minim','0','1','1.4333','E535','2','*'),
('216','erat','erat','0','0','0.2667','E630','3','*'),
('4388','icon-sort-by-attributes-alt','icon-sort-by-attributes-alt','0','0','1','I2526313613243','1','*'),
('219','et','et','0','0','0.1333','E300','3','*'),
('220','et dolore','et dolore','0','1','1.3','E346','2','*'),
('221','et dolore magna','et dolore magna','0','1','1.5','E346525','2','*'),
('222','ex','ex','0','0','0.1333','E200','2','*'),
('223','ex ea','ex ea','0','1','1.1667','E200','2','*'),
('224','ex ea commodo','ex ea commodo','0','1','1.4333','E253','2','*'),
('225','exercitation','exercitation','0','0','0.8','E26235','2','*'),
('226','exercitation ullamco','exercitation ullamco','0','1','1.6667','E26235452','2','*'),
('227','exercitation ullamco laboris','exercitation ullamco laboris','0','1','1.9333','E262354524162','2','*'),
('228','felis','felis','0','0','0.3333','F420','3','*'),
('4387','icon-sort-by-attributes icon-sort-by-attributes-alt icon-unchecked','icon-sort-by-attributes icon-sort-by-attributes-alt icon-unchecked','0','1','2','I252631361325263136132432523','1','*'),
('4386','icon-sort-by-attributes icon-sort-by-attributes-alt','icon-sort-by-attributes icon-sort-by-attributes-alt','0','1','2','I25263136132526313613243','1','*'),
('4385','icon-sort-by-attributes','icon-sort-by-attributes','0','0','1','I25263136132','1','*'),
('240','font','font','0','0','0.2667','F530','2','*'),
('4384','icon-sort-by-alphabet-alt icon-sort-by-order icon-sort-by-order-alt','icon-sort-by-alphabet-alt icon-sort-by-order icon-sort-by-order-alt','0','1','2','I2526314134325263163625263163643','1','*'),
('4383','icon-sort-by-alphabet-alt icon-sort-by-order','icon-sort-by-alphabet-alt icon-sort-by-order','0','1','2','I25263141343252631636','1','*'),
('4382','icon-sort-by-alphabet-alt','icon-sort-by-alphabet-alt','0','0','1','I25263141343','1','*'),
('4381','icon-sort-by-alphabet icon-sort-by-alphabet-alt icon-sort-by-order','icon-sort-by-alphabet icon-sort-by-alphabet-alt icon-sort-by-order','0','1','2','I25263141325263141343252631636','1','*'),
('4380','icon-sort-by-alphabet icon-sort-by-alphabet-alt','icon-sort-by-alphabet icon-sort-by-alphabet-alt','0','1','2','I25263141325263141343','1','*'),
('4379','icon-sort-by-alphabet','icon-sort-by-alphabet','0','0','1','I252631413','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4378','icon-sort icon-sort-by-alphabet icon-sort-by-alphabet-alt','icon-sort icon-sort-by-alphabet icon-sort-by-alphabet-alt','0','1','2','I2526325263141325263141343','1','*'),
('4377','icon-sort icon-sort-by-alphabet','icon-sort icon-sort-by-alphabet','0','1','2','I25263252631413','1','*'),
('4376','icon-sort','icon-sort','0','0','0.6','I25263','1','*'),
('4375','icon-signal icon-cog icon-trash','icon-signal icon-cog icon-trash','0','1','2','I252542525362','1','*'),
('4374','icon-signal icon-cog','icon-signal icon-cog','0','1','1.6667','I25254252','1','*'),
('4373','icon-signal','icon-signal','0','0','0.7333','I25254','1','*'),
('4372','icon-shopping-cart icon-folder-close icon-folder-open','icon-shopping-cart icon-folder-close icon-folder-open','0','1','2','I252152632514362425143615','1','*'),
('4371','icon-shopping-cart icon-folder-close','icon-shopping-cart icon-folder-close','0','1','2','I25215263251436242','1','*'),
('4370','icon-shopping-cart','icon-shopping-cart','0','0','1','I25215263','1','*'),
('4369','icon-share-alt icon-resize-full icon-resize-small','icon-share-alt icon-resize-full icon-resize-small','0','1','2','I252643256214256254','1','*'),
('4368','icon-share-alt icon-resize-full','icon-share-alt icon-resize-full','0','1','2','I252643256214','1','*'),
('4367','icon-share-alt','icon-share-alt','0','0','0.9333','I252643','1','*'),
('4366','icon-share icon-check icon-move','icon-share icon-check icon-move','0','1','2','I252625251','1','*'),
('4365','icon-share icon-check','icon-share icon-check','0','1','1.7','I2526252','1','*'),
('4364','icon-share','icon-share','0','0','0.6667','I2526','1','*'),
('4363','icon-send icon-floppy-disk icon-floppy-saved','icon-send icon-floppy-disk icon-floppy-saved','0','1','2','I2525325141325141213','1','*'),
('4362','icon-send icon-floppy-disk','icon-send icon-floppy-disk','0','1','1.8667','I252532514132','1','*'),
('4361','icon-send','icon-send','0','0','0.6','I25253','1','*'),
('4360','icon-search icon-heart icon-star','icon-search icon-heart icon-star','0','1','2','I2526256325236','1','*'),
('4359','icon-search icon-heart','icon-search icon-heart','0','1','1.7333','I25262563','1','*'),
('4358','icon-search','icon-search','0','0','0.7333','I25262','1','*'),
('4356','icon-sd-video icon-hd-video','icon-sd-video icon-hd-video','0','1','1.9','I25231325313','1','*'),
('4357','icon-sd-video icon-hd-video icon-subtitles','icon-sd-video icon-hd-video icon-subtitles','0','1','2','I252313253132521342','1','*'),
('4355','icon-sd-video','icon-sd-video','0','0','0.8667','I252313','1','*'),
('4354','icon-screenshot icon-remove-circle icon-ok-circle','icon-screenshot icon-remove-circle icon-ok-circle','0','1','2','I2526523256512624252624','1','*'),
('4352','icon-screenshot','icon-screenshot','0','0','1','I2526523','1','*'),
('4353','icon-screenshot icon-remove-circle','icon-screenshot icon-remove-circle','0','1','2','I2526523256512624','1','*'),
('4351','icon-saved icon-import icon-export','icon-saved icon-import icon-export','0','1','2','I2521325163252163','1','*'),
('4350','icon-saved icon-import','icon-saved icon-import','0','1','1.7333','I2521325163','1','*'),
('4349','icon-saved','icon-saved','0','0','0.6667','I25213','1','*'),
('4347','icon-save icon-open','icon-save icon-open','0','1','1.6333','I25212515','1','*'),
('4348','icon-save icon-open icon-saved','icon-save icon-open icon-saved','0','1','2','I2521251525213','1','*'),
('4346','icon-save','icon-save','0','0','0.6','I2521','1','*'),
('4344','icon-road icon-download-alt','icon-road icon-download-alt','0','1','1.9','I256325354343','1','*'),
('4345','icon-road icon-download-alt icon-download','icon-road icon-download-alt icon-download','0','1','2','I256325354343253543','1','*'),
('4343','icon-road','icon-road','0','0','0.6','I2563','1','*'),
('4342','icon-retweet icon-shopping-cart icon-folder-close','icon-retweet icon-shopping-cart icon-folder-close','0','1','2','I256325215263251436242','1','*'),
('4341','icon-retweet icon-shopping-cart','icon-retweet icon-shopping-cart','0','1','2','I256325215263','1','*'),
('4340','icon-retweet','icon-retweet','0','0','0.8','I2563','1','*'),
('4339','icon-resize-vertical icon-resize-horizontal icon-hdd','icon-resize-vertical icon-resize-horizontal icon-hdd','0','1','2','I256216324256262534253','1','*'),
('4338','icon-resize-vertical icon-resize-horizontal','icon-resize-vertical icon-resize-horizontal','0','1','2','I256216324256262534','1','*'),
('4337','icon-resize-vertical','icon-resize-vertical','0','0','1','I256216324','1','*'),
('4336','icon-resize-small icon-exclamation-sign icon-gift','icon-resize-small icon-exclamation-sign icon-gift','0','1','2','I25625425245352525213','1','*'),
('4335','icon-resize-small icon-exclamation-sign','icon-resize-small icon-exclamation-sign','0','1','2','I256254252453525','1','*'),
('4334','icon-resize-small','icon-resize-small','0','0','1','I256254','1','*'),
('4333','icon-resize-horizontal icon-hdd icon-bullhorn','icon-resize-horizontal icon-hdd icon-bullhorn','0','1','2','I256262534253251465','1','*'),
('4332','icon-resize-horizontal icon-hdd','icon-resize-horizontal icon-hdd','0','1','2','I256262534253','1','*'),
('4331','icon-resize-horizontal','icon-resize-horizontal','0','0','1','I256262534','1','*'),
('4330','icon-resize-full icon-resize-small icon-exclamation-sign','icon-resize-full icon-resize-small icon-exclamation-sign','0','1','2','I256214256254252453525','1','*'),
('4329','icon-resize-full icon-resize-small','icon-resize-full icon-resize-small','0','1','2','I256214256254','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4328','icon-resize-full','icon-resize-full','0','0','1','I256214','1','*'),
('4327','icon-repeat icon-refresh icon-list-alt','icon-repeat icon-refresh icon-list-alt','0','1','2','I25613256162542343','1','*'),
('4326','icon-repeat icon-refresh','icon-repeat icon-refresh','0','1','1.8','I25613256162','1','*'),
('4325','icon-repeat','icon-repeat','0','0','0.7333','I25613','1','*'),
('4324','icon-remove-sign icon-ok-sign icon-question-sign','icon-remove-sign icon-ok-sign icon-question-sign','0','1','2','I256512525252523525','1','*'),
('4323','icon-remove-sign icon-ok-sign','icon-remove-sign icon-ok-sign','0','1','1.9667','I25651252525','1','*'),
('4322','icon-remove-sign','icon-remove-sign','0','0','1','I2565125','1','*'),
('4321','icon-remove-circle icon-ok-circle icon-ban-circle','icon-remove-circle icon-ok-circle icon-ban-circle','0','1','2','I25651262425262425152624','1','*'),
('4320','icon-remove-circle icon-ok-circle','icon-remove-circle icon-ok-circle','0','1','2','I256512624252624','1','*'),
('4319','icon-remove-circle','icon-remove-circle','0','0','1','I256512624','1','*'),
('4318','icon-remove icon-zoom-in icon-zoom-out','icon-remove icon-zoom-in icon-zoom-out','0','1','2','I25651252525253','1','*'),
('4317','icon-remove icon-zoom-in','icon-remove icon-zoom-in','0','1','1.8','I256512525','1','*'),
('4316','icon-remove','icon-remove','0','0','0.7333','I25651','1','*'),
('4315','icon-registration-mark icon-cloud-download icon-cloud-upload','icon-registration-mark icon-cloud-download icon-cloud-upload','0','1','2','I2562363562524354325243143','1','*'),
('4314','icon-registration-mark icon-cloud-download','icon-registration-mark icon-cloud-download','0','1','2','I25623635625243543','1','*'),
('4313','icon-registration-mark','icon-registration-mark','0','0','1','I2562363562','1','*'),
('4312','icon-refresh icon-list-alt icon-lock','icon-refresh icon-list-alt icon-lock','0','1','2','I2561625423432542','1','*'),
('4311','icon-refresh icon-list-alt','icon-refresh icon-list-alt','0','1','1.8667','I256162542343','1','*'),
('4310','icon-refresh','icon-refresh','0','0','0.8','I256162','1','*'),
('4309','icon-record icon-save icon-open','icon-record icon-save icon-open','0','1','2','I25626325212515','1','*'),
('4307','icon-record','icon-record','0','0','0.7333','I256263','1','*'),
('4308','icon-record icon-save','icon-record icon-save','0','1','1.7','I2562632521','1','*'),
('4306','icon-random icon-comment icon-magnet','icon-random icon-comment icon-magnet','0','1','2','I2565352525325253','1','*'),
('4305','icon-random icon-comment','icon-random icon-comment','0','1','1.8','I25653525253','1','*'),
('4304','icon-random','icon-random','0','0','0.7333','I256535','1','*'),
('4303','icon-question-sign icon-info-sign icon-screenshot','icon-question-sign icon-info-sign icon-screenshot','0','1','2','I2523525251252526523','1','*'),
('4302','icon-question-sign icon-info-sign','icon-question-sign icon-info-sign','0','1','2','I252352525125','1','*'),
('4301','icon-question-sign','icon-question-sign','0','0','1','I2523525','1','*'),
('4300','icon-qrcode icon-barcode icon-tag','icon-qrcode icon-barcode icon-tag','0','1','2','I2526232516232532','1','*'),
('4298','icon-qrcode','icon-qrcode','0','0','0.7333','I252623','1','*'),
('4299','icon-qrcode icon-barcode','icon-qrcode icon-barcode','0','1','1.8','I252623251623','1','*'),
('4297','icon-pushpin icon-usd icon-gbp','icon-pushpin icon-usd icon-gbp','0','1','2','I25121525232521','1','*'),
('4295','icon-pushpin','icon-pushpin','0','0','0.8','I251215','1','*'),
('4296','icon-pushpin icon-usd','icon-pushpin icon-usd','0','1','1.7','I2512152523','1','*'),
('4294','icon-print icon-camera icon-font','icon-print icon-camera icon-font','0','1','2','I2516532525625153','1','*'),
('4293','icon-print icon-camera','icon-print icon-camera','0','1','1.7333','I25165325256','1','*'),
('4292','icon-print','icon-print','0','0','0.6667','I251653','1','*'),
('4291','icon-plus-sign icon-minus-sign icon-remove-sign','icon-plus-sign icon-minus-sign icon-remove-sign','0','1','2','I25142525252565125','1','*'),
('4290','icon-plus-sign icon-minus-sign','icon-plus-sign icon-minus-sign','0','1','2','I2514252525','1','*'),
('4288','icon-plus icon-euro icon-minus','icon-plus icon-euro icon-minus','0','1','2','I2514256252','1','*'),
('4289','icon-plus-sign','icon-plus-sign','0','0','0.9333','I251425','1','*'),
('4286','icon-plus','icon-plus','0','0','0.6','I25142','1','*'),
('4287','icon-plus icon-euro','icon-plus icon-euro','0','1','1.6333','I2514256','1','*'),
('4285','icon-play-circle icon-repeat icon-refresh','icon-play-circle icon-repeat icon-refresh','0','1','2','I2514262425613256162','1','*'),
('4283','icon-play-circle','icon-play-circle','0','0','1','I25142624','1','*'),
('4284','icon-play-circle icon-repeat','icon-play-circle icon-repeat','0','1','1.9333','I2514262425613','1','*'),
('4282','icon-play icon-pause icon-stop','icon-play icon-pause icon-stop','0','1','2','I251425125231','1','*'),
('4280','icon-play','icon-play','0','0','0.6','I2514','1','*'),
('4281','icon-play icon-pause','icon-play icon-pause','0','1','1.6667','I25142512','1','*'),
('4279','icon-plane icon-calendar icon-random','icon-plane icon-calendar icon-random','0','1','2','I251452524536256535','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4277','icon-plane','icon-plane','0','0','0.6667','I25145','1','*'),
('4278','icon-plane icon-calendar','icon-plane icon-calendar','0','1','1.8','I251452524536','1','*'),
('4276','icon-picture icon-map-marker icon-adjust','icon-picture icon-map-marker icon-adjust','0','1','2','I251236251562625323','1','*'),
('4274','icon-picture','icon-picture','0','0','0.8','I251236','1','*'),
('4275','icon-picture icon-map-marker','icon-picture icon-map-marker','0','1','1.9333','I2512362515626','1','*'),
('4273','icon-phone-alt icon-tower icon-stats','icon-phone-alt icon-tower icon-stats','0','1','2','I251543253625232','1','*'),
('4272','icon-phone-alt icon-tower','icon-phone-alt icon-tower','0','1','1.8333','I2515432536','1','*'),
('4271','icon-phone-alt','icon-phone-alt','0','0','0.9333','I251543','1','*'),
('4270','icon-phone icon-pushpin icon-usd','icon-phone icon-pushpin icon-usd','0','1','2','I25152512152523','1','*'),
('4269','icon-phone icon-pushpin','icon-phone icon-pushpin','0','1','1.7667','I2515251215','1','*'),
('4268','icon-phone','icon-phone','0','0','0.6667','I2515','1','*'),
('4267','icon-pencil icon-glass icon-music','icon-pencil icon-glass icon-music','0','1','2','I2515242524252','1','*'),
('4265','icon-pencil','icon-pencil','0','0','0.7333','I251524','1','*'),
('4266','icon-pencil icon-glass','icon-pencil icon-glass','0','1','1.7333','I25152425242','1','*'),
('4264','icon-pause icon-stop icon-forward','icon-pause icon-stop icon-forward','0','1','2','I2512523125163','1','*'),
('4263','icon-pause icon-stop','icon-pause icon-stop','0','1','1.6667','I25125231','1','*'),
('4262','icon-pause','icon-pause','0','0','0.6667','I2512','1','*'),
('4260','icon-paperclip icon-heart-empty','icon-paperclip icon-heart-empty','0','1','2','I25162412563513','1','*'),
('4261','icon-paperclip icon-heart-empty icon-link','icon-paperclip icon-heart-empty icon-link','0','1','2','I2516241256351325452','1','*'),
('4259','icon-paperclip','icon-paperclip','0','0','0.9333','I2516241','1','*'),
('4257','icon-open icon-saved','icon-open icon-saved','0','1','1.6667','I251525213','1','*'),
('4258','icon-open icon-saved icon-import','icon-open icon-saved icon-import','0','1','2','I25152521325163','1','*'),
('4256','icon-open','icon-open','0','0','0.6','I2515','1','*'),
('4255','icon-ok-sign icon-question-sign icon-info-sign','icon-ok-sign icon-question-sign icon-info-sign','0','1','2','I2525252352525125','1','*'),
('4253','icon-ok-sign','icon-ok-sign','0','0','0.8','I2525','1','*'),
('4254','icon-ok-sign icon-question-sign','icon-ok-sign icon-question-sign','0','1','2','I25252523525','1','*'),
('4252','icon-ok-circle icon-ban-circle icon-arrow-left','icon-ok-circle icon-ban-circle icon-arrow-left','0','1','2','I25262425152624256413','1','*'),
('4251','icon-ok-circle icon-ban-circle','icon-ok-circle icon-ban-circle','0','1','2','I25262425152624','1','*'),
('4250','icon-ok-circle','icon-ok-circle','0','0','0.9333','I252624','1','*'),
('4249','icon-ok icon-remove icon-zoom-in','icon-ok icon-remove icon-zoom-in','0','1','2','I25256512525','1','*'),
('4248','icon-ok icon-remove','icon-ok icon-remove','0','1','1.6333','I2525651','1','*'),
('4247','icon-ok','icon-ok','0','0','0.4667','I252','1','*'),
('4246','icon-off icon-signal icon-cog','icon-off icon-signal icon-cog','0','1','1.9667','I25125254252','1','*'),
('4245','icon-off icon-signal','icon-off icon-signal','0','1','1.6667','I25125254','1','*'),
('4244','icon-off','icon-off','0','0','0.5333','I251','1','*'),
('4243','icon-new-window icon-record icon-save','icon-new-window icon-record icon-save','0','1','2','I2532562632521','1','*'),
('4241','icon-new-window','icon-new-window','0','0','1','I253','1','*'),
('4242','icon-new-window icon-record','icon-new-window icon-record','0','1','1.9','I253256263','1','*'),
('4240','icon-music icon-search icon-heart','icon-music icon-search icon-heart','0','1','2','I2525262563','1','*'),
('4239','icon-music icon-search','icon-music icon-search','0','1','1.7333','I2525262','1','*'),
('4238','icon-music','icon-music','0','0','0.6667','I252','1','*'),
('4237','icon-move icon-step-backward icon-fast-backward','icon-move icon-step-backward icon-fast-backward','0','1','2','I25125231263251231263','1','*'),
('4235','icon-move','icon-move','0','0','0.6','I251','1','*'),
('4236','icon-move icon-step-backward','icon-move icon-step-backward','0','1','1.9333','I25125231263','1','*'),
('4234','icon-minus-sign icon-remove-sign icon-ok-sign','icon-minus-sign icon-remove-sign icon-ok-sign','0','1','2','I252525651252525','1','*'),
('4233','icon-minus-sign icon-remove-sign','icon-minus-sign icon-remove-sign','0','1','2','I25252565125','1','*'),
('4232','icon-minus-sign','icon-minus-sign','0','0','1','I2525','1','*'),
('4231','icon-minus icon-cloud icon-envelope','icon-minus icon-cloud icon-envelope','0','1','2','I252524325141','1','*'),
('4230','icon-minus icon-cloud','icon-minus icon-cloud','0','1','1.7','I2525243','1','*'),
('4229','icon-minus','icon-minus','0','0','0.6667','I252','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4228','icon-map-marker icon-adjust icon-tint','icon-map-marker icon-adjust icon-tint','0','1','2','I25156262532325353','1','*'),
('4226','icon-map-marker','icon-map-marker','0','0','1','I2515626','1','*'),
('4227','icon-map-marker icon-adjust','icon-map-marker icon-adjust','0','1','1.9','I251562625323','1','*'),
('4224','icon-magnet icon-chevron-up','icon-magnet icon-chevron-up','0','1','1.9','I252532521651','1','*'),
('4225','icon-magnet icon-chevron-up icon-chevron-down','icon-magnet icon-chevron-up icon-chevron-down','0','1','2','I25253252165125216535','1','*'),
('4223','icon-magnet','icon-magnet','0','0','0.7333','I25253','1','*'),
('4221','icon-log-out icon-new-window','icon-log-out icon-new-window','0','1','1.9333','I25423253','1','*'),
('4222','icon-log-out icon-new-window icon-record','icon-log-out icon-new-window icon-record','0','1','2','I25423253256263','1','*'),
('4220','icon-log-out','icon-log-out','0','0','0.8','I25423','1','*'),
('4218','icon-log-in icon-flash','icon-log-in icon-flash','0','1','1.7333','I2542525142','1','*'),
('4219','icon-log-in icon-flash icon-log-out','icon-log-in icon-flash icon-log-out','0','1','2','I25425251425423','1','*'),
('4217','icon-log-in','icon-log-in','0','0','0.7333','I25425','1','*'),
('4215','icon-lock icon-flag','icon-lock icon-flag','0','1','1.6333','I25425142','1','*'),
('4216','icon-lock icon-flag icon-headphones','icon-lock icon-flag icon-headphones','0','1','2','I2542514253152','1','*'),
('4214','icon-lock','icon-lock','0','0','0.6','I2542','1','*'),
('4213','icon-list-alt icon-lock icon-flag','icon-list-alt icon-lock icon-flag','0','1','2','I254234325425142','1','*'),
('4212','icon-list-alt icon-lock','icon-list-alt icon-lock','0','1','1.7667','I25423432542','1','*'),
('4211','icon-list-alt','icon-list-alt','0','0','0.8667','I2542343','1','*'),
('4210','icon-list icon-indent-left icon-indent-right','icon-list icon-indent-left icon-indent-right','0','1','2','I254232535341325353623','1','*'),
('4208','icon-list','icon-list','0','0','0.6','I25423','1','*'),
('4209','icon-list icon-indent-left','icon-list icon-indent-left','0','1','1.8667','I2542325353413','1','*'),
('4207','icon-link icon-phone icon-pushpin','icon-link icon-phone icon-pushpin','0','1','2','I25452515251215','1','*'),
('4206','icon-link icon-phone','icon-link icon-phone','0','1','1.6667','I25452515','1','*'),
('4205','icon-link','icon-link','0','0','0.6','I25452','1','*'),
('4204','icon-leaf icon-fire icon-eye-open','icon-leaf icon-fire icon-eye-open','0','1','2','I254125162515','1','*'),
('4203','icon-leaf icon-fire','icon-leaf icon-fire','0','1','1.6333','I25412516','1','*'),
('4202','icon-leaf','icon-leaf','0','0','0.6','I2541','1','*'),
('4201','icon-italic icon-text-height icon-text-width','icon-italic icon-text-height icon-text-width','0','1','2','I2534253232325323','1','*'),
('4200','icon-italic icon-text-height','icon-italic icon-text-height','0','1','1.9333','I25342532323','1','*'),
('4199','icon-italic','icon-italic','0','0','0.7333','I25342','1','*'),
('4198','icon-info-sign icon-screenshot icon-remove-circle','icon-info-sign icon-screenshot icon-remove-circle','0','1','2','I251252526523256512624','1','*'),
('4197','icon-info-sign icon-screenshot','icon-info-sign icon-screenshot','0','1','2','I251252526523','1','*'),
('4196','icon-info-sign','icon-info-sign','0','0','0.9333','I25125','1','*'),
('4195','icon-indent-right icon-facetime-video icon-picture','icon-indent-right icon-facetime-video icon-picture','0','1','2','I2535362325123513251236','1','*'),
('4193','icon-indent-right','icon-indent-right','0','0','1','I25353623','1','*'),
('4194','icon-indent-right icon-facetime-video','icon-indent-right icon-facetime-video','0','1','2','I2535362325123513','1','*'),
('4192','icon-indent-left icon-indent-right icon-facetime-video','icon-indent-left icon-indent-right icon-facetime-video','0','1','2','I253534132535362325123513','1','*'),
('4191','icon-indent-left icon-indent-right','icon-indent-left icon-indent-right','0','1','2','I2535341325353623','1','*'),
('4190','icon-indent-left','icon-indent-left','0','0','1','I25353413','1','*'),
('4188','icon-inbox icon-play-circle','icon-inbox icon-play-circle','0','1','1.9','I25125142624','1','*'),
('4189','icon-inbox icon-play-circle icon-repeat','icon-inbox icon-play-circle icon-repeat','0','1','2','I2512514262425613','1','*'),
('4187','icon-inbox','icon-inbox','0','0','0.6667','I2512','1','*'),
('4186','icon-import icon-export icon-send','icon-import icon-export icon-send','0','1','2','I2516325216325253','1','*'),
('4184','icon-import','icon-import','0','0','0.7333','I25163','1','*'),
('4185','icon-import icon-export','icon-import icon-export','0','1','1.7667','I25163252163','1','*'),
('4182','icon-home icon-file','icon-home icon-file','0','1','1.6333','I252514','1','*'),
('4183','icon-home icon-file icon-time','icon-home icon-file icon-time','0','1','1.9667','I2525142535','1','*'),
('4181','icon-home','icon-home','0','0','0.6','I250','1','*'),
('4180','icon-heart-empty icon-link icon-phone','icon-heart-empty icon-link icon-phone','0','1','2','I256351325452515','1','*'),
('4179','icon-heart-empty icon-link','icon-heart-empty icon-link','0','1','1.8667','I256351325452','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4178','icon-heart-empty','icon-heart-empty','0','0','1','I2563513','1','*'),
('4176','icon-heart icon-star','icon-heart icon-star','0','1','1.6667','I256325236','1','*'),
('4177','icon-heart icon-star icon-star-empty','icon-heart icon-star icon-star-empty','0','1','2','I25632523625236513','1','*'),
('4175','icon-heart','icon-heart','0','0','0.6667','I2563','1','*'),
('4174','icon-headphones icon-volume-off icon-volume-down','icon-headphones icon-volume-off icon-volume-down','0','1','2','I253152514512514535','1','*'),
('4173','icon-headphones icon-volume-off','icon-headphones icon-volume-off','0','1','2','I25315251451','1','*'),
('4172','icon-headphones','icon-headphones','0','0','1','I253152','1','*'),
('4171','icon-header icon-compressed icon-earphone','icon-header icon-compressed icon-earphone','0','1','2','I25362525162325615','1','*'),
('4169','icon-header','icon-header','0','0','0.7333','I2536','1','*'),
('4170','icon-header icon-compressed','icon-header icon-compressed','0','1','1.9','I253625251623','1','*'),
('4168','icon-hdd icon-bullhorn icon-bell','icon-hdd icon-bullhorn icon-bell','0','1','2','I2532514652514','1','*'),
('4167','icon-hdd icon-bullhorn','icon-hdd icon-bullhorn','0','1','1.7333','I253251465','1','*'),
('4166','icon-hdd','icon-hdd','0','0','0.5333','I253','1','*'),
('4165','icon-hd-video icon-subtitles icon-sound-stereo','icon-hd-video icon-subtitles icon-sound-stereo','0','1','2','I2531325213425253236','1','*'),
('4163','icon-hd-video','icon-hd-video','0','0','0.8667','I25313','1','*'),
('4164','icon-hd-video icon-subtitles','icon-hd-video icon-subtitles','0','1','1.9333','I253132521342','1','*'),
('4162','icon-hand-up icon-hand-down icon-circle-arrow-right','icon-hand-up icon-hand-down icon-circle-arrow-right','0','1','2','I25312535252624623','1','*'),
('4161','icon-hand-up icon-hand-down','icon-hand-up icon-hand-down','0','1','1.9','I25312535','1','*'),
('4160','icon-hand-up','icon-hand-up','0','0','0.8','I2531','1','*'),
('4159','icon-hand-right icon-hand-left icon-hand-up','icon-hand-right icon-hand-left icon-hand-up','0','1','2','I2536232534132531','1','*'),
('4158','icon-hand-right icon-hand-left','icon-hand-right icon-hand-left','0','1','2','I253623253413','1','*'),
('4157','icon-hand-right','icon-hand-right','0','0','1','I253623','1','*'),
('4156','icon-hand-left icon-hand-up icon-hand-down','icon-hand-left icon-hand-up icon-hand-down','0','1','2','I25341325312535','1','*'),
('4154','icon-hand-left','icon-hand-left','0','0','0.9333','I253413','1','*'),
('4155','icon-hand-left icon-hand-up','icon-hand-left icon-hand-up','0','1','1.9','I2534132531','1','*'),
('4153','icon-hand-down icon-circle-arrow-right icon-circle-arrow-left','icon-hand-down icon-circle-arrow-right icon-circle-arrow-left','0','1','2','I25352526246232526246413','1','*'),
('4152','icon-hand-down icon-circle-arrow-right','icon-hand-down icon-circle-arrow-right','0','1','2','I2535252624623','1','*'),
('4151','icon-hand-down','icon-hand-down','0','0','0.9333','I2535','1','*'),
('4150','icon-globe icon-wrench icon-tasks','icon-globe icon-wrench icon-tasks','0','1','2','I2524125652532','1','*'),
('4149','icon-globe icon-wrench','icon-globe icon-wrench','0','1','1.7333','I2524125652','1','*'),
('4148','icon-globe','icon-globe','0','0','0.6667','I25241','1','*'),
('4147','icon-glass icon-music icon-search','icon-glass icon-music icon-search','0','1','2','I25242525262','1','*'),
('4145','icon-glass','icon-glass','0','0','0.6667','I25242','1','*'),
('4146','icon-glass icon-music','icon-glass icon-music','0','1','1.7','I2524252','1','*'),
('4144','icon-gift icon-leaf icon-fire','icon-gift icon-leaf icon-fire','0','1','1.9667','I2521325412516','1','*'),
('4142','icon-gift','icon-gift','0','0','0.6','I25213','1','*'),
('4143','icon-gift icon-leaf','icon-gift icon-leaf','0','1','1.6333','I252132541','1','*'),
('4140','icon-gbp icon-sort','icon-gbp icon-sort','0','1','1.6','I252125263','1','*'),
('4141','icon-gbp icon-sort icon-sort-by-alphabet','icon-gbp icon-sort icon-sort-by-alphabet','0','1','2','I252125263252631413','1','*'),
('4139','icon-gbp','icon-gbp','0','0','0.5333','I2521','1','*'),
('4138','icon-fullscreen icon-dashboard icon-paperclip','icon-fullscreen icon-dashboard icon-paperclip','0','1','2','I251426525321632516241','1','*'),
('4137','icon-fullscreen icon-dashboard','icon-fullscreen icon-dashboard','0','1','2','I25142652532163','1','*'),
('4136','icon-fullscreen','icon-fullscreen','0','0','1','I2514265','1','*'),
('4135','icon-forward icon-fast-forward icon-step-forward','icon-forward icon-fast-forward icon-step-forward','0','1','2','I25163251231632523163','1','*'),
('4134','icon-forward icon-fast-forward','icon-forward icon-fast-forward','0','1','2','I2516325123163','1','*'),
('4133','icon-forward','icon-forward','0','0','0.8','I25163','1','*'),
('4132','icon-font icon-bold icon-italic','icon-font icon-bold icon-italic','0','1','2','I251532514325342','1','*'),
('4130','icon-font','icon-font','0','0','0.6','I25153','1','*'),
('4131','icon-font icon-bold','icon-font icon-bold','0','1','1.6333','I2515325143','1','*'),
('4129','icon-folder-open icon-resize-vertical icon-resize-horizontal','icon-folder-open icon-resize-vertical icon-resize-horizontal','0','1','2','I25143615256216324256262534','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4128','icon-folder-open icon-resize-vertical','icon-folder-open icon-resize-vertical','0','1','2','I25143615256216324','1','*'),
('4127','icon-folder-open','icon-folder-open','0','0','1','I25143615','1','*'),
('4126','icon-folder-close icon-folder-open icon-resize-vertical','icon-folder-close icon-folder-open icon-resize-vertical','0','1','2','I2514362425143615256216324','1','*'),
('4125','icon-folder-close icon-folder-open','icon-folder-close icon-folder-open','0','1','2','I2514362425143615','1','*'),
('4124','icon-folder-close','icon-folder-close','0','0','1','I251436242','1','*'),
('4123','icon-floppy-saved icon-floppy-remove icon-floppy-save','icon-floppy-saved icon-floppy-remove icon-floppy-save','0','1','2','I25141213251416512514121','1','*'),
('4122','icon-floppy-saved icon-floppy-remove','icon-floppy-saved icon-floppy-remove','0','1','2','I2514121325141651','1','*'),
('4121','icon-floppy-saved','icon-floppy-saved','0','0','1','I25141213','1','*'),
('4120','icon-floppy-save icon-floppy-open icon-credit-card','icon-floppy-save icon-floppy-open icon-credit-card','0','1','2','I251412125141525263263','1','*'),
('4119','icon-floppy-save icon-floppy-open','icon-floppy-save icon-floppy-open','0','1','2','I2514121251415','1','*'),
('4118','icon-floppy-save','icon-floppy-save','0','0','1','I2514121','1','*'),
('4117','icon-floppy-remove icon-floppy-save icon-floppy-open','icon-floppy-remove icon-floppy-save icon-floppy-open','0','1','2','I251416512514121251415','1','*'),
('4116','icon-floppy-remove icon-floppy-save','icon-floppy-remove icon-floppy-save','0','1','2','I251416512514121','1','*'),
('4115','icon-floppy-remove','icon-floppy-remove','0','0','1','I25141651','1','*'),
('4114','icon-floppy-open icon-credit-card icon-transfer','icon-floppy-open icon-credit-card icon-transfer','0','1','2','I2514152526326325365216','1','*'),
('4113','icon-floppy-open icon-credit-card','icon-floppy-open icon-credit-card','0','1','2','I25141525263263','1','*'),
('4112','icon-floppy-open','icon-floppy-open','0','0','1','I251415','1','*'),
('4111','icon-floppy-disk icon-floppy-saved icon-floppy-remove','icon-floppy-disk icon-floppy-saved icon-floppy-remove','0','1','2','I2514132514121325141651','1','*'),
('4109','icon-floppy-disk','icon-floppy-disk','0','0','1','I2514132','1','*'),
('4110','icon-floppy-disk icon-floppy-saved','icon-floppy-disk icon-floppy-saved','0','1','2','I25141325141213','1','*'),
('4108','icon-flash icon-log-out icon-new-window','icon-flash icon-log-out icon-new-window','0','1','2','I251425423253','1','*'),
('4106','icon-flash','icon-flash','0','0','0.6667','I25142','1','*'),
('4107','icon-flash icon-log-out','icon-flash icon-log-out','0','1','1.7667','I251425423','1','*'),
('4105','icon-flag icon-headphones icon-volume-off','icon-flag icon-headphones icon-volume-off','0','1','2','I251425315251451','1','*'),
('4104','icon-flag icon-headphones','icon-flag icon-headphones','0','1','1.8333','I2514253152','1','*'),
('4103','icon-flag','icon-flag','0','0','0.6','I25142','1','*'),
('4102','icon-fire icon-eye-open icon-eye-close','icon-fire icon-eye-open icon-eye-close','0','1','2','I2516251525242','1','*'),
('4101','icon-fire icon-eye-open','icon-fire icon-eye-open','0','1','1.7667','I25162515','1','*'),
('4100','icon-fire','icon-fire','0','0','0.6','I2516','1','*'),
('4099','icon-filter icon-briefcase icon-fullscreen','icon-filter icon-briefcase icon-fullscreen','0','1','2','I251436251612514265','1','*'),
('4098','icon-filter icon-briefcase','icon-filter icon-briefcase','0','1','1.8667','I251436251612','1','*'),
('4096','icon-film icon-th-large icon-th','icon-film icon-th-large icon-th','0','1','2','I2514525346253','1','*'),
('4097','icon-filter','icon-filter','0','0','0.7333','I251436','1','*'),
('4095','icon-film icon-th-large','icon-film icon-th-large','0','1','1.7667','I25145253462','1','*'),
('4094','icon-film','icon-film','0','0','0.6','I25145','1','*'),
('4093','icon-file icon-time icon-road','icon-file icon-time icon-road','0','1','1.9667','I251425352563','1','*'),
('4092','icon-file icon-time','icon-file icon-time','0','1','1.6333','I25142535','1','*'),
('4091','icon-file','icon-file','0','0','0.6','I2514','1','*'),
('4090','icon-fast-forward icon-step-forward icon-eject','icon-fast-forward icon-step-forward icon-eject','0','1','2','I2512316325231632523','1','*'),
('4089','icon-fast-forward icon-step-forward','icon-fast-forward icon-step-forward','0','1','2','I251231632523163','1','*'),
('4088','icon-fast-forward','icon-fast-forward','0','0','1','I25123163','1','*'),
('4087','icon-fast-backward icon-backward icon-play','icon-fast-backward icon-backward icon-play','0','1','2','I2512312632512632514','1','*'),
('4086','icon-fast-backward icon-backward','icon-fast-backward icon-backward','0','1','2','I251231263251263','1','*'),
('4085','icon-fast-backward','icon-fast-backward','0','0','1','I251231263','1','*'),
('4084','icon-facetime-video icon-picture icon-map-marker','icon-facetime-video icon-picture icon-map-marker','0','1','2','I251235132512362515626','1','*'),
('4083','icon-facetime-video icon-picture','icon-facetime-video icon-picture','0','1','2','I25123513251236','1','*'),
('4082','icon-facetime-video','icon-facetime-video','0','0','1','I25123513','1','*'),
('4081','icon-eye-open icon-eye-close icon-warning-sign','icon-eye-open icon-eye-close icon-warning-sign','0','1','2','I25152524256525','1','*'),
('4080','icon-eye-open icon-eye-close','icon-eye-open icon-eye-close','0','1','1.9333','I251525242','1','*'),
('4079','icon-eye-open','icon-eye-open','0','0','0.8667','I2515','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4078','icon-eye-close icon-warning-sign icon-plane','icon-eye-close icon-warning-sign icon-plane','0','1','2','I252425652525145','1','*'),
('4077','icon-eye-close icon-warning-sign','icon-eye-close icon-warning-sign','0','1','2','I2524256525','1','*'),
('4076','icon-eye-close','icon-eye-close','0','0','0.9333','I25242','1','*'),
('4075','icon-export icon-send icon-floppy-disk','icon-export icon-send icon-floppy-disk','0','1','2','I252163252532514132','1','*'),
('4074','icon-export icon-send','icon-export icon-send','0','1','1.7','I25216325253','1','*'),
('4073','icon-export','icon-export','0','0','0.7333','I252163','1','*'),
('4072','icon-expand icon-collapse-down icon-collapse-up','icon-expand icon-collapse-down icon-collapse-up','0','1','2','I252153252412352524121','1','*'),
('4071','icon-expand icon-collapse-down','icon-expand icon-collapse-down','0','1','2','I25215325241235','1','*'),
('4070','icon-expand','icon-expand','0','0','0.7333','I252153','1','*'),
('4069','icon-exclamation-sign icon-gift icon-leaf','icon-exclamation-sign icon-gift icon-leaf','0','1','2','I252453525252132541','1','*'),
('4068','icon-exclamation-sign icon-gift','icon-exclamation-sign icon-gift','0','1','2','I25245352525213','1','*'),
('4067','icon-exclamation-sign','icon-exclamation-sign','0','0','1','I252453525','1','*'),
('4066','icon-euro icon-minus icon-cloud','icon-euro icon-minus icon-cloud','0','1','2','I2562525243','1','*'),
('4065','icon-euro icon-minus','icon-euro icon-minus','0','1','1.6667','I256252','1','*'),
('4064','icon-euro','icon-euro','0','0','0.6','I256','1','*'),
('4063','icon-envelope icon-pencil icon-glass','icon-envelope icon-pencil icon-glass','0','1','2','I2514125152425242','1','*'),
('4061','icon-envelope','icon-envelope','0','0','0.8667','I25141','1','*'),
('4062','icon-envelope icon-pencil','icon-envelope icon-pencil','0','1','1.8333','I25141251524','1','*'),
('4060','icon-eject icon-chevron-left icon-chevron-right','icon-eject icon-chevron-left icon-chevron-right','0','1','2','I2523252165413252165623','1','*'),
('4059','icon-eject icon-chevron-left','icon-eject icon-chevron-left','0','1','1.9333','I2523252165413','1','*'),
('4058','icon-eject','icon-eject','0','0','0.6667','I2523','1','*'),
('4057','icon-edit icon-share icon-check','icon-edit icon-share icon-check','0','1','2','I2532526252','1','*'),
('4056','icon-edit icon-share','icon-edit icon-share','0','1','1.6667','I2532526','1','*'),
('4055','icon-edit','icon-edit','0','0','0.6','I253','1','*'),
('4054','icon-earphone icon-phone-alt icon-tower','icon-earphone icon-phone-alt icon-tower','0','1','2','I256152515432536','1','*'),
('4053','icon-earphone icon-phone-alt','icon-earphone icon-phone-alt','0','1','1.9333','I25615251543','1','*'),
('4052','icon-earphone','icon-earphone','0','0','0.8667','I25615','1','*'),
('4051','icon-download-alt icon-download icon-upload','icon-download-alt icon-download icon-upload','0','1','2','I2535434325354325143','1','*'),
('4050','icon-download-alt icon-download','icon-download-alt icon-download','0','1','2','I25354343253543','1','*'),
('4049','icon-download-alt','icon-download-alt','0','0','1','I25354343','1','*'),
('4048','icon-download icon-upload icon-inbox','icon-download icon-upload icon-inbox','0','1','2','I253543251432512','1','*'),
('4047','icon-download icon-upload','icon-download icon-upload','0','1','1.8333','I25354325143','1','*'),
('4046','icon-download','icon-download','0','0','0.8667','I253543','1','*'),
('4045','icon-dashboard icon-paperclip icon-heart-empty','icon-dashboard icon-paperclip icon-heart-empty','0','1','2','I253216325162412563513','1','*'),
('4044','icon-dashboard icon-paperclip','icon-dashboard icon-paperclip','0','1','1.9667','I25321632516241','1','*'),
('4043','icon-dashboard','icon-dashboard','0','0','0.9333','I2532163','1','*'),
('4042','icon-cutlery icon-header icon-compressed','icon-cutlery icon-header icon-compressed','0','1','2','I252346253625251623','1','*'),
('4041','icon-cutlery icon-header','icon-cutlery icon-header','0','1','1.8','I2523462536','1','*'),
('4040','icon-cutlery','icon-cutlery','0','0','0.8','I252346','1','*'),
('4039','icon-credit-card icon-transfer icon-cutlery','icon-credit-card icon-transfer icon-cutlery','0','1','2','I2526326325365216252346','1','*'),
('4038','icon-credit-card icon-transfer','icon-credit-card icon-transfer','0','1','2','I2526326325365216','1','*'),
('4037','icon-credit-card','icon-credit-card','0','0','1','I25263263','1','*'),
('4036','icon-copyright-mark icon-registration-mark icon-cloud-download','icon-copyright-mark icon-registration-mark icon-cloud-download','0','1','2','I25216235625623635625243543','1','*'),
('4035','icon-copyright-mark icon-registration-mark','icon-copyright-mark icon-registration-mark','0','1','2','I2521623562562363562','1','*'),
('4034','icon-copyright-mark','icon-copyright-mark','0','0','1','I2521623562','1','*'),
('4033','icon-compressed icon-earphone icon-phone-alt','icon-compressed icon-earphone icon-phone-alt','0','1','2','I2525162325615251543','1','*'),
('4032','icon-compressed icon-earphone','icon-compressed icon-earphone','0','1','1.9667','I2525162325615','1','*'),
('4031','icon-compressed','icon-compressed','0','0','1','I25251623','1','*'),
('4030','icon-comment icon-magnet icon-chevron-up','icon-comment icon-magnet icon-chevron-up','0','1','2','I25253252532521651','1','*'),
('4028','icon-comment','icon-comment','0','0','0.8','I25253','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4029','icon-comment icon-magnet','icon-comment icon-magnet','0','1','1.8','I2525325253','1','*'),
('4027','icon-collapse-up icon-log-in icon-flash','icon-collapse-up icon-log-in icon-flash','0','1','2','I25241212542525142','1','*'),
('4025','icon-collapse-up','icon-collapse-up','0','0','1','I2524121','1','*'),
('4026','icon-collapse-up icon-log-in','icon-collapse-up icon-log-in','0','1','1.9333','I252412125425','1','*'),
('4024','icon-collapse-down icon-collapse-up icon-log-in','icon-collapse-down icon-collapse-up icon-log-in','0','1','2','I25241235252412125425','1','*'),
('4023','icon-collapse-down icon-collapse-up','icon-collapse-down icon-collapse-up','0','1','2','I252412352524121','1','*'),
('4022','icon-collapse-down','icon-collapse-down','0','0','1','I25241235','1','*'),
('4021','icon-cog icon-trash icon-home','icon-cog icon-trash icon-home','0','1','1.9667','I25253625','1','*'),
('4019','icon-cog','icon-cog','0','0','0.5333','I252','1','*'),
('4020','icon-cog icon-trash','icon-cog icon-trash','0','1','1.6333','I2525362','1','*'),
('4018','icon-cloud-upload icon-tree-conifer icon-tree-deciduous','icon-cloud-upload icon-tree-conifer icon-tree-deciduous','0','1','2','I252431432536251625363232','1','*'),
('4016','icon-cloud-upload','icon-cloud-upload','0','0','1','I25243143','1','*'),
('4017','icon-cloud-upload icon-tree-conifer','icon-cloud-upload icon-tree-conifer','0','1','2','I2524314325362516','1','*'),
('4015','icon-cloud-download icon-cloud-upload icon-tree-conifer','icon-cloud-download icon-cloud-upload icon-tree-conifer','0','1','2','I252435432524314325362516','1','*'),
('4013','icon-cloud-download','icon-cloud-download','0','0','1','I25243543','1','*'),
('4014','icon-cloud-download icon-cloud-upload','icon-cloud-download icon-cloud-upload','0','1','2','I2524354325243143','1','*'),
('4012','icon-cloud icon-envelope icon-pencil','icon-cloud icon-envelope icon-pencil','0','1','2','I2524325141251524','1','*'),
('4011','icon-cloud icon-envelope','icon-cloud icon-envelope','0','1','1.8','I2524325141','1','*'),
('4010','icon-cloud','icon-cloud','0','0','0.6667','I25243','1','*'),
('4009','icon-circle-arrow-up icon-circle-arrow-down icon-globe','icon-circle-arrow-up icon-circle-arrow-down icon-globe','0','1','2','I2526246125262463525241','1','*'),
('4008','icon-circle-arrow-up icon-circle-arrow-down','icon-circle-arrow-up icon-circle-arrow-down','0','1','2','I25262461252624635','1','*'),
('4007','icon-circle-arrow-up','icon-circle-arrow-up','0','0','1','I25262461','1','*'),
('4006','icon-circle-arrow-right icon-circle-arrow-left icon-circle-arrow-up','icon-circle-arrow-right icon-circle-arrow-left icon-circle-arrow-up','0','1','2','I252624623252624641325262461','1','*'),
('4004','icon-circle-arrow-right','icon-circle-arrow-right','0','0','1','I252624623','1','*'),
('4005','icon-circle-arrow-right icon-circle-arrow-left','icon-circle-arrow-right icon-circle-arrow-left','0','1','2','I2526246232526246413','1','*'),
('4003','icon-circle-arrow-left icon-circle-arrow-up icon-circle-arrow-down','icon-circle-arrow-left icon-circle-arrow-up icon-circle-arrow-down','0','1','2','I252624641325262461252624635','1','*'),
('4002','icon-circle-arrow-left icon-circle-arrow-up','icon-circle-arrow-left icon-circle-arrow-up','0','1','2','I252624641325262461','1','*'),
('4001','icon-circle-arrow-left','icon-circle-arrow-left','0','0','1','I2526246413','1','*'),
('4000','icon-circle-arrow-down icon-globe icon-wrench','icon-circle-arrow-down icon-globe icon-wrench','0','1','2','I2526246352524125652','1','*'),
('3999','icon-circle-arrow-down icon-globe','icon-circle-arrow-down icon-globe','0','1','2','I25262463525241','1','*'),
('3998','icon-circle-arrow-down','icon-circle-arrow-down','0','0','1','I252624635','1','*'),
('3997','icon-chevron-up icon-chevron-down icon-retweet','icon-chevron-up icon-chevron-down icon-retweet','0','1','2','I2521651252165352563','1','*'),
('3996','icon-chevron-up icon-chevron-down','icon-chevron-up icon-chevron-down','0','1','2','I252165125216535','1','*'),
('3994','icon-chevron-right icon-plus-sign icon-minus-sign','icon-chevron-right icon-plus-sign icon-minus-sign','0','1','2','I2521656232514252525','1','*'),
('3995','icon-chevron-up','icon-chevron-up','0','0','1','I2521651','1','*'),
('3992','icon-chevron-right','icon-chevron-right','0','0','1','I252165623','1','*'),
('3993','icon-chevron-right icon-plus-sign','icon-chevron-right icon-plus-sign','0','1','2','I252165623251425','1','*'),
('3991','icon-chevron-left icon-chevron-right icon-plus-sign','icon-chevron-left icon-chevron-right icon-plus-sign','0','1','2','I252165413252165623251425','1','*'),
('3989','icon-chevron-left','icon-chevron-left','0','0','1','I252165413','1','*'),
('3990','icon-chevron-left icon-chevron-right','icon-chevron-left icon-chevron-right','0','1','2','I252165413252165623','1','*'),
('3988','icon-chevron-down icon-retweet icon-shopping-cart','icon-chevron-down icon-retweet icon-shopping-cart','0','1','2','I25216535256325215263','1','*'),
('3986','icon-chevron-down','icon-chevron-down','0','0','1','I25216535','1','*'),
('3987','icon-chevron-down icon-retweet','icon-chevron-down icon-retweet','0','1','2','I252165352563','1','*'),
('3985','icon-check icon-move icon-step-backward','icon-check icon-move icon-step-backward','0','1','2','I2525125231263','1','*'),
('3984','icon-check icon-move','icon-check icon-move','0','1','1.6667','I25251','1','*'),
('3983','icon-check','icon-check','0','0','0.6667','I252','1','*'),
('3981','icon-certificate icon-thumbs-up','icon-certificate icon-thumbs-up','0','1','2','I252631232535121','1','*'),
('3982','icon-certificate icon-thumbs-up icon-thumbs-down','icon-certificate icon-thumbs-up icon-thumbs-down','0','1','2','I25263123253512125351235','1','*'),
('3980','icon-certificate','icon-certificate','0','0','1','I25263123','1','*'),
('3978','icon-camera icon-font','icon-camera icon-font','0','1','1.7','I2525625153','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3979','icon-camera icon-font icon-bold','icon-camera icon-font icon-bold','0','1','2','I252562515325143','1','*'),
('3977','icon-camera','icon-camera','0','0','0.7333','I25256','1','*'),
('3975','icon-calendar icon-random','icon-calendar icon-random','0','1','1.8333','I2524536256535','1','*'),
('3976','icon-calendar icon-random icon-comment','icon-calendar icon-random icon-comment','0','1','2','I252453625653525253','1','*'),
('3974','icon-calendar','icon-calendar','0','0','0.8667','I2524536','1','*'),
('3972','icon-bullhorn icon-bell','icon-bullhorn icon-bell','0','1','1.7667','I2514652514','1','*'),
('3973','icon-bullhorn icon-bell icon-certificate','icon-bullhorn icon-bell icon-certificate','0','1','2','I251465251425263123','1','*'),
('3971','icon-bullhorn','icon-bullhorn','0','0','0.8667','I251465','1','*'),
('3970','icon-briefcase icon-fullscreen icon-dashboard','icon-briefcase icon-fullscreen icon-dashboard','0','1','2','I2516125142652532163','1','*'),
('3969','icon-briefcase icon-fullscreen','icon-briefcase icon-fullscreen','0','1','2','I251612514265','1','*'),
('3968','icon-briefcase','icon-briefcase','0','0','0.9333','I251612','1','*'),
('3967','icon-bookmark icon-print icon-camera','icon-bookmark icon-print icon-camera','0','1','2','I25125625165325256','1','*'),
('3966','icon-bookmark icon-print','icon-bookmark icon-print','0','1','1.8','I251256251653','1','*'),
('3965','icon-bookmark','icon-bookmark','0','0','0.8667','I2512562','1','*'),
('3964','icon-book icon-bookmark icon-print','icon-book icon-bookmark icon-print','0','1','2','I251251256251653','1','*'),
('3962','icon-book','icon-book','0','0','0.6','I2512','1','*'),
('3963','icon-book icon-bookmark','icon-book icon-bookmark','0','1','1.7667','I2512512562','1','*'),
('3961','icon-bold icon-italic icon-text-height','icon-bold icon-italic icon-text-height','0','1','2','I2514325342532323','1','*'),
('3960','icon-bold icon-italic','icon-bold icon-italic','0','1','1.7','I2514325342','1','*'),
('3959','icon-bold','icon-bold','0','0','0.6','I25143','1','*'),
('3958','icon-bell icon-certificate icon-thumbs-up','icon-bell icon-certificate icon-thumbs-up','0','1','2','I2514252631232535121','1','*'),
('3956','icon-bell','icon-bell','0','0','0.6','I2514','1','*'),
('3957','icon-bell icon-certificate','icon-bell icon-certificate','0','1','1.8667','I251425263123','1','*'),
('3955','icon-barcode icon-tag icon-tags','icon-barcode icon-tag icon-tags','0','1','2','I2516232532532','1','*'),
('3954','icon-barcode icon-tag','icon-barcode icon-tag','0','1','1.7','I2516232532','1','*'),
('3953','icon-barcode','icon-barcode','0','0','0.8','I251623','1','*'),
('3952','icon-ban-circle icon-arrow-left icon-arrow-right','icon-ban-circle icon-arrow-left icon-arrow-right','0','1','2','I2515262425641325623','1','*'),
('3951','icon-ban-circle icon-arrow-left','icon-ban-circle icon-arrow-left','0','1','2','I25152624256413','1','*'),
('3950','icon-ban-circle','icon-ban-circle','0','0','1','I25152624','1','*'),
('3949','icon-backward icon-play icon-pause','icon-backward icon-play icon-pause','0','1','2','I25126325142512','1','*'),
('3948','icon-backward icon-play','icon-backward icon-play','0','1','1.7667','I2512632514','1','*'),
('3947','icon-backward','icon-backward','0','0','0.8667','I251263','1','*'),
('3946','icon-asterisk icon-plus icon-euro','icon-asterisk icon-plus icon-euro','0','1','2','I252362514256','1','*'),
('3945','icon-asterisk icon-plus','icon-asterisk icon-plus','0','1','1.7667','I2523625142','1','*'),
('3944','icon-asterisk','icon-asterisk','0','0','0.8667','I252362','1','*'),
('3943','icon-arrow-up icon-arrow-down icon-share-alt','icon-arrow-up icon-arrow-down icon-share-alt','0','1','2','I256125635252643','1','*'),
('3941','icon-arrow-up','icon-arrow-up','0','0','0.8667','I2561','1','*'),
('3942','icon-arrow-up icon-arrow-down','icon-arrow-up icon-arrow-down','0','1','1.9667','I256125635','1','*'),
('3940','icon-arrow-right icon-arrow-up icon-arrow-down','icon-arrow-right icon-arrow-up icon-arrow-down','0','1','2','I25623256125635','1','*'),
('3939','icon-arrow-right icon-arrow-up','icon-arrow-right icon-arrow-up','0','1','2','I256232561','1','*'),
('3938','icon-arrow-right','icon-arrow-right','0','0','1','I25623','1','*'),
('3937','icon-arrow-left icon-arrow-right icon-arrow-up','icon-arrow-left icon-arrow-right icon-arrow-up','0','1','2','I256413256232561','1','*'),
('3936','icon-arrow-left icon-arrow-right','icon-arrow-left icon-arrow-right','0','1','2','I25641325623','1','*'),
('3935','icon-arrow-left','icon-arrow-left','0','0','1','I256413','1','*'),
('3934','icon-arrow-down icon-share-alt icon-resize-full','icon-arrow-down icon-share-alt icon-resize-full','0','1','2','I25635252643256214','1','*'),
('3933','icon-arrow-down icon-share-alt','icon-arrow-down icon-share-alt','0','1','2','I25635252643','1','*'),
('3932','icon-arrow-down','icon-arrow-down','0','0','1','I25635','1','*'),
('3931','icon-align-right icon-align-justify icon-list','icon-align-right icon-align-justify icon-list','0','1','2','I254256232542523125423','1','*'),
('3930','icon-align-right icon-align-justify','icon-align-right icon-align-justify','0','1','2','I2542562325425231','1','*'),
('3929','icon-align-right','icon-align-right','0','0','1','I25425623','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3928','icon-align-left icon-align-center icon-align-right','icon-align-left icon-align-center icon-align-right','0','1','2','I2542541325425253625425623','1','*'),
('3927','icon-align-left icon-align-center','icon-align-left icon-align-center','0','1','2','I25425413254252536','1','*'),
('3926','icon-align-left','icon-align-left','0','0','1','I25425413','1','*'),
('3925','icon-align-justify icon-list icon-indent-left','icon-align-justify icon-list icon-indent-left','0','1','2','I254252312542325353413','1','*'),
('3924','icon-align-justify icon-list','icon-align-justify icon-list','0','1','1.9333','I2542523125423','1','*'),
('3923','icon-align-justify','icon-align-justify','0','0','1','I25425231','1','*'),
('3922','icon-align-center icon-align-right icon-align-justify','icon-align-center icon-align-right icon-align-justify','0','1','2','I2542525362542562325425231','1','*'),
('3921','icon-align-center icon-align-right','icon-align-center icon-align-right','0','1','2','I25425253625425623','1','*'),
('3920','icon-align-center','icon-align-center','0','0','1','I254252536','1','*'),
('3918','icon-adjust icon-tint','icon-adjust icon-tint','0','1','1.7','I2532325353','1','*'),
('3919','icon-adjust icon-tint icon-edit','icon-adjust icon-tint icon-edit','0','1','2','I2532325353253','1','*'),
('3917','icon-adjust','icon-adjust','0','0','0.7333','I25323','1','*'),
('3915','icon blocks','icon blocks','0','1','1.3667','I25142','1','*'),
('3916','icon blocks text','icon blocks text','0','1','1.5333','I25142323','1','*'),
('3914','icon','icon','0','0','0.2667','I250','1','*'),
('3913','here text goes','here text goes','0','1','1.4667','H63232','1','*'),
('3911','here icon blocks','here icon blocks','0','1','1.5333','H625142','1','*'),
('3912','here text','here text','0','1','1.3','H6323','1','*'),
('3910','here icon','here icon','0','1','1.3','H625','1','*'),
('3909','here blockquote lorem','here blockquote lorem','0','1','1.7','H61423465','1','*'),
('3907','here a lorem','here a lorem','0','1','1.4','H6465','1','*'),
('3908','here blockquote','here blockquote','0','1','1.5','H61423','1','*'),
('3906','here a','here a','0','1','1.2','H600','1','*'),
('3904','here 01','here 01','0','1','1.2333','H600','1','*'),
('3905','here 01 lorem','here 01 lorem','0','1','1.4333','H6465','1','*'),
('3903','here','here','0','0','0.2667','H600','1','*'),
('3902','headings this is','headings this is','0','1','1.5333','H35232','1','*'),
('3900','headings','headings','0','0','0.5333','H352','1','*'),
('3901','headings this','headings this','0','1','1.4333','H35232','1','*'),
('3898','heading two','heading two','0','1','1.3667','H3523','1','*'),
('3899','heading two h2','heading two h2','0','1','1.4667','H3523','1','*'),
('3896','heading three','heading three','0','1','1.4333','H35236','1','*'),
('3897','heading three h3','heading three h3','0','1','1.5333','H35236','1','*'),
('3894','heading six','heading six','0','1','1.3667','H352','1','*'),
('3895','heading six h6','heading six h6','0','1','1.4667','H352','1','*'),
('3892','heading one','heading one','0','1','1.3667','H3525','1','*'),
('3893','heading one h1','heading one h1','0','1','1.4667','H3525','1','*'),
('3891','heading four h4','heading four h4','0','1','1.5','H35216','1','*'),
('3890','heading four','heading four','0','1','1.4','H35216','1','*'),
('3888','heading five','heading five','0','1','1.4','H3521','1','*'),
('3889','heading five h5','heading five h5','0','1','1.5','H3521','1','*'),
('3887','heading','heading','0','0','0.4667','H352','1','*'),
('3886','h6 lorem ipsum','h6 lorem ipsum','0','1','1.4667','H465125','1','*'),
('3884','h6','h6','0','0','0.1333','H000','1','*'),
('3885','h6 lorem','h6 lorem','0','1','1.2667','H465','1','*'),
('3883','h5 lorem ipsum','h5 lorem ipsum','0','1','1.4667','H465125','1','*'),
('3882','h5 lorem','h5 lorem','0','1','1.2667','H465','1','*'),
('3881','h5','h5','0','0','0.1333','H000','1','*'),
('3880','h4 lorem ipsum','h4 lorem ipsum','0','1','1.4667','H465125','1','*'),
('3878','h4','h4','0','0','0.1333','H000','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3879','h4 lorem','h4 lorem','0','1','1.2667','H465','1','*'),
('3877','h3 lorem ipsum','h3 lorem ipsum','0','1','1.4667','H465125','1','*'),
('3876','h3 lorem','h3 lorem','0','1','1.2667','H465','1','*'),
('3875','h3','h3','0','0','0.1333','H000','1','*'),
('3874','h2 lorem ipsum','h2 lorem ipsum','0','1','1.4667','H465125','1','*'),
('889','in','in','0','0','0.1333','I500','3','*'),
('890','in reprehenderit','in reprehenderit','0','1','1.5333','I56165363','2','*'),
('3873','h2 lorem','h2 lorem','0','1','1.2667','H465','1','*'),
('892','incididunt','incididunt','0','0','0.6667','I52353','2','*'),
('893','incididunt ut','incididunt ut','0','1','1.4333','I52353','2','*'),
('894','incididunt ut labore','incididunt ut labore','0','1','1.6667','I52353416','2','*'),
('895','index','index','0','0','0.3333','I532','5','*'),
('3872','h2','h2','0','0','0.1333','H000','1','*'),
('3871','h1 lorem ipsum','h1 lorem ipsum','0','1','1.4667','H465125','1','*'),
('3870','h1 lorem','h1 lorem','0','1','1.2667','H465','1','*'),
('899','ipsum','ipsum','0','0','0.3333','I125','3','*'),
('900','ipsum dolor','ipsum dolor','0','1','1.3667','I125346','3','*'),
('901','ipsum dolor sit','ipsum dolor sit','0','1','1.5','I12534623','3','*'),
('3869','h1','h1','0','0','0.1333','H000','1','*'),
('3868','greg amaro consectetur','greg amaro consectetur','0','1','1.7333','G625625236','1','*'),
('3867','greg amaro','greg amaro','0','1','1.3333','G6256','1','*'),
('3866','greg','greg','0','0','0.2667','G620','1','*'),
('3865','goes here text','goes here text','0','1','1.4667','G6323','1','*'),
('3864','goes here icon','goes here icon','0','1','1.4667','G625','1','*'),
('908','irure','irure','0','0','0.3333','I600','2','*'),
('909','irure dolor','irure dolor','0','1','1.3667','I6346','2','*'),
('910','irure dolor in','irure dolor in','0','1','1.4667','I63465','2','*'),
('911','is','is','0','0','0.1333','I200','2','*'),
('3863','goes here blockquote','goes here blockquote','0','1','1.6667','G61423','1','*'),
('3862','goes here a','goes here a','0','1','1.3667','G600','1','*'),
('3861','goes here 01','goes here 01','0','1','1.4','G600','1','*'),
('3860','goes here','goes here','0','1','1.3','G600','1','*'),
('3859','goes','goes','0','0','0.2667','G000','1','*'),
('3858','glyphicon font nbsp','glyphicon font nbsp','0','1','1.6333','G41251535121','1','*'),
('3857','glyphicon font','glyphicon font','0','1','1.4667','G4125153','1','*'),
('3856','glyphicon','glyphicon','0','0','0.6','G4125','1','*'),
('3855','gessler consectetur adipisicing','gessler consectetur adipisicing','0','1','2','G462523631252','1','*'),
('925','jm-sample-data','jm-sample-data','0','0','0.9333','J525143','5','*'),
('3854','gessler consectetur','gessler consectetur','0','1','1.6333','G4625236','1','*'),
('3853','gessler','gessler','0','0','0.4667','G460','1','*'),
('3852','four h4 lorem','four h4 lorem','0','1','1.4333','F6465','1','*'),
('3851','four h4','four h4','0','1','1.2333','F600','1','*'),
('3850','four','four','0','0','0.2667','F600','1','*'),
('3849','font nbsp icon-asterisk','font nbsp icon-asterisk','0','1','1.7667','F535121252362','1','*'),
('933','labore','labore','0','0','0.4','L160','2','*'),
('934','labore et','labore et','0','1','1.3','L163','2','*'),
('935','labore et dolore','labore et dolore','0','1','1.5333','L16346','2','*'),
('3848','font nbsp','font nbsp','0','1','1.3','F535121','1','*'),
('3847','five h5 lorem','five h5 lorem','0','1','1.4333','F465','1','*'),
('938','laboris','laboris','0','0','0.4667','L162','2','*');
INSERT INTO `#__finder_terms` VALUES 
('3846','five h5','five h5','0','1','1.2333','F000','1','*'),
('3845','five','five','0','0','0.2667','F000','1','*'),
('941','lacinia','lacinia','0','0','0.4667','L250','3','*'),
('3844','few words module','few words module','0','1','1.5333','F632534','1','*'),
('3843','few words lorem','few words lorem','0','1','1.5','F632465','1','*'),
('3842','few words','few words','0','1','1.3','F632','1','*'),
('3841','few','few','0','0','0.2','F000','1','*'),
('3840','felis this is','felis this is','0','1','1.4333','F4232','1','*'),
('3839','felis this','felis this','0','1','1.3333','F4232','1','*'),
('950','lorem','lorem','0','0','0.3333','L650','3','*'),
('951','lorem ipsum','lorem ipsum','0','1','1.3667','L65125','3','*'),
('952','lorem ipsum dolor','lorem ipsum dolor','0','1','1.5667','L65125346','3','*'),
('3838','felis numered blocks','felis numered blocks','0','1','1.6667','F42563142','1','*'),
('3837','felis numered','felis numered','0','1','1.4333','F42563','1','*'),
('956','magna','magna','0','0','0.3333','M250','3','*'),
('957','magna aliqua','magna aliqua','0','1','1.4','M2542','2','*'),
('3836','erat a ante','erat a ante','0','1','1.3667','E6353','1','*'),
('3835','erat a','erat a','0','1','1.2','E630','1','*'),
('3834','email +44 7837','email +44 7837','0','1','1.4667','E540','1','*'),
('3833','email +44','email +44','0','1','1.3','E540','1','*'),
('3832','email','email','0','0','0.3333','E540','1','*'),
('3831','elit integer posuere','elit integer posuere','0','1','1.6667','E435326126','1','*'),
('965','mauris','mauris','0','0','0.4','M620','3','*'),
('3830','elit integer','elit integer','0','1','1.4','E435326','1','*'),
('3829','elit duis viverra','elit duis viverra','0','1','1.5667','E43216','1','*'),
('3828','elit duis','elit duis','0','1','1.3','E432','1','*'),
('3827','eimod tempor jimmy','eimod tempor jimmy','0','1','1.6','E5351625','1','*'),
('3826','eimod tempor greg','eimod tempor greg','0','1','1.5667','E53516262','1','*'),
('3825','eimod tempor','eimod tempor','0','1','1.4','E53516','1','*'),
('3824','eimod','eimod','0','0','0.3333','E530','1','*'),
('3823','duis viverra leo','duis viverra leo','0','1','1.5333','D2164','1','*'),
('3822','duis viverra','duis viverra','0','1','1.4','D216','1','*'),
('3821','duis tincidunt nunc','duis tincidunt nunc','0','1','1.6333','D235235352','1','*'),
('3820','duis tincidunt','duis tincidunt','0','1','1.4667','D2352353','1','*'),
('3819','doe unordered lists','doe unordered lists','0','1','1.6333','D563634232','1','*'),
('980','minim','minim','0','0','0.3333','M000','2','*'),
('981','minim veniam','minim veniam','0','1','1.4','M150','2','*'),
('982','minim veniam quis','minim veniam quis','0','1','1.5667','M152','2','*'),
('983','module','module','0','0','0.4','M340','3','*'),
('3818','doe unordered','doe unordered','0','1','1.4333','D56363','1','*'),
('3817','doe lorem ipsumdolor','doe lorem ipsumdolor','0','1','1.6667','D465125346','1','*'),
('3816','doe lorem ipsum','doe lorem ipsum','0','1','1.5','D465125','1','*'),
('3815','doe lorem','doe lorem','0','1','1.3','D465','1','*'),
('3814','doe','doe','0','0','0.2','D000','1','*'),
('3813','do eimod tempor','do eimod tempor','0','1','1.5','D53516','1','*'),
('992','morbi','morbi','0','0','0.3333','M610','2','*'),
('3812','do eimod','do eimod','0','1','1.2667','D530','1','*'),
('3811','diam vehicula morbi','diam vehicula morbi','0','1','1.6333','D5124561','1','*'),
('995','more','more','0','0','0.2667','M600','2','*'),
('3810','diam vehicula','diam vehicula','0','1','1.4333','D5124','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3809','diam','diam','0','0','0.2667','D500','1','*'),
('3808','cooks module greg','cooks module greg','0','1','1.5667','C534262','1','*'),
('3807','cooks module','cooks module','0','1','1.4','C534','1','*'),
('3806','cooks','cooks','0','0','0.3333','C000','1','*'),
('3805','convallis sit amet','convallis sit amet','0','1','1.6','C5142353','1','*'),
('3804','convallis sit','convallis sit','0','1','1.4333','C51423','1','*'),
('3803','convallis porta lacinia','convallis porta lacinia','0','1','1.7667','C5142163425','1','*'),
('1007','nec','nec','0','0','0.2','N200','3','*'),
('3802','convallis porta','convallis porta','0','1','1.5','C5142163','1','*'),
('1010','nisi','nisi','0','0','0.2667','N200','3','*'),
('1011','nisi ut','nisi ut','0','1','1.2333','N230','3','*'),
('1012','nisi ut aliquip','nisi ut aliquip','0','1','1.5','N23421','2','*'),
('1013','nisl','nisl','0','0','0.2667','N240','2','*'),
('3801','contact module peterborough','contact module peterborough','0','1','1.9','C5323534136162','1','*'),
('1016','nostrud','nostrud','0','0','0.4667','N2363','2','*'),
('1017','nostrud exercitation','nostrud exercitation','0','1','1.6667','N236326235','2','*'),
('1018','nostrud exercitation ullamco','nostrud exercitation ullamco','0','1','1.9333','N236326235452','2','*'),
('3800','contact module','contact module','0','1','1.4667','C5323534','1','*'),
('3799','contact','contact','0','0','0.4667','C5323','1','*'),
('1022','nunc','nunc','0','0','0.2667','N200','2','*'),
('3798','condimentum diam vehicula','condimentum diam vehicula','0','1','1.8333','C5353535124','1','*'),
('1025','odio','odio','0','0','0.2667','O300','2','*'),
('3797','condimentum diam','condimentum diam','0','1','1.5333','C5353535','1','*'),
('3796','colored blocks text','colored blocks text','0','1','1.6333','C463142323','1','*'),
('3795','colored blocks','colored blocks','0','1','1.4667','C463142','1','*'),
('3794','colored','colored','0','0','0.4667','C463','1','*'),
('3793','color boxes time','color boxes time','0','1','1.5333','C461235','1','*'),
('3792','color boxes','color boxes','0','1','1.3667','C4612','1','*'),
('3791','color','color','0','0','0.3333','C460','1','*'),
('3790','c lorem ipsum','c lorem ipsum','0','1','1.4333','C465125','1','*'),
('3789','c lorem','c lorem','0','1','1.2333','C465','1','*'),
('3788','c','c','0','0','0.0667','C000','1','*'),
('3787','button read more','button read more','0','1','1.5333','B356356','1','*'),
('3786','button read','button read','0','1','1.3667','B3563','1','*'),
('3785','button','button','0','0','0.4','B350','1','*'),
('1043','porta','porta','0','0','0.3333','P630','2','*'),
('3784','boxes time machine','boxes time machine','0','1','1.6','B23525','1','*'),
('3783','boxes time','boxes time','0','1','1.3333','B235','1','*'),
('1046','posuere','posuere','0','0','0.4667','P260','2','*'),
('3782','boxes','boxes','0','0','0.3333','B200','1','*'),
('1049','quis','quis','0','0','0.2667','Q000','2','*'),
('1050','quis nostrud','quis nostrud','0','1','1.4','Q52363','2','*'),
('1051','quis nostrud exercitation','quis nostrud exercitation','0','1','1.8333','Q5236326235','2','*'),
('3781','borders headings this','borders headings this','0','1','1.7','B636235232','1','*'),
('3780','borders headings','borders headings','0','1','1.5333','B6362352','1','*'),
('3779','borders','borders','0','0','0.4667','B6362','1','*'),
('3778','blocks text goes','blocks text goes','0','1','1.5333','B423232','1','*'),
('3777','blocks text','blocks text','0','1','1.3667','B42323','1','*'),
('3776','blocks 01 text','blocks 01 text','0','1','1.4667','B42323','1','*'),
('3775','blocks 01','blocks 01','0','1','1.3','B420','1','*');
INSERT INTO `#__finder_terms` VALUES 
('1060','reprehenderit','reprehenderit','0','0','0.8667','R165363','2','*'),
('3774','blocks','blocks','0','0','0.4','B420','1','*'),
('3773','blockquote lorem ipsum','blockquote lorem ipsum','0','1','1.7333','B423465125','1','*'),
('1063','sapien','sapien','0','0','0.4','S150','3','*'),
('3772','blockquote lorem','blockquote lorem','0','1','1.5333','B423465','1','*'),
('3771','blockquote','blockquote','0','0','0.6667','B423','1','*'),
('1066','sed','sed','0','0','0.2','S300','3','*'),
('1067','sed do','sed do','0','1','1.2','S300','2','*'),
('1069','sed do eiusmod','sed do eiusmod','0','1','1.4667','S3253','2','*'),
('3770','bibendum felis this','bibendum felis this','0','1','1.6333','B53514232','1','*'),
('3769','bibendum felis numered','bibendum felis numered','0','1','1.7333','B535142563','1','*'),
('3768','bibendum felis','bibendum felis','0','1','1.4667','B535142','1','*'),
('3767','b lorem ipsum','b lorem ipsum','0','1','1.4333','B465125','1','*'),
('1075','sit','sit','0','0','0.2','S300','3','*'),
('1076','sit amet','sit amet','0','1','1.2667','S353','3','*'),
('3766','b lorem','b lorem','0','1','1.2333','B465','1','*'),
('1078','sit amet consectetur','sit amet consectetur','0','1','1.6667','S35325236','3','*'),
('3765','b','b','0','0','0.0667','B000','1','*'),
('3764','ante john doe','ante john doe','0','1','1.4333','A53253','1','*'),
('3763','ante john','ante john','0','1','1.3','A5325','1','*'),
('3762','analytics lorem ipsum','analytics lorem ipsum','0','1','1.7','A5432465125','1','*'),
('1086','sodales','sodales','0','0','0.4667','S342','3','*'),
('3761','analytics lorem','analytics lorem','0','1','1.5','A5432465','1','*'),
('3760','analytics','analytics','0','0','0.6','A5432','1','*'),
('3759','amet ipsum read','amet ipsum read','0','1','1.5','A5312563','1','*'),
('3758','amet ipsum ordered','amet ipsum ordered','0','1','1.6','A531256363','1','*'),
('3757','amet ipsum duis','amet ipsum duis','0','1','1.5','A5312532','1','*'),
('3756','amet ipsum','amet ipsum','0','1','1.3333','A53125','1','*'),
('1094','super','super','0','0','0.3333','S160','5','*'),
('1095','super user','super user','0','1','1.3333','S1626','5','*'),
('1096','suscipit','suscipit','0','0','0.5333','S130','2','*'),
('3755','amet condimentum diam','amet condimentum diam','0','1','1.7','A5325353535','1','*'),
('3754','amet condimentum','amet condimentum','0','1','1.5333','A53253535','1','*'),
('3753','amaro consectetur adipisicing','amaro consectetur adipisicing','0','1','1.9667','A562523631252','1','*'),
('3751','amaro','amaro','0','0','0.3333','A560','1','*'),
('3752','amaro consectetur','amaro consectetur','0','1','1.5667','A5625236','1','*'),
('3750','aliqua worldwide service','aliqua worldwide service','0','1','1.8','A426432612','1','*'),
('3749','aliqua worldwide','aliqua worldwide','0','1','1.5333','A42643','1','*'),
('3748','aliqua time machine','aliqua time machine','0','1','1.6333','A423525','1','*'),
('1107','tellus','tellus','0','0','0.4','T420','3','*'),
('3747','aliqua time','aliqua time','0','1','1.3667','A4235','1','*'),
('3746','aliqua just few','aliqua just few','0','1','1.5','A4231','1','*'),
('1110','tempor','tempor','0','0','0.4','T516','3','*'),
('3745','aliqua just','aliqua just','0','1','1.3667','A423','1','*'),
('1113','tempor incididunt','tempor incididunt','0','1','1.5667','T51652353','2','*'),
('1114','tempor incididunt ut','tempor incididunt ut','0','1','1.6667','T51652353','2','*'),
('3744','aliqua analytics lorem','aliqua analytics lorem','0','1','1.7333','A425432465','1','*'),
('3743','aliqua analytics','aliqua analytics','0','1','1.5333','A425432','1','*'),
('3742','aenean quis sapien','aenean quis sapien','0','1','1.6','A5215','1','*'),
('3741','aenean quis','aenean quis','0','1','1.3667','A520','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3740','adipiscing elit integer','adipiscing elit integer','0','1','1.7667','A31252435326','1','*'),
('3739','adipiscing elit duis','adipiscing elit duis','0','1','1.6667','A31252432','1','*'),
('3738','a text goes','a text goes','0','1','1.3667','A3232','1','*'),
('3737','a text','a text','0','1','1.2','A323','1','*'),
('3736','a lorem ipsum','a lorem ipsum','0','1','1.4333','A465125','1','*'),
('3735','a lorem','a lorem','0','1','1.2333','A465','1','*'),
('1129','tincidunt','tincidunt','0','0','0.6','T52353','2','*'),
('3734','a ante john','a ante john','0','1','1.3667','A5325','1','*'),
('3733','a ante','a ante','0','1','1.2','A530','1','*'),
('3732','87','87','0','0','0.2','','1','*'),
('3731','7837 383 484','7837 383 484','0','1','1.4','','1','*'),
('3730','7837 383','7837 383','0','1','1.2667','','1','*'),
('1135','turpis','turpis','0','0','0.4','T612','2','*'),
('3729','7837','7837','0','0','0.4','','1','*'),
('3728','484 peterborough uk','484 peterborough uk','0','1','1.6333','P36162','1','*'),
('3727','484 peterborough','484 peterborough','0','1','1.5333','P36162','1','*'),
('3726','484 color boxes','484 color boxes','0','1','1.5','C4612','1','*'),
('3725','484 color','484 color','0','1','1.3','C460','1','*'),
('3724','484','484','0','0','0.3','','1','*'),
('1145','ullamco','ullamco','0','0','0.4667','U452','2','*'),
('1146','ullamco laboris','ullamco laboris','0','1','1.5','U4524162','2','*'),
('3723','383 484 peterborough','383 484 peterborough','0','1','1.6667','P36162','1','*'),
('3722','383 484 color','383 484 color','0','1','1.4333','C460','1','*'),
('3720','383','383','0','0','0.3','','1','*'),
('3721','383 484','383 484','0','1','1.2333','','1','*'),
('1151','user','user','0','0','0.2667','U260','5','*'),
('1152','ut','ut','0','0','0.1333','U300','3','*'),
('1153','ut aliquip','ut aliquip','0','1','1.3333','U3421','2','*'),
('1154','ut aliquip ex','ut aliquip ex','0','1','1.4333','U34212','2','*'),
('1155','ut enim','ut enim','0','1','1.2333','U350','2','*'),
('1156','ut enim ad','ut enim ad','0','1','1.3333','U353','2','*'),
('1157','ut labore','ut labore','0','1','1.3','U3416','2','*'),
('1158','ut labore et','ut labore et','0','1','1.4','U34163','2','*'),
('3719','03 lorem ipsum','03 lorem ipsum','0','1','1.4667','L65125','1','*'),
('1160','vehicula','vehicula','0','0','0.5333','V240','2','*'),
('3718','03 lorem','03 lorem','0','1','1.2667','L650','1','*'),
('3717','03','03','0','0','0.2','','1','*'),
('1163','veniam','veniam','0','0','0.4','V500','2','*'),
('1164','veniam quis','veniam quis','0','1','1.3667','V520','2','*'),
('1165','veniam quis nostrud','veniam quis nostrud','0','1','1.6333','V5252363','2','*'),
('1166','viverra','viverra','0','0','0.4667','V600','2','*'),
('3716','02 lorem ipsum','02 lorem ipsum','0','1','1.4667','L65125','1','*'),
('3715','02 lorem','02 lorem','0','1','1.2667','L650','1','*'),
('3714','02','02','0','0','0.2','','1','*'),
('3713','01 text goes','01 text goes','0','1','1.4','T232','1','*'),
('3712','01 text','01 text','0','1','1.2333','T230','1','*'),
('3711','01 lorem ipsum','01 lorem ipsum','0','1','1.4667','L65125','1','*'),
('3710','01 lorem','01 lorem','0','1','1.2667','L650','1','*'),
('3709','01','01','0','0','0.2','','1','*'),
('3708','+44 7837 383','+44 7837 383','0','1','1.4','','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3706','+44','+44','0','0','0.3','','1','*'),
('3707','+44 7837','+44 7837','0','1','1.2667','','1','*'),
('2583','pretium vitae nulla','pretium vitae nulla','0','1','1.6333','P6351354','1','*'),
('2582','pretium vitae','pretium vitae','0','1','1.4333','P63513','1','*'),
('2581','pretium sed quam','pretium sed quam','0','1','1.5333','P6352325','1','*'),
('2580','pretium sed','pretium sed','0','1','1.3667','P63523','1','*'),
('2579','pretium pellentesque lectus','pretium pellentesque lectus','0','1','1.9','P635145324232','1','*'),
('2578','pretium pellentesque','pretium pellentesque','0','1','1.6667','P63514532','1','*'),
('2577','pretium dolor non','pretium dolor non','0','1','1.5667','P6353465','1','*'),
('2576','pretium dolor','pretium dolor','0','1','1.4333','P635346','1','*'),
('2575','pretium','pretium','0','0','0.4667','P635','2','*'),
('2574','praesent vehicula libero','praesent vehicula libero','0','1','1.8','P625312416','1','*'),
('2573','praesent vehicula','praesent vehicula','0','1','1.5667','P6253124','1','*'),
('2572','praesent','praesent','0','0','0.5333','P6253','1','*'),
('2571','porttitor ullamcorper proin','porttitor ullamcorper proin','0','1','1.9','P636452616165','1','*'),
('2570','porttitor ullamcorper','porttitor ullamcorper','0','1','1.7','P636452616','1','*'),
('2569','porttitor elit sed','porttitor elit sed','0','1','1.6','P6364323','1','*'),
('2568','porttitor elit','porttitor elit','0','1','1.4667','P63643','1','*'),
('2567','porttitor commodo velit','porttitor commodo velit','0','1','1.7667','P636253143','1','*'),
('2566','porttitor commodo','porttitor commodo','0','1','1.5667','P636253','1','*'),
('2565','porttitor','porttitor','0','0','0.6','P636','1','*'),
('2564','porta vel tempus','porta vel tempus','0','1','1.5333','P63143512','1','*'),
('2563','porta vel','porta vel','0','1','1.3','P6314','1','*'),
('2562','placerat nisl ut','placerat nisl ut','0','1','1.5333','P42635243','1','*'),
('2561','placerat nisl','placerat nisl','0','1','1.4333','P4263524','1','*'),
('2560','placerat egestas vehicula','placerat egestas vehicula','0','1','1.8333','P4263232124','1','*'),
('2559','placerat egestas','placerat egestas','0','1','1.5333','P4263232','1','*'),
('2558','placerat consectetur maecenas','placerat consectetur maecenas','0','1','1.9667','P4263252365252','1','*'),
('2557','placerat consectetur consectetur','placerat consectetur consectetur','0','1','2','P42632523625236','1','*'),
('2556','placerat consectetur','placerat consectetur','0','1','1.6667','P426325236','1','*'),
('2555','placerat','placerat','0','0','0.5333','P4263','1','*'),
('2554','phasellus vulputate ac','phasellus vulputate ac','0','1','1.7333','P24214132','1','*'),
('2553','phasellus vulputate','phasellus vulputate','0','1','1.6333','P2421413','1','*'),
('2552','phasellus','phasellus','0','0','0.6','P242','2','*'),
('2551','pharetra lectus velit','pharetra lectus velit','0','1','1.7','P6364232143','1','*'),
('2550','pharetra lectus','pharetra lectus','0','1','1.5','P6364232','1','*'),
('2549','pharetra','pharetra','0','0','0.5333','P636','1','*'),
('2548','pellentesque ligula nisl','pellentesque ligula nisl','0','1','1.8','P4532424524','1','*'),
('2547','pellentesque ligula','pellentesque ligula','0','1','1.6333','P4532424','1','*'),
('2546','pellentesque lectus donec','pellentesque lectus donec','0','1','1.8333','P45324232352','1','*'),
('2545','pellentesque lectus','pellentesque lectus','0','1','1.6333','P45324232','1','*'),
('2544','pellentesque imperdiet purus','pellentesque imperdiet purus','0','1','1.9333','P45325163162','1','*'),
('2543','pellentesque imperdiet','pellentesque imperdiet','0','1','1.7333','P45325163','1','*'),
('2542','pellentesque','pellentesque','0','0','0.8','P4532','1','*'),
('2541','pariatur ut lectus','pariatur ut lectus','0','1','1.6','P63634232','1','*'),
('2540','pariatur ut','pariatur ut','0','1','1.3667','P6363','1','*'),
('2539','pariatur','pariatur','0','0','0.5333','P636','1','*'),
('2538','ornare urna consequat','ornare urna consequat','0','1','1.7','O65652523','1','*'),
('2537','ornare urna','ornare urna','0','1','1.3667','O6565','1','*'),
('2536','ornare','ornare','0','0','0.4','O656','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2535','orci tellus in','orci tellus in','0','1','1.4667','O623425','1','*'),
('2534','orci tellus','orci tellus','0','1','1.3667','O62342','1','*'),
('2533','orci porttitor ullamcorper','orci porttitor ullamcorper','0','1','1.8667','O621636452616','1','*'),
('2532','orci porttitor','orci porttitor','0','1','1.4667','O621636','1','*'),
('2531','orci','orci','0','0','0.2667','O620','2','*'),
('2530','odio sed lacinia','odio sed lacinia','0','1','1.5333','O323425','1','*'),
('2529','odio sed','odio sed','0','1','1.2667','O323','1','*'),
('2528','odio eget convallis','odio eget convallis','0','1','1.6333','O32325142','1','*'),
('2527','odio eget','odio eget','0','1','1.3','O323','1','*'),
('2526','nunc placerat egestas','nunc placerat egestas','0','1','1.7','N214263232','1','*'),
('2525','nunc placerat','nunc placerat','0','1','1.4333','N214263','1','*'),
('2524','nunc nam eu','nunc nam eu','0','1','1.3667','N250','1','*'),
('2523','nunc nam','nunc nam','0','1','1.2667','N250','1','*'),
('2522','nunc lorem ipsum','nunc lorem ipsum','0','1','1.5333','N2465125','1','*'),
('2521','nunc lorem','nunc lorem','0','1','1.3333','N2465','1','*'),
('2520','nunc ac justo','nunc ac justo','0','1','1.4333','N230','1','*'),
('2519','nunc ac','nunc ac','0','1','1.2333','N200','1','*'),
('2518','nulla vestibulum ultrices','nulla vestibulum ultrices','0','1','1.8333','N41231454362','1','*'),
('2517','nulla vestibulum','nulla vestibulum','0','1','1.5333','N4123145','1','*'),
('2516','nulla scelerisque magna','nulla scelerisque magna','0','1','1.7667','N42462525','1','*'),
('2515','nulla scelerisque','nulla scelerisque','0','1','1.5667','N42462','1','*'),
('2514','nulla porttitor commodo','nulla porttitor commodo','0','1','1.7667','N41636253','1','*'),
('2513','nulla porttitor','nulla porttitor','0','1','1.5','N41636','1','*'),
('2512','nulla pariatur ut','nulla pariatur ut','0','1','1.5667','N416363','1','*'),
('2511','nulla pariatur','nulla pariatur','0','1','1.4667','N41636','1','*'),
('2510','nulla morbi et','nulla morbi et','0','1','1.4667','N45613','1','*'),
('2509','nulla morbi','nulla morbi','0','1','1.3667','N4561','1','*'),
('2508','nulla interdum varius','nulla interdum varius','0','1','1.7','N453635162','1','*'),
('2507','nulla interdum','nulla interdum','0','1','1.4667','N453635','1','*'),
('2506','nulla facilisi sed','nulla facilisi sed','0','1','1.6','N412423','1','*'),
('2505','nulla facilisi','nulla facilisi','0','1','1.4667','N41242','1','*'),
('2504','nulla ac nulla','nulla ac nulla','0','1','1.4667','N4254','1','*'),
('2503','nulla ac malesuada','nulla ac malesuada','0','1','1.6','N425423','1','*'),
('2502','nulla ac','nulla ac','0','1','1.2667','N420','1','*'),
('2501','nulla','nulla','0','0','0.3333','N400','2','*'),
('2500','non lobortis lacus','non lobortis lacus','0','1','1.6','N4163242','1','*'),
('2499','non lobortis','non lobortis','0','1','1.4','N41632','1','*'),
('2498','non ligula malesuada','non ligula malesuada','0','1','1.6667','N4245423','1','*'),
('2497','non ligula','non ligula','0','1','1.3333','N424','1','*'),
('2496','non consectetur aliquam','non consectetur aliquam','0','1','1.7667','N25236425','1','*'),
('2495','non consectetur','non consectetur','0','1','1.5','N25236','1','*'),
('2494','non','non','0','0','0.2','N000','2','*'),
('2493','nisl ut tempor','nisl ut tempor','0','1','1.4667','N243516','1','*'),
('2492','nisl ut','nisl ut','0','1','1.2333','N243','1','*'),
('2491','nisl in vestibulum','nisl in vestibulum','0','1','1.6','N245123145','1','*'),
('2490','nisl in','nisl in','0','1','1.2333','N245','1','*'),
('2489','nisl hendrerit nec','nisl hendrerit nec','0','1','1.6','N24536352','1','*'),
('2488','nisl hendrerit','nisl hendrerit','0','1','1.4667','N245363','1','*'),
('2487','nisi aliquet ut','nisi aliquet ut','0','1','1.5','N2423','1','*'),
('2486','nisi aliquet','nisi aliquet','0','1','1.4','N2423','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2485','nisi a aliquam','nisi a aliquam','0','1','1.4667','N2425','1','*'),
('2484','nisi a','nisi a','0','1','1.2','N200','1','*'),
('2483','nibh nisi ut','nibh nisi ut','0','1','1.4','N1523','1','*'),
('2482','nibh nisi','nibh nisi','0','1','1.3','N152','1','*'),
('2481','nibh est morbi','nibh est morbi','0','1','1.4667','N123561','1','*'),
('2480','nibh est','nibh est','0','1','1.2667','N123','1','*'),
('2479','nibh augue vel','nibh augue vel','0','1','1.4667','N1214','1','*'),
('2478','nibh augue','nibh augue','0','1','1.3333','N120','1','*'),
('2477','nibh','nibh','0','0','0.2667','N100','2','*'),
('2476','neque praesent vehicula','neque praesent vehicula','0','1','1.7667','N216253124','1','*'),
('2475','neque praesent','neque praesent','0','1','1.4667','N216253','1','*'),
('2474','neque erat nam','neque erat nam','0','1','1.4667','N2635','1','*'),
('2473','neque erat','neque erat','0','1','1.3333','N263','1','*'),
('2472','neque donec eget','neque donec eget','0','1','1.5333','N23523','1','*'),
('2471','neque donec','neque donec','0','1','1.3667','N2352','1','*'),
('2470','neque','neque','0','0','0.3333','N200','1','*'),
('2469','nec ut lectus','nec ut lectus','0','1','1.4333','N234232','1','*'),
('2468','nec ut','nec ut','0','1','1.2','N230','1','*'),
('2467','nec rhoncus vivamus','nec rhoncus vivamus','0','1','1.6333','N2652152','1','*'),
('2466','nec rhoncus ut','nec rhoncus ut','0','1','1.4667','N26523','1','*'),
('2465','nec rhoncus donec','nec rhoncus donec','0','1','1.5667','N2652352','1','*'),
('2464','nec rhoncus','nec rhoncus','0','1','1.3667','N2652','1','*'),
('2463','nec facilisis sit','nec facilisis sit','0','1','1.5667','N212423','1','*'),
('2462','nec facilisis','nec facilisis','0','1','1.4333','N21242','1','*'),
('2461','nec erat at','nec erat at','0','1','1.3667','N263','1','*'),
('2460','nec erat','nec erat','0','1','1.2667','N263','1','*'),
('2459','nec duis id','nec duis id','0','1','1.3667','N2323','1','*'),
('2458','nec duis','nec duis','0','1','1.2667','N232','1','*'),
('2457','nec accumsan','nec accumsan','0','1','1.4','N2525','1','*'),
('2456','nam viverra semper','nam viverra semper','0','1','1.6','N162516','1','*'),
('2455','nam viverra','nam viverra','0','1','1.3667','N160','1','*'),
('2454','nam eu aliquam','nam eu aliquam','0','1','1.4667','N425','1','*'),
('2453','nam eu','nam eu','0','1','1.2','N000','1','*'),
('2452','nam dictum justo','nam dictum justo','0','1','1.5333','N323523','1','*'),
('2451','nam dictum','nam dictum','0','1','1.3333','N3235','1','*'),
('2450','nam','nam','0','0','0.2','N000','1','*'),
('2449','morbi vel placerat','morbi vel placerat','0','1','1.6','M61414263','1','*'),
('2448','morbi vel','morbi vel','0','1','1.3','M614','1','*'),
('2447','morbi et consectetur','morbi et consectetur','0','1','1.6667','M61325236','1','*'),
('2446','morbi et','morbi et','0','1','1.2667','M613','1','*'),
('2445','morbi augue libero','morbi augue libero','0','1','1.6','M612416','1','*'),
('2444','morbi augue','morbi augue','0','1','1.3667','M612','1','*'),
('2443','mi scelerisque scelerisque','mi scelerisque scelerisque','0','1','1.8667','M2462462','1','*'),
('2442','mi scelerisque','mi scelerisque','0','1','1.4667','M2462','1','*'),
('2441','mi lacus proin','mi lacus proin','0','1','1.4667','M42165','1','*'),
('2440','mi lacus','mi lacus','0','1','1.2667','M420','1','*'),
('2439','mi','mi','0','0','0.1333','M000','2','*'),
('2438','metus sagittis volutpat','metus sagittis volutpat','0','1','1.7667','M323214313','1','*'),
('2437','metus sagittis','metus sagittis','0','1','1.4667','M3232','1','*'),
('2436','metus mauris tincidunt','metus mauris tincidunt','0','1','1.7333','M32562352353','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2435','metus mauris','metus mauris','0','1','1.4','M32562','2','*'),
('2434','metus','metus','0','0','0.3333','M320','2','*'),
('2433','mauris tincidunt quam','mauris tincidunt quam','0','1','1.7','M6235235325','1','*'),
('2432','mauris tincidunt','mauris tincidunt','0','1','1.5333','M62352353','1','*'),
('2431','mattis eu pellentesque','mattis eu pellentesque','0','1','1.7333','M3214532','1','*'),
('2430','mattis eu nulla','mattis eu nulla','0','1','1.5','M3254','1','*'),
('2429','mattis eu','mattis eu','0','1','1.3','M320','1','*'),
('2428','mattis','mattis','0','0','0.4','M320','1','*'),
('2427','massa quisque vestibulum','massa quisque vestibulum','0','1','1.8','M2123145','1','*'),
('2426','massa quisque','massa quisque','0','1','1.4333','M200','1','*'),
('2425','massa nulla interdum','massa nulla interdum','0','1','1.6667','M25453635','1','*'),
('2424','massa nulla','massa nulla','0','1','1.3667','M254','1','*'),
('2423','massa eu feugiat','massa eu feugiat','0','1','1.5333','M2123','1','*'),
('2422','massa eu','massa eu','0','1','1.2667','M200','1','*'),
('2421','massa','massa','0','0','0.3333','M200','1','*'),
('2420','malesuada ultricies neque','malesuada ultricies neque','0','1','1.8333','M423436252','1','*'),
('2419','malesuada ultricies','malesuada ultricies','0','1','1.6333','M4234362','1','*'),
('2418','malesuada imperdiet sed','malesuada imperdiet sed','0','1','1.7667','M423516323','1','*'),
('2417','malesuada imperdiet','malesuada imperdiet','0','1','1.6333','M4235163','1','*'),
('2416','malesuada','malesuada','0','0','0.6','M423','1','*'),
('2415','magna et orci','magna et orci','0','1','1.4333','M25362','1','*'),
('2414','magna et','magna et','0','1','1.2667','M253','1','*'),
('2413','magna cursus adipiscing','magna cursus adipiscing','0','1','1.7667','M2526231252','1','*'),
('2412','magna cursus','magna cursus','0','1','1.4','M25262','1','*'),
('2411','magna aliqua ut','magna aliqua ut','0','1','1.5','M25423','1','*'),
('2410','maecenas laoreet ligula','maecenas laoreet ligula','0','1','1.7667','M252463424','1','*'),
('2409','maecenas laoreet','maecenas laoreet','0','1','1.5333','M252463','1','*'),
('2408','maecenas','maecenas','0','0','0.5333','M252','2','*'),
('2407','luctus odio eget','luctus odio eget','0','1','1.5333','L232323','1','*'),
('2406','luctus odio','luctus odio','0','1','1.3667','L2323','1','*'),
('2405','luctus eros nulla','luctus eros nulla','0','1','1.5667','L2326254','1','*'),
('2404','luctus eros','luctus eros','0','1','1.3667','L23262','1','*'),
('2403','luctus','luctus','0','0','0.4','L232','2','*'),
('2402','lorem urna luctus','lorem urna luctus','0','1','1.5667','L65654232','1','*'),
('2401','lorem urna','lorem urna','0','1','1.3333','L6565','1','*'),
('2400','lorem dictum tincidunt','lorem dictum tincidunt','0','1','1.7333','L653235352353','1','*'),
('2399','lorem dictum','lorem dictum','0','1','1.4','L653235','1','*'),
('2398','lobortis lacus condimentum','lobortis lacus condimentum','0','1','1.8667','L16324253535','1','*'),
('2397','lobortis lacus','lobortis lacus','0','1','1.4667','L163242','1','*'),
('2396','lobortis','lobortis','0','0','0.5333','L1632','1','*'),
('2395','ligula vel scelerisque','ligula vel scelerisque','0','1','1.7333','L24142462','1','*'),
('2394','ligula vel','ligula vel','0','1','1.3333','L2414','1','*'),
('2393','ligula phasellus vulputate','ligula phasellus vulputate','0','1','1.8667','L2412421413','1','*'),
('2392','ligula phasellus','ligula phasellus','0','1','1.5333','L241242','1','*'),
('2391','ligula nisl hendrerit','ligula nisl hendrerit','0','1','1.7','L245245363','1','*'),
('2390','ligula nisl','ligula nisl','0','1','1.3667','L24524','1','*'),
('2389','ligula malesuada imperdiet','ligula malesuada imperdiet','0','1','1.8667','L2454235163','1','*'),
('2388','ligula malesuada','ligula malesuada','0','1','1.5333','L245423','1','*'),
('2387','ligula hendrerit auctor','ligula hendrerit auctor','0','1','1.7667','L245363236','1','*'),
('2386','ligula hendrerit','ligula hendrerit','0','1','1.5333','L245363','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2385','ligula','ligula','0','0','0.4','L240','2','*'),
('2384','libero pretium vitae','libero pretium vitae','0','1','1.6667','L16163513','1','*'),
('2383','libero pretium','libero pretium','0','1','1.4667','L161635','1','*'),
('2382','libero id varius','libero id varius','0','1','1.5333','L163162','1','*'),
('2381','libero id','libero id','0','1','1.3','L163','1','*'),
('2380','libero ac tellus','libero ac tellus','0','1','1.5333','L162342','1','*'),
('2379','libero ac','libero ac','0','1','1.3','L162','1','*'),
('2378','libero a luctus','libero a luctus','0','1','1.5','L164232','1','*'),
('2377','libero a','libero a','0','1','1.2667','L160','1','*'),
('2376','libero','libero','0','0','0.4','L160','2','*'),
('2375','lectus velit scelerisque','lectus velit scelerisque','0','1','1.8','L2321432462','1','*'),
('2374','lectus velit','lectus velit','0','1','1.4','L232143','1','*'),
('2373','lectus in laoreet','lectus in laoreet','0','1','1.5667','L2325463','1','*'),
('2372','lectus in','lectus in','0','1','1.3','L2325','1','*'),
('2371','lectus felis facilisis','lectus felis facilisis','0','1','1.7333','L2321421242','1','*'),
('2370','lectus felis','lectus felis','0','1','1.4','L232142','1','*'),
('2369','lectus donec sit','lectus donec sit','0','1','1.5333','L2323523','1','*'),
('2368','lectus donec','lectus donec','0','1','1.4','L232352','1','*'),
('2367','lectus','lectus','0','0','0.4','L232','2','*'),
('2366','laoreet tempor felis','laoreet tempor felis','0','1','1.6667','L63516142','1','*'),
('2365','laoreet tempor','laoreet tempor','0','1','1.4667','L63516','1','*'),
('2364','laoreet ligula vel','laoreet ligula vel','0','1','1.6','L6342414','1','*'),
('2363','laoreet ligula','laoreet ligula','0','1','1.4667','L63424','1','*'),
('2362','laoreet','laoreet','0','0','0.4667','L630','1','*'),
('2361','lacus proin fermentum','lacus proin fermentum','0','1','1.7','L216516535','1','*'),
('2360','lacus proin','lacus proin','0','1','1.3667','L2165','1','*'),
('2359','lacus condimentum duis','lacus condimentum duis','0','1','1.7333','L25353532','1','*'),
('2358','lacus condimentum','lacus condimentum','0','1','1.5667','L253535','1','*'),
('2357','lacus','lacus','0','0','0.3333','L200','2','*'),
('2356','lacinia purus sit','lacinia purus sit','0','1','1.5667','L251623','1','*'),
('2355','lacinia purus','lacinia purus','0','1','1.4333','L25162','1','*'),
('2354','laboris sit amet','laboris sit amet','0','1','1.5333','L162353','1','*'),
('2353','laboris sit','laboris sit','0','1','1.3667','L1623','1','*'),
('2352','justo vel sagittis','justo vel sagittis','0','1','1.6','J314232','1','*'),
('2351','justo vel','justo vel','0','1','1.3','J314','1','*'),
('2350','justo sit amet','justo sit amet','0','1','1.4667','J32353','1','*'),
('2349','justo sit','justo sit','0','1','1.3','J323','1','*'),
('2348','justo morbi vel','justo morbi vel','0','1','1.5','J35614','1','*'),
('2347','justo morbi','justo morbi','0','1','1.3667','J3561','1','*'),
('2346','justo hendrerit non','justo hendrerit non','0','1','1.6333','J353635','1','*'),
('2345','justo hendrerit','justo hendrerit','0','1','1.5','J35363','1','*'),
('2344','justo','justo','0','0','0.3333','J300','1','*'),
('2343','jmmail cras eleifend','jmmail cras eleifend','0','1','1.6667','J542624153','1','*'),
('2342','jmmail cras','jmmail cras','0','1','1.3667','J54262','1','*'),
('2341','jmmail','jmmail','0','0','0.4','J540','1','*'),
('2340','ipsum dolor nunc','ipsum dolor nunc','0','1','1.5333','I12534652','1','*'),
('2339','interdum varius arcu','interdum varius arcu','0','1','1.6667','I5363516262','1','*'),
('2338','interdum varius','interdum varius','0','1','1.5','I53635162','1','*'),
('2337','interdum','interdum','0','0','0.5333','I53635','1','*'),
('2336','in volutpat tellus','in volutpat tellus','0','1','1.6','I51431342','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2335','in volutpat','in volutpat','0','1','1.3667','I514313','1','*'),
('2334','in voluptate velit','in voluptate velit','0','1','1.6','I51413143','1','*'),
('2333','in voluptate','in voluptate','0','1','1.4','I51413','1','*'),
('2332','in vestibulum ut','in vestibulum ut','0','1','1.5333','I51231453','1','*'),
('2331','in vestibulum','in vestibulum','0','1','1.4333','I5123145','1','*'),
('2330','in tristique urna','in tristique urna','0','1','1.5667','I53623265','1','*'),
('2329','in tristique','in tristique','0','1','1.4','I536232','1','*'),
('2328','in reprehenderit in','in reprehenderit in','0','1','1.6333','I561653635','1','*'),
('2327','in ornare urna','in ornare urna','0','1','1.4667','I56565','1','*'),
('2326','in ornare','in ornare','0','1','1.3','I5656','1','*'),
('2325','in laoreet tempor','in laoreet tempor','0','1','1.5667','I5463516','1','*'),
('2324','in laoreet','in laoreet','0','1','1.3333','I5463','1','*'),
('2323','imperdiet sed sapien','imperdiet sed sapien','0','1','1.6667','I516323215','1','*'),
('2322','imperdiet sed','imperdiet sed','0','1','1.4333','I516323','1','*'),
('2321','imperdiet purus vel','imperdiet purus vel','0','1','1.6333','I516316214','1','*'),
('2320','imperdiet purus','imperdiet purus','0','1','1.5','I5163162','1','*'),
('2319','imperdiet orci tellus','imperdiet orci tellus','0','1','1.7','I516362342','1','*'),
('2318','imperdiet orci','imperdiet orci','0','1','1.4667','I516362','1','*'),
('2317','imperdiet','imperdiet','0','0','0.6','I5163','1','*'),
('2316','id varius massa','id varius massa','0','1','1.5','I316252','1','*'),
('2315','id varius','id varius','0','1','1.3','I3162','1','*'),
('2314','id erat nunc','id erat nunc','0','1','1.4','I36352','1','*'),
('2313','id erat','id erat','0','1','1.2333','I363','1','*'),
('2312','id','id','0','0','0.1333','I300','1','*'),
('2311','iaculis purus sed','iaculis purus sed','0','1','1.5667','I2421623','1','*'),
('2310','iaculis purus','iaculis purus','0','1','1.4333','I242162','1','*'),
('2309','iaculis','iaculis','0','0','0.4667','I242','2','*'),
('2308','hendrerit nulla facilisi','hendrerit nulla facilisi','0','1','1.8','H5363541242','1','*'),
('2307','hendrerit nulla','hendrerit nulla','0','1','1.5','H536354','1','*'),
('2306','hendrerit non lobortis','hendrerit non lobortis','0','1','1.7333','H5363541632','1','*'),
('2305','hendrerit non','hendrerit non','0','1','1.4333','H53635','1','*'),
('2304','hendrerit nisi aliquet','hendrerit nisi aliquet','0','1','1.7333','H536352423','1','*'),
('2303','hendrerit nisi','hendrerit nisi','0','1','1.4667','H536352','1','*'),
('2302','hendrerit nec facilisis','hendrerit nec facilisis','0','1','1.7667','H5363521242','1','*'),
('2301','hendrerit nec','hendrerit nec','0','1','1.4333','H536352','1','*'),
('2300','hendrerit auctor justo','hendrerit auctor justo','0','1','1.7333','H536323623','1','*'),
('2299','hendrerit auctor','hendrerit auctor','0','1','1.5333','H5363236','1','*'),
('2298','hendrerit','hendrerit','0','0','0.6','H5363','1','*'),
('2297','gravida arcu aliquam','gravida arcu aliquam','0','1','1.6667','G61362425','1','*'),
('2296','gravida arcu','gravida arcu','0','1','1.4','G61362','1','*'),
('2295','gravida','gravida','0','0','0.4667','G613','1','*'),
('2294','fusce eu risus','fusce eu risus','0','1','1.4667','F262','1','*'),
('2293','fusce eu','fusce eu','0','1','1.2667','F200','1','*'),
('2292','fusce','fusce','0','0','0.3333','F200','1','*'),
('2291','fugiat nulla pariatur','fugiat nulla pariatur','0','1','1.7','F23541636','1','*'),
('2290','fugiat nulla','fugiat nulla','0','1','1.4','F2354','1','*'),
('2289','fugiat','fugiat','0','0','0.4','F230','1','*'),
('2288','fringilla purus sed','fringilla purus sed','0','1','1.6333','F65241623','1','*'),
('2287','fringilla purus','fringilla purus','0','1','1.5','F6524162','1','*'),
('2286','fringilla','fringilla','0','0','0.6','F6524','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2285','font awesome example','font awesome example','0','1','1.6667','F53252514','1','*'),
('2284','font awesome','font awesome','0','1','1.4','F5325','1','*'),
('2283','feugiat pharetra lectus','feugiat pharetra lectus','0','1','1.7667','F2316364232','1','*'),
('2282','feugiat pharetra','feugiat pharetra','0','1','1.5333','F231636','1','*'),
('2281','feugiat nunc ac','feugiat nunc ac','0','1','1.5','F2352','1','*'),
('2280','feugiat nunc','feugiat nunc','0','1','1.4','F2352','1','*'),
('2279','feugiat 1 nulla','feugiat 1 nulla','0','1','1.5','F2354','1','*'),
('2278','feugiat 1','feugiat 1','0','1','1.3','F230','1','*'),
('2277','feugiat','feugiat','0','0','0.4667','F230','1','*'),
('2276','fermentum velit non','fermentum velit non','0','1','1.6333','F65351435','1','*'),
('2275','fermentum velit','fermentum velit','0','1','1.5','F6535143','1','*'),
('2274','fermentum','fermentum','0','0','0.6','F6535','1','*'),
('2273','felis sit amet','felis sit amet','0','1','1.4667','F42353','1','*'),
('2272','felis sit','felis sit','0','1','1.3','F423','1','*'),
('2271','felis nulla interdum','felis nulla interdum','0','1','1.6667','F425453635','1','*'),
('2270','felis nulla','felis nulla','0','1','1.3667','F4254','1','*'),
('2269','felis in ornare','felis in ornare','0','1','1.5','F425656','1','*'),
('2268','felis in','felis in','0','1','1.2667','F425','1','*'),
('2267','felis facilisis nec','felis facilisis nec','0','1','1.6333','F42124252','1','*'),
('2266','felis facilisis','felis facilisis','0','1','1.5','F421242','1','*'),
('2265','faucibus ac nulla','faucibus ac nulla','0','1','1.5667','F21254','1','*'),
('2264','faucibus ac','faucibus ac','0','1','1.3667','F212','1','*'),
('2263','faucibus','faucibus','0','0','0.5333','F212','2','*'),
('2262','facilisis sit amet','facilisis sit amet','0','1','1.6','F242353','1','*'),
('2261','facilisis sit','facilisis sit','0','1','1.4333','F2423','1','*'),
('2260','facilisis nec erat','facilisis nec erat','0','1','1.6','F2425263','1','*'),
('2259','facilisis nec','facilisis nec','0','1','1.4333','F24252','1','*'),
('2258','facilisis','facilisis','0','0','0.6','F242','1','*'),
('2257','facilisi sed congue','facilisi sed congue','0','1','1.6333','F2423252','1','*'),
('2256','facilisi sed','facilisi sed','0','1','1.4','F2423','1','*'),
('2255','facilisi','facilisi','0','0','0.5333','F242','1','*'),
('2254','example','example','0','0','0.4667','E2514','1','*'),
('2253','euismod rhoncus ut','euismod rhoncus ut','0','1','1.6','E2536523','1','*'),
('2252','euismod rhoncus 2','euismod rhoncus 2','0','1','1.5667','E253652','1','*'),
('2251','euismod rhoncus','euismod rhoncus','0','1','1.5','E253652','1','*'),
('2250','euismod pretium dolor','euismod pretium dolor','0','1','1.7','E2531635346','1','*'),
('2249','euismod pretium','euismod pretium','0','1','1.5','E2531635','1','*'),
('2248','euismod','euismod','0','0','0.4667','E253','1','*'),
('2247','eu sodales tortor','eu sodales tortor','0','1','1.5667','E23423636','1','*'),
('2246','eu sodales','eu sodales','0','1','1.3333','E2342','1','*'),
('2245','eu risus sit','eu risus sit','0','1','1.4','E623','1','*'),
('2244','eu risus','eu risus','0','1','1.2667','E620','1','*'),
('2243','eu quam vitae','eu quam vitae','0','1','1.4333','E2513','1','*'),
('2242','eu quam','eu quam','0','1','1.2333','E250','1','*'),
('2241','eu pulvinar sagittis','eu pulvinar sagittis','0','1','1.6667','E14156232','1','*'),
('2240','eu pulvinar','eu pulvinar','0','1','1.3667','E14156','1','*'),
('2239','eu pellentesque ligula','eu pellentesque ligula','0','1','1.7333','E14532424','1','*'),
('2238','eu pellentesque','eu pellentesque','0','1','1.5','E14532','1','*'),
('2237','eu nulla vestibulum','eu nulla vestibulum','0','1','1.6333','E54123145','1','*'),
('2236','eu nulla','eu nulla','0','1','1.2667','E540','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2235','eu fugiat nulla','eu fugiat nulla','0','1','1.5','E12354','1','*'),
('2234','eu fugiat','eu fugiat','0','1','1.3','E123','1','*'),
('2233','eu feugiat 1','eu feugiat 1','0','1','1.4','E123','1','*'),
('2232','eu feugiat','eu feugiat','0','1','1.3333','E123','1','*'),
('2231','eu consectetur libero','eu consectetur libero','0','1','1.7','E25236416','1','*'),
('2230','eu consectetur','eu consectetur','0','1','1.4667','E25236','1','*'),
('2229','eu aliquam velit','eu aliquam velit','0','1','1.5333','E425143','1','*'),
('2228','eu aliquam','eu aliquam','0','1','1.3333','E425','1','*'),
('2227','eu','eu','0','0','0.1333','E000','2','*'),
('2225','etiam quis','etiam quis','0','1','1.3333','E352','1','*'),
('2226','etiam quis mi','etiam quis mi','0','1','1.4333','E3525','1','*'),
('2224','etiam eu sodales','etiam eu sodales','0','1','1.5333','E352342','1','*'),
('2223','etiam eu','etiam eu','0','1','1.2667','E350','1','*'),
('2222','etiam','etiam','0','0','0.3333','E350','2','*'),
('2221','et pulvinar varius','et pulvinar varius','0','1','1.6','E314156162','1','*'),
('2220','et pulvinar','et pulvinar','0','1','1.3667','E314156','1','*'),
('2219','et orci porttitor','et orci porttitor','0','1','1.5667','E3621636','1','*'),
('2218','et orci','et orci','0','1','1.2333','E362','1','*'),
('2217','et ligula hendrerit','et ligula hendrerit','0','1','1.6333','E34245363','1','*'),
('2216','et ligula','et ligula','0','1','1.3','E3424','1','*'),
('2215','et hendrerit nisi','et hendrerit nisi','0','1','1.5667','E3536352','1','*'),
('2214','et hendrerit','et hendrerit','0','1','1.4','E35363','1','*'),
('2213','et consectetur ante','et consectetur ante','0','1','1.6333','E32523653','1','*'),
('2212','et consectetur','et consectetur','0','1','1.4667','E325236','1','*'),
('2211','est morbi augue','est morbi augue','0','1','1.5','E235612','1','*'),
('2210','est morbi','est morbi','0','1','1.3','E23561','1','*'),
('2209','est','est','0','0','0.2','E230','2','*'),
('2208','esse cillum dolore','esse cillum dolore','0','1','1.6','E245346','1','*'),
('2207','esse cillum','esse cillum','0','1','1.3667','E245','1','*'),
('2206','esse','esse','0','0','0.2667','E200','1','*'),
('2205','eros nulla porttitor','eros nulla porttitor','0','1','1.6667','E62541636','1','*'),
('2203','eros','eros','0','0','0.2667','E620','2','*'),
('2204','eros nulla','eros nulla','0','1','1.3333','E6254','1','*'),
('2202','erat volutpat cras','erat volutpat cras','0','1','1.6','E6314313262','1','*'),
('2201','erat volutpat','erat volutpat','0','1','1.4333','E6314313','1','*'),
('2200','erat quis justo','erat quis justo','0','1','1.5','E6323','1','*'),
('2199','erat quis','erat quis','0','1','1.3','E632','1','*'),
('2198','erat nunc nam','erat nunc nam','0','1','1.4333','E63525','1','*'),
('2197','erat nunc lorem','erat nunc lorem','0','1','1.5','E6352465','1','*'),
('2196','erat nunc','erat nunc','0','1','1.3','E6352','1','*'),
('2195','erat nam dictum','erat nam dictum','0','1','1.5','E6353235','1','*'),
('2194','erat nam','erat nam','0','1','1.2667','E635','1','*'),
('2193','erat at pretium','erat at pretium','0','1','1.5','E631635','1','*'),
('2192','erat at','erat at','0','1','1.2333','E630','1','*'),
('2191','enim porta vel','enim porta vel','0','1','1.4667','E516314','1','*'),
('2190','enim porta','enim porta','0','1','1.3333','E5163','1','*'),
('2189','enim ligula phasellus','enim ligula phasellus','0','1','1.7','E54241242','1','*'),
('2188','enim ligula','enim ligula','0','1','1.3667','E5424','1','*'),
('2187','elit sed fringilla','elit sed fringilla','0','1','1.6','E432316524','1','*'),
('2186','elit nulla scelerisque','elit nulla scelerisque','0','1','1.7333','E43542462','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2185','elit nulla','elit nulla','0','1','1.3333','E4354','1','*'),
('2184','elit cras eleifend','elit cras eleifend','0','1','1.6','E432624153','1','*'),
('2183','elit cras','elit cras','0','1','1.3','E43262','1','*'),
('2182','eleifend iaculis purus','eleifend iaculis purus','0','1','1.7333','E4153242162','1','*'),
('2181','eleifend iaculis','eleifend iaculis','0','1','1.5333','E4153242','1','*'),
('2180','eleifend','eleifend','0','0','0.5333','E4153','1','*'),
('2179','eget neque erat','eget neque erat','0','1','1.5','E235263','1','*'),
('2178','eget neque','eget neque','0','1','1.3333','E2352','1','*'),
('2177','eget convallis urna','eget convallis urna','0','1','1.6333','E232514265','1','*'),
('2176','eget convallis quisque','eget convallis quisque','0','1','1.7333','E2325142','1','*'),
('2175','eget convallis','eget convallis','0','1','1.4667','E2325142','1','*'),
('2174','eget','eget','0','0','0.2667','E230','2','*'),
('2173','egestas vehicula fusce','egestas vehicula fusce','0','1','1.7333','E23212412','1','*'),
('2172','egestas vehicula','egestas vehicula','0','1','1.5333','E232124','1','*'),
('2171','egestas','egestas','0','0','0.4667','E232','1','*'),
('2170','duis id erat','duis id erat','0','1','1.4','D2363','1','*'),
('2169','duis id','duis id','0','1','1.2333','D230','1','*'),
('2168','dui aliquet dapibus','dui aliquet dapibus','0','1','1.6333','D42312','1','*'),
('2167','dui aliquet','dui aliquet','0','1','1.3667','D423','1','*'),
('2166','dui','dui','0','0','0.2','D000','1','*'),
('2165','donec vel enim','donec vel enim','0','1','1.4667','D52145','1','*'),
('2164','donec vel','donec vel','0','1','1.3','D5214','1','*'),
('2163','donec sit amet','donec sit amet','0','1','1.4667','D52353','1','*'),
('2162','donec sit','donec sit','0','1','1.3','D523','1','*'),
('2161','donec pretium sed','donec pretium sed','0','1','1.5667','D52163523','1','*'),
('2160','donec pretium','donec pretium','0','1','1.4333','D521635','1','*'),
('2159','donec eget neque','donec eget neque','0','1','1.5333','D52352','1','*'),
('2158','donec eget','donec eget','0','1','1.3333','D523','1','*'),
('2157','donec','donec','0','0','0.3333','D520','1','*'),
('2156','dolore eu fugiat','dolore eu fugiat','0','1','1.5333','D46123','1','*'),
('2155','dolore eu','dolore eu','0','1','1.3','D460','1','*'),
('2154','dolor nunc placerat','dolor nunc placerat','0','1','1.6333','D465214263','1','*'),
('2153','dolor nunc','dolor nunc','0','1','1.3333','D4652','1','*'),
('2152','dolor non consectetur','dolor non consectetur','0','1','1.7','D46525236','1','*'),
('2151','dolor non','dolor non','0','1','1.3','D465','1','*'),
('2150','dictum tincidunt font','dictum tincidunt font','0','1','1.7','D235352353153','1','*'),
('2149','dictum tincidunt','dictum tincidunt','0','1','1.5333','D235352353','1','*'),
('2148','dictum justo sit','dictum justo sit','0','1','1.5333','D2352323','1','*'),
('2147','dictum justo','dictum justo','0','1','1.4','D23523','1','*'),
('2146','dictum','dictum','0','0','0.4','D235','2','*'),
('2145','dapibus suspendisse ut','dapibus suspendisse ut','0','1','1.7333','D1215323','1','*'),
('2144','dapibus suspendisse et','dapibus suspendisse et','0','1','1.7333','D1215323','1','*'),
('2143','dapibus suspendisse','dapibus suspendisse','0','1','1.6333','D121532','1','*'),
('2142','dapibus lectus in','dapibus lectus in','0','1','1.5667','D1242325','1','*'),
('2141','dapibus lectus','dapibus lectus','0','1','1.4667','D124232','1','*'),
('2140','dapibus','dapibus','0','0','0.4667','D120','2','*'),
('2139','cursus adipiscing etiam','cursus adipiscing etiam','0','1','1.7667','C623125235','1','*'),
('2138','cursus adipiscing','cursus adipiscing','0','1','1.5667','C6231252','1','*'),
('2137','cursus','cursus','0','0','0.4','C620','2','*'),
('2136','cras eu quam','cras eu quam','0','1','1.4','C625','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2135','cras eu','cras eu','0','1','1.2333','C620','1','*'),
('2134','cras eleifend iaculis','cras eleifend iaculis','0','1','1.7','C624153242','1','*'),
('2133','cras eleifend','cras eleifend','0','1','1.4333','C624153','1','*'),
('2132','cras','cras','0','0','0.2667','C620','1','*'),
('2131','convallis urna erat','convallis urna erat','0','1','1.6333','C51426563','1','*'),
('2130','convallis urna','convallis urna','0','1','1.4667','C514265','1','*'),
('2129','convallis quisque vestibulum','convallis quisque vestibulum','0','1','1.9333','C5142123145','1','*'),
('2128','convallis quisque','convallis quisque','0','1','1.5667','C5142','1','*'),
('2127','consequat sit amet','consequat sit amet','0','1','1.6','C5232353','1','*'),
('2126','consequat sit','consequat sit','0','1','1.4333','C52323','1','*'),
('2125','consequat nam viverra','consequat nam viverra','0','1','1.7','C523516','1','*'),
('2124','consequat nam','consequat nam','0','1','1.4333','C5235','1','*'),
('2123','consectetur maecenas laoreet','consectetur maecenas laoreet','0','1','1.9333','C52365252463','1','*'),
('2122','consectetur maecenas','consectetur maecenas','0','1','1.6667','C52365252','1','*'),
('2121','consectetur libero id','consectetur libero id','0','1','1.7','C52364163','1','*'),
('2120','consectetur libero','consectetur libero','0','1','1.6','C5236416','1','*'),
('2119','consectetur consectetur adipiscing','consectetur consectetur adipiscing','0','1','2','C52362523631252','1','*'),
('2118','consectetur consectetur','consectetur consectetur','0','1','1.7667','C523625236','1','*'),
('2117','consectetur ante etiam','consectetur ante etiam','0','1','1.7333','C5236535','1','*'),
('2116','consectetur ante','consectetur ante','0','1','1.5333','C523653','1','*'),
('2115','consectetur aliquam feugiat','consectetur aliquam feugiat','0','1','1.9','C5236425123','1','*'),
('2114','consectetur aliquam','consectetur aliquam','0','1','1.6333','C5236425','1','*'),
('2113','congue semper consequat','congue semper consequat','0','1','1.7667','C525162523','1','*'),
('2112','congue semper','congue semper','0','1','1.4333','C52516','1','*'),
('2111','congue','congue','0','0','0.4','C520','2','*'),
('2110','condimentum duis id','condimentum duis id','0','1','1.6333','C53535323','1','*'),
('2109','condimentum duis','condimentum duis','0','1','1.5333','C5353532','1','*'),
('2108','commodo velit nec','commodo velit nec','0','1','1.5667','C5314352','1','*'),
('2107','commodo velit','commodo velit','0','1','1.4333','C53143','1','*'),
('2106','class jmmail cras','class jmmail cras','0','1','1.5667','C4254262','1','*'),
('2105','class jmmail','class jmmail','0','1','1.4','C4254','1','*'),
('2104','cillum dolore eu','cillum dolore eu','0','1','1.5333','C45346','1','*'),
('2103','cillum dolore','cillum dolore','0','1','1.4333','C45346','1','*'),
('2102','cillum','cillum','0','0','0.4','C450','1','*'),
('2101','blandit tellus risus','blandit tellus risus','0','1','1.6667','B4534262','1','*'),
('2100','blandit tellus','blandit tellus','0','1','1.4667','B45342','1','*'),
('2099','blandit','blandit','0','0','0.4667','B453','1','*'),
('2098','awesome example','awesome example','0','1','1.5','A252514','1','*'),
('2097','awesome','awesome','0','0','0.4667','A250','1','*'),
('2096','augue vel urna','augue vel urna','0','1','1.4667','A21465','1','*'),
('2095','augue vel','augue vel','0','1','1.3','A214','1','*'),
('2094','augue libero pretium','augue libero pretium','0','1','1.6667','A24161635','1','*'),
('2093','augue libero','augue libero','0','1','1.4','A2416','1','*'),
('2092','augue','augue','0','0','0.3333','A200','2','*'),
('2091','auctor justo vel','auctor justo vel','0','1','1.5333','A2362314','1','*'),
('2090','auctor justo','auctor justo','0','1','1.4','A23623','1','*'),
('2089','auctor','auctor','0','0','0.4','A236','2','*'),
('2088','at pretium pellentesque','at pretium pellentesque','0','1','1.7667','A3163514532','1','*'),
('2087','at pretium','at pretium','0','1','1.3333','A31635','1','*'),
('2086','at','at','0','0','0.1333','A300','2','*');
INSERT INTO `#__finder_terms` VALUES 
('2085','arcu nec ut','arcu nec ut','0','1','1.3667','A62523','1','*'),
('2084','arcu nec duis','arcu nec duis','0','1','1.4333','A625232','1','*'),
('2083','arcu nec accumsan','arcu nec accumsan','0','1','1.5667','A6252525','1','*'),
('2082','arcu nec','arcu nec','0','1','1.2667','A6252','1','*'),
('2081','arcu aliquam erat','arcu aliquam erat','0','1','1.5667','A6242563','1','*'),
('2080','arcu aliquam','arcu aliquam','0','1','1.4','A62425','1','*'),
('2079','arcu','arcu','0','0','0.2667','A620','1','*'),
('2078','ante etiam eu','ante etiam eu','0','1','1.4333','A535','1','*'),
('2077','ante etiam','ante etiam','0','1','1.3333','A535','1','*'),
('2076','amet praesent vehicula','amet praesent vehicula','0','1','1.7333','A5316253124','1','*'),
('2075','amet praesent','amet praesent','0','1','1.4333','A5316253','1','*'),
('2074','amet placerat consectetur','amet placerat consectetur','0','1','1.8333','A531426325236','1','*'),
('2073','amet placerat','amet placerat','0','1','1.4333','A5314263','1','*'),
('2072','amet nibh nisi','amet nibh nisi','0','1','1.4667','A535152','1','*'),
('2071','amet nibh est','amet nibh est','0','1','1.4333','A535123','1','*'),
('2070','amet nibh','amet nibh','0','1','1.3','A5351','1','*'),
('2069','amet metus sagittis','amet metus sagittis','0','1','1.6333','A5353232','1','*'),
('2068','amet metus','amet metus','0','1','1.3333','A53532','1','*'),
('2067','amet lorem dictum','amet lorem dictum','0','1','1.5667','A534653235','1','*'),
('2066','amet lorem','amet lorem','0','1','1.3333','A53465','1','*'),
('2065','amet faucibus ac','amet faucibus ac','0','1','1.5333','A531212','1','*'),
('2064','amet faucibus','amet faucibus','0','1','1.4333','A531212','1','*'),
('2063','amet dapibus suspendisse','amet dapibus suspendisse','0','1','1.8','A53121532','1','*'),
('2062','amet dapibus','amet dapibus','0','1','1.4','A5312','1','*'),
('2061','aliquet ut ut','aliquet ut ut','0','1','1.4333','A423','1','*'),
('2060','aliquet ut','aliquet ut','0','1','1.3333','A423','1','*'),
('2059','aliquet dapibus suspendisse','aliquet dapibus suspendisse','0','1','1.9','A423121532','1','*'),
('2058','aliquet dapibus','aliquet dapibus','0','1','1.5','A42312','1','*'),
('2057','aliquet','aliquet','0','0','0.4667','A423','2','*'),
('2056','aliquam velit donec','aliquam velit donec','0','1','1.6333','A42514352','1','*'),
('2055','aliquam velit','aliquam velit','0','1','1.4333','A425143','1','*'),
('2054','aliquam nibh augue','aliquam nibh augue','0','1','1.6','A42512','1','*'),
('2053','aliquam nibh','aliquam nibh','0','1','1.4','A4251','1','*'),
('2052','aliquam feugiat nunc','aliquam feugiat nunc','0','1','1.6667','A42512352','1','*'),
('2051','aliquam feugiat','aliquam feugiat','0','1','1.5','A425123','1','*'),
('2050','aliquam erat volutpat','aliquam erat volutpat','0','1','1.7','A4256314313','1','*'),
('2049','aliquam erat','aliquam erat','0','1','1.4','A42563','1','*'),
('2048','aliquam','aliquam','0','0','0.4667','A425','2','*'),
('2047','aliqua ut enim','aliqua ut enim','0','1','1.4667','A4235','1','*'),
('2046','aliqua ut','aliqua ut','0','1','1.3','A423','1','*'),
('2045','aenean ultricies euismod','aenean ultricies euismod','0','1','1.8','A5436253','1','*'),
('2044','aenean ultricies','aenean ultricies','0','1','1.5333','A54362','1','*'),
('2043','adipiscing etiam quis','adipiscing etiam quis','0','1','1.7','A31252352','1','*'),
('2042','adipiscing etiam','adipiscing etiam','0','1','1.5333','A3125235','1','*'),
('2041','adipiscing elit nulla','adipiscing elit nulla','0','1','1.7','A312524354','1','*'),
('2040','adipiscing elit cras','adipiscing elit cras','0','1','1.6667','A3125243262','1','*'),
('2039','accumsan','accumsan','0','0','0.5333','A2525','2','*'),
('2038','ac tellus rutrum','ac tellus rutrum','0','1','1.5333','A23426365','1','*'),
('2037','ac tellus','ac tellus','0','1','1.3','A2342','1','*'),
('2036','ac nulla porttitor','ac nulla porttitor','0','1','1.6','A2541636','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2035','ac nulla morbi','ac nulla morbi','0','1','1.4667','A254561','1','*'),
('2034','ac nulla','ac nulla','0','1','1.2667','A254','1','*'),
('2033','ac malesuada ultricies','ac malesuada ultricies','0','1','1.7333','A254234362','1','*'),
('2032','ac malesuada','ac malesuada','0','1','1.4','A25423','1','*'),
('2031','ac justo hendrerit','ac justo hendrerit','0','1','1.6','A235363','1','*'),
('2030','ac justo','ac justo','0','1','1.2667','A230','1','*'),
('2029','ac dui aliquet','ac dui aliquet','0','1','1.4667','A23423','1','*'),
('2028','ac dui','ac dui','0','1','1.2','A230','1','*'),
('2027','ac dapibus lectus','ac dapibus lectus','0','1','1.5667','A23124232','1','*'),
('2026','ac dapibus','ac dapibus','0','1','1.3333','A2312','1','*'),
('2025','ac','ac','0','0','0.1333','A200','2','*'),
('2024','a luctus eros','a luctus eros','0','1','1.4333','A423262','1','*'),
('2023','a luctus','a luctus','0','1','1.2667','A4232','1','*'),
('2022','a aliquam nibh','a aliquam nibh','0','1','1.4667','A4251','1','*'),
('2021','a aliquam','a aliquam','0','1','1.3','A425','1','*'),
('2020','3 cras eleifend','3 cras eleifend','0','1','1.5','C624153','1','*'),
('2019','3 cras','3 cras','0','1','1.2','C620','1','*'),
('2018','3','3','0','0','0.1','','1','*'),
('2017','2 lorem ipsum','2 lorem ipsum','0','1','1.4333','L65125','1','*'),
('2016','2 lorem','2 lorem','0','1','1.2333','L650','1','*'),
('2014','111','111','0','0','0.3','','1','*'),
('2015','2','2','0','0','0.1','','2','*'),
('2013','1 nulla vestibulum','1 nulla vestibulum','0','1','1.6','N4123145','1','*'),
('2011','1','1','0','0','0.1','','2','*'),
('2012','1 nulla','1 nulla','0','1','1.2333','N400','1','*'),
('2605','quam eu','quam eu','0','1','1.2333','Q500','1','*'),
('2736','ullamcorper proin euismod','ullamcorper proin euismod','0','1','1.8333','U452616165253','1','*'),
('2735','ullamcorper proin','ullamcorper proin','0','1','1.5667','U452616165','1','*'),
('2734','ullamcorper','ullamcorper','0','0','0.7333','U452616','1','*'),
('2733','ullamco laboris sit','ullamco laboris sit','0','1','1.6333','U45241623','1','*'),
('2732','tristique urna mattis','tristique urna mattis','0','1','1.7','T62326532','1','*'),
('2731','tristique urna','tristique urna','0','1','1.4667','T623265','1','*'),
('2730','tristique','tristique','0','0','0.6','T6232','2','*'),
('2729','tortor ac dapibus','tortor ac dapibus','0','1','1.5667','T6362312','1','*'),
('2728','tortor ac','tortor ac','0','1','1.3','T6362','2','*'),
('2727','tortor','tortor','0','0','0.4','T636','2','*'),
('2726','tincidunt quam eu','tincidunt quam eu','0','1','1.5667','T5235325','1','*'),
('2725','tincidunt quam','tincidunt quam','0','1','1.4667','T5235325','1','*'),
('2724','tincidunt font awesome','tincidunt font awesome','0','1','1.7333','T5235315325','1','*'),
('2624','rhoncus','rhoncus','0','0','0.4667','R520','1','*'),
('2697','suscipit quis','suscipit quis','0','1','1.4333','S132','1','*'),
('2696','sodales tortor ac','sodales tortor ac','0','1','1.5667','S34236362','1','*'),
('2695','sodales tortor','sodales tortor','0','1','1.4667','S3423636','1','*'),
('2694','sit amet praesent','sit amet praesent','0','1','1.5667','S35316253','1','*'),
('2693','sit amet placerat','sit amet placerat','0','1','1.5667','S35314263','1','*'),
('2692','sit amet nibh','sit amet nibh','0','1','1.4333','S35351','1','*'),
('2691','sit amet metus','sit amet metus','0','1','1.4667','S353532','1','*'),
('2654','scelerisque magna et','scelerisque magna et','0','1','1.6667','S4625253','1','*'),
('2653','scelerisque magna','scelerisque magna','0','1','1.5667','S462525','1','*'),
('2652','scelerisque donec vel','scelerisque donec vel','0','1','1.7','S46235214','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2651','scelerisque donec','scelerisque donec','0','1','1.5667','S462352','1','*'),
('2650','scelerisque','scelerisque','0','0','0.7333','S462','1','*'),
('2604','quam','quam','0','0','0.2667','Q500','1','*'),
('2603','purus vel feugiat','purus vel feugiat','0','1','1.5667','P6214123','1','*'),
('2602','purus vel','purus vel','0','1','1.3','P6214','1','*'),
('2601','purus sit amet','purus sit amet','0','1','1.4667','P62353','1','*'),
('2600','purus sit','purus sit','0','1','1.3','P623','1','*'),
('2599','purus sed mi','purus sed mi','0','1','1.4','P6235','1','*'),
('2598','purus sed hendrerit','purus sed hendrerit','0','1','1.6333','P6235363','1','*'),
('2597','purus sed','purus sed','0','1','1.3','P623','1','*'),
('2596','purus','purus','0','0','0.3333','P620','1','*'),
('2595','pulvinar varius aenean','pulvinar varius aenean','0','1','1.7333','P41561625','1','*'),
('2594','pulvinar varius','pulvinar varius','0','1','1.5','P4156162','1','*'),
('2593','pulvinar sagittis pellentesque','pulvinar sagittis pellentesque','0','1','2','P415623214532','1','*'),
('2592','pulvinar sagittis','pulvinar sagittis','0','1','1.5667','P4156232','1','*'),
('2591','pulvinar 3 cras','pulvinar 3 cras','0','1','1.5','P4156262','1','*'),
('2590','pulvinar 3','pulvinar 3','0','1','1.3333','P4156','1','*'),
('2589','pulvinar','pulvinar','0','0','0.5333','P4156','1','*'),
('2649','sapien enim porta','sapien enim porta','0','1','1.5667','S15163','1','*'),
('2648','sapien enim','sapien enim','0','1','1.3667','S150','1','*'),
('2647','sagittis volutpat vehicula','sagittis volutpat vehicula','0','1','1.8667','S3214313124','1','*'),
('2646','sagittis volutpat','sagittis volutpat','0','1','1.5667','S3214313','1','*'),
('2645','sagittis pellentesque imperdiet','sagittis pellentesque imperdiet','0','1','2','S32145325163','1','*'),
('2644','sagittis pellentesque','sagittis pellentesque','0','1','1.7','S3214532','1','*'),
('2610','quam vitae magna','quam vitae magna','0','1','1.5333','Q513525','1','*'),
('2609','quam vitae','quam vitae','0','1','1.3333','Q513','1','*'),
('2711','tellus rutrum ultrices','tellus rutrum ultrices','0','1','1.7333','T4263654362','1','*'),
('2710','tellus rutrum','tellus rutrum','0','1','1.4333','T426365','1','*'),
('2643','sagittis metus mauris','sagittis metus mauris','0','1','1.7','S32532562','1','*'),
('2642','sagittis metus','sagittis metus','0','1','1.4667','S32532','1','*'),
('2641','sagittis','sagittis','0','0','0.5333','S320','1','*'),
('2640','rutrum ultrices sed','rutrum ultrices sed','0','1','1.6333','R36543623','1','*'),
('2639','rutrum ultrices','rutrum ultrices','0','1','1.5','R3654362','1','*'),
('2638','rutrum','rutrum','0','0','0.4','R365','2','*'),
('2699','suspendisse','suspendisse','0','0','0.7333','S1532','1','*'),
('2698','suscipit quis nisl','suscipit quis nisl','0','1','1.6','S132524','1','*'),
('2709','tellus risus et','tellus risus et','0','1','1.5','T42623','1','*'),
('2708','tellus risus','tellus risus','0','1','1.4','T4262','1','*'),
('2707','tellus in tristique','tellus in tristique','0','1','1.6333','T42536232','1','*'),
('2706','tellus in','tellus in','0','1','1.3','T425','1','*'),
('2705','tellus et pulvinar','tellus et pulvinar','0','1','1.6','T42314156','1','*'),
('2704','tellus et','tellus et','0','1','1.3','T423','1','*'),
('2703','suspendisse ut vestibulum','suspendisse ut vestibulum','0','1','1.8333','S15323123145','1','*'),
('2702','suspendisse ut','suspendisse ut','0','1','1.4667','S15323','1','*'),
('2701','suspendisse et ligula','suspendisse et ligula','0','1','1.7','S15323424','1','*'),
('2700','suspendisse et','suspendisse et','0','1','1.4667','S15323','1','*'),
('2686','single','single','0','0','0.4','S524','1','*'),
('2685','semper libero a','semper libero a','0','1','1.5','S516416','1','*'),
('2684','semper libero','semper libero','0','1','1.4333','S516416','1','*'),
('2683','semper consequat nam','semper consequat nam','0','1','1.6667','S51625235','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2682','semper consequat','semper consequat','0','1','1.5333','S5162523','1','*'),
('2681','semper','semper','0','0','0.4','S516','2','*'),
('2680','sed suscipit quis','sed suscipit quis','0','1','1.5667','S32132','1','*'),
('2679','sed suscipit','sed suscipit','0','1','1.4','S3213','1','*'),
('2678','sed sapien enim','sed sapien enim','0','1','1.5','S3215','1','*'),
('2677','sed sapien','sed sapien','0','1','1.3333','S3215','1','*'),
('2676','sed quam quis','sed quam quis','0','1','1.4333','S3252','1','*'),
('2675','sed quam','sed quam','0','1','1.2667','S325','1','*'),
('2674','sed mi scelerisque','sed mi scelerisque','0','1','1.6','S352462','1','*'),
('2673','sed mi','sed mi','0','1','1.2','S350','1','*'),
('2672','sed lacinia purus','sed lacinia purus','0','1','1.5667','S3425162','1','*'),
('2671','sed lacinia','sed lacinia','0','1','1.3667','S3425','1','*'),
('2670','sed hendrerit nulla','sed hendrerit nulla','0','1','1.6333','S3536354','1','*'),
('2669','sed hendrerit','sed hendrerit','0','1','1.4333','S35363','1','*'),
('2668','sed gravida arcu','sed gravida arcu','0','1','1.5333','S3261362','1','*'),
('2667','sed gravida','sed gravida','0','1','1.3667','S32613','1','*'),
('2666','sed fringilla purus','sed fringilla purus','0','1','1.6333','S316524162','1','*'),
('2665','sed fringilla','sed fringilla','0','1','1.4333','S316524','1','*'),
('2664','sed eu consectetur','sed eu consectetur','0','1','1.6','S325236','1','*'),
('2608','quam quis pulvinar','quam quis pulvinar','0','1','1.6','Q5214156','1','*'),
('2607','quam quis','quam quis','0','1','1.3','Q520','1','*'),
('2606','quam eu pulvinar','quam eu pulvinar','0','1','1.5333','Q514156','1','*'),
('2637','risus sit amet','risus sit amet','0','1','1.4667','R2353','1','*'),
('2636','risus sit','risus sit','0','1','1.3','R230','1','*'),
('2635','risus et hendrerit','risus et hendrerit','0','1','1.6','R235363','1','*'),
('2634','risus et','risus et','0','1','1.2667','R230','1','*'),
('2633','risus','risus','0','0','0.3333','R200','2','*'),
('2632','rhoncus vivamus blandit','rhoncus vivamus blandit','0','1','1.7667','R521521453','1','*'),
('2631','rhoncus vivamus','rhoncus vivamus','0','1','1.5','R52152','1','*'),
('2630','rhoncus ut lectus','rhoncus ut lectus','0','1','1.5667','R5234232','1','*'),
('2629','rhoncus ut','rhoncus ut','0','1','1.3333','R523','1','*'),
('2628','rhoncus donec sit','rhoncus donec sit','0','1','1.5667','R523523','1','*'),
('2627','rhoncus donec','rhoncus donec','0','1','1.4333','R52352','1','*'),
('2626','rhoncus 2 lorem','rhoncus 2 lorem','0','1','1.5','R52465','1','*'),
('2625','rhoncus 2','rhoncus 2','0','1','1.3','R520','1','*'),
('2663','sed eu','sed eu','0','1','1.2','S300','1','*'),
('2662','sed congue semper','sed congue semper','0','1','1.5667','S3252516','1','*'),
('2661','sed congue','sed congue','0','1','1.3333','S3252','1','*'),
('2690','sit amet lorem','sit amet lorem','0','1','1.4667','S353465','1','*'),
('2689','sit amet faucibus','sit amet faucibus','0','1','1.5667','S3531212','1','*'),
('2688','sit amet dapibus','sit amet dapibus','0','1','1.5333','S35312','1','*'),
('2687','single article','single article','0','1','1.4667','S5246324','1','*'),
('2723','tincidunt font','tincidunt font','0','1','1.4667','T52353153','1','*'),
('2722','tempus sed suscipit','tempus sed suscipit','0','1','1.6333','T5123213','1','*'),
('2721','tempus sed','tempus sed','0','1','1.3333','T5123','1','*'),
('2720','tempus felis nulla','tempus felis nulla','0','1','1.6','T51214254','1','*'),
('2719','tempus felis','tempus felis','0','1','1.4','T512142','1','*'),
('2718','tempus','tempus','0','0','0.4','T512','2','*'),
('2717','tempor odio sed','tempor odio sed','0','1','1.5','T516323','1','*'),
('2716','tempor odio','tempor odio','0','1','1.3667','T5163','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2715','tempor felis in','tempor felis in','0','1','1.5','T5161425','1','*'),
('2714','tempor felis','tempor felis','0','1','1.4','T516142','1','*'),
('2713','tellus sed gravida','tellus sed gravida','0','1','1.6','T4232613','1','*'),
('2712','tellus sed','tellus sed','0','1','1.3333','T423','1','*'),
('2588','proin fermentum velit','proin fermentum velit','0','1','1.7','P6516535143','1','*'),
('2587','proin fermentum','proin fermentum','0','1','1.5','P6516535','1','*'),
('2586','proin euismod pretium','proin euismod pretium','0','1','1.7','P652531635','1','*'),
('2585','proin euismod','proin euismod','0','1','1.4333','P65253','1','*'),
('2584','proin','proin','0','0','0.3333','P650','1','*'),
('2660','scelerisque ultricies lorem','scelerisque ultricies lorem','0','1','1.9','S4624362465','1','*'),
('2659','scelerisque ultricies','scelerisque ultricies','0','1','1.7','S4624362','1','*'),
('2658','scelerisque scelerisque donec','scelerisque scelerisque donec','0','1','1.9667','S462462352','1','*'),
('2657','scelerisque scelerisque','scelerisque scelerisque','0','1','1.7667','S462462','1','*'),
('2656','scelerisque nisi a','scelerisque nisi a','0','1','1.6','S46252','1','*'),
('2655','scelerisque nisi','scelerisque nisi','0','1','1.5333','S46252','1','*'),
('2623','reprehenderit in voluptate','reprehenderit in voluptate','0','1','1.8667','R16536351413','1','*'),
('2622','reprehenderit in','reprehenderit in','0','1','1.5333','R1653635','1','*'),
('2621','quisque vestibulum tempus','quisque vestibulum tempus','0','1','1.8333','Q1231453512','1','*'),
('2620','quisque vestibulum','quisque vestibulum','0','1','1.6','Q123145','1','*'),
('2619','quisque','quisque','0','0','0.4667','Q000','1','*'),
('2618','quis pulvinar 3','quis pulvinar 3','0','1','1.5','Q14156','1','*'),
('2617','quis pulvinar','quis pulvinar','0','1','1.4333','Q14156','1','*'),
('2616','quis nisl in','quis nisl in','0','1','1.4','Q5245','1','*'),
('2615','quis nisl','quis nisl','0','1','1.3','Q524','1','*'),
('2614','quis mi lacus','quis mi lacus','0','1','1.4333','Q542','1','*'),
('2613','quis mi','quis mi','0','1','1.2333','Q500','1','*'),
('2612','quis justo morbi','quis justo morbi','0','1','1.5333','Q3561','1','*'),
('2611','quis justo','quis justo','0','1','1.3333','Q300','1','*'),
('2737','ultrices','ultrices','0','0','0.5333','U4362','2','*'),
('2738','ultrices felis','ultrices felis','0','1','1.4667','U4362142','1','*'),
('2739','ultrices felis sit','ultrices felis sit','0','1','1.6','U43621423','1','*'),
('2740','ultrices sed','ultrices sed','0','1','1.4','U43623','1','*'),
('2741','ultrices sed eu','ultrices sed eu','0','1','1.5','U43623','1','*'),
('2742','ultricies','ultricies','0','0','0.6','U4362','1','*'),
('2743','ultricies euismod','ultricies euismod','0','1','1.5667','U436253','1','*'),
('2744','ultricies euismod rhoncus','ultricies euismod rhoncus','0','1','1.8333','U436253652','1','*'),
('2745','ultricies lorem','ultricies lorem','0','1','1.5','U4362465','1','*'),
('2746','ultricies lorem urna','ultricies lorem urna','0','1','1.6667','U436246565','1','*'),
('2747','ultricies neque','ultricies neque','0','1','1.5','U436252','1','*'),
('2748','ultricies neque donec','ultricies neque donec','0','1','1.7','U436252352','1','*'),
('2749','ultricies neque praesent','ultricies neque praesent','0','1','1.8','U43625216253','1','*'),
('2750','urna','urna','0','0','0.2667','U650','1','*'),
('2751','urna consequat','urna consequat','0','1','1.4667','U652523','1','*'),
('2752','urna consequat sit','urna consequat sit','0','1','1.6','U65252323','1','*'),
('2753','urna erat','urna erat','0','1','1.3','U6563','1','*'),
('2754','urna erat quis','urna erat quis','0','1','1.4667','U65632','1','*'),
('2755','urna in','urna in','0','1','1.2333','U650','1','*'),
('2756','urna in volutpat','urna in volutpat','0','1','1.5333','U6514313','1','*'),
('2757','urna luctus','urna luctus','0','1','1.3667','U654232','1','*'),
('2758','urna luctus odio','urna luctus odio','0','1','1.5333','U6542323','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2759','urna mattis','urna mattis','0','1','1.3667','U6532','1','*'),
('2760','urna mattis eu','urna mattis eu','0','1','1.4667','U6532','1','*'),
('2761','ut imperdiet','ut imperdiet','0','1','1.4','U35163','1','*'),
('2762','ut imperdiet orci','ut imperdiet orci','0','1','1.5667','U3516362','1','*'),
('2763','ut lectus','ut lectus','0','1','1.3','U34232','1','*'),
('2764','ut lectus felis','ut lectus felis','0','1','1.5','U34232142','1','*'),
('2765','ut massa','ut massa','0','1','1.2667','U352','1','*'),
('2766','ut massa eu','ut massa eu','0','1','1.3667','U352','1','*'),
('2767','ut tempor','ut tempor','0','1','1.3','U3516','1','*'),
('2768','ut tempor odio','ut tempor odio','0','1','1.4667','U35163','1','*'),
('2769','ut ut','ut ut','0','1','1.1667','U300','1','*'),
('2770','ut ut imperdiet','ut ut imperdiet','0','1','1.5','U35163','1','*'),
('2771','ut vestibulum','ut vestibulum','0','1','1.4333','U3123145','1','*'),
('2772','ut vestibulum tellus','ut vestibulum tellus','0','1','1.6667','U3123145342','1','*'),
('2773','varius','varius','0','0','0.4','V620','1','*'),
('2774','varius aenean','varius aenean','0','1','1.4333','V625','1','*'),
('2775','varius aenean ultricies','varius aenean ultricies','0','1','1.7667','V6254362','1','*'),
('2776','varius arcu','varius arcu','0','1','1.3667','V6262','1','*'),
('2777','varius arcu nec','varius arcu nec','0','1','1.5','V626252','1','*'),
('2778','varius massa','varius massa','0','1','1.4','V6252','1','*'),
('2779','varius massa nulla','varius massa nulla','0','1','1.6','V625254','1','*'),
('2780','varius massa quisque','varius massa quisque','0','1','1.6667','V6252','1','*'),
('2781','vehicula fusce','vehicula fusce','0','1','1.4667','V2412','1','*'),
('2782','vehicula fusce eu','vehicula fusce eu','0','1','1.5667','V2412','1','*'),
('2783','vehicula libero','vehicula libero','0','1','1.5','V2416','1','*'),
('2784','vehicula libero ac','vehicula libero ac','0','1','1.6','V24162','1','*'),
('2785','vehicula porttitor','vehicula porttitor','0','1','1.6','V241636','1','*'),
('2786','vehicula porttitor elit','vehicula porttitor elit','0','1','1.7667','V24163643','1','*'),
('2787','vel','vel','0','0','0.2','V400','2','*'),
('2788','vel enim','vel enim','0','1','1.2667','V450','1','*'),
('2789','vel enim ligula','vel enim ligula','0','1','1.5','V45424','1','*'),
('2790','vel feugiat','vel feugiat','0','1','1.3667','V4123','1','*'),
('2791','vel feugiat pharetra','vel feugiat pharetra','0','1','1.6667','V41231636','1','*'),
('2792','vel placerat','vel placerat','0','1','1.4','V414263','1','*'),
('2793','vel placerat nisl','vel placerat nisl','0','1','1.5667','V414263524','1','*'),
('2794','vel sagittis','vel sagittis','0','1','1.4','V4232','1','*'),
('2795','vel sagittis metus','vel sagittis metus','0','1','1.6','V4232532','1','*'),
('2796','vel scelerisque','vel scelerisque','0','1','1.5','V42462','1','*'),
('2797','vel scelerisque ultricies','vel scelerisque ultricies','0','1','1.8333','V424624362','1','*'),
('2798','vel tempus','vel tempus','0','1','1.3333','V43512','1','*'),
('2799','vel tempus sed','vel tempus sed','0','1','1.4667','V435123','1','*'),
('2800','vel urna','vel urna','0','1','1.2667','V465','1','*'),
('2801','vel urna in','vel urna in','0','1','1.3667','V465','1','*'),
('2802','velit','velit','0','0','0.3333','V430','2','*'),
('2803','velit donec','velit donec','0','1','1.3667','V4352','1','*'),
('2804','velit donec pretium','velit donec pretium','0','1','1.6333','V43521635','1','*'),
('2805','velit esse','velit esse','0','1','1.3333','V432','1','*'),
('2806','velit esse cillum','velit esse cillum','0','1','1.5667','V43245','1','*'),
('2807','velit nec','velit nec','0','1','1.3','V4352','1','*'),
('2808','velit nec rhoncus','velit nec rhoncus','0','1','1.5667','V4352652','1','*');
INSERT INTO `#__finder_terms` VALUES 
('2809','velit non','velit non','0','1','1.3','V435','1','*'),
('2810','velit non ligula','velit non ligula','0','1','1.5333','V435424','1','*'),
('2811','velit scelerisque','velit scelerisque','0','1','1.5667','V432462','1','*'),
('2812','velit scelerisque nisi','velit scelerisque nisi','0','1','1.7333','V43246252','1','*'),
('2813','vestibulum','vestibulum','0','0','0.6667','V23145','2','*'),
('2814','vestibulum tellus','vestibulum tellus','0','1','1.5667','V23145342','1','*'),
('2815','vestibulum tellus sed','vestibulum tellus sed','0','1','1.7','V231453423','1','*'),
('2816','vestibulum tempus','vestibulum tempus','0','1','1.5667','V231453512','1','*'),
('2817','vestibulum tempus felis','vestibulum tempus felis','0','1','1.7667','V231453512142','1','*'),
('2818','vestibulum ultrices','vestibulum ultrices','0','1','1.6333','V231454362','1','*'),
('2819','vestibulum ultrices felis','vestibulum ultrices felis','0','1','1.8333','V231454362142','1','*'),
('2820','vestibulum ut','vestibulum ut','0','1','1.4333','V231453','2','*'),
('2821','vestibulum ut massa','vestibulum ut massa','0','1','1.6333','V23145352','1','*'),
('2822','vitae','vitae','0','0','0.3333','V300','2','*'),
('2823','vitae magna','vitae magna','0','1','1.3667','V3525','1','*'),
('2824','vitae magna cursus','vitae magna cursus','0','1','1.6','V3525262','1','*'),
('2825','vitae nulla','vitae nulla','0','1','1.3667','V354','1','*'),
('2826','vitae nulla ac','vitae nulla ac','0','1','1.4667','V3542','1','*'),
('2827','vivamus','vivamus','0','0','0.4667','V520','2','*'),
('2828','vivamus blandit','vivamus blandit','0','1','1.5','V521453','1','*'),
('2829','vivamus blandit tellus','vivamus blandit tellus','0','1','1.7333','V52145342','1','*'),
('2830','viverra semper','viverra semper','0','1','1.4667','V62516','1','*'),
('2831','viverra semper libero','viverra semper libero','0','1','1.7','V62516416','1','*'),
('2832','voluptate','voluptate','0','0','0.6','V413','1','*'),
('2833','voluptate velit','voluptate velit','0','1','1.5','V413143','1','*'),
('2834','voluptate velit esse','voluptate velit esse','0','1','1.6667','V4131432','1','*'),
('2835','volutpat','volutpat','0','0','0.5333','V4313','2','*'),
('2836','volutpat cras','volutpat cras','0','1','1.4333','V4313262','1','*'),
('2837','volutpat cras eu','volutpat cras eu','0','1','1.5333','V4313262','1','*'),
('2838','volutpat tellus','volutpat tellus','0','1','1.5','V431342','1','*'),
('2839','volutpat tellus et','volutpat tellus et','0','1','1.6','V4313423','1','*'),
('2840','volutpat vehicula','volutpat vehicula','0','1','1.5667','V4313124','1','*'),
('2841','volutpat vehicula porttitor','volutpat vehicula porttitor','0','1','1.9','V43131241636','1','*'),
('2842','vulputate','vulputate','0','0','0.6','V413','2','*'),
('2843','vulputate ac','vulputate ac','0','1','1.4','V4132','1','*'),
('2844','vulputate ac dui','vulputate ac dui','0','1','1.5333','V41323','1','*'),
('3265','sed mauris','sed mauris','0','1','1.3333','S3562','1','*'),
('3264','sed auctor felis','sed auctor felis','0','1','1.5333','S3236142','1','*'),
('3263','sed auctor','sed auctor','0','1','1.3333','S3236','1','*'),
('3262','sed a libero','sed a libero','0','1','1.4','S3416','1','*'),
('3261','sed a','sed a','0','1','1.1667','S300','1','*'),
('3260','sapien sed auctor','sapien sed auctor','0','1','1.5667','S1523236','1','*'),
('3259','sapien sed','sapien sed','0','1','1.3333','S1523','1','*'),
('3258','rutrum velit et','rutrum velit et','0','1','1.5','R365143','1','*'),
('3257','rutrum velit','rutrum velit','0','1','1.4','R365143','1','*'),
('3256','risus tempor phasellus','risus tempor phasellus','0','1','1.7333','R235161242','1','*'),
('3255','risus tempor','risus tempor','0','1','1.4','R23516','1','*'),
('3254','pretium congue erat','pretium congue erat','0','1','1.6333','P63525263','1','*'),
('3253','pretium congue','pretium congue','0','1','1.4667','P635252','1','*'),
('3252','posuere venenatis lacinia','posuere venenatis lacinia','0','1','1.8333','P261532425','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3251','posuere venenatis','posuere venenatis','0','1','1.5667','P261532','1','*'),
('3250','posuere in mauris','posuere in mauris','0','1','1.5667','P26562','1','*'),
('3249','posuere in','posuere in','0','1','1.3333','P265','1','*'),
('3248','phasellus sed nisi','phasellus sed nisi','0','1','1.6','P242352','1','*'),
('3247','phasellus sed','phasellus sed','0','1','1.4333','P2423','1','*'),
('3246','orci pretium congue','orci pretium congue','0','1','1.6333','O621635252','1','*'),
('3245','orci pretium','orci pretium','0','1','1.4','O621635','1','*'),
('3244','nullam nec magna','nullam nec magna','0','1','1.5333','N452525','1','*'),
('3243','nullam nec','nullam nec','0','1','1.3333','N452','1','*'),
('3242','nullam','nullam','0','0','0.4','N450','1','*'),
('3241','nulla tristique ac','nulla tristique ac','0','1','1.6','N436232','1','*'),
('3240','nulla tristique','nulla tristique','0','1','1.5','N436232','1','*'),
('3239','nulla etiam ac','nulla etiam ac','0','1','1.4667','N4352','1','*'),
('3238','nulla etiam','nulla etiam','0','1','1.3667','N435','1','*'),
('3237','non iaculis tristique','non iaculis tristique','0','1','1.7','N24236232','1','*'),
('3236','non iaculis','non iaculis','0','1','1.3667','N242','1','*'),
('3235','nisi ut nibh','nisi ut nibh','0','1','1.4','N2351','1','*'),
('3234','nisi sed mauris','nisi sed mauris','0','1','1.5','N23562','1','*'),
('3233','nisi sed','nisi sed','0','1','1.2667','N230','1','*'),
('3232','nibh accumsan commodo','nibh accumsan commodo','0','1','1.7','N12525253','1','*'),
('3231','nibh accumsan','nibh accumsan','0','1','1.4333','N12525','1','*'),
('3230','nec magna tellus','nec magna tellus','0','1','1.5333','N2525342','1','*'),
('3229','nec magna','nec magna','0','1','1.3','N2525','1','*'),
('3228','nec dictum eget','nec dictum eget','0','1','1.5','N2323523','1','*'),
('3227','nec dictum','nec dictum','0','1','1.3333','N23235','1','*'),
('3226','mollis semper est','mollis semper est','0','1','1.5667','M4251623','1','*'),
('3225','mollis semper','mollis semper','0','1','1.4333','M42516','1','*'),
('3224','mollis','mollis','0','0','0.4','M420','1','*'),
('3223','mi ut et','mi ut et','0','1','1.2667','M300','1','*'),
('3222','mi ut','mi ut','0','1','1.1667','M300','1','*'),
('3221','metus ultrices vel','metus ultrices vel','0','1','1.6','M32436214','1','*'),
('3220','metus ultrices','metus ultrices','0','1','1.4667','M324362','1','*'),
('3219','metus mauris at','metus mauris at','0','1','1.5','M325623','1','*'),
('3218','mauris metus ultrices','mauris metus ultrices','0','1','1.7','M625324362','1','*'),
('3217','mauris metus','mauris metus','0','1','1.4','M62532','1','*'),
('3216','mauris maecenas eu','mauris maecenas eu','0','1','1.6','M625252','1','*'),
('3215','mauris maecenas','mauris maecenas','0','1','1.5','M625252','1','*'),
('3214','mauris in augue','mauris in augue','0','1','1.5','M6252','1','*'),
('3213','mauris in','mauris in','0','1','1.3','M625','1','*'),
('3212','mauris at orci','mauris at orci','0','1','1.4667','M62362','1','*'),
('3211','mauris at','mauris at','0','1','1.3','M623','1','*'),
('3210','mauris aliquam faucibus','mauris aliquam faucibus','0','1','1.7667','M624251212','1','*'),
('3209','mauris aliquam','mauris aliquam','0','1','1.4667','M62425','1','*'),
('3208','magna tellus vestibulum','magna tellus vestibulum','0','1','1.7667','M25342123145','1','*'),
('3207','magna tellus','magna tellus','0','1','1.4','M25342','1','*'),
('3206','maecenas eu iaculis','maecenas eu iaculis','0','1','1.6333','M25242','1','*'),
('3205','maecenas eu','maecenas eu','0','1','1.3667','M252','1','*'),
('3204','luctus sapien sed','luctus sapien sed','0','1','1.5667','L2321523','1','*'),
('3203','luctus sapien','luctus sapien','0','1','1.4333','L23215','1','*'),
('3202','ligula non iaculis','ligula non iaculis','0','1','1.6','L245242','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3201','ligula non','ligula non','0','1','1.3333','L245','1','*'),
('3200','libero in ut','libero in ut','0','1','1.4','L1653','1','*'),
('3199','libero in','libero in','0','1','1.3','L165','1','*'),
('3198','lectus vivamus tempus','lectus vivamus tempus','0','1','1.7','L2321523512','1','*'),
('3197','lectus vivamus','lectus vivamus','0','1','1.4667','L232152','1','*'),
('3196','lacus lectus vivamus','lacus lectus vivamus','0','1','1.6667','L24232152','1','*'),
('3195','lacus lectus','lacus lectus','0','1','1.4','L24232','1','*'),
('3194','lacus erat nullam','lacus erat nullam','0','1','1.5667','L263545','1','*'),
('3193','lacus erat','lacus erat','0','1','1.3333','L263','1','*'),
('3192','lacinia mauris aliquam','lacinia mauris aliquam','0','1','1.7333','L2562425','1','*'),
('3191','lacinia mauris','lacinia mauris','0','1','1.4667','L2562','1','*'),
('3190','ipsum in eget','ipsum in eget','0','1','1.4333','I12523','1','*'),
('3189','ipsum in','ipsum in','0','1','1.2667','I125','1','*'),
('3188','in ut semper','in ut semper','0','1','1.4','I532516','1','*'),
('3187','in ut','in ut','0','1','1.1667','I530','1','*'),
('3186','in posuere venenatis','in posuere venenatis','0','1','1.6667','I51261532','1','*'),
('3185','in posuere','in posuere','0','1','1.3333','I5126','1','*'),
('3184','in mauris metus','in mauris metus','0','1','1.5','I562532','1','*'),
('3183','in mauris','in mauris','0','1','1.3','I562','1','*'),
('3182','in eget lacus','in eget lacus','0','1','1.4333','I52342','1','*'),
('3181','in eget','in eget','0','1','1.2333','I523','1','*'),
('3180','in augue mollis','in augue mollis','0','1','1.5','I52542','1','*'),
('3179','in augue','in augue','0','1','1.2667','I520','1','*'),
('3178','iaculis tristique erat','iaculis tristique erat','0','1','1.7333','I2423623263','1','*'),
('3177','iaculis tristique','iaculis tristique','0','1','1.5667','I24236232','1','*'),
('3176','iaculis tortor ac','iaculis tortor ac','0','1','1.5667','I24236362','1','*'),
('3175','iaculis tortor','iaculis tortor','0','1','1.4667','I2423636','1','*'),
('3174','felis nisi sed','felis nisi sed','0','1','1.4667','F42523','1','*'),
('3173','felis nisi','felis nisi','0','1','1.3333','F4252','1','*'),
('3172','felis a vestibulum','felis a vestibulum','0','1','1.6','F42123145','1','*'),
('3171','felis a','felis a','0','1','1.2333','F420','1','*'),
('3170','faucibus velit vitae','faucibus velit vitae','0','1','1.6667','F21214313','1','*'),
('3169','faucibus velit','faucibus velit','0','1','1.4667','F212143','1','*'),
('3168','eu iaculis tortor','eu iaculis tortor','0','1','1.5667','E2423636','1','*'),
('3167','eu iaculis','eu iaculis','0','1','1.3333','E242','1','*'),
('3166','etiam ac est','etiam ac est','0','1','1.4','E3523','1','*'),
('3165','etiam ac','etiam ac','0','1','1.2667','E352','1','*'),
('3164','et nulla tristique','et nulla tristique','0','1','1.6','E35436232','1','*'),
('3163','et nulla','et nulla','0','1','1.2667','E354','1','*'),
('3162','et lacus lectus','et lacus lectus','0','1','1.5','E3424232','1','*'),
('3161','et lacus','et lacus','0','1','1.2667','E342','1','*'),
('3160','et augue bibendum','et augue bibendum','0','1','1.5667','E321535','1','*'),
('3159','et augue','et augue','0','1','1.2667','E320','1','*'),
('3158','est metus mauris','est metus mauris','0','1','1.5333','E23532562','1','*'),
('3157','est metus','est metus','0','1','1.3','E23532','1','*'),
('3156','est ac aliquet','est ac aliquet','0','1','1.4667','E232423','1','*'),
('3155','est ac','est ac','0','1','1.2','E232','1','*'),
('3154','eros in posuere','eros in posuere','0','1','1.5','E625126','1','*'),
('3153','eros in','eros in','0','1','1.2333','E625','1','*'),
('3152','erat vel vulputate','erat vel vulputate','0','1','1.6','E63141413','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3151','erat vel','erat vel','0','1','1.2667','E6314','1','*'),
('3150','erat sem luctus','erat sem luctus','0','1','1.5','E63254232','1','*'),
('3149','erat sem','erat sem','0','1','1.2667','E6325','1','*'),
('3148','erat nullam nec','erat nullam nec','0','1','1.5','E635452','1','*'),
('3147','erat nullam','erat nullam','0','1','1.3667','E63545','1','*'),
('3146','erat et augue','erat et augue','0','1','1.4333','E632','1','*'),
('3145','erat et','erat et','0','1','1.2333','E630','1','*'),
('3144','elit mauris in','elit mauris in','0','1','1.4667','E435625','1','*'),
('3143','elit mauris','elit mauris','0','1','1.3667','E43562','1','*'),
('3142','eget nulla etiam','eget nulla etiam','0','1','1.5333','E235435','1','*'),
('3141','eget nulla','eget nulla','0','1','1.3333','E2354','1','*'),
('3140','eget lacus erat','eget lacus erat','0','1','1.5','E234263','1','*'),
('3139','eget lacus','eget lacus','0','1','1.3333','E2342','1','*'),
('3138','dolor yt','dolor yt','0','1','1.2667','D463','1','*'),
('3137','dolor vestibulum commodo','dolor vestibulum commodo','0','1','1.8','D46123145253','1','*'),
('3136','dolor vestibulum','dolor vestibulum','0','1','1.5333','D46123145','1','*'),
('3135','dolor mauris in','dolor mauris in','0','1','1.5','D465625','1','*'),
('3134','dolor mauris','dolor mauris','0','1','1.4','D46562','1','*'),
('3133','dictum eget nulla','dictum eget nulla','0','1','1.5667','D2352354','1','*'),
('3132','dictum eget','dictum eget','0','1','1.3667','D23523','1','*'),
('3131','dapibus dolor yt','dapibus dolor yt','0','1','1.5333','D123463','1','*'),
('3130','dapibus dolor vestibulum','dapibus dolor vestibulum','0','1','1.8','D12346123145','1','*'),
('3129','dapibus dolor mauris','dapibus dolor mauris','0','1','1.6667','D12346562','1','*'),
('3128','dapibus dolor','dapibus dolor','0','1','1.4333','D12346','1','*'),
('3127','cursus tellus aliquam','cursus tellus aliquam','0','1','1.7','C62342425','1','*'),
('3126','cursus tellus','cursus tellus','0','1','1.4333','C62342','1','*'),
('3125','congue erat vel','congue erat vel','0','1','1.5','C526314','1','*'),
('3124','congue erat','congue erat','0','1','1.3667','C5263','1','*'),
('3123','commodo sed a','commodo sed a','0','1','1.4333','C5323','1','*'),
('3122','commodo sed','commodo sed','0','1','1.3667','C5323','1','*'),
('3121','commodo ligula non','commodo ligula non','0','1','1.6','C534245','1','*'),
('3120','commodo ligula','commodo ligula','0','1','1.4667','C53424','1','*'),
('3119','bibendum posuere in','bibendum posuere in','0','1','1.6333','B5351265','1','*'),
('3118','bibendum posuere','bibendum posuere','0','1','1.5333','B535126','1','*'),
('3117','augue mollis semper','augue mollis semper','0','1','1.6333','A2542516','1','*'),
('3116','augue mollis','augue mollis','0','1','1.4','A2542','1','*'),
('3115','augue bibendum posuere','augue bibendum posuere','0','1','1.7333','A21535126','1','*'),
('3114','augue bibendum','augue bibendum','0','1','1.4667','A21535','1','*'),
('3113','auctor felis nisi','auctor felis nisi','0','1','1.5667','A23614252','1','*'),
('3112','auctor felis','auctor felis','0','1','1.4','A236142','1','*'),
('3111','at orci pretium','at orci pretium','0','1','1.5','A3621635','1','*'),
('3110','at orci','at orci','0','1','1.2333','A362','1','*'),
('3109','aliquet turpis vestibulum','aliquet turpis vestibulum','0','1','1.8333','A423612123145','1','*'),
('3108','aliquet turpis','aliquet turpis','0','1','1.4667','A423612','1','*'),
('3107','aliquam vel lorem','aliquam vel lorem','0','1','1.5667','A4251465','1','*'),
('3106','aliquam vel','aliquam vel','0','1','1.3667','A42514','1','*'),
('3105','aliquam faucibus velit','aliquam faucibus velit','0','1','1.7333','A4251212143','1','*'),
('3104','aliquam faucibus','aliquam faucibus','0','1','1.5333','A4251212','1','*'),
('3103','adipiscing elit mauris','adipiscing elit mauris','0','1','1.7333','A3125243562','1','*'),
('3102','accumsan commodo sed','accumsan commodo sed','0','1','1.6667','A252525323','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3101','accumsan commodo','accumsan commodo','0','1','1.5333','A2525253','1','*'),
('3100','ac volutpat ipsum','ac volutpat ipsum','0','1','1.5667','A214313125','1','*'),
('3099','ac volutpat','ac volutpat','0','1','1.3667','A214313','1','*'),
('3098','ac sodales risus','ac sodales risus','0','1','1.5333','A234262','1','*'),
('3097','ac sodales','ac sodales','0','1','1.3333','A2342','1','*'),
('3096','ac est metus','ac est metus','0','1','1.4','A23532','1','*'),
('3095','ac est','ac est','0','1','1.2','A230','1','*'),
('3094','ac aliquet turpis','ac aliquet turpis','0','1','1.5667','A2423612','1','*'),
('3093','ac aliquet','ac aliquet','0','1','1.3333','A2423','1','*'),
('3092','a vestibulum mi','a vestibulum mi','0','1','1.5','A123145','1','*'),
('3091','a vestibulum','a vestibulum','0','1','1.4','A123145','1','*'),
('3090','a libero in','a libero in','0','1','1.3667','A4165','1','*'),
('3088','73','73','0','0','0.2','','1','*'),
('3089','a libero','a libero','0','1','1.2667','A416','1','*'),
('3323','vitae cursus','vitae cursus','0','1','1.4','V3262','1','*'),
('3324','vitae cursus tellus','vitae cursus tellus','0','1','1.6333','V3262342','1','*'),
('3325','vivamus tempus','vivamus tempus','0','1','1.4667','V523512','1','*'),
('3326','vivamus tempus erat','vivamus tempus erat','0','1','1.6333','V52351263','1','*'),
('3327','volutpat ipsum','volutpat ipsum','0','1','1.4667','V4313125','1','*'),
('3328','volutpat ipsum in','volutpat ipsum in','0','1','1.5667','V4313125','1','*'),
('3329','vulputate eros','vulputate eros','0','1','1.4667','V41362','1','*'),
('3330','vulputate eros in','vulputate eros in','0','1','1.5667','V413625','1','*'),
('3331','vulputate nec','vulputate nec','0','1','1.4333','V41352','1','*'),
('3332','vulputate nec dictum','vulputate nec dictum','0','1','1.6667','V413523235','1','*'),
('3333','yt','yt','0','0','0.1333','Y300','1','*'),
('3266','sed mauris maecenas','sed mauris maecenas','0','1','1.6333','S35625252','1','*'),
('3267','sed nisi','sed nisi','0','1','1.2667','S352','1','*'),
('3268','sed nisi ut','sed nisi ut','0','1','1.3667','S3523','1','*'),
('3269','sem','sem','0','0','0.2','S500','1','*'),
('3270','sem luctus','sem luctus','0','1','1.3333','S54232','1','*'),
('3271','sem luctus sapien','sem luctus sapien','0','1','1.5667','S5423215','1','*'),
('3272','semper est','semper est','0','1','1.3333','S51623','1','*'),
('3273','semper est ac','semper est ac','0','1','1.4333','S516232','1','*'),
('3274','semper felis','semper felis','0','1','1.4','S516142','1','*'),
('3275','semper felis a','semper felis a','0','1','1.4667','S516142','1','*'),
('3276','sodales risus','sodales risus','0','1','1.4333','S34262','1','*'),
('3277','sodales risus tempor','sodales risus tempor','0','1','1.6667','S342623516','1','*'),
('3278','subpage','subpage','0','0','0.4667','S120','1','*'),
('3279','tellus aliquam','tellus aliquam','0','1','1.4667','T42425','1','*'),
('3280','tellus aliquam vel','tellus aliquam vel','0','1','1.6','T4242514','1','*'),
('3281','tellus vestibulum','tellus vestibulum','0','1','1.5667','T42123145','1','*'),
('3282','tellus vestibulum rutrum','tellus vestibulum rutrum','0','1','1.8','T421231456365','1','*'),
('3283','tempor phasellus','tempor phasellus','0','1','1.5333','T5161242','1','*'),
('3284','tempor phasellus sed','tempor phasellus sed','0','1','1.6667','T51612423','1','*'),
('3285','tempus erat','tempus erat','0','1','1.3667','T51263','1','*'),
('3286','tempus erat et','tempus erat et','0','1','1.4667','T51263','1','*'),
('3287','tortor ac volutpat','tortor ac volutpat','0','1','1.6','T636214313','1','*'),
('3288','tristique ac','tristique ac','0','1','1.4','T6232','1','*'),
('3289','tristique ac sodales','tristique ac sodales','0','1','1.6667','T6232342','1','*'),
('3290','tristique erat','tristique erat','0','1','1.4667','T623263','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3291','tristique erat sem','tristique erat sem','0','1','1.6','T62326325','1','*'),
('3292','turpis vestibulum','turpis vestibulum','0','1','1.5667','T612123145','1','*'),
('3293','turpis vestibulum ut','turpis vestibulum ut','0','1','1.6667','T6121231453','1','*'),
('3294','ultrices vel','ultrices vel','0','1','1.4','U436214','1','*'),
('3295','ultrices vel vulputate','ultrices vel vulputate','0','1','1.7333','U4362141413','1','*'),
('3296','ut dapibus','ut dapibus','0','1','1.3333','U312','1','*'),
('3297','ut dapibus dolor','ut dapibus dolor','0','1','1.5333','U312346','1','*'),
('3298','ut et','ut et','0','1','1.1667','U300','1','*'),
('3299','ut et lacus','ut et lacus','0','1','1.3667','U342','1','*'),
('3300','ut nibh','ut nibh','0','1','1.2333','U351','1','*'),
('3301','ut nibh accumsan','ut nibh accumsan','0','1','1.5333','U3512525','1','*'),
('3302','ut semper','ut semper','0','1','1.3','U32516','1','*'),
('3303','ut semper felis','ut semper felis','0','1','1.5','U32516142','1','*'),
('3304','vel lorem','vel lorem','0','1','1.3','V465','1','*'),
('3305','vel lorem ipsum','vel lorem ipsum','0','1','1.5','V465125','1','*'),
('3306','vel vulputate','vel vulputate','0','1','1.4333','V41413','1','*'),
('3307','vel vulputate eros','vel vulputate eros','0','1','1.6','V4141362','1','*'),
('3308','vel vulputate nec','vel vulputate nec','0','1','1.5667','V4141352','1','*'),
('3309','velit et','velit et','0','1','1.2667','V430','1','*'),
('3310','velit et nulla','velit et nulla','0','1','1.4667','V4354','1','*'),
('3311','velit vitae','velit vitae','0','1','1.3667','V4313','1','*'),
('3312','velit vitae cursus','velit vitae cursus','0','1','1.6','V4313262','1','*'),
('3313','venenatis','venenatis','0','0','0.6','V532','1','*'),
('3314','venenatis lacinia','venenatis lacinia','0','1','1.5667','V532425','1','*'),
('3315','venenatis lacinia mauris','venenatis lacinia mauris','0','1','1.8','V53242562','1','*'),
('3316','vestibulum commodo','vestibulum commodo','0','1','1.6','V23145253','1','*'),
('3317','vestibulum commodo ligula','vestibulum commodo ligula','0','1','1.8333','V23145253424','1','*'),
('3318','vestibulum mi','vestibulum mi','0','1','1.4333','V23145','1','*'),
('3319','vestibulum mi ut','vestibulum mi ut','0','1','1.5333','V231453','1','*'),
('3320','vestibulum rutrum','vestibulum rutrum','0','1','1.5667','V231456365','1','*'),
('3321','vestibulum rutrum velit','vestibulum rutrum velit','0','1','1.7667','V231456365143','1','*'),
('3322','vestibulum ut dapibus','vestibulum ut dapibus','0','1','1.7','V23145312','1','*'),
('3334','130','130','0','0','0.3','','1','*'),
('3335','480px','480px','0','0','0.3333','P200','1','*'),
('3336','480px and','480px and','0','1','1.3','P253','1','*'),
('3337','480px and smaller','480px and smaller','0','1','1.5667','P2532546','1','*'),
('3338','481px-767px','481px-767px','0','0','0.7333','P212','1','*'),
('3339','481px-767px check','481px-767px check','0','1','1.5667','P212','1','*'),
('3340','481px-767px check out','481px-767px check out','0','1','1.7','P2123','1','*'),
('3341','768px-979px','768px-979px','0','0','0.7333','P212','1','*'),
('3342','768px-979px check','768px-979px check','0','1','1.5667','P212','1','*'),
('3343','768px-979px check out','768px-979px check out','0','1','1.7','P2123','1','*'),
('3344','980px','980px','0','0','0.3333','P200','1','*'),
('3345','980px and','980px and','0','1','1.3','P253','1','*'),
('3346','980px and higher','980px and higher','0','1','1.5333','P25326','1','*'),
('3347','about','about','0','0','0.3333','A130','1','*'),
('3348','about layout','about layout','0','1','1.4','A1343','1','*'),
('3349','about layout customization','about layout customization','0','1','1.8667','A1343235235','1','*'),
('3350','adjusts','adjusts','0','0','0.4667','A3232','1','*'),
('3351','adjusts to','adjusts to','0','1','1.3333','A32323','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3352','adjusts to various','adjusts to various','0','1','1.6','A32323162','1','*'),
('3353','all','all','0','0','0.2','A400','2','*'),
('3354','all template','all template','0','1','1.4','A435143','1','*'),
('3355','all template positions','all template positions','0','1','1.7333','A43514312352','1','*'),
('3356','allows','allows','0','0','0.4','A420','1','*'),
('3357','allows you','allows you','0','1','1.3333','A420','1','*'),
('3358','allows you to','allows you to','0','1','1.4333','A423','1','*'),
('3359','and','and','0','0','0.2','A530','1','*'),
('3360','and higher','and higher','0','1','1.3333','A5326','1','*'),
('3361','and higher check','and higher check','0','1','1.5333','A53262','1','*'),
('3362','and large','and large','0','1','1.3','A53462','1','*'),
('3363','and large screen','and large screen','0','1','1.5333','A5346265','1','*'),
('3364','and mobile','and mobile','0','1','1.3333','A53514','1','*'),
('3365','and mobile landscape','and mobile landscape','0','1','1.6667','A535145321','1','*'),
('3366','and smaller','and smaller','0','1','1.3667','A532546','1','*'),
('3367','and smaller check','and smaller check','0','1','1.5667','A5325462','1','*'),
('3368','and tablet','and tablet','0','1','1.3333','A53143','1','*'),
('3369','and tablet landscape','and tablet landscape','0','1','1.6667','A5314345321','1','*'),
('3370','builder','builder','0','0','0.4667','B436','1','*'),
('3371','builder tool','builder tool','0','1','1.4','B43634','1','*'),
('3372','builder tool which','builder tool which','0','1','1.6','B436342','1','*'),
('3373','check','check','0','0','0.3333','C000','2','*'),
('3374','check out','check out','0','1','1.3','C300','1','*'),
('3375','check out more','check out more','0','1','1.4667','C356','1','*'),
('3376','customization','customization','0','0','0.8667','C35235','1','*'),
('3377','customization module','customization module','0','1','1.6667','C3523534','1','*'),
('3378','customization module positions','customization module positions','0','1','2','C352353412352','1','*'),
('3379','customize','customize','0','0','0.6','C352','1','*'),
('3380','customize template','customize template','0','1','1.6','C35235143','1','*'),
('3381','customize template layout','customize template layout','0','1','1.8333','C3523514343','1','*'),
('3382','desktop','desktop','0','0','0.4667','D231','1','*'),
('3383','desktop and','desktop and','0','1','1.3667','D23153','1','*'),
('3384','desktop and tablet','desktop and tablet','0','1','1.6','D23153143','1','*'),
('3385','desktops','desktops','0','0','0.5333','D2312','1','*'),
('3386','desktops tablets','desktops tablets','0','1','1.5333','D231231432','1','*'),
('3387','desktops tablets or','desktops tablets or','0','1','1.6333','D2312314326','1','*'),
('3388','details','details','0','0','0.4667','D420','1','*'),
('3389','details about','details about','0','1','1.4333','D4213','1','*'),
('3390','details about layout','details about layout','0','1','1.6667','D421343','1','*'),
('3391','different','different','0','0','0.6','D1653','1','*'),
('3392','different screen','different screen','0','1','1.5333','D1653265','1','*'),
('3393','different screen dimensions','different screen dimensions','0','1','1.9','D165326535252','1','*'),
('3394','dimensions','dimensions','0','0','0.6667','D5252','1','*'),
('3395','ef4','ef4','0','0','0.2','E100','1','*'),
('3396','ef4 framework','ef4 framework','0','1','1.4333','E16562','1','*'),
('3397','ef4 framework includes','ef4 framework includes','0','1','1.7333','E1656252432','1','*'),
('3398','extra','extra','0','0','0.3333','E236','1','*'),
('3399','extra small','extra small','0','1','1.3667','E236254','1','*'),
('3400','extra small screen','extra small screen','0','1','1.6','E236254265','1','*'),
('3401','for','for','0','0','0.2','F600','2','*');
INSERT INTO `#__finder_terms` VALUES 
('3402','for different','for different','0','1','1.4333','F631653','1','*'),
('3403','for different screen','for different screen','0','1','1.6667','F631653265','1','*'),
('3404','for extra','for extra','0','1','1.3','F6236','1','*'),
('3405','for extra small','for extra small','0','1','1.5','F6236254','1','*'),
('3406','for medium','for medium','0','1','1.3333','F6535','1','*'),
('3407','for medium screen','for medium screen','0','1','1.5667','F6535265','1','*'),
('3408','for normal','for normal','0','1','1.3333','F65654','1','*'),
('3409','for normal and','for normal and','0','1','1.4667','F6565453','1','*'),
('3410','for small','for small','0','1','1.3','F6254','1','*'),
('3411','for small screen','for small screen','0','1','1.5333','F6254265','1','*'),
('3412','framework','framework','0','0','0.6','F6562','1','*'),
('3413','framework includes','framework includes','0','1','1.6','F656252432','1','*'),
('3414','framework includes layout','framework includes layout','0','1','1.8333','F65625243243','1','*'),
('3415','fully','fully','0','0','0.3333','F400','1','*'),
('3416','fully responsive','fully responsive','0','1','1.5333','F4621521','1','*'),
('3417','fully responsive layout','fully responsive layout','0','1','1.7667','F462152143','1','*'),
('3418','higher','higher','0','0','0.4','H260','1','*'),
('3419','higher check','higher check','0','1','1.4','H262','1','*'),
('3420','higher check out','higher check out','0','1','1.5333','H2623','1','*'),
('3421','includes','includes','0','0','0.5333','I52432','1','*'),
('3422','includes layout','includes layout','0','1','1.5','I5243243','1','*'),
('3423','includes layout builder','includes layout builder','0','1','1.7667','I52432431436','1','*'),
('3424','is using','is using','0','1','1.2667','I252','1','*'),
('3425','is using fully','is using fully','0','1','1.4667','I25214','1','*'),
('3426','jm','jm','0','0','0.1333','J500','1','*'),
('3427','jm services','jm services','0','1','1.3667','J52612','1','*'),
('3428','jm services joomla','jm services joomla','0','1','1.6','J5261254','1','*'),
('3429','joomla','joomla','0','0','0.4','J540','1','*'),
('3430','joomla template','joomla template','0','1','1.5','J5435143','1','*'),
('3431','joomla template is','joomla template is','0','1','1.6','J54351432','1','*'),
('3432','landscape','landscape','0','0','0.6','L5321','1','*'),
('3433','landscape 481px-767px','landscape 481px-767px','0','1','1.7','L5321212','1','*'),
('3434','landscape 481px-767px check','landscape 481px-767px check','0','1','1.9','L5321212','1','*'),
('3435','landscape 980px','landscape 980px','0','1','1.5','L53212','1','*'),
('3436','landscape 980px and','landscape 980px and','0','1','1.6333','L5321253','1','*'),
('3437','large','large','0','0','0.3333','L620','1','*'),
('3438','large screen','large screen','0','1','1.4','L6265','1','*'),
('3439','large screen usually','large screen usually','0','1','1.6667','L626524','1','*'),
('3440','layout','layout','0','0','0.4','L300','1','*'),
('3441','layout builder','layout builder','0','1','1.4667','L31436','1','*'),
('3442','layout builder tool','layout builder tool','0','1','1.6333','L3143634','1','*'),
('3443','layout customization','layout customization','0','1','1.6667','L3235235','1','*'),
('3444','layout customization module','layout customization module','0','1','1.9','L323523534','1','*'),
('3445','layout for','layout for','0','1','1.3333','L316','1','*'),
('3446','layout for different','layout for different','0','1','1.6667','L31631653','1','*'),
('3447','layout that','layout that','0','1','1.3667','L300','1','*'),
('3448','layout that adjusts','layout that adjusts','0','1','1.6333','L3232','1','*'),
('3449','medium','medium','0','0','0.4','M350','1','*'),
('3450','medium screen','medium screen','0','1','1.4333','M35265','1','*'),
('3451','medium screen usually','medium screen usually','0','1','1.7','M3526524','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3452','mobile','mobile','0','0','0.4','M140','1','*'),
('3453','mobile landscape','mobile landscape','0','1','1.5333','M145321','1','*'),
('3454','mobile landscape 481px-767px','mobile landscape 481px-767px','0','1','1.9333','M145321212','1','*'),
('3455','mobile portrait','mobile portrait','0','1','1.5','M1416363','1','*'),
('3456','mobile portrait 480px','mobile portrait 480px','0','1','1.7','M141636312','1','*'),
('3457','mobiles','mobiles','0','0','0.4667','M142','1','*'),
('3458','mobiles ef4','mobiles ef4','0','1','1.3667','M1421','1','*'),
('3459','mobiles ef4 framework','mobiles ef4 framework','0','1','1.7','M14216562','1','*'),
('3460','module positions','module positions','0','1','1.5333','M3412352','1','*'),
('3461','module positions for','module positions for','0','1','1.6667','M341235216','1','*'),
('3462','more details','more details','0','1','1.4','M6342','1','*'),
('3463','more details about','more details about','0','1','1.6','M634213','1','*'),
('3464','normal','normal','0','0','0.4','N654','1','*'),
('3465','normal and','normal and','0','1','1.3333','N65453','1','*'),
('3466','normal and large','normal and large','0','1','1.5333','N65453462','1','*'),
('3467','or','or','0','0','0.1333','O600','1','*'),
('3468','or mobiles','or mobiles','0','1','1.3333','O65142','1','*'),
('3469','or mobiles ef4','or mobiles ef4','0','1','1.4667','O651421','1','*'),
('3470','out','out','0','0','0.2','O300','1','*'),
('3471','out more','out more','0','1','1.2667','O356','1','*'),
('3472','out more details','out more details','0','1','1.5333','O356342','1','*'),
('3473','portrait','portrait','0','0','0.5333','P6363','1','*'),
('3474','portrait 480px','portrait 480px','0','1','1.4667','P636312','1','*'),
('3475','portrait 480px and','portrait 480px and','0','1','1.6','P63631253','1','*'),
('3476','portrait and','portrait and','0','1','1.4','P636353','1','*'),
('3477','portrait and mobile','portrait and mobile','0','1','1.6333','P636353514','1','*'),
('3478','positions','positions','0','0','0.6','P2352','1','*'),
('3479','positions for','positions for','0','1','1.4333','P235216','1','*'),
('3480','positions for extra','positions for extra','0','1','1.6333','P235216236','1','*'),
('3481','positions for medium','positions for medium','0','1','1.6667','P235216535','1','*'),
('3482','positions for normal','positions for normal','0','1','1.6667','P2352165654','1','*'),
('3483','positions for small','positions for small','0','1','1.6333','P235216254','1','*'),
('3484','responsive','responsive','0','0','0.6667','R21521','1','*'),
('3485','responsive layout','responsive layout','0','1','1.5667','R2152143','1','*'),
('3486','responsive layout that','responsive layout that','0','1','1.7333','R2152143','1','*'),
('3487','screen','screen','0','0','0.4','S650','1','*'),
('3488','screen dimensions','screen dimensions','0','1','1.5667','S6535252','1','*'),
('3489','screen usually','screen usually','0','1','1.4667','S6524','1','*'),
('3490','screen usually desktop','screen usually desktop','0','1','1.7333','S65243231','1','*'),
('3491','screen usually mobile','screen usually mobile','0','1','1.7','S6524514','1','*'),
('3492','screen usually tablet','screen usually tablet','0','1','1.7','S65243143','1','*'),
('3493','screens','screens','0','0','0.4667','S652','1','*'),
('3494','screens desktops','screens desktops','0','1','1.5333','S65232312','1','*'),
('3495','screens desktops tablets','screens desktops tablets','0','1','1.8','S6523231231432','1','*'),
('3496','services','services','0','0','0.5333','S612','1','*'),
('3497','services joomla','services joomla','0','1','1.5','S61254','1','*'),
('3498','services joomla template','services joomla template','0','1','1.8','S6125435143','1','*'),
('3499','small','small','0','0','0.3333','S540','1','*'),
('3500','small screen','small screen','0','1','1.4','S54265','1','*'),
('3501','small screen usually','small screen usually','0','1','1.6667','S5426524','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3502','smaller','smaller','0','0','0.4667','S546','1','*'),
('3503','smaller check','smaller check','0','1','1.4333','S5462','1','*'),
('3504','smaller check out','smaller check out','0','1','1.5667','S54623','1','*'),
('3505','tablet','tablet','0','0','0.4','T143','1','*'),
('3506','tablet 768px-979px','tablet 768px-979px','0','1','1.6','T1431212','1','*'),
('3507','tablet 768px-979px check','tablet 768px-979px check','0','1','1.8','T1431212','1','*'),
('3508','tablet landscape','tablet landscape','0','1','1.5333','T14345321','1','*'),
('3509','tablet landscape 980px','tablet landscape 980px','0','1','1.7333','T143453212','1','*'),
('3510','tablet portrait','tablet portrait','0','1','1.5','T14316363','1','*'),
('3511','tablet portrait and','tablet portrait and','0','1','1.6333','T1431636353','1','*'),
('3512','tablets','tablets','0','0','0.4667','T1432','1','*'),
('3513','tablets or','tablets or','0','1','1.3333','T14326','1','*'),
('3514','tablets or mobiles','tablets or mobiles','0','1','1.6','T143265142','1','*'),
('3515','template','template','0','0','0.5333','T5143','1','*'),
('3516','template is','template is','0','1','1.3667','T51432','1','*'),
('3517','template is using','template is using','0','1','1.5667','T5143252','1','*'),
('3518','template layout','template layout','0','1','1.5','T514343','1','*'),
('3519','template layout for','template layout for','0','1','1.6333','T51434316','1','*'),
('3520','template positions','template positions','0','1','1.6','T514312352','1','*'),
('3521','that','that','0','0','0.2667','T000','2','*'),
('3522','that adjusts','that adjusts','0','1','1.4','T232','1','*'),
('3523','that adjusts to','that adjusts to','0','1','1.5','T2323','1','*'),
('3524','to','to','0','0','0.1333','T000','2','*'),
('3525','to customize','to customize','0','1','1.4','T2352','1','*'),
('3526','to customize template','to customize template','0','1','1.7','T235235143','1','*'),
('3527','to various','to various','0','1','1.3333','T162','1','*'),
('3528','to various screens','to various screens','0','1','1.6','T162652','1','*'),
('3529','tool','tool','0','0','0.2667','T400','1','*'),
('3530','tool which','tool which','0','1','1.3333','T420','1','*'),
('3531','tool which allows','tool which allows','0','1','1.5667','T4242','1','*'),
('3532','using','using','0','0','0.3333','U252','1','*'),
('3533','using fully','using fully','0','1','1.3667','U25214','1','*'),
('3534','using fully responsive','using fully responsive','0','1','1.7333','U25214621521','1','*'),
('3535','usually','usually','0','0','0.4667','U240','1','*'),
('3536','usually desktop','usually desktop','0','1','1.5','U243231','1','*'),
('3537','usually desktop and','usually desktop and','0','1','1.6333','U24323153','1','*'),
('3538','usually mobile','usually mobile','0','1','1.4667','U24514','1','*'),
('3539','usually mobile portrait','usually mobile portrait','0','1','1.7667','U2451416363','1','*'),
('3540','usually tablet','usually tablet','0','1','1.4667','U243143','1','*'),
('3541','usually tablet 768px-979px','usually tablet 768px-979px','0','1','1.8667','U2431431212','1','*'),
('3542','usually tablet portrait','usually tablet portrait','0','1','1.7667','U24314316363','1','*'),
('3543','various','various','0','0','0.4667','V620','1','*'),
('3544','various screens','various screens','0','1','1.5','V62652','1','*'),
('3545','various screens desktops','various screens desktops','0','1','1.8','V6265232312','1','*'),
('3546','which','which','0','0','0.3333','W200','1','*'),
('3547','which allows','which allows','0','1','1.4','W242','1','*'),
('3548','which allows you','which allows you','0','1','1.5333','W242','1','*'),
('3549','you','you','0','0','0.2','Y000','2','*'),
('3550','you to','you to','0','1','1.2','Y300','1','*'),
('3551','you to customize','you to customize','0','1','1.5333','Y32352','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3552','1 available','1 available','0','1','1.3667','A1414','1','*'),
('3553','1 available module','1 available module','0','1','1.6','A1414534','1','*'),
('3554','121','121','0','0','0.3','','1','*'),
('3555','2 use','2 use','0','1','1.1667','U200','1','*'),
('3556','2 use the','2 use the','0','1','1.3','U230','1','*'),
('3557','a correct','a correct','0','1','1.3','A2623','1','*'),
('3558','a correct suffix','a correct suffix','0','1','1.5333','A2623212','1','*'),
('3559','a module','a module','0','1','1.2667','A534','1','*'),
('3560','a module parameter','a module parameter','0','1','1.6','A53416536','1','*'),
('3561','a module will','a module will','0','1','1.4333','A534','1','*'),
('3562','additional','additional','0','0','0.6667','A354','1','*'),
('3563','additional module','additional module','0','1','1.5667','A354534','1','*'),
('3564','additional module designs','additional module designs','0','1','1.8333','A3545343252','1','*'),
('3565','all 1','all 1','0','1','1.1667','A400','1','*'),
('3566','all 1 available','all 1 available','0','1','1.5','A41414','1','*'),
('3567','alternative-ms','alternative-ms','0','0','0.9333','A43653152','1','*'),
('3568','are','are','0','0','0.2','A600','1','*'),
('3569','are additional','are additional','0','1','1.4667','A6354','1','*'),
('3570','are additional module','are additional module','0','1','1.7','A6354534','1','*'),
('3571','as','as','0','0','0.1333','A200','1','*'),
('3572','as a','as a','0','1','1.1333','A200','1','*'),
('3573','as a module','as a module','0','1','1.3667','A2534','1','*'),
('3574','available','available','0','0','0.6','A1414','1','*'),
('3575','available module','available module','0','1','1.5333','A1414534','1','*'),
('3576','available module designs','available module designs','0','1','1.8','A14145343252','1','*'),
('3577','available that','available that','0','1','1.4667','A14143','1','*'),
('3578','available that you','available that you','0','1','1.6','A14143','1','*'),
('3579','by','by','0','0','0.1333','B000','1','*'),
('3580','by entering','by entering','0','1','1.3667','B53652','1','*'),
('3581','by entering a','by entering a','0','1','1.4333','B53652','1','*'),
('3582','can','can','0','0','0.2','C500','1','*'),
('3583','can control','can control','0','1','1.3667','C525364','1','*'),
('3584','can control by','can control by','0','1','1.4667','C5253641','1','*'),
('3585','check them','check them','0','1','1.3333','C350','1','*'),
('3586','check them all','check them all','0','1','1.4667','C354','1','*'),
('3587','control','control','0','0','0.4667','C5364','1','*'),
('3588','control by','control by','0','1','1.3333','C53641','1','*'),
('3589','control by entering','control by entering','0','1','1.6333','C5364153652','1','*'),
('3590','correct','correct','0','0','0.4667','C623','1','*'),
('3591','correct suffix','correct suffix','0','1','1.4667','C623212','1','*'),
('3592','correct suffix name','correct suffix name','0','1','1.6333','C6232125','1','*'),
('3593','css','css','0','0','0.2','C000','1','*'),
('3594','css styles','css styles','0','1','1.3333','C342','1','*'),
('3595','css styles suffix','css styles suffix','0','1','1.5667','C34212','1','*'),
('3596','default','default','0','0','0.4667','D143','1','*'),
('3597','default css','default css','0','1','1.3667','D1432','1','*'),
('3598','default css styles','default css styles','0','1','1.6','D1432342','1','*'),
('3599','designs','designs','0','0','0.4667','D252','1','*'),
('3600','designs 2','designs 2','0','1','1.3','D252','1','*'),
('3601','designs 2 use','designs 2 use','0','1','1.4333','D252','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3602','designs available','designs available','0','1','1.5667','D2521414','1','*'),
('3603','designs available that','designs available that','0','1','1.7333','D25214143','1','*'),
('3604','dj-imageslider','dj-imageslider','0','0','0.9333','D252436','1','*'),
('3605','dj-imageslider module','dj-imageslider module','0','1','1.7','D252436534','1','*'),
('3606','dj-imageslider module if','dj-imageslider module if','0','1','1.8','D2524365341','1','*'),
('3607','entering','entering','0','0','0.5333','E53652','1','*'),
('3608','entering a','entering a','0','1','1.3333','E53652','1','*'),
('3609','entering a correct','entering a correct','0','1','1.6','E53652623','1','*'),
('3610','following','following','0','0','0.6','F452','1','*'),
('3611','following suffixes','following suffixes','0','1','1.6','F45212','1','*'),
('3612','following suffixes for','following suffixes for','0','1','1.7333','F4521216','1','*'),
('3613','following view','following view','0','1','1.4667','F4521','1','*'),
('3614','following view for','following view for','0','1','1.6','F45216','1','*'),
('3615','for dj-imageslider','for dj-imageslider','0','1','1.6','F63252436','1','*'),
('3616','for dj-imageslider module','for dj-imageslider module','0','1','1.8333','F63252436534','1','*'),
('3617','for slides','for slides','0','1','1.3333','F62432','1','*'),
('3618','for slides otherwise','for slides otherwise','0','1','1.6667','F62432362','1','*'),
('3619','get','get','0','0','0.2','G300','1','*'),
('3620','get the','get the','0','1','1.2333','G300','1','*'),
('3621','get the following','get the following','0','1','1.5667','G31452','1','*'),
('3622','if','if','0','0','0.1333','I100','1','*'),
('3623','if you','if you','0','1','1.2','I100','1','*'),
('3624','if you want','if you want','0','1','1.3667','I153','1','*'),
('3625','let\'s','let','0','0','0.3333','L320','1','*'),
('3626','let\'s check','let check','0','1','1.3667','L320','1','*'),
('3627','let\'s check them','let check them','0','1','1.5333','L3235','1','*'),
('3628','module designs','module designs','0','1','1.4667','M343252','1','*'),
('3629','module designs 2','module designs 2','0','1','1.5333','M343252','1','*'),
('3630','module designs available','module designs available','0','1','1.8','M3432521414','1','*'),
('3631','module if','module if','0','1','1.3','M341','1','*'),
('3632','module if you','module if you','0','1','1.4333','M341','1','*'),
('3633','module parameter','module parameter','0','1','1.5333','M3416536','1','*'),
('3634','module parameter let\'s','module parameter let','0','1','1.7333','M3416536432','1','*'),
('3635','module suffixes','module suffixes','0','1','1.5','M34212','1','*'),
('3636','module will','module will','0','1','1.3667','M340','1','*'),
('3637','module will use','module will use','0','1','1.5','M342','1','*'),
('3638','name','name','0','0','0.2667','N000','1','*'),
('3639','name as','name as','0','1','1.2333','N200','1','*'),
('3640','name as a','name as a','0','1','1.3','N200','1','*'),
('3641','name slider1-ms','name slider1-ms','0','1','1.5','N243652','1','*'),
('3642','name slider1-ms suffix','name slider1-ms suffix','0','1','1.7333','N24365212','1','*'),
('3643','name testimonials-ms','name testimonials-ms','0','1','1.6667','N32354252','1','*'),
('3644','name testimonials-ms alternative-ms','name testimonials-ms alternative-ms','0','1','2','N3235425243653152','1','*'),
('3645','name testimonials-ms suffix','name testimonials-ms suffix','0','1','1.9','N3235425212','1','*'),
('3646','otherwise','otherwise','0','0','0.6','O362','1','*'),
('3647','otherwise a','otherwise a','0','1','1.3667','O362','1','*'),
('3648','otherwise a module','otherwise a module','0','1','1.6','O362534','1','*'),
('3649','parameter','parameter','0','0','0.6','P6536','1','*'),
('3650','parameter let\'s','parameter let','0','1','1.5','P6536432','1','*'),
('3651','parameter let\'s check','parameter let check','0','1','1.7','P6536432','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3652','slider1-ms','slider1-ms','0','0','0.6667','S43652','1','*'),
('3653','slider1-ms suffix','slider1-ms suffix','0','1','1.5667','S4365212','1','*'),
('3654','slider1-ms suffix name','slider1-ms suffix name','0','1','1.7333','S43652125','1','*'),
('3655','slides','slides','0','0','0.4','S432','1','*'),
('3656','slides otherwise','slides otherwise','0','1','1.5333','S432362','1','*'),
('3657','slides otherwise a','slides otherwise a','0','1','1.6','S432362','1','*'),
('3658','styles','styles','0','0','0.4','S342','1','*'),
('3659','styles suffix','styles suffix','0','1','1.4333','S34212','1','*'),
('3660','styles suffix name','styles suffix name','0','1','1.6','S342125','1','*'),
('3661','suffix','suffix','0','0','0.4','S120','1','*'),
('3662','suffix name','suffix name','0','1','1.3667','S125','1','*'),
('3663','suffix name as','suffix name as','0','1','1.4667','S1252','1','*'),
('3664','suffix name slider1-ms','suffix name slider1-ms','0','1','1.7333','S125243652','1','*'),
('3665','suffix name testimonials-ms','suffix name testimonials-ms','0','1','1.9','S12532354252','1','*'),
('3666','suffixes','suffixes','0','0','0.5333','S120','1','*'),
('3667','suffixes for','suffixes for','0','1','1.4','S1216','1','*'),
('3668','suffixes for dj-imageslider','suffixes for dj-imageslider','0','1','1.9','S12163252436','1','*'),
('3669','testimonials-ms','testimonials-ms','0','0','1','T2354252','1','*'),
('3670','testimonials-ms alternative-ms','testimonials-ms alternative-ms','0','1','2','T235425243653152','1','*'),
('3671','testimonials-ms suffix','testimonials-ms suffix','0','1','1.7333','T235425212','1','*'),
('3672','testimonials-ms suffix name','testimonials-ms suffix name','0','1','1.9','T2354252125','1','*'),
('3673','that you','that you','0','1','1.2667','T000','1','*'),
('3674','that you can','that you can','0','1','1.4','T250','1','*'),
('3675','the','the','0','0','0.2','T000','1','*'),
('3676','the default','the default','0','1','1.3667','T143','1','*'),
('3677','the default css','the default css','0','1','1.5','T1432','1','*'),
('3678','the following','the following','0','1','1.4333','T1452','1','*'),
('3679','the following suffixes','the following suffixes','0','1','1.7333','T145212','1','*'),
('3680','the following view','the following view','0','1','1.6','T14521','1','*'),
('3681','them','them','0','0','0.2667','T500','1','*'),
('3682','them all','them all','0','1','1.2667','T540','1','*'),
('3683','them all 1','them all 1','0','1','1.3333','T540','1','*'),
('3684','there','there','0','0','0.3333','T600','1','*'),
('3685','there are','there are','0','1','1.3','T600','1','*'),
('3686','there are additional','there are additional','0','1','1.6667','T6354','1','*'),
('3687','to get','to get','0','1','1.2','T230','1','*'),
('3688','to get the','to get the','0','1','1.3333','T230','1','*'),
('3689','use','use','0','0','0.2','U200','1','*'),
('3690','use the','use the','0','1','1.2333','U230','1','*'),
('3691','use the default','use the default','0','1','1.5','U23143','1','*'),
('3692','use the following','use the following','0','1','1.5667','U231452','1','*'),
('3693','view','view','0','0','0.2667','V000','1','*'),
('3694','view for','view for','0','1','1.2667','V600','1','*'),
('3695','view for slides','view for slides','0','1','1.5','V62432','1','*'),
('3696','want','want','0','0','0.2667','W530','1','*'),
('3697','want to','want to','0','1','1.2333','W530','1','*'),
('3698','want to get','want to get','0','1','1.3667','W5323','1','*'),
('3699','will','will','0','0','0.2667','W400','1','*'),
('3700','will use','will use','0','1','1.2667','W420','1','*'),
('3701','will use the','will use the','0','1','1.4','W423','1','*');
INSERT INTO `#__finder_terms` VALUES 
('3702','you can','you can','0','1','1.2333','Y250','1','*'),
('3703','you can control','you can control','0','1','1.5','Y2525364','1','*'),
('3704','you want','you want','0','1','1.2667','Y530','1','*'),
('3705','you want to','you want to','0','1','1.3667','Y530','1','*'),
('4452','icon-th-large icon-th','icon-th-large icon-th','0','1','1.7','I25346253','1','*'),
('4453','icon-th-large icon-th icon-th-list','icon-th-large icon-th icon-th-list','0','1','2','I25346253253423','1','*'),
('4454','icon-th-list','icon-th-list','0','0','0.8','I253423','1','*'),
('4455','icon-th-list icon-ok','icon-th-list icon-ok','0','1','1.6667','I253423252','1','*'),
('4456','icon-th-list icon-ok icon-remove','icon-th-list icon-ok icon-remove','0','1','2','I2534232525651','1','*'),
('4457','icon-thumbs-down','icon-thumbs-down','0','0','1','I25351235','1','*'),
('4458','icon-thumbs-down icon-hand-right','icon-thumbs-down icon-hand-right','0','1','2','I25351235253623','1','*'),
('4459','icon-thumbs-down icon-hand-right icon-hand-left','icon-thumbs-down icon-hand-right icon-hand-left','0','1','2','I25351235253623253413','1','*'),
('4460','icon-thumbs-up','icon-thumbs-up','0','0','0.9333','I2535121','1','*'),
('4461','icon-thumbs-up icon-thumbs-down','icon-thumbs-up icon-thumbs-down','0','1','2','I253512125351235','1','*'),
('4462','icon-thumbs-up icon-thumbs-down icon-hand-right','icon-thumbs-up icon-thumbs-down icon-hand-right','0','1','2','I253512125351235253623','1','*'),
('4463','icon-time','icon-time','0','0','0.6','I2535','1','*'),
('4464','icon-time icon-road','icon-time icon-road','0','1','1.6333','I25352563','1','*'),
('4465','icon-time icon-road icon-download-alt','icon-time icon-road icon-download-alt','0','1','2','I2535256325354343','1','*'),
('4466','icon-tint','icon-tint','0','0','0.6','I25353','1','*'),
('4467','icon-tint icon-edit','icon-tint icon-edit','0','1','1.6333','I25353253','1','*'),
('4468','icon-tint icon-edit icon-share','icon-tint icon-edit icon-share','0','1','2','I253532532526','1','*'),
('4469','icon-tower','icon-tower','0','0','0.6667','I2536','1','*'),
('4470','icon-tower icon-stats','icon-tower icon-stats','0','1','1.7','I253625232','1','*'),
('4471','icon-tower icon-stats icon-sd-video','icon-tower icon-stats icon-sd-video','0','1','2','I25362523252313','1','*'),
('4472','icon-transfer','icon-transfer','0','0','0.8667','I25365216','1','*'),
('4473','icon-transfer icon-cutlery','icon-transfer icon-cutlery','0','1','1.8667','I25365216252346','1','*'),
('4474','icon-transfer icon-cutlery icon-header','icon-transfer icon-cutlery icon-header','0','1','2','I253652162523462536','1','*'),
('4475','icon-trash','icon-trash','0','0','0.6667','I25362','1','*'),
('4476','icon-trash icon-home','icon-trash icon-home','0','1','1.6667','I253625','1','*'),
('4477','icon-trash icon-home icon-file','icon-trash icon-home icon-file','0','1','2','I2536252514','1','*'),
('4478','icon-tree-conifer','icon-tree-conifer','0','0','1','I25362516','1','*'),
('4479','icon-tree-conifer icon-tree-deciduous','icon-tree-conifer icon-tree-deciduous','0','1','2','I2536251625363232','1','*'),
('4480','icon-tree-conifer icon-tree-deciduous top','icon-tree-conifer icon-tree-deciduous top','0','1','2','I253625162536323231','1','*'),
('4481','icon-tree-deciduous','icon-tree-deciduous','0','0','1','I25363232','1','*'),
('4482','icon-tree-deciduous top','icon-tree-deciduous top','0','1','1.7667','I2536323231','1','*'),
('4483','icon-tree-deciduous top contact','icon-tree-deciduous top contact','0','1','2','I253632323125323','1','*'),
('4484','icon-unchecked','icon-unchecked','0','0','0.9333','I2523','1','*'),
('4485','icon-unchecked icon-expand','icon-unchecked icon-expand','0','1','1.8667','I2523252153','1','*'),
('4486','icon-unchecked icon-expand icon-collapse-down','icon-unchecked icon-expand icon-collapse-down','0','1','2','I252325215325241235','1','*'),
('4487','icon-upload','icon-upload','0','0','0.7333','I25143','1','*'),
('4488','icon-upload icon-inbox','icon-upload icon-inbox','0','1','1.7333','I251432512','1','*'),
('4489','icon-upload icon-inbox icon-play-circle','icon-upload icon-inbox icon-play-circle','0','1','2','I2514325125142624','1','*'),
('4490','icon-usd','icon-usd','0','0','0.5333','I2523','1','*'),
('4491','icon-usd icon-gbp','icon-usd icon-gbp','0','1','1.5667','I25232521','1','*'),
('4492','icon-usd icon-gbp icon-sort','icon-usd icon-gbp icon-sort','0','1','1.9','I2523252125263','1','*'),
('4493','icon-user','icon-user','0','0','0.6','I2526','1','*'),
('4494','icon-user icon-film','icon-user icon-film','0','1','1.6333','I252625145','1','*'),
('4495','icon-user icon-film icon-th-large','icon-user icon-film icon-th-large','0','1','2','I252625145253462','1','*'),
('4496','icon-volume-down','icon-volume-down','0','0','1','I2514535','1','*'),
('4497','icon-volume-down icon-volume-up','icon-volume-down icon-volume-up','0','1','2','I2514535251451','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4498','icon-volume-down icon-volume-up icon-qrcode','icon-volume-down icon-volume-up icon-qrcode','0','1','2','I2514535251451252623','1','*'),
('4499','icon-volume-off','icon-volume-off','0','0','1','I251451','1','*'),
('4500','icon-volume-off icon-volume-down','icon-volume-off icon-volume-down','0','1','2','I2514512514535','1','*'),
('4501','icon-volume-off icon-volume-down icon-volume-up','icon-volume-off icon-volume-down icon-volume-up','0','1','2','I2514512514535251451','1','*'),
('4502','icon-volume-up','icon-volume-up','0','0','0.9333','I251451','1','*'),
('4503','icon-volume-up icon-qrcode','icon-volume-up icon-qrcode','0','1','1.8667','I251451252623','1','*'),
('4504','icon-volume-up icon-qrcode icon-barcode','icon-volume-up icon-qrcode icon-barcode','0','1','2','I251451252623251623','1','*'),
('4505','icon-warning-sign','icon-warning-sign','0','0','1','I256525','1','*'),
('4506','icon-warning-sign icon-plane','icon-warning-sign icon-plane','0','1','1.9333','I25652525145','1','*'),
('4507','icon-warning-sign icon-plane icon-calendar','icon-warning-sign icon-plane icon-calendar','0','1','2','I256525251452524536','1','*'),
('4508','icon-wrench','icon-wrench','0','0','0.7333','I25652','1','*'),
('4509','icon-wrench icon-tasks','icon-wrench icon-tasks','0','1','1.7333','I25652532','1','*'),
('4510','icon-wrench icon-tasks icon-filter','icon-wrench icon-tasks icon-filter','0','1','2','I2565253251436','1','*'),
('4511','icon-zoom-in','icon-zoom-in','0','0','0.8','I2525','1','*'),
('4512','icon-zoom-in icon-zoom-out','icon-zoom-in icon-zoom-out','0','1','1.8667','I252525253','1','*'),
('4513','icon-zoom-in icon-zoom-out icon-off','icon-zoom-in icon-zoom-out icon-off','0','1','2','I252525253251','1','*'),
('4514','icon-zoom-out','icon-zoom-out','0','0','0.8667','I25253','1','*'),
('4515','icon-zoom-out icon-off','icon-zoom-out icon-off','0','1','1.7333','I25253251','1','*'),
('4516','icon-zoom-out icon-off icon-signal','icon-zoom-out icon-off icon-signal','0','1','2','I2525325125254','1','*'),
('4517','image','image','0','0','0.3333','I520','1','*'),
('4518','image borders','image borders','0','1','1.4333','I5216362','1','*'),
('4519','image borders headings','image borders headings','0','1','1.7333','I5216362352','1','*'),
('4520','in reprehenderit read','in reprehenderit read','0','1','1.7','I5616536363','1','*'),
('4521','integer','integer','0','0','0.4667','I5326','1','*'),
('4522','integer posuere','integer posuere','0','1','1.5','I5326126','1','*'),
('4523','integer posuere erat','integer posuere erat','0','1','1.6667','I53261263','1','*'),
('4524','ipsum duis','ipsum duis','0','1','1.3333','I12532','1','*'),
('4525','ipsum duis tincidunt','ipsum duis tincidunt','0','1','1.6667','I12532352353','1','*'),
('4526','ipsum ordered','ipsum ordered','0','1','1.4333','I1256363','1','*'),
('4527','ipsum ordered lists','ipsum ordered lists','0','1','1.6333','I12563634232','1','*'),
('4528','ipsum read','ipsum read','0','1','1.3333','I12563','1','*'),
('4529','ipsum read more','ipsum read more','0','1','1.5','I1256356','1','*'),
('4530','ipsumdolor','ipsumdolor','0','0','0.6667','I125346','1','*'),
('4531','ipsumdolor sit','ipsumdolor sit','0','1','1.4667','I12534623','1','*'),
('4532','ipsumdolor sit amet','ipsumdolor sit amet','0','1','1.6333','I1253462353','1','*'),
('4533','is heading','is heading','0','1','1.3333','I2352','1','*'),
('4534','is heading five','is heading five','0','1','1.5','I23521','1','*'),
('4535','is heading four','is heading four','0','1','1.5','I235216','1','*'),
('4536','is heading one','is heading one','0','1','1.4667','I23525','1','*'),
('4537','is heading six','is heading six','0','1','1.4667','I2352','1','*'),
('4538','is heading three','is heading three','0','1','1.5333','I235236','1','*'),
('4539','is heading two','is heading two','0','1','1.4667','I23523','1','*'),
('4540','jimmy','jimmy','0','0','0.3333','J500','1','*'),
('4541','jimmy gessler','jimmy gessler','0','1','1.4333','J5246','1','*'),
('4542','jimmy gessler consectetur','jimmy gessler consectetur','0','1','1.8333','J524625236','1','*'),
('4543','john','john','0','0','0.2667','J500','1','*'),
('4544','john doe','john doe','0','1','1.2667','J530','1','*'),
('4545','john doe lorem','john doe lorem','0','1','1.4667','J53465','1','*'),
('4546','john doe unordered','john doe unordered','0','1','1.6','J5356363','1','*'),
('4547','just','just','0','0','0.2667','J300','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4548','just few','just few','0','1','1.2667','J310','1','*'),
('4549','just few words','just few words','0','1','1.4667','J31632','1','*'),
('4550','labore ut','labore ut','0','1','1.3','L163','1','*'),
('4551','labore ut enim','labore ut enim','0','1','1.4667','L1635','1','*'),
('4552','laboris nisi','laboris nisi','0','1','1.4','L16252','1','*'),
('4553','laboris nisi ut','laboris nisi ut','0','1','1.5','L162523','1','*'),
('4554','lacinia bibendum','lacinia bibendum','0','1','1.5333','L251535','1','*'),
('4555','lacinia bibendum felis','lacinia bibendum felis','0','1','1.7333','L251535142','1','*'),
('4556','leo','leo','0','0','0.2','L000','1','*'),
('4557','leo sed','leo sed','0','1','1.2333','L230','1','*'),
('4558','leo sed turpis','leo sed turpis','0','1','1.4667','L23612','1','*'),
('4559','lists','lists','0','0','0.3333','L232','1','*'),
('4560','lists duis','lists duis','0','1','1.3333','L23232','1','*'),
('4561','lists duis tincidunt','lists duis tincidunt','0','1','1.6667','L23232352353','1','*'),
('4562','lorem ipsumdolor','lorem ipsumdolor','0','1','1.5333','L65125346','1','*'),
('4563','lorem ipsumdolor sit','lorem ipsumdolor sit','0','1','1.6667','L6512534623','1','*'),
('4564','machine','machine','0','0','0.4667','M250','1','*'),
('4565','machine lorem','machine lorem','0','1','1.4333','M25465','1','*'),
('4566','machine lorem ipsum','machine lorem ipsum','0','1','1.6333','M25465125','1','*'),
('4567','magna aliqua analytics','magna aliqua analytics','0','1','1.7333','M25425432','1','*'),
('4568','magna aliqua just','magna aliqua just','0','1','1.5667','M25423','1','*'),
('4569','magna aliqua time','magna aliqua time','0','1','1.5667','M254235','1','*'),
('4570','magna aliqua worldwide','magna aliqua worldwide','0','1','1.7333','M2542643','1','*'),
('4571','mauris 02','mauris 02','0','1','1.3','M620','1','*'),
('4572','mauris 02 lorem','mauris 02 lorem','0','1','1.5','M62465','1','*'),
('4573','mauris 03','mauris 03','0','1','1.3','M620','1','*'),
('4574','mauris 03 lorem','mauris 03 lorem','0','1','1.5','M62465','1','*'),
('4575','mauris a','mauris a','0','1','1.2667','M620','1','*'),
('4576','mauris a text','mauris a text','0','1','1.4333','M62323','1','*'),
('4577','mauris b','mauris b','0','1','1.2667','M621','1','*'),
('4578','mauris b lorem','mauris b lorem','0','1','1.4667','M621465','1','*'),
('4579','mauris c','mauris c','0','1','1.2667','M620','1','*'),
('4580','mauris c lorem','mauris c lorem','0','1','1.4667','M62465','1','*'),
('4581','mauris colored','mauris colored','0','1','1.4667','M62463','1','*'),
('4582','mauris colored blocks','mauris colored blocks','0','1','1.7','M62463142','1','*'),
('4583','mauris convallis','mauris convallis','0','1','1.5333','M625142','1','*'),
('4584','mauris convallis porta','mauris convallis porta','0','1','1.7333','M625142163','1','*'),
('4585','module greg','module greg','0','1','1.3667','M34262','1','*'),
('4586','module greg amaro','module greg amaro','0','1','1.5667','M3426256','1','*'),
('4587','module just','module just','0','1','1.3667','M3423','1','*'),
('4588','module just few','module just few','0','1','1.5','M34231','1','*'),
('4589','module our','module our','0','1','1.3333','M346','1','*'),
('4590','module our cooks','module our cooks','0','1','1.5333','M3462','1','*'),
('4591','module peterborough','module peterborough','0','1','1.6333','M34136162','1','*'),
('4592','module peterborough uk','module peterborough uk','0','1','1.7333','M34136162','1','*'),
('4593','morbi suscipit','morbi suscipit','0','1','1.4667','M61213','1','*'),
('4594','morbi suscipit nisl','morbi suscipit nisl','0','1','1.6333','M61213524','1','*'),
('4595','more button','more button','0','1','1.3667','M6135','1','*'),
('4596','more button read','more button read','0','1','1.5333','M613563','1','*'),
('4597','more glyphicon','more glyphicon','0','1','1.4667','M624125','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4598','more glyphicon font','more glyphicon font','0','1','1.6333','M624125153','1','*'),
('4599','more just','more just','0','1','1.3','M623','1','*'),
('4600','more just few','more just few','0','1','1.4333','M6231','1','*'),
('4601','more read','more read','0','1','1.3','M630','1','*'),
('4602','more read more','more read more','0','1','1.4667','M6356','1','*'),
('4603','more social','more social','0','1','1.3667','M624','1','*'),
('4604','more social module','more social module','0','1','1.6','M624534','1','*'),
('4605','nbsp','nbsp','0','0','0.2667','N121','1','*'),
('4606','nbsp icon-asterisk','nbsp icon-asterisk','0','1','1.6','N121252362','1','*'),
('4607','nbsp icon-asterisk icon-plus','nbsp icon-asterisk icon-plus','0','1','1.9333','N1212523625142','1','*'),
('4608','nec sodales','nec sodales','0','1','1.3667','N2342','1','*'),
('4609','nec sodales tellus','nec sodales tellus','0','1','1.6','N2342342','1','*'),
('4610','nec sodalestellus','nec sodalestellus','0','1','1.5667','N2342342','1','*'),
('4611','nec sodalestellus aenean','nec sodalestellus aenean','0','1','1.8','N23423425','1','*'),
('4612','nisl odio','nisl odio','0','1','1.3','N243','1','*'),
('4613','nisl odio nec','nisl odio nec','0','1','1.4333','N24352','1','*'),
('4614','numered','numered','0','0','0.4667','N630','1','*'),
('4615','numered blocks','numered blocks','0','1','1.4667','N63142','1','*'),
('4616','numered blocks 01','numered blocks 01','0','1','1.5667','N63142','1','*'),
('4617','nunc sit','nunc sit','0','1','1.2667','N230','1','*'),
('4618','nunc sit amet','nunc sit amet','0','1','1.4333','N2353','1','*'),
('4619','odio nec','odio nec','0','1','1.2667','O352','1','*'),
('4620','odio nec sodales','odio nec sodales','0','1','1.5333','O352342','1','*'),
('4621','odio nec sodalestellus','odio nec sodalestellus','0','1','1.7333','O352342342','1','*'),
('4622','one','one','0','0','0.2','O500','1','*'),
('4623','one h1','one h1','0','1','1.2','O500','1','*'),
('4624','one h1 lorem','one h1 lorem','0','1','1.4','O5465','1','*'),
('4625','ordered','ordered','0','0','0.4667','O6363','1','*'),
('4626','ordered lists','ordered lists','0','1','1.4333','O63634232','1','*'),
('4627','ordered lists duis','ordered lists duis','0','1','1.6','O6363423232','1','*'),
('4628','our','our','0','0','0.2','O600','1','*'),
('4629','our cooks','our cooks','0','1','1.3','O620','1','*'),
('4630','our cooks module','our cooks module','0','1','1.5333','O62534','1','*'),
('4631','peterborough','peterborough','0','0','0.8','P36162','1','*'),
('4632','peterborough uk','peterborough uk','0','1','1.5','P36162','1','*'),
('4633','peterborough uk email','peterborough uk email','0','1','1.7','P3616254','1','*'),
('4634','porta lacinia','porta lacinia','0','1','1.4333','P63425','1','*'),
('4635','porta lacinia bibendum','porta lacinia bibendum','0','1','1.7333','P634251535','1','*'),
('4636','posuere erat','posuere erat','0','1','1.4','P263','1','*'),
('4637','posuere erat a','posuere erat a','0','1','1.4667','P263','1','*'),
('4638','quis sapien','quis sapien','0','1','1.3667','Q150','1','*'),
('4639','quis sapien suscipit','quis sapien suscipit','0','1','1.6667','Q15213','1','*'),
('4640','read','read','0','0','0.2667','R300','1','*'),
('4641','read more','read more','0','1','1.3','R356','1','*'),
('4642','read more button','read more button','0','1','1.5333','R356135','1','*'),
('4643','read more glyphicon','read more glyphicon','0','1','1.6333','R35624125','1','*'),
('4644','read more just','read more just','0','1','1.4667','R35623','1','*'),
('4645','read more read','read more read','0','1','1.4667','R3563','1','*'),
('4646','read more social','read more social','0','1','1.5333','R35624','1','*'),
('4647','reprehenderit read','reprehenderit read','0','1','1.6','R16536363','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4648','reprehenderit read more','reprehenderit read more','0','1','1.7667','R1653636356','1','*'),
('4649','sapien suscipit','sapien suscipit','0','1','1.5','S15213','1','*'),
('4650','sapien suscipit mauris','sapien suscipit mauris','0','1','1.7333','S15213562','1','*'),
('4651','sed do eimod','sed do eimod','0','1','1.4','S353','1','*'),
('4652','sed turpis','sed turpis','0','1','1.3333','S3612','1','*'),
('4653','sed turpis convallis','sed turpis convallis','0','1','1.6667','S36125142','1','*'),
('4654','service','service','0','0','0.4667','S612','1','*'),
('4655','service lorem','service lorem','0','1','1.4333','S612465','1','*'),
('4656','service lorem ipsum','service lorem ipsum','0','1','1.6333','S612465125','1','*'),
('4657','sit amet condimentum','sit amet condimentum','0','1','1.6667','S353253535','1','*'),
('4658','sit amet ipsum','sit amet ipsum','0','1','1.4667','S353125','1','*'),
('4659','six','six','0','0','0.2','S000','1','*'),
('4660','six h6','six h6','0','1','1.2','S000','1','*'),
('4661','six h6 lorem','six h6 lorem','0','1','1.4','S465','1','*'),
('4662','social','social','0','0','0.4','S400','1','*'),
('4663','social module','social module','0','1','1.4333','S4534','1','*'),
('4664','social module our','social module our','0','1','1.5667','S45346','1','*'),
('4665','sodales tellus','sodales tellus','0','1','1.4667','S342342','1','*'),
('4666','sodales tellus aenean','sodales tellus aenean','0','1','1.7','S3423425','1','*'),
('4667','sodalestellus','sodalestellus','0','0','0.8667','S342342','1','*'),
('4668','sodalestellus aenean','sodalestellus aenean','0','1','1.6667','S3423425','1','*'),
('4669','sodalestellus aenean quis','sodalestellus aenean quis','0','1','1.8333','S34234252','1','*'),
('4670','suscipit mauris','suscipit mauris','0','1','1.5','S13562','1','*'),
('4671','suscipit mauris 02','suscipit mauris 02','0','1','1.6','S13562','1','*'),
('4672','suscipit mauris 03','suscipit mauris 03','0','1','1.6','S13562','1','*'),
('4673','suscipit mauris a','suscipit mauris a','0','1','1.5667','S13562','1','*'),
('4674','suscipit mauris b','suscipit mauris b','0','1','1.5667','S135621','1','*'),
('4675','suscipit mauris c','suscipit mauris c','0','1','1.5667','S13562','1','*'),
('4676','suscipit mauris colored','suscipit mauris colored','0','1','1.7667','S13562463','1','*'),
('4677','suscipit mauris convallis','suscipit mauris convallis','0','1','1.8333','S135625142','1','*'),
('4678','suscipit nisl','suscipit nisl','0','1','1.4333','S13524','1','*'),
('4679','suscipit nisl odio','suscipit nisl odio','0','1','1.6','S135243','1','*'),
('4680','tellus aenean','tellus aenean','0','1','1.4333','T425','1','*'),
('4681','tellus aenean quis','tellus aenean quis','0','1','1.6','T4252','1','*'),
('4682','tempor greg','tempor greg','0','1','1.3667','T516262','1','*'),
('4683','tempor greg amaro','tempor greg amaro','0','1','1.5667','T51626256','1','*'),
('4684','tempor jimmy','tempor jimmy','0','1','1.4','T51625','1','*'),
('4685','tempor jimmy gessler','tempor jimmy gessler','0','1','1.6667','T51625246','1','*'),
('4686','text','text','0','0','0.2667','T230','1','*'),
('4687','text goes','text goes','0','1','1.3','T232','1','*'),
('4688','text goes here','text goes here','0','1','1.4667','T2326','1','*'),
('4689','this','this','0','0','0.2667','T200','1','*'),
('4690','this is','this is','0','1','1.2333','T200','1','*'),
('4691','this is heading','this is heading','0','1','1.5','T2352','1','*'),
('4692','three','three','0','0','0.3333','T600','1','*'),
('4693','three h3','three h3','0','1','1.2667','T600','1','*'),
('4694','three h3 lorem','three h3 lorem','0','1','1.4667','T6465','1','*'),
('4695','time','time','0','0','0.2667','T500','1','*'),
('4696','time machine','time machine','0','1','1.4','T525','1','*'),
('4697','time machine lorem','time machine lorem','0','1','1.6','T525465','1','*');
INSERT INTO `#__finder_terms` VALUES 
('4698','tincidunt nunc','tincidunt nunc','0','1','1.4667','T5235352','1','*'),
('4699','tincidunt nunc sit','tincidunt nunc sit','0','1','1.6','T52353523','1','*'),
('4700','top','top','0','0','0.2','T100','1','*'),
('4701','top contact','top contact','0','1','1.3667','T125323','1','*'),
('4702','top contact module','top contact module','0','1','1.6','T125323534','1','*'),
('4703','turpis convallis','turpis convallis','0','1','1.5333','T6125142','1','*'),
('4704','turpis convallis sit','turpis convallis sit','0','1','1.6667','T61251423','1','*'),
('4705','two','two','0','0','0.2','T000','1','*'),
('4706','two h2','two h2','0','1','1.2','T000','1','*'),
('4707','two h2 lorem','two h2 lorem','0','1','1.4','T465','1','*'),
('4708','typography','typography','0','0','0.6667','T1261','1','*'),
('4709','uk','uk','0','0','0.1333','U200','1','*'),
('4710','uk email','uk email','0','1','1.2667','U254','1','*'),
('4711','uk email +44','uk email +44','0','1','1.4','U254','1','*'),
('4712','ullamco laboris nisi','ullamco laboris nisi','0','1','1.6667','U452416252','1','*'),
('4713','unordered','unordered','0','0','0.6','U56363','1','*'),
('4714','unordered lists','unordered lists','0','1','1.5','U563634232','1','*'),
('4715','unordered lists duis','unordered lists duis','0','1','1.6667','U56363423232','1','*'),
('4716','ut labore ut','ut labore ut','0','1','1.4','U34163','1','*'),
('4717','vehicula morbi','vehicula morbi','0','1','1.4667','V24561','1','*'),
('4718','vehicula morbi suscipit','vehicula morbi suscipit','0','1','1.7667','V24561213','1','*'),
('4719','viverra leo','viverra leo','0','1','1.3667','V640','1','*'),
('4720','viverra leo sed','viverra leo sed','0','1','1.5','V6423','1','*'),
('4721','words','words','0','0','0.3333','W632','1','*'),
('4722','words lorem','words lorem','0','1','1.3667','W632465','1','*'),
('4723','words lorem ipsum','words lorem ipsum','0','1','1.5667','W632465125','1','*'),
('4724','words module','words module','0','1','1.4','W632534','1','*'),
('4725','words module just','words module just','0','1','1.5667','W63253423','1','*'),
('4726','worldwide','worldwide','0','0','0.6','W643','1','*'),
('4727','worldwide service','worldwide service','0','1','1.5667','W6432612','1','*'),
('4728','worldwide service lorem','worldwide service lorem','0','1','1.7667','W6432612465','1','*');

DROP TABLE IF EXISTS #__finder_terms_common;
CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_terms_common` VALUES 
('a','en'),
('about','en'),
('after','en'),
('ago','en'),
('all','en'),
('am','en'),
('an','en'),
('and','en'),
('ani','en'),
('any','en'),
('are','en'),
('aren\'t','en'),
('as','en'),
('at','en'),
('be','en'),
('but','en'),
('by','en'),
('for','en'),
('from','en'),
('get','en'),
('go','en'),
('how','en'),
('if','en'),
('in','en'),
('into','en'),
('is','en'),
('isn\'t','en'),
('it','en'),
('its','en'),
('me','en'),
('more','en'),
('most','en'),
('must','en'),
('my','en'),
('new','en'),
('no','en'),
('none','en'),
('not','en'),
('noth','en'),
('nothing','en'),
('of','en'),
('off','en'),
('often','en'),
('old','en'),
('on','en'),
('onc','en'),
('once','en'),
('onli','en'),
('only','en'),
('or','en');
INSERT INTO `#__finder_terms_common` VALUES 
('other','en'),
('our','en'),
('ours','en'),
('out','en'),
('over','en'),
('page','en'),
('she','en'),
('should','en'),
('small','en'),
('so','en'),
('some','en'),
('than','en'),
('thank','en'),
('that','en'),
('the','en'),
('their','en'),
('theirs','en'),
('them','en'),
('then','en'),
('there','en'),
('these','en'),
('they','en'),
('this','en'),
('those','en'),
('thus','en'),
('time','en'),
('times','en'),
('to','en'),
('too','en'),
('true','en'),
('under','en'),
('until','en'),
('up','en'),
('upon','en'),
('use','en'),
('user','en'),
('users','en'),
('veri','en'),
('version','en'),
('very','en'),
('via','en'),
('want','en'),
('was','en'),
('way','en'),
('were','en'),
('what','en'),
('when','en'),
('where','en'),
('whi','en'),
('which','en');
INSERT INTO `#__finder_terms_common` VALUES 
('who','en'),
('whom','en'),
('whose','en'),
('why','en'),
('wide','en'),
('will','en'),
('with','en'),
('within','en'),
('without','en'),
('would','en'),
('yes','en'),
('yet','en'),
('you','en'),
('your','en'),
('yours','en');

DROP TABLE IF EXISTS #__finder_tokens;
CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT '',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_tokens_aggregate;
CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT '',
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__finder_types;
CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_types` VALUES 
('1','Tag',''),
('2','Category',''),
('3','Contact',''),
('4','Article',''),
('5','News Feed',''),
('6','Web Link','');

DROP TABLE IF EXISTS #__languages;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` mediumtext NOT NULL,
  `metadesc` mediumtext NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `#__languages` VALUES 
('1','0','en-GB','English (UK)','English (UK)','en','en','','','','','1','1','1'),
('2','0','de-DE','German (DE)','German (DE)','de','de','','','','','1','1','0');

DROP TABLE IF EXISTS #__menu;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(400) NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` mediumtext NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`(100),`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_alias` (`alias`(100)),
  KEY `idx_path` (`path`(100))
) AUTO_INCREMENT=815 DEFAULT CHARSET=utf8;

INSERT INTO `#__menu` VALUES 
('1','','Menu_Item_Root','root','','','','','1','0','0','0','0','0000-00-00 00:00:00','0','0','','0','','0','315','0','*','0'),
('2','main','com_banners','Banners','','Banners','index.php?option=com_banners','component','1','1','1','4','0','0000-00-00 00:00:00','0','0','class:banners','0','','85','94','0','*','1'),
('3','main','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component','1','2','2','4','0','0000-00-00 00:00:00','0','0','class:banners','0','','86','87','0','*','1'),
('4','main','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component','1','2','2','6','0','0000-00-00 00:00:00','0','0','class:banners-cat','0','','88','89','0','*','1'),
('5','main','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component','1','2','2','4','0','0000-00-00 00:00:00','0','0','class:banners-clients','0','','90','91','0','*','1'),
('6','main','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component','1','2','2','4','0','0000-00-00 00:00:00','0','0','class:banners-tracks','0','','92','93','0','*','1'),
('7','main','com_contact','Contacts','','Contacts','index.php?option=com_contact','component','1','1','1','8','0','0000-00-00 00:00:00','0','0','class:contact','0','','95','100','0','*','1'),
('8','main','com_contact_contacts','Contacts','','Contacts/Contacts','index.php?option=com_contact','component','1','7','2','8','0','0000-00-00 00:00:00','0','0','class:contact','0','','96','97','0','*','1'),
('9','main','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component','1','7','2','6','0','0000-00-00 00:00:00','0','0','class:contact-cat','0','','98','99','0','*','1'),
('10','main','com_messages','Messaging','','Messaging','index.php?option=com_messages','component','1','1','1','15','0','0000-00-00 00:00:00','0','0','class:messages','0','','101','104','0','*','1'),
('11','main','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component','1','10','2','15','0','0000-00-00 00:00:00','0','0','class:messages-add','0','','102','103','0','*','1'),
('13','main','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component','1','1','1','17','0','0000-00-00 00:00:00','0','0','class:newsfeeds','0','','105','110','0','*','1'),
('14','main','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component','1','13','2','17','0','0000-00-00 00:00:00','0','0','class:newsfeeds','0','','106','107','0','*','1'),
('15','main','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component','1','13','2','6','0','0000-00-00 00:00:00','0','0','class:newsfeeds-cat','0','','108','109','0','*','1'),
('16','main','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component','1','1','1','24','0','0000-00-00 00:00:00','0','0','class:redirect','0','','117','118','0','*','1'),
('17','main','com_search','Basic Search','','Basic Search','index.php?option=com_search','component','1','1','1','19','0','0000-00-00 00:00:00','0','0','class:search','0','','115','116','0','*','1'),
('813','main','com_weblinks_categories','com-weblinks-categories','','com-weblinks/com-weblinks-categories','index.php?option=com_categories&extension=com_weblinks','component','1','811','2','21','0','0000-00-00 00:00:00','0','1','class:weblinks-cat','0','{}','312','313','0','','1'),
('812','main','com_weblinks_links','com-weblinks-links','','com-weblinks/com-weblinks-links','index.php?option=com_weblinks','component','1','811','2','21','0','0000-00-00 00:00:00','0','1','class:weblinks','0','{}','310','311','0','','1'),
('811','main','com_weblinks','com-weblinks','','com-weblinks','index.php?option=com_weblinks','component','1','1','1','21','0','0000-00-00 00:00:00','0','1','class:weblinks','0','{}','309','314','0','','1'),
('21','main','com_finder','Smart Search','','Smart Search','index.php?option=com_finder','component','1','1','1','27','0','0000-00-00 00:00:00','0','0','class:finder','0','','113','114','0','*','1'),
('22','main','com_joomlaupdate','Joomla! Update','','Joomla! Update','index.php?option=com_joomlaupdate','component','1','1','1','28','0','0000-00-00 00:00:00','0','0','class:joomlaupdate','0','','111','112','0','*','1'),
('435','mainmenu','Home','homepage','','homepage','index.php?option=com_content&view=article&id=73','component','1','1','1','22','0','0000-00-00 00:00:00','0','1',' ','0','{"show_title":"1","link_titles":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_associations":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/djmenu\\/icon1.png","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','1','2','1','*','0'),
('470','main','com_tags','com-tags','','com-tags','index.php?option=com_tags','component','1','1','1','29','0','0000-00-00 00:00:00','0','1','class:tags','0','','119','120','0','','1'),
('471','main','com_postinstall','Post-installation messages','','Post-installation messages','index.php?option=com_postinstall','component','1','1','1','32','0','0000-00-00 00:00:00','0','1','class:postinstall','0','','121','122','0','*','1'),
('479','mainmenu','Pages','pages','','pages','index.php?option=com_content&view=article&id=73','component','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/djmenu\\/icon2.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','25','76','0','*','0'),
('499','mainmenu','Languages','2014-05-13-19-05-45','','2014-05-13-19-05-45','','url','1','1','1','0','0','0000-00-00 00:00:00','0','1',' ','0','{"menu-anchor_title":"","menu-anchor_css":"","menu-anchor_rel":"","menu_image":"images\\/djmenu\\/icon4.png","menu_image_css":"","menu_text":1,"menu_show":1,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','77','82','0','*','0'),
('500','mainmenu','LTR Languages','2014-05-13-19-06-11','','2014-05-13-19-05-45/2014-05-13-19-06-11','?direction=ltr','url','1','499','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','78','79','0','*','0'),
('501','mainmenu','RTL Languages','2014-05-13-19-06-34','','2014-05-13-19-05-45/2014-05-13-19-06-34','?direction=rtl','url','1','499','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','80','81','0','*','0'),
('502','mainmenu','Features','features','','features','','separator','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"images\\/djmenu\\/icon5.png","menu_text":1}','3','16','0','*','0'),
('503','mainmenu','Typography','typography','','features/typography','https://templates.joomla-monster.com/joomla30/jm-services/en/features/typography','url','1','502','2','0','0','0000-00-00 00:00:00','0','1',' ','0','{"menu-anchor_title":"","menu-anchor_css":"","menu-anchor_rel":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','10','11','0','*','0'),
('514','mainmenu','Examples','examples','','examples','index.php?option=com_content&view=article&id=133','component','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/djmenu\\/icon3.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','17','24','0','*','0'),
('515','hiddenmenu','Newsflash','newsflash','','newsflash','index.php?option=com_content&view=category&layout=blog&id=88','component','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"2","num_columns":"2","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','123','124','0','*','0'),
('516','mainmenu','Contact Us','contact','','contact','index.php?option=com_contact&view=contact&id=9','component','1','1','1','8','0','0000-00-00 00:00:00','0','1',' ','0','{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_tags":"","show_info":"","show_name":"","show_position":"","show_email":"","add_mailto_link":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_image":"","allow_vcard":"","show_misc":"","show_articles":"","articles_display_num":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/djmenu\\/icon6.png","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','83','84','0','*','0'),
('519','mainmenu','Scheme Layouts','scheme-layouts','','pages/scheme-layouts','','separator','1','479','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','26','39','0','*','0'),
('520','mainmenu','Left-Content-Right','left-content-right','','pages/scheme-layouts/left-content-right','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1',' ','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_associations":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','27','28','0','*','0'),
('521','mainmenu','Left-Right-Content','left-right-content','just a note','pages/scheme-layouts/left-right-content','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1',' ','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_associations":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-column_break":"0","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-accesskey":""}','29','30','0','*','0'),
('522','mainmenu','Content-Left-Right','content-left-right','','pages/scheme-layouts/content-left-right','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','31','32','0','*','0'),
('523','mainmenu','Left-Content','left-content','','pages/scheme-layouts/left-content','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','33','34','0','*','0'),
('524','mainmenu','Content-Right','content-right','','pages/scheme-layouts/content-right','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','35','36','0','*','0'),
('525','mainmenu','Content','content','','pages/scheme-layouts/content','index.php?option=com_content&view=article&id=73','component','1','519','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','37','38','0','*','0'),
('526','mainmenu','J! Content','joomla-content','','pages/joomla-content','','separator','1','479','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','40','57','0','*','0'),
('527','mainmenu','Single Article','single-article','','pages/joomla-content/single-article','index.php?option=com_content&view=article&id=111','component','1','526','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','41','42','0','*','0'),
('528','mainmenu','Blog - 2 columns','blog-2-columns','','pages/joomla-content/blog-2-columns','index.php?option=com_content&view=category&layout=blog&id=83','component','1','526','3','22','0','0000-00-00 00:00:00','0','1','','0','{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"0","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','43','44','0','*','0'),
('529','mainmenu','Blog - 1 column ','blog-1-column','','pages/joomla-content/blog-1-column','index.php?option=com_content&view=category&layout=blog&id=83','component','1','526','3','22','0','0000-00-00 00:00:00','0','1','','0','{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"0","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"1","num_links":"0","multi_column_order":"","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','45','46','0','*','0'),
('530','mainmenu','Category List','category-list','','pages/joomla-content/category-list','index.php?option=com_content&view=category&id=90','component','1','526','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"0","show_empty_categories":"","show_no_articles":"","show_category_heading_title":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','47','48','0','*','0'),
('531','mainmenu','Submit Article','submit-article','','pages/joomla-content/submit-article','index.php?option=com_content&view=form&layout=edit','component','1','526','3','22','0','0000-00-00 00:00:00','0','2','','0','{"enable_category":"0","catid":"9","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','49','50','0','*','0'),
('532','mainmenu','Tabs','tabs','','pages/joomla-content/tabs','index.php?option=com_content&view=article&id=112','component','1','526','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','51','52','0','*','0'),
('533','mainmenu','J! Other Pages','joomla-other-pages','','pages/joomla-other-pages','','separator','1','479','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','58','75','0','*','0'),
('534','mainmenu','Registration Form','registration-form','','pages/joomla-other-pages/registration-form','index.php?option=com_users&view=registration','component','1','533','3','25','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','59','60','0','*','0'),
('535','mainmenu','Login Form','login-form','','pages/joomla-other-pages/login-form','index.php?option=com_users&view=login','component','1','533','3','25','0','0000-00-00 00:00:00','0','1','','0','{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','61','62','0','*','0');
INSERT INTO `#__menu` VALUES 
('536','mainmenu','User Profile','user-profile','','pages/joomla-other-pages/user-profile','index.php?option=com_users&view=profile','component','1','533','3','25','0','0000-00-00 00:00:00','0','2','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','63','64','0','*','0'),
('538','mainmenu','Search Form','search-form','','pages/joomla-other-pages/search-form','index.php?option=com_search&view=search','component','1','533','3','19','0','0000-00-00 00:00:00','0','1','','0','{"search_areas":"","show_date":"","searchphrase":"0","ordering":"newest","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','65','66','0','*','0'),
('539','mainmenu','Smart Search','smart-search','','pages/joomla-other-pages/smart-search','index.php?option=com_finder&view=search','component','1','533','3','27','0','0000-00-00 00:00:00','0','1','','0','{"show_date_filters":"","show_advanced":"","expand_advanced":"","show_description":"","description_length":255,"show_url":"","show_pagination_limit":"","show_pagination":"","show_pagination_results":"","allow_empty_query":"0","show_suggested_query":"1","show_explained_query":"1","sort_order":"","sort_direction":"","show_feed":"0","show_feed_text":"0","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','67','68','0','*','0'),
('541','mainmenu','Single Contact','single-contact','','pages/joomla-other-pages/single-contact','index.php?option=com_contact&view=contact&id=10','component','1','533','3','8','0','0000-00-00 00:00:00','0','1','','0','{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_tags":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','69','70','0','*','0'),
('542','mainmenu','Accordion','accordion','','pages/joomla-content/accordion','index.php?Itemid=','alias','1','526','3','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"541","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','53','54','0','*','0'),
('562','mainmenu','Template Parameters','2014-06-25-09-39-35','','features/2014-06-25-09-39-35','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/general-info-ef4-framework-for-joomla-3-x/settings','url','1','502','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','4','5','0','*','0'),
('563','mainmenu','All Template\'s Positions','all-templates-positions','','features/all-templates-positions','https://templates.joomla-monster.com/joomla30/jm-services/en/features/all-templates-positions','url','1','502','2','0','0','0000-00-00 00:00:00','0','1',' ','0','{"menu-anchor_title":"","menu-anchor_css":"","menu-anchor_rel":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','6','7','0','*','0'),
('564','mainmenu','Module Suffixes','module-suffixes','','features/module-suffixes','https://templates.joomla-monster.com/joomla30/jm-services/en/features/module-suffixes','url','1','502','2','0','0','0000-00-00 00:00:00','0','1',' ','0','{"menu-anchor_title":"","menu-anchor_css":"","menu-anchor_rel":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','8','9','0','*','0'),
('566','mainmenu','Install Demo Copy','2014-06-25-09-56-46','','features/2014-06-25-09-56-46','http://www.joomla-monster.com/knowledge-base-area/general-questions/about-our-store/what-is-a-quickstart','url','1','502','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','12','13','0','*','0'),
('567','mainmenu','Joomla Templates','2014-06-25-09-58-22','','features/2014-06-25-09-58-22','http://www.joomla-monster.com/all-templates','url','1','502','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','14','15','0','*','0'),
('568','mainmenu','Culinary Theme','culinary-theme','','examples/culinary-theme','index.php?option=com_content&view=category&layout=blog&id=93','component','1','514','2','22','0','0000-00-00 00:00:00','0','1',' ','11','{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"6","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"0","show_pagination_results":"0","show_featured":"","article_layout":"_:default","show_title":"","link_titles":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_associations":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','20','21','0','*','0'),
('613','mainmenu','Dental Theme','dental-theme','','examples/dental-theme','index.php?option=com_content&view=article&id=73','component','1','514','2','22','0','0000-00-00 00:00:00','0','1',' ','14','{"show_title":"1","link_titles":"","show_intro":"","info_block_position":"","info_block_show_title":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_associations":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','22','23','0','*','0'),
('657','mainmenu','Error 404','error-404','','pages/joomla-other-pages/error-404','index.php?option=com_content&view=article&id=131','component','1','533','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"0","link_titles":"","show_intro":"","info_block_position":"","show_category":"0","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"0","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','71','72','0','*','0'),
('658','mainmenu','Offline Page','offline-page','','pages/joomla-other-pages/offline-page','index.php?option=com_content&view=article&id=132','component','1','533','3','22','0','0000-00-00 00:00:00','0','1','','0','{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','73','74','0','*','0'),
('659','mainmenuculinary','Home','homepage-culinary','','homepage-culinary','index.php?Itemid=','alias','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/culinary\\/djmenu\\/icon1.png","menu_text":1}','125','126','0','*','0'),
('660','mainmenuculinary','Features','features-culinary','','features-culinary','','separator','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"images\\/culinary\\/djmenu\\/icon2.png","menu_text":1}','127','140','0','*','0'),
('661','mainmenuculinary','Template Parameters','2014-06-25-09-39-35','','features-culinary/2014-06-25-09-39-35','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/general-info-ef4-framework-for-joomla-3-x/settings','url','1','660','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','128','129','0','*','0'),
('662','mainmenuculinary','All Template\'s Positions','all-templates-positions','','features-culinary/all-templates-positions','index.php?Itemid=','alias','1','660','2','22','0','0000-00-00 00:00:00','1','1','','0','{"aliasoptions":"563","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','130','131','0','*','0'),
('663','mainmenuculinary','Module Suffixes','module-suffixes','','features-culinary/module-suffixes','index.php?Itemid=','alias','1','660','2','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"564","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','132','133','0','*','0'),
('664','mainmenuculinary','Typography','typography','','features-culinary/typography','index.php?Itemid=','alias','1','660','2','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"503","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','134','135','0','*','0'),
('665','mainmenuculinary','Install Demo Copy','2014-06-25-09-56-46','','features-culinary/2014-06-25-09-56-46','http://www.joomla-monster.com/knowledge-base-area/general-questions/about-our-store/what-is-a-quickstart','url','1','660','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','136','137','0','*','0'),
('666','mainmenuculinary','Joomla Templates','2014-06-25-09-58-22','','features-culinary/2014-06-25-09-58-22','http://www.joomla-monster.com/all-templates','url','1','660','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','138','139','0','*','0'),
('667','mainmenuculinary','Examples','examples-culinary','','examples-culinary','index.php?Itemid=','alias','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"514","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/culinary\\/djmenu\\/icon3.png","menu_text":1}','141','148','0','*','0'),
('668','mainmenuculinary','Culinary Theme','culinary-theme','','examples-culinary/culinary-theme','index.php?Itemid=','alias','1','667','2','22','0','0000-00-00 00:00:00','0','1','','11','{"aliasoptions":"568","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','144','145','0','*','0'),
('669','mainmenuculinary','Dental Theme','dental-theme','','examples-culinary/dental-theme','index.php?Itemid=','alias','1','667','2','22','0','0000-00-00 00:00:00','0','1','','14','{"aliasoptions":"613","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','146','147','0','*','0'),
('670','mainmenuculinary','Pages','pages-culinary','','pages-culinary','index.php?Itemid=','alias','1','1','1','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"479","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/culinary\\/djmenu\\/icon4.png","menu_text":1}','149','198','0','*','0'),
('671','mainmenuculinary','Scheme Layouts','scheme-layouts','','pages-culinary/scheme-layouts','','separator','1','670','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','150','163','0','*','0'),
('672','mainmenuculinary','Left-Content-Right','left-content-right','','pages-culinary/scheme-layouts/left-content-right','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"520","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','151','152','0','*','0'),
('673','mainmenuculinary','Left-Right-Content','left-right-content','','pages-culinary/scheme-layouts/left-right-content','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"521","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','153','154','0','*','0'),
('674','mainmenuculinary','Content-Left-Right','content-left-right','','pages-culinary/scheme-layouts/content-left-right','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"522","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','155','156','0','*','0'),
('675','mainmenuculinary','Left-Content','left-content','','pages-culinary/scheme-layouts/left-content','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"523","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','157','158','0','*','0'),
('676','mainmenuculinary','Content-Right','content-right','','pages-culinary/scheme-layouts/content-right','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"524","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','159','160','0','*','0'),
('677','mainmenuculinary','Content','content','','pages-culinary/scheme-layouts/content','index.php?Itemid=','alias','1','671','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"525","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','161','162','0','*','0'),
('678','mainmenuculinary','J! Content','joomla-content','','pages-culinary/joomla-content','','separator','1','670','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','164','179','0','*','0'),
('679','mainmenuculinary','Single Article','single-article','','pages-culinary/joomla-content/single-article','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"527","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','165','166','0','*','0'),
('680','mainmenuculinary','Blog - 2 columns','blog-2-columns','','pages-culinary/joomla-content/blog-2-columns','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"528","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','167','168','0','*','0'),
('681','mainmenuculinary','Blog - 1 column ','blog-1-column','','pages-culinary/joomla-content/blog-1-column','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"529","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','169','170','0','*','0'),
('682','mainmenuculinary','Category List','category-list','','pages-culinary/joomla-content/category-list','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"530","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','171','172','0','*','0'),
('683','mainmenuculinary','Submit Article','submit-article','','pages-culinary/joomla-content/submit-article','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','2','','0','{"aliasoptions":"531","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','173','174','0','*','0'),
('684','mainmenuculinary','Tabs','tabs','','pages-culinary/joomla-content/tabs','index.php?Itemid=','alias','1','678','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"532","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','175','176','0','*','0'),
('685','mainmenuculinary','Accordion','accordion','','pages-culinary/joomla-content/accordion','index.php?Itemid=','alias','1','678','3','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"685","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','177','178','0','*','0'),
('686','mainmenuculinary','J! Other Pages','joomla-other-pages','','pages-culinary/joomla-other-pages','','separator','1','670','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','180','197','0','*','0'),
('687','mainmenuculinary','Registration Form','registration-form','','pages-culinary/joomla-other-pages/registration-form','index.php?Itemid=','alias','1','686','3','25','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"534","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','181','182','0','*','0'),
('688','mainmenuculinary','Login Form','login-form','','pages-culinary/joomla-other-pages/login-form','index.php?Itemid=','alias','1','686','3','25','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"535","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','183','184','0','*','0'),
('689','mainmenuculinary','User Profile','user-profile','','pages-culinary/joomla-other-pages/user-profile','index.php?Itemid=','alias','1','686','3','25','0','0000-00-00 00:00:00','0','2','','0','{"aliasoptions":"536","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','185','186','0','*','0'),
('690','mainmenuculinary','Search Form','search-form','','pages-culinary/joomla-other-pages/search-form','index.php?Itemid=','alias','1','686','3','19','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"538","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','187','188','0','*','0'),
('691','mainmenuculinary','Smart Search','smart-search','','pages-culinary/joomla-other-pages/smart-search','index.php?Itemid=','alias','1','686','3','27','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"539","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','189','190','0','*','0'),
('692','mainmenuculinary','Single Contact','single-contact','','pages-culinary/joomla-other-pages/single-contact','index.php?Itemid=','alias','1','686','3','8','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"541","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','191','192','0','*','0'),
('693','mainmenuculinary','Error 404','error-404','','pages-culinary/joomla-other-pages/error-404','index.php?Itemid=','alias','1','686','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"657","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','193','194','0','*','0'),
('694','mainmenuculinary','Offline Page','offline-page','','pages-culinary/joomla-other-pages/offline-page','index.php?Itemid=','alias','1','686','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"658","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','195','196','0','*','0');
INSERT INTO `#__menu` VALUES 
('695','mainmenuculinary','Languages','2014-05-13-19-05-48','','2014-05-13-19-05-48','','url','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/culinary\\/djmenu\\/icon5.png","menu_text":1}','199','204','0','*','0'),
('696','mainmenuculinary','LTR Languages','2014-05-13-19-06-11','','2014-05-13-19-05-48/2014-05-13-19-06-11','?direction=ltr','url','1','695','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','200','201','0','*','0'),
('697','mainmenuculinary','RTL Languages','2014-05-13-19-06-34','','2014-05-13-19-05-48/2014-05-13-19-06-34','?direction=rtl','url','1','695','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','202','203','0','*','0'),
('698','mainmenuculinary','Contact Us','contact-culinary','','contact-culinary','index.php?Itemid=','alias','1','1','1','8','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"516","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/culinary\\/djmenu\\/icon6.png","menu_text":1}','205','206','0','*','0'),
('739','mainmenudental','Home','homepage-dental','','homepage-dental','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','207','208','0','*','0'),
('740','mainmenudental','Features','features-dental','','features-dental','','separator','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','209','222','0','*','0'),
('741','mainmenudental','Template Parameters','2014-06-25-09-39-35','','features-dental/2014-06-25-09-39-35','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/general-info-ef4-framework-for-joomla-3-x/settings','url','1','740','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','210','211','0','*','0'),
('742','mainmenudental','All Template\'s Positions','all-templates-positions','','features-dental/all-templates-positions','index.php?Itemid=','alias','1','740','2','22','0','0000-00-00 00:00:00','1','1','','0','{"aliasoptions":"563","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','212','213','0','*','0'),
('743','mainmenudental','Module Suffixes','module-suffixes','','features-dental/module-suffixes','index.php?Itemid=','alias','1','740','2','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"564","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','214','215','0','*','0'),
('744','mainmenudental','Typography','typography','','features-dental/typography','index.php?Itemid=','alias','1','740','2','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"503","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','216','217','0','*','0'),
('745','mainmenudental','Install Demo Copy','2014-06-25-09-56-46','','features-dental/2014-06-25-09-56-46','http://www.joomla-monster.com/knowledge-base-area/general-questions/about-our-store/what-is-a-quickstart','url','1','740','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','218','219','0','*','0'),
('746','mainmenudental','Joomla Templates','2014-06-25-09-58-22','','features-dental/2014-06-25-09-58-22','http://www.joomla-monster.com/all-templates','url','1','740','2','0','0','0000-00-00 00:00:00','1','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','220','221','0','*','0'),
('747','mainmenudental','Examples','examples-dental','','examples-dental','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"514","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','223','230','0','*','0'),
('748','mainmenudental','Culinary Theme','culinary-theme','','examples-dental/culinary-theme','index.php?Itemid=','alias','1','747','2','22','0','0000-00-00 00:00:00','0','1','','11','{"aliasoptions":"568","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','226','227','0','*','0'),
('749','mainmenudental','Dental Theme','dental-theme','','examples-dental/dental-theme','index.php?Itemid=','alias','1','747','2','22','0','0000-00-00 00:00:00','0','1','','14','{"aliasoptions":"613","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','228','229','0','*','0'),
('750','mainmenudental','Pages','pages-dental','','pages-dental','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"479","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','231','280','0','*','0'),
('751','mainmenudental','Scheme Layouts','scheme-layouts','','pages-dental/scheme-layouts','','separator','1','750','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','232','245','0','*','0'),
('752','mainmenudental','Left-Content-Right','left-content-right','','pages-dental/scheme-layouts/left-content-right','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"520","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','233','234','0','*','0'),
('753','mainmenudental','Left-Right-Content','left-right-content','','pages-dental/scheme-layouts/left-right-content','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"521","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','235','236','0','*','0'),
('754','mainmenudental','Content-Left-Right','content-left-right','','pages-dental/scheme-layouts/content-left-right','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"522","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','237','238','0','*','0'),
('755','mainmenudental','Left-Content','left-content','','pages-dental/scheme-layouts/left-content','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"523","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','239','240','0','*','0'),
('756','mainmenudental','Content-Right','content-right','','pages-dental/scheme-layouts/content-right','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"524","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','241','242','0','*','0'),
('757','mainmenudental','Content','content','','pages-dental/scheme-layouts/content','index.php?Itemid=','alias','1','751','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"525","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','243','244','0','*','0'),
('758','mainmenudental','J! Content','joomla-content','','pages-dental/joomla-content','','separator','1','750','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','246','261','0','*','0'),
('759','mainmenudental','Single Article','single-article','','pages-dental/joomla-content/single-article','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"527","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','247','248','0','*','0'),
('760','mainmenudental','Blog - 2 columns','blog-2-columns','','pages-dental/joomla-content/blog-2-columns','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"528","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','249','250','0','*','0'),
('761','mainmenudental','Blog - 1 column ','blog-1-column','','pages-dental/joomla-content/blog-1-column','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"529","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','251','252','0','*','0'),
('762','mainmenudental','Category List','category-list','','pages-dental/joomla-content/category-list','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"530","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','253','254','0','*','0'),
('763','mainmenudental','Submit Article','submit-article','','pages-dental/joomla-content/submit-article','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','2','','0','{"aliasoptions":"531","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','255','256','0','*','0'),
('764','mainmenudental','Tabs','tabs','','pages-dental/joomla-content/tabs','index.php?Itemid=','alias','1','758','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"532","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','257','258','0','*','0'),
('765','mainmenudental','Accordion','accordion','','pages-dental/joomla-content/accordion','index.php?Itemid=','alias','1','758','3','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"685","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','259','260','0','*','0'),
('766','mainmenudental','J! Other Pages','joomla-other-pages','','pages-dental/joomla-other-pages','','separator','1','750','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','262','279','0','*','0'),
('767','mainmenudental','Registration Form','registration-form','','pages-dental/joomla-other-pages/registration-form','index.php?Itemid=','alias','1','766','3','25','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"534","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','263','264','0','*','0'),
('768','mainmenudental','Login Form','login-form','','pages-dental/joomla-other-pages/login-form','index.php?Itemid=','alias','1','766','3','25','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"535","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','265','266','0','*','0'),
('769','mainmenudental','User Profile','user-profile','','pages-dental/joomla-other-pages/user-profile','index.php?Itemid=','alias','1','766','3','25','0','0000-00-00 00:00:00','0','2','','0','{"aliasoptions":"536","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','267','268','0','*','0'),
('770','mainmenudental','Search Form','search-form','','pages-dental/joomla-other-pages/search-form','index.php?Itemid=','alias','1','766','3','19','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"538","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','269','270','0','*','0'),
('771','mainmenudental','Smart Search','smart-search','','pages-dental/joomla-other-pages/smart-search','index.php?Itemid=','alias','1','766','3','27','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"539","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','271','272','0','*','0'),
('772','mainmenudental','Single Contact','single-contact','','pages-dental/joomla-other-pages/single-contact','index.php?Itemid=','alias','1','766','3','8','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"541","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','273','274','0','*','0'),
('773','mainmenudental','Error 404','error-404','','pages-dental/joomla-other-pages/error-404','index.php?Itemid=','alias','1','766','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"657","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','275','276','0','*','0'),
('774','mainmenudental','Offline Page','offline-page','','pages-dental/joomla-other-pages/offline-page','index.php?Itemid=','alias','1','766','3','22','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"658","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','277','278','0','*','0'),
('775','mainmenudental','Languages','2014-05-13-19-05-49','','2014-05-13-19-05-49','','url','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','281','286','0','*','0'),
('776','mainmenudental','LTR Languages','2014-05-13-19-06-11','','2014-05-13-19-05-49/2014-05-13-19-06-11','?direction=ltr','url','1','775','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','282','283','0','*','0'),
('777','mainmenudental','RTL Languages','2014-05-13-19-06-34','','2014-05-13-19-05-49/2014-05-13-19-06-34','?direction=rtl','url','1','775','2','0','0','0000-00-00 00:00:00','0','1','','0','{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','284','285','0','*','0'),
('778','mainmenudental','Contact Us','contact-dental','','contact-dental','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"516","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','287','288','0','*','0'),
('779','mainmenu','Business Theme','business-theme','','examples/business-theme','index.php?Itemid=','alias','1','514','2','0','0','0000-00-00 00:00:00','0','1',' ','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_image_css":"","menu_text":1,"menu_show":1,"djmegamenu-show":"","djmegamenu-subtitle":"","djmegamenu-fa":"","djmegamenu-fullwidth":"0","djmegamenu-column_break":"0","djmegamenu-column_width":"","djmegamenu-expand":"","djmegamenu-dropdown_dir":"","djmegamenu-bg_image":"","djmegamenu-bg_pos_hor":"right","djmegamenu-bg_pos_ver":"bottom","djmegamenu-module_pos":"","djmegamenu-module_style":"System-xhtml","djmegamenu-module_show_link":"0","djmobilemenu-module_pos":"","djmobilemenu-module_style":"System-xhtml","djmobilemenu-module_show_link":"0","djmegamenu-accesskey":""}','18','19','0','*','0'),
('780','mainmenuculinary','Business Theme','business-theme','','examples-culinary/business-theme','index.php?Itemid=','alias','1','667','2','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','142','143','0','*','0'),
('781','mainmenudental','Business Theme','business-theme','','examples-dental/business-theme','index.php?Itemid=','alias','1','747','2','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','224','225','0','*','0'),
('782','mainmenualias','Home','home-alias','','home-alias','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','289','290','0','*','0'),
('783','mainmenualias','Features','features-alias','','features-alias','index.php?Itemid=','separator','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','291','292','0','*','0'),
('784','mainmenualias','Examples','examples-alias','','examples-alias','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"514","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','293','294','0','*','0');
INSERT INTO `#__menu` VALUES 
('785','mainmenualias','Pages','pages-alias','','pages-alias','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"479","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','295','296','0','*','0'),
('786','mainmenualias','Languages','languages-alias','','languages-alias','','separator','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"menu_image":"","menu_text":1}','297','298','0','*','0'),
('787','mainmenualias','Contact','contact-alias','','contact-alias','index.php?Itemid=','alias','1','1','1','0','0','0000-00-00 00:00:00','0','1','','0','{"aliasoptions":"516","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}','299','300','0','*','0'),
('788','mainmenu','News Feed','news-feed','','pages/joomla-content/news-feed','index.php?option=com_newsfeeds&view=newsfeed&id=5','component','1','526','3','17','0','0000-00-00 00:00:00','0','1','','0','{"show_feed_image":"","show_feed_description":"","show_item_description":"","show_tags":"","feed_character_count":"0","feed_display_order":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}','55','56','0','*','0'),
('810','main','COM_DJIMAGESLIDER_CATEGORIES','com-djimageslider-categories','','com-djimageslider/com-djimageslider-categories','index.php?option=com_categories&extension=com_djimageslider','component','1','808','2','10003','0','0000-00-00 00:00:00','0','1','class:category','0','{}','306','307','0','','1'),
('808','main','COM_DJIMAGESLIDER','com-djimageslider','','com-djimageslider','index.php?option=com_djimageslider','component','1','1','1','10003','0','0000-00-00 00:00:00','0','1','components/com_djimageslider/assets/icon-16-djimageslider.png','0','{}','303','308','0','','1'),
('809','main','COM_DJIMAGESLIDER_SLIDES','com-djimageslider-slides','','com-djimageslider/com-djimageslider-slides','index.php?option=com_djimageslider&view=items','component','1','808','2','10003','0','0000-00-00 00:00:00','0','1','components/com_djimageslider/assets/icon-16-menu-slides.png','0','{}','304','305','0','','1'),
('807','main','com_associations','multilingual-associations','','multilingual-associations','index.php?option=com_associations','component','1','1','1','34','0','0000-00-00 00:00:00','0','1','class:associations','0','{}','301','302','0','*','1');

DROP TABLE IF EXISTS #__menu_types;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  `client_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;

INSERT INTO `#__menu_types` VALUES 
('6','0','mainmenu','Main Menu','Simple Home Menu','0'),
('11','0','hiddenmenu','Hidden','Hidden','0'),
('18','0','mainmenuculinary','Main Menu Culinary','mainmenuculinary','0'),
('19','0','mainmenudental','Main Menu Dental','Main Menu Dental','0'),
('20','0','mainmenualias','Main Menu Alias','Main Menu Alias','0');

DROP TABLE IF EXISTS #__messages;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` mediumtext NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__messages_cfg;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__modules;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` mediumtext NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) AUTO_INCREMENT=193 DEFAULT CHARSET=utf8;

INSERT INTO `#__modules` VALUES 
('2','0','Login','','','1','login','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_login','1','1','','1','*'),
('3','0','Popular Articles','','','2','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_popular','3','1','{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('4','0','Recently Added Articles','','','1','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_latest','3','1','{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('8','0','Toolbar','','','1','toolbar','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_toolbar','3','1','','1','*'),
('9','0','Quick Icons','','','1','icon','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_quickicon','3','1','','1','*'),
('10','0','Logged-in Users','','','4','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_logged','3','1','{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('12','0','Admin Menu','','','1','menu','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_menu','3','1','{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}','1','*'),
('13','0','Admin Submenu','','','1','submenu','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_submenu','3','1','','1','*'),
('14','0','User Status','','','2','status','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_status','3','1','','1','*'),
('15','0','Title','','','1','title','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_title','3','1','','1','*'),
('17','222','Breadcrumbs','','','1','breadcrumbs','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_breadcrumbs','1','0','{"showHere":"1","showHome":"1","homeText":"","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('44','225','Login','','','3','top-bar2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_login','1','1','{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","usetext":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('79','0','Multilanguage status','','','1','status','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0','mod_multilangstatus','3','1','{"layout":"_:default","moduleclass_sfx":"","cache":"0"}','1','*'),
('86','0','Joomla Version','','','1','footer','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_version','3','1','{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}','1','*'),
('90','0','Custom Module','','<p>Example custom module for the testing data.</p>','5','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('91','0','Admin Feed Model','','','6','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0','mod_feed','1','1','{"rssurl":"http:\\/\\/feeds.joomla.org\\/JoomlaAnnouncements","rssrtl":"0","rsstitle":"1","rssdesc":"1","rssimage":"1","rssitems":"3","rssitemdesc":"1","word_count":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('92','0','Statistics','','','3','cpanel','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_stats_admin','1','1','{"serverinfo":"1","siteinfo":"1","counter":"1","increase":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"6","header_tag":"h3","header_class":"","style":"0"}','1','*'),
('98','183','DJ-Menu','','','1','top-menu-nav','0','0000-00-00 00:00:00','2017-12-27 11:28:19','0000-00-00 00:00:00','-2','mod_djmenu','1','0','{"menu":"mainmenu","endLevel":"0","css":"0","select":"1","width":"1100","moo":"1","animation_in":"fadeIn","animation_out":"fadeOut","animation_speed":"normal","wrapper":"","delay":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('99','184','Top-Bar1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','1','top-bar1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('101','186','Header','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.</p>','1','header','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('102','187','Top1','','<p><strong>Default module</strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top1-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('103','188','Top1','','<p><strong>Module suffix: title-ms</strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top1-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('104','189','Top1','','<p><strong>Module suffix: blank-ms</strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top1-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('105','190','Top1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top1-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('106','191','Top2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top2-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('107','192','Top2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top2-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('108','193','Top2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top2-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('109','194','Top2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','top2-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('110','195','Content-Top','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('111','196','Content-Bottom','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','content-bottom','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('112','197','Left-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','left-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('113','198','Left-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','left-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('114','199','Left-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','left-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('118','203','Right-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('119','204','Right-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','2','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('120','205','Right-Column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','3','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('124','209','Bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom1-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('125','210','Bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom1-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('126','211','Bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom1-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('127','212','Bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom1-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('128','213','Bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom2-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('129','214','Bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom2-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('130','215','Bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom2-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('131','216','Bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','bottom2-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('132','217','Footer-Mod','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','footer-mod-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('133','218','Footer-Mod','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','footer-mod-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('134','219','Footer-Mod','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','footer-mod-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('135','220','Footer-Mod','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris.</p>','1','footer-mod-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('136','221','Copyrights','','<p>All Rights Reserved.</p>','1','copyrights','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('137','234','Top Contact','','<ul class="jm-contact-icons">\r\n<li class="jm-direction"><img src="images/modules/direction.png" alt="Direction" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">Peterborough, UK</a></li>\r\n<li class="jm-email"><img src="images/modules/email.png" alt="Email" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">hello@services.com</a></li>\r\n<li class="jm-phone"><img src="images/modules/phone.png" alt="Phone" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">+44 7837 383 484</a></li>\r\n</ul>','1','top-bar1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*');
INSERT INTO `#__modules` VALUES 
('138','241','Latest Projects','','','3','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','1','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"81","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"255","image_height":"255","fit_to":"0","image_centering":"0","visible_images":"4","space_between_images":"30","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"0","show_custom_nav":"1","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"0","arrows_horizontal":"0","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('139','244','DJ-ImageSlider','','','1','header','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','0','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"80","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"1170","image_height":"400","fit_to":"2","image_centering":"0","visible_images":"1","space_between_images":"0","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"2","show_custom_nav":"0","desc_width":"400","desc_bottom":"0","desc_horizontal":"770","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"347","arrows_horizontal":"0","idx_style":"1","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":"slider1-ms blank-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('140','247','Time Machine','','<p style="margin: 0;"><a class="jm-color-box1 text-center" href="#"> <span class="jm-icon-title">TIME MACHINE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('141','248','Analytics','','<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">ANALYTICS</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('142','249','Worldwide Service','','<p style="margin: 0;"><a class="jm-color-box3 text-center" href="#"> <span class="jm-icon-title">WORLDWIDE SERVICE</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('143','250','Just Few Words','','<div class="pull-left visible-desktop"><img class="jm-image-margin" src="images/modules/custom1.jpg" alt="Custom" /></div>\r\n<div class="jm-table">\r\n<h3 class="jm-title" style="margin-bottom: 20px;">JUST FEW WORDS</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.</p>\r\n<ul class="jm-custom-list">\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi</li>\r\n<li>Ut aliquip ex ea commodo consequat.</li>\r\n<li>Duis aute irure dolor in reprehenderit</li>\r\n</ul>\r\n<p class="readmore text-right"><a class="btn" href="#">read more</a></p>\r\n</div>','1','content-bottom','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"8","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('144','252','Testimonials','','','1','content-bottom','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','0','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"82","show_title":"0","show_desc":"1","show_readmore":"0","readmore_text":"","link_title":"0","link_desc":"0","limit_desc":"","image_width":"311","image_height":"281","fit_to":"1","image_centering":"0","visible_images":"1","space_between_images":"0","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"0","show_custom_nav":"1","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"","right_arrow":"","play_button":"","pause_button":"","arrows_top":"30","arrows_horizontal":"5","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":" testimonials-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('146','272','Popular Articles','','','1','footer-mod-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_popular','1','1','{"catid":[""],"count":"5","show_front":"1","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('147','273','Tags','','','1','footer-mod-2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_tags_popular','1','1','{"maximum":"6","timeframe":"alltime","order_value":"count","order_direction":"1","display_count":0,"no_results_text":"0","minsize":1,"maxsize":1,"layout":"_:cloud","moduleclass_sfx":" blank-ms","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('148','274','Latest News','','','1','footer-mod-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_news','1','1','{"catid":["88"],"image":"0","item_title":"1","link_titles":"1","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"2","ordering":"a.publish_up","direction":"1","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('149','275','Stay Connected','','<div class="jm-socials"><a class="facebook" href="#"> </a> <a class="googleplus" href="#"> </a> <a class="twitter" href="#"> </a> <a class="linkedin" href="#"> </a> <a class="skype" href="#"> </a> <a class="vimeo" href="#"> </a></div>','1','footer-mod-4','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('150','303','Latest News','','','8','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_latest','1','1','{"catid":[""],"count":"5","show_featured":"","ordering":"c_dsc","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('151','304','Blog Archive','','','9','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_archive','1','1','{"count":"10","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('152','319','Categories','','','7','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_categories','1','1','{"parent":"83","show_description":"1","numitems":"1","show_children":"0","count":"0","maxlevel":"0","layout":"_:default","item_heading":"4","moduleclass_sfx":"","owncache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('153','325','Main Menu','','','1','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_menu','1','1','{"menutype":"mainmenu","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('154','327','Map','','<p><iframe style="border: 0;" src="https://www.google.com/maps/embed?pb=!1m14!1m8!1m3!1d2424.1877486636104!2d-0.2446241!3d52.5842987!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x4877f102a7bb5aff%3A0xa8a97bf13d59df1a!2sGreen+Ln!5e0!3m2!1spl!2spl!4v1400164688960" width="100%" height="450" frameborder="0"></iframe></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('159','352','sample-block-1','','<p>sample</p>','1','sample-block-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('160','353','Popular Tags','','','12','right-column','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_tags_popular','1','1','{"maximum":"5","timeframe":"alltime","order_value":"count","order_direction":"1","display_count":1,"no_results_text":"0","minsize":0.5,"maxsize":1.5,"layout":"_:cloud","moduleclass_sfx":" tags-ms","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('161','354','DJ-Menu Culinary','','','1','top-menu-nav','0','0000-00-00 00:00:00','2017-12-27 11:28:19','0000-00-00 00:00:00','-2','mod_djmenu','1','0','{"menu":"mainmenuculinary","endLevel":"0","css":"0","select":"1","width":"1100","moo":"1","animation_in":"fadeIn","animation_out":"fadeOut","animation_speed":"normal","wrapper":"","delay":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('162','355','DJ-ImageSlider Culinary','','','1','header','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','0','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"91","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"1170","image_height":"400","fit_to":"2","image_centering":"0","visible_images":"1","space_between_images":"0","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"2","show_custom_nav":"0","desc_width":"400","desc_bottom":"0","desc_horizontal":"770","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"347","arrows_horizontal":"0","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":"slider1-ms blank-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('163','357','Dinner','','<p style="margin: 0;"><a class="jm-color-box1 text-center" href="#"> <span class="jm-icon-title">DINNER</span> <span class="jm-icon-image" style="background-image: url(\'images/culinary/modules/colorboxes/color-icon1.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('164','358','Cookie','','<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">COOKIE</span> <span class="jm-icon-image" style="background-image: url(\'images/culinary/modules/colorboxes/color-icon2.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('165','359','Dessert','','<p style="margin: 0;"><a class="jm-color-box3 text-center" href="#"> <span class="jm-icon-title">DESSERT</span> <span class="jm-icon-image" style="background-image: url(\'images/culinary/modules/colorboxes/color-icon3.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('166','361','Latest Recipes','','','3','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','1','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"92","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"255","image_height":"255","fit_to":"0","image_centering":"0","visible_images":"4","space_between_images":"30","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"0","show_custom_nav":"1","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"0","arrows_horizontal":"0","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('167','379','Popular Recipes','','','1','footer-mod-3','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_popular','1','1','{"catid":[""],"count":"5","show_front":"1","layout":"_:default","moduleclass_sfx":" blank-ms ","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('168','380','Our Cooks','','<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook1.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Greg Amaro</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>\r\n<div class="media"><a class="pull-left" href="#"> <img src="images/culinary/modules/cooks/cook2.png" alt="" /> </a>\r\n<div class="media-body">\r\n<h5 class="media-heading"><a href="#">Jimmy Gessler</a></h5>\r\n<p>Consectetur adipisicing elit sed do eimod tempor.</p>\r\n</div>\r\n</div>','1','footer-mod-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('169','382','DJ-Menu Dental','','','1','top-menu-nav','0','0000-00-00 00:00:00','2017-12-27 11:28:19','0000-00-00 00:00:00','-2','mod_djmenu','1','0','{"menu":"mainmenudental","endLevel":"0","css":"0","select":"1","width":"1100","moo":"1","animation_in":"fadeIn","animation_out":"fadeOut","animation_speed":"normal","wrapper":"","delay":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('170','383','Top Contact Dental','','<ul class="jm-contact-icons">\r\n<li><img src="images/dental/modules/contact/direction.png" alt="Direction" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">Peterborough, UK</a></li>\r\n<li><img src="images/dental/modules/contact/email.png" alt="Email" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">hello@dental.com</a></li>\r\n<li><img src="images/dental/modules/contact/phone.png" alt="Phone" /><a title="Contact" href="index.php?option=com_contact&amp;view=contact&amp;id=9&amp;Itemid=516">+44 7837 383 484</a></li>\r\n</ul>','1','top-bar1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('171','385','DJ-ImageSlider Dental','','','1','header','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','0','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"94","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"1170","image_height":"400","fit_to":"2","image_centering":"0","visible_images":"1","space_between_images":"0","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"2","show_custom_nav":"0","desc_width":"400","desc_bottom":"0","desc_horizontal":"770","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"347","arrows_horizontal":"0","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":"slider1-ms blank-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('172','386','Treatment','','<p style="margin: 0;"><a class="jm-color-box1 text-center" href="#"> <span class="jm-icon-title">TREATMENT</span> <span class="jm-icon-image" style="background-image: url(\'images/dental/modules/colorboxes/color-icon1.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('173','387','Whitening','','<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">WHITENING</span> <span class="jm-icon-image" style="background-image: url(\'images/dental/modules/colorboxes/color-icon2.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('174','388','Implants','','<p style="margin: 0;"><a class="jm-color-box3 text-center" href="#"> <span class="jm-icon-title">IMPLANTS</span> <span class="jm-icon-image" style="background-image: url(\'images/dental/modules/colorboxes/color-icon3.png\');"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','1','content-top','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('175','389','Just Few Words','','<div class="pull-left visible-desktop"><img class="jm-image-margin" src="images/dental/modules/custom1.jpg" alt="Custom" /></div>\r\n<div class="jm-table">\r\n<h3 class="jm-title" style="margin-bottom: 20px;">JUST FEW WORDS</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.</p>\r\n<ul class="jm-custom-list green">\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi</li>\r\n<li>Ut aliquip ex ea commodo consequat.</li>\r\n<li>Duis aute irure dolor in reprehenderit</li>\r\n</ul>\r\n<p class="readmore text-right"><a class="btn" href="#">read more</a></p>\r\n</div>','1','content-bottom','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"8","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('176','390','Testimonials Dental','','','1','content-bottom','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','0','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"95","show_title":"0","show_desc":"1","show_readmore":"0","readmore_text":"","link_title":"0","link_desc":"0","limit_desc":"","image_width":"311","image_height":"281","fit_to":"1","image_centering":"0","visible_images":"1","space_between_images":"0","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"0","show_custom_nav":"1","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"","right_arrow":"","play_button":"","pause_button":"","arrows_top":"30","arrows_horizontal":"5","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":" testimonials-ms alternative-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('177','392','Our Services','','','1','bottom1-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djimageslider','1','1','{"slider_source":"1","slider_type":"0","theme":"_override","link_image":"1","image_folder":"images\\/sampledata\\/fruitshop","link":"","category":"96","show_title":"1","show_desc":"1","show_readmore":"1","readmore_text":"","link_title":"1","link_desc":"1","limit_desc":"","image_width":"255","image_height":"255","fit_to":"0","image_centering":"0","visible_images":"4","space_between_images":"30","max_images":"20","sort_by":"1","css3":"1","autoplay":"0","show_buttons":"0","show_arrows":"0","show_custom_nav":"1","desc_width":"","desc_bottom":"0","desc_horizontal":"0","left_arrow":"images\\/djimageslider\\/navigation\\/prev.png","right_arrow":"images\\/djimageslider\\/navigation\\/next.png","play_button":"images\\/djimageslider\\/navigation\\/play.png","pause_button":"images\\/djimageslider\\/navigation\\/pause.png","arrows_top":"0","arrows_horizontal":"0","idx_style":"0","effect":"Expo","effect_type":"0","duration":"","delay":"","preload":"800","layout":"_:default","moduleclass_sfx":" title-ms","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('178','394','Popular Articles','','','1','footer-mod-1','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_articles_popular','1','1','{"catid":[""],"count":"5","show_front":"1","layout":"_:default","moduleclass_sfx":" blank-ms jm-light-list","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('179','397','Search on Error 404 page','','','1','error404-search','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_search','1','0','{"label":"","width":"20","text":"","button":"1","button_pos":"right","imagebutton":"0","button_text":"","opensearch":"1","opensearch_title":"","set_itemid":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('180','400','Toggle Nav','','<p><a class="toggle-nav menu"><span class="icon-align-justify"></span></a></p>','1','top-bar2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" nomargin-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('181','401','Analytics','','<p style="margin: 0;"><a class="jm-color-box2 text-center" href="#"> <span class="jm-icon-title">ANALYTICS</span> <span class="jm-icon-image"> </span> <span class="jm-icon-desc">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</span> </a></p>','2','offcanvas','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"4","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('182','402','Tags','','','3','offcanvas','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_tags_popular','1','1','{"maximum":"6","timeframe":"alltime","order_value":"count","order_direction":"1","display_count":0,"no_results_text":"0","minsize":1,"maxsize":1,"layout":"_:cloud","moduleclass_sfx":" blank-ms","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('183','403','Main Menu','','','1','offcanvas','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_menu','1','1','{"menutype":"mainmenualias","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('184','404','Offcanvas Info','','<p>Assign modules on offcanvas module position to make them visible in the sidebar.</p>','0','offcanvas','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','0','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('185','406','Our site is coming soon','','<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium eaque ipsa quae ab illo inventore veritatis et quasi architecto.</p>','1','coming-soon','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_custom','1','1','{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"blank-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('186','409','DJ-MegaMenu','','','1','top-menu-nav','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djmegamenu','1','0','{"menu":"mainmenu","base":"","startLevel":"1","endLevel":"0","icons":"2","subtitles":"2","usenote":"1","fa":"0","theme":"_override","expand":"dropdown","dropdown_dir":"","column_width":"200","moo":"1","animation_in":"fadeInUp","animation_out":"zoomOut","animation_speed":"normal","closeDelay":"500","event":"mouseenter","wrapper":"","wcag":"1","select":"2","mobiletheme":"light","width":"979","select_type":"button","accordion_pos":"static","accordion_align":"right","offcanvas_logo":"images\\/logo.png","offcanvas_pos":"left","offcanvas_effect":"3","accordion_collapsed":"0","moduleclass_sfx":"","layout":"_:default","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('187','410','DJ-MegaMenu - Mobile Menu Button','','','0','','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0','mod_djmegamenu_button','1','1','','0','*'),
('188','411','Menu','','','1','test1','0','0000-00-00 00:00:00','2017-12-21 10:06:58','0000-00-00 00:00:00','-2','mod_menu','1','1','{"menutype":"mainmenuculinary","base":"","startLevel":"1","endLevel":"0","showAllChildren":"1","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('189','412','Test2','','','1','test2','0','0000-00-00 00:00:00','2017-12-21 10:06:45','0000-00-00 00:00:00','-2','mod_menu','1','1','{"menutype":"mainmenudental","base":"","startLevel":"1","endLevel":"0","showAllChildren":"1","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('190','413','JM Offcanvas Button Toggle','','','2','top-bar2','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_jm_offcanvas_button','1','1','{"image_file":"","icon":"fa fa-bars","layout":"_:default","moduleclass_sfx":" visible-desktop  nomargin-ms","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('191','414','DJ-MegaMenu Culinary','','','1','top-menu-nav','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djmegamenu','1','0','{"menu":"mainmenuculinary","base":"","startLevel":"1","endLevel":"0","icons":"2","subtitles":"2","usenote":"1","fa":"0","theme":"_override","expand":"dropdown","dropdown_dir":"","column_width":"200","moo":"1","animation_in":"fadeInUp","animation_out":"zoomOut","animation_speed":"normal","closeDelay":"500","event":"mouseenter","wrapper":"","wcag":"1","select":"2","mobiletheme":"light","width":"979","select_type":"button","accordion_pos":"static","accordion_align":"right","offcanvas_logo":"images\\/culinary\\/logo.png","offcanvas_pos":"left","offcanvas_effect":"3","accordion_collapsed":"0","moduleclass_sfx":"","layout":"_:default","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*'),
('192','415','DJ-MegaMenu Dental','','','1','top-menu-nav','0','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','1','mod_djmegamenu','1','0','{"menu":"mainmenudental","base":"","startLevel":"1","endLevel":"0","icons":"2","subtitles":"2","usenote":"1","fa":"0","theme":"_override","expand":"dropdown","dropdown_dir":"","column_width":"200","moo":"1","animation_in":"fadeInUp","animation_out":"zoomOut","animation_speed":"normal","closeDelay":"500","event":"mouseenter","wrapper":"","wcag":"1","select":"2","mobiletheme":"light","width":"979","select_type":"button","accordion_pos":"static","accordion_align":"right","offcanvas_logo":"images\\/dental\\/logo.png","offcanvas_pos":"left","offcanvas_effect":"3","accordion_collapsed":"0","moduleclass_sfx":"","layout":"_:default","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}','0','*');

DROP TABLE IF EXISTS #__modules_menu;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__modules_menu` VALUES 
('2','0'),
('3','0'),
('4','0'),
('6','0'),
('7','0'),
('8','0'),
('9','0'),
('10','0'),
('12','0'),
('13','0'),
('14','0'),
('15','0'),
('17','-613'),
('17','-568'),
('17','-435'),
('19','-463'),
('19','-462'),
('19','-433'),
('19','-432'),
('19','-431'),
('19','-430'),
('19','-429'),
('19','-427'),
('19','-400'),
('19','-399'),
('19','-296'),
('19','-244'),
('19','-243'),
('19','-242'),
('19','-234'),
('20','0'),
('22','231'),
('22','234'),
('22','238'),
('22','242'),
('22','243'),
('22','244'),
('22','296'),
('22','399'),
('22','400'),
('23','277'),
('23','280'),
('23','282'),
('23','283'),
('23','284'),
('23','285'),
('23','303'),
('23','316'),
('23','317'),
('23','318');
INSERT INTO `#__modules_menu` VALUES 
('23','319'),
('23','320'),
('23','321'),
('23','322'),
('23','323'),
('23','419'),
('23','422'),
('23','423'),
('23','424'),
('23','437'),
('23','456'),
('23','457'),
('23','458'),
('23','496'),
('32','309'),
('44','-568'),
('57','238'),
('57','427'),
('57','429'),
('57','430'),
('57','431'),
('57','432'),
('57','433'),
('57','462'),
('57','463'),
('71','285'),
('71','316'),
('79','0'),
('86','0'),
('87','227'),
('87','229'),
('87','249'),
('87','251'),
('87','252'),
('87','253'),
('87','254'),
('87','255'),
('87','256'),
('87','257'),
('87','259'),
('87','260'),
('87','262'),
('87','263'),
('87','265'),
('87','266'),
('87','267'),
('87','270'),
('87','271'),
('87','272'),
('87','274');
INSERT INTO `#__modules_menu` VALUES 
('87','275'),
('87','276'),
('87','402'),
('87','403'),
('87','404'),
('87','405'),
('87','406'),
('87','409'),
('87','452'),
('87','466'),
('87','474'),
('87','475'),
('87','476'),
('87','477'),
('87','478'),
('87','495'),
('88','300'),
('88','301'),
('88','302'),
('88','303'),
('88','304'),
('88','305'),
('88','306'),
('88','307'),
('88','309'),
('88','310'),
('88','311'),
('88','312'),
('88','313'),
('88','324'),
('88','325'),
('88','326'),
('88','410'),
('88','411'),
('88','412'),
('88','416'),
('88','417'),
('88','418'),
('88','443'),
('88','447'),
('88','459'),
('88','467'),
('88','472'),
('88','473'),
('88','495'),
('89','238'),
('89','427'),
('89','429'),
('89','430'),
('89','431');
INSERT INTO `#__modules_menu` VALUES 
('89','432'),
('89','433'),
('89','462'),
('89','463'),
('90','0'),
('91','0'),
('92','0'),
('98','-613'),
('98','-568'),
('99','479'),
('99','519'),
('99','520'),
('99','521'),
('99','522'),
('99','523'),
('99','524'),
('99','525'),
('101','479'),
('101','520'),
('101','521'),
('101','522'),
('101','523'),
('101','524'),
('101','525'),
('102','479'),
('102','519'),
('102','520'),
('102','521'),
('102','522'),
('102','523'),
('102','524'),
('102','525'),
('103','479'),
('103','519'),
('103','520'),
('103','521'),
('103','522'),
('103','523'),
('103','524'),
('103','525'),
('104','479'),
('104','519'),
('104','520'),
('104','521'),
('104','522'),
('104','523'),
('104','524'),
('104','525'),
('105','479'),
('105','519');
INSERT INTO `#__modules_menu` VALUES 
('105','520'),
('105','521'),
('105','522'),
('105','523'),
('105','524'),
('105','525'),
('106','479'),
('106','519'),
('106','520'),
('106','521'),
('106','522'),
('106','523'),
('106','524'),
('106','525'),
('107','479'),
('107','519'),
('107','520'),
('107','521'),
('107','522'),
('107','523'),
('107','524'),
('107','525'),
('108','479'),
('108','519'),
('108','520'),
('108','521'),
('108','522'),
('108','523'),
('108','524'),
('108','525'),
('109','479'),
('109','519'),
('109','520'),
('109','521'),
('109','522'),
('109','523'),
('109','524'),
('109','525'),
('110','479'),
('110','519'),
('110','520'),
('110','521'),
('110','522'),
('110','523'),
('110','524'),
('110','525'),
('111','479'),
('111','519'),
('111','520'),
('111','521');
INSERT INTO `#__modules_menu` VALUES 
('111','522'),
('111','523'),
('111','524'),
('111','525'),
('112','479'),
('112','519'),
('112','520'),
('112','521'),
('112','522'),
('112','523'),
('113','479'),
('113','519'),
('113','520'),
('113','521'),
('113','522'),
('113','523'),
('114','479'),
('114','519'),
('114','520'),
('114','521'),
('114','522'),
('118','479'),
('118','519'),
('118','520'),
('118','521'),
('118','522'),
('118','524'),
('119','479'),
('119','519'),
('119','520'),
('119','521'),
('119','522'),
('119','524'),
('120','479'),
('120','519'),
('120','520'),
('120','521'),
('120','522'),
('124','479'),
('124','519'),
('124','520'),
('124','521'),
('124','522'),
('124','523'),
('124','524'),
('124','525'),
('125','479'),
('125','519'),
('125','520'),
('125','521');
INSERT INTO `#__modules_menu` VALUES 
('125','522'),
('125','523'),
('125','524'),
('125','525'),
('126','479'),
('126','519'),
('126','520'),
('126','521'),
('126','522'),
('126','523'),
('126','524'),
('126','525'),
('127','479'),
('127','519'),
('127','520'),
('127','521'),
('127','522'),
('127','523'),
('127','524'),
('127','525'),
('128','479'),
('128','519'),
('128','520'),
('128','521'),
('128','522'),
('128','523'),
('128','524'),
('128','525'),
('129','479'),
('129','519'),
('129','520'),
('129','521'),
('129','522'),
('129','523'),
('129','524'),
('129','525'),
('130','479'),
('130','519'),
('130','520'),
('130','521'),
('130','522'),
('130','523'),
('130','524'),
('130','525'),
('131','479'),
('131','519'),
('131','520'),
('131','521'),
('131','522'),
('131','523');
INSERT INTO `#__modules_menu` VALUES 
('131','524'),
('131','525'),
('132','479'),
('132','519'),
('132','520'),
('132','521'),
('132','522'),
('132','523'),
('132','524'),
('132','525'),
('133','479'),
('133','519'),
('133','520'),
('133','521'),
('133','522'),
('133','523'),
('133','524'),
('133','525'),
('134','479'),
('134','519'),
('134','520'),
('134','521'),
('134','522'),
('134','523'),
('134','524'),
('134','525'),
('135','479'),
('135','519'),
('135','520'),
('135','521'),
('135','522'),
('135','523'),
('135','524'),
('135','525'),
('136','0'),
('137','435'),
('138','435'),
('139','435'),
('140','435'),
('141','435'),
('142','435'),
('143','435'),
('144','435'),
('146','435'),
('147','435'),
('147','568'),
('147','613'),
('148','435'),
('148','613'),
('149','435');
INSERT INTO `#__modules_menu` VALUES 
('149','568'),
('149','613'),
('150','527'),
('150','528'),
('150','529'),
('151','527'),
('151','528'),
('151','529'),
('152','527'),
('152','528'),
('152','529'),
('152','530'),
('152','532'),
('153','515'),
('154','516'),
('155','527'),
('155','528'),
('155','529'),
('155','530'),
('155','531'),
('155','532'),
('155','542'),
('156','534'),
('156','535'),
('156','536'),
('157','538'),
('157','539'),
('158','541'),
('159','479'),
('160','528'),
('160','529'),
('161','568'),
('162','568'),
('163','568'),
('164','568'),
('165','568'),
('166','568'),
('167','568'),
('168','568'),
('169','613'),
('170','613'),
('171','613'),
('172','613'),
('173','613'),
('174','613'),
('175','613'),
('176','613'),
('177','613'),
('178','613'),
('179','0');
INSERT INTO `#__modules_menu` VALUES 
('180','-568'),
('181','435'),
('181','479'),
('181','499'),
('181','500'),
('181','501'),
('181','502'),
('181','503'),
('181','514'),
('181','515'),
('181','516'),
('181','519'),
('181','520'),
('181','521'),
('181','522'),
('181','523'),
('181','524'),
('181','525'),
('181','526'),
('181','527'),
('181','528'),
('181','529'),
('181','530'),
('181','531'),
('181','532'),
('181','533'),
('181','534'),
('181','535'),
('181','536'),
('181','538'),
('181','539'),
('181','541'),
('181','542'),
('181','562'),
('181','563'),
('181','564'),
('181','566'),
('181','567'),
('181','568'),
('181','613'),
('181','657'),
('181','658'),
('181','659'),
('181','660'),
('181','661'),
('181','662'),
('181','663'),
('181','664'),
('181','665'),
('181','666');
INSERT INTO `#__modules_menu` VALUES 
('181','667'),
('181','668'),
('181','669'),
('181','670'),
('181','671'),
('181','672'),
('181','673'),
('181','674'),
('181','675'),
('181','676'),
('181','677'),
('181','678'),
('181','679'),
('181','680'),
('181','681'),
('181','682'),
('181','683'),
('181','684'),
('181','685'),
('181','686'),
('181','687'),
('181','688'),
('181','689'),
('181','690'),
('181','691'),
('181','692'),
('181','693'),
('181','694'),
('181','695'),
('181','696'),
('181','697'),
('181','698'),
('181','739'),
('181','740'),
('181','741'),
('181','742'),
('181','743'),
('181','744'),
('181','745'),
('181','746'),
('181','747'),
('181','748'),
('181','749'),
('181','750'),
('181','751'),
('181','752'),
('181','753'),
('181','754'),
('181','755'),
('181','756');
INSERT INTO `#__modules_menu` VALUES 
('181','757'),
('181','758'),
('181','759'),
('181','760'),
('181','761'),
('181','762'),
('181','763'),
('181','764'),
('181','765'),
('181','766'),
('181','767'),
('181','768'),
('181','769'),
('181','770'),
('181','771'),
('181','772'),
('181','773'),
('181','774'),
('181','775'),
('181','776'),
('181','777'),
('181','778'),
('181','779'),
('181','780'),
('181','781'),
('182','435'),
('182','479'),
('182','499'),
('182','500'),
('182','501'),
('182','502'),
('182','503'),
('182','514'),
('182','515'),
('182','516'),
('182','519'),
('182','520'),
('182','521'),
('182','522'),
('182','523'),
('182','524'),
('182','525'),
('182','526'),
('182','527'),
('182','528'),
('182','529'),
('182','530'),
('182','531'),
('182','532'),
('182','533');
INSERT INTO `#__modules_menu` VALUES 
('182','534'),
('182','535'),
('182','536'),
('182','538'),
('182','539'),
('182','541'),
('182','542'),
('182','562'),
('182','563'),
('182','564'),
('182','566'),
('182','567'),
('182','568'),
('182','613'),
('182','657'),
('182','658'),
('182','659'),
('182','660'),
('182','661'),
('182','662'),
('182','663'),
('182','664'),
('182','665'),
('182','666'),
('182','667'),
('182','668'),
('182','669'),
('182','670'),
('182','671'),
('182','672'),
('182','673'),
('182','674'),
('182','675'),
('182','676'),
('182','677'),
('182','678'),
('182','679'),
('182','680'),
('182','681'),
('182','682'),
('182','683'),
('182','684'),
('182','685'),
('182','686'),
('182','687'),
('182','688'),
('182','689'),
('182','690'),
('182','691'),
('182','692');
INSERT INTO `#__modules_menu` VALUES 
('182','693'),
('182','694'),
('182','695'),
('182','696'),
('182','697'),
('182','698'),
('182','739'),
('182','740'),
('182','741'),
('182','742'),
('182','743'),
('182','744'),
('182','745'),
('182','746'),
('182','747'),
('182','748'),
('182','749'),
('182','750'),
('182','751'),
('182','752'),
('182','753'),
('182','754'),
('182','755'),
('182','756'),
('182','757'),
('182','758'),
('182','759'),
('182','760'),
('182','761'),
('182','762'),
('182','763'),
('182','764'),
('182','765'),
('182','766'),
('182','767'),
('182','768'),
('182','769'),
('182','770'),
('182','771'),
('182','772'),
('182','773'),
('182','774'),
('182','775'),
('182','776'),
('182','777'),
('182','778'),
('182','779'),
('182','780'),
('182','781'),
('183','435');
INSERT INTO `#__modules_menu` VALUES 
('183','479'),
('183','499'),
('183','500'),
('183','501'),
('183','502'),
('183','503'),
('183','514'),
('183','515'),
('183','516'),
('183','519'),
('183','520'),
('183','521'),
('183','522'),
('183','523'),
('183','524'),
('183','525'),
('183','526'),
('183','527'),
('183','528'),
('183','529'),
('183','530'),
('183','531'),
('183','532'),
('183','533'),
('183','534'),
('183','535'),
('183','536'),
('183','538'),
('183','539'),
('183','541'),
('183','542'),
('183','562'),
('183','563'),
('183','564'),
('183','566'),
('183','567'),
('183','568'),
('183','613'),
('183','657'),
('183','658'),
('183','659'),
('183','660'),
('183','661'),
('183','662'),
('183','663'),
('183','664'),
('183','665'),
('183','666'),
('183','667'),
('183','668');
INSERT INTO `#__modules_menu` VALUES 
('183','669'),
('183','670'),
('183','671'),
('183','672'),
('183','673'),
('183','674'),
('183','675'),
('183','676'),
('183','677'),
('183','678'),
('183','679'),
('183','680'),
('183','681'),
('183','682'),
('183','683'),
('183','684'),
('183','685'),
('183','686'),
('183','687'),
('183','688'),
('183','689'),
('183','690'),
('183','691'),
('183','692'),
('183','693'),
('183','694'),
('183','695'),
('183','696'),
('183','697'),
('183','698'),
('183','739'),
('183','740'),
('183','741'),
('183','742'),
('183','743'),
('183','744'),
('183','745'),
('183','746'),
('183','747'),
('183','748'),
('183','749'),
('183','750'),
('183','751'),
('183','752'),
('183','753'),
('183','754'),
('183','755'),
('183','756'),
('183','757'),
('183','758');
INSERT INTO `#__modules_menu` VALUES 
('183','759'),
('183','760'),
('183','761'),
('183','762'),
('183','763'),
('183','764'),
('183','765'),
('183','766'),
('183','767'),
('183','768'),
('183','769'),
('183','770'),
('183','771'),
('183','772'),
('183','773'),
('183','774'),
('183','775'),
('183','776'),
('183','777'),
('183','778'),
('183','779'),
('183','780'),
('183','781'),
('184','0'),
('185','0'),
('186','-613'),
('186','-568'),
('188','0'),
('189','0'),
('190','-568'),
('191','568'),
('192','613');

DROP TABLE IF EXISTS #__newsfeeds;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(400) NOT NULL DEFAULT '',
  `link` varchar(2048) NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` mediumtext NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` mediumtext NOT NULL,
  `metadesc` mediumtext NOT NULL,
  `metadata` mediumtext NOT NULL,
  `xreference` varchar(50) NOT NULL DEFAULT '',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` mediumtext NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` mediumtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO `#__newsfeeds` VALUES 
('97','5','News Feed','news-feed','http://www.cbc.ca/cmlink/rss-world','1','5','3600','0','0000-00-00 00:00:00','1','0','1','*','{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","newsfeed_layout":"","feed_display_order":""}','2014-11-28 12:58:38','936','','0000-00-00 00:00:00','0','','','{"robots":"","rights":""}','','0000-00-00 00:00:00','0000-00-00 00:00:00','','1','1','{"image_first":"","float_first":"","image_first_alt":"","image_first_caption":"","image_second":"","float_second":"","image_second_alt":"","image_second_caption":""}');

DROP TABLE IF EXISTS #__overrider;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` mediumtext NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__postinstall_messages;
CREATE TABLE `#__postinstall_messages` (
  `postinstall_message_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `extension_id` bigint(20) NOT NULL DEFAULT '700' COMMENT 'FK to #__extensions',
  `title_key` varchar(255) NOT NULL DEFAULT '' COMMENT 'Lang key for the title',
  `description_key` varchar(255) NOT NULL DEFAULT '' COMMENT 'Lang key for description',
  `action_key` varchar(255) NOT NULL DEFAULT '',
  `language_extension` varchar(255) NOT NULL DEFAULT 'com_postinstall' COMMENT 'Extension holding lang keys',
  `language_client_id` tinyint(3) NOT NULL DEFAULT '1',
  `type` varchar(10) NOT NULL DEFAULT 'link' COMMENT 'Message type - message, link, action',
  `action_file` varchar(255) DEFAULT '' COMMENT 'RAD URI to the PHP file containing action method',
  `action` varchar(255) DEFAULT '' COMMENT 'Action method name or URL',
  `condition_file` varchar(255) DEFAULT NULL COMMENT 'RAD URI to file holding display condition method',
  `condition_method` varchar(255) DEFAULT NULL COMMENT 'Display condition method, must return boolean',
  `version_introduced` varchar(50) NOT NULL DEFAULT '3.2.0' COMMENT 'Version when this message was introduced',
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  PRIMARY KEY (`postinstall_message_id`)
) AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;

INSERT INTO `#__postinstall_messages` VALUES 
('1','700','PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_TITLE','PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_BODY','PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_ACTION','plg_twofactorauth_totp','1','action','site://plugins/twofactorauth/totp/postinstall/actions.php','twofactorauth_postinstall_action','site://plugins/twofactorauth/totp/postinstall/actions.php','twofactorauth_postinstall_condition','3.2.0','1'),
('2','700','COM_CPANEL_MSG_EACCELERATOR_TITLE','COM_CPANEL_MSG_EACCELERATOR_BODY','COM_CPANEL_MSG_EACCELERATOR_BUTTON','com_cpanel','1','action','admin://components/com_admin/postinstall/eaccelerator.php','admin_postinstall_eaccelerator_action','admin://components/com_admin/postinstall/eaccelerator.php','admin_postinstall_eaccelerator_condition','3.2.0','1'),
('3','700','COM_CPANEL_WELCOME_BEGINNERS_TITLE','COM_CPANEL_WELCOME_BEGINNERS_MESSAGE','','com_cpanel','1','message','','','','','3.2.0','1'),
('5','700','COM_CPANEL_MSG_HTACCESS_TITLE','COM_CPANEL_MSG_HTACCESS_BODY','','com_cpanel','1','message','','','admin://components/com_admin/postinstall/htaccess.php','admin_postinstall_htaccess_condition','3.4.0','1'),
('6','700','COM_CPANEL_MSG_ROBOTS_TITLE','COM_CPANEL_MSG_ROBOTS_BODY','','com_cpanel','1','message','','','','','3.3.0','1'),
('7','700','COM_CPANEL_MSG_LANGUAGEACCESS340_TITLE','COM_CPANEL_MSG_LANGUAGEACCESS340_BODY','','com_cpanel','1','message','','','admin://components/com_admin/postinstall/languageaccess340.php','admin_postinstall_languageaccess340_condition','3.4.1','1'),
('8','700','COM_CPANEL_MSG_STATS_COLLECTION_TITLE','COM_CPANEL_MSG_STATS_COLLECTION_BODY','','com_cpanel','1','message','','','admin://components/com_admin/postinstall/statscollection.php','admin_postinstall_statscollection_condition','3.5.0','1'),
('9','700','PLG_SYSTEM_UPDATENOTIFICATION_POSTINSTALL_UPDATECACHETIME','PLG_SYSTEM_UPDATENOTIFICATION_POSTINSTALL_UPDATECACHETIME_BODY','PLG_SYSTEM_UPDATENOTIFICATION_POSTINSTALL_UPDATECACHETIME_ACTION','plg_system_updatenotification','1','action','site://plugins/system/updatenotification/postinstall/updatecachetime.php','updatecachetime_postinstall_action','site://plugins/system/updatenotification/postinstall/updatecachetime.php','updatecachetime_postinstall_condition','3.6.3','1'),
('10','700','COM_CPANEL_MSG_JOOMLA40_PRE_CHECKS_TITLE','COM_CPANEL_MSG_JOOMLA40_PRE_CHECKS_BODY','','com_cpanel','1','message','','','admin://components/com_admin/postinstall/joomla40checks.php','admin_postinstall_joomla40checks_condition','3.7.0','1'),
('11','700','TPL_HATHOR_MESSAGE_POSTINSTALL_TITLE','TPL_HATHOR_MESSAGE_POSTINSTALL_BODY','TPL_HATHOR_MESSAGE_POSTINSTALL_ACTION','tpl_hathor','1','action','admin://templates/hathor/postinstall/hathormessage.php','hathormessage_postinstall_action','admin://templates/hathor/postinstall/hathormessage.php','hathormessage_postinstall_condition','3.7.0','1');

DROP TABLE IF EXISTS #__schemas;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__schemas` VALUES 
('21','3.5.1'),
('700','3.8.2-2017-10-14'),
('10003','2.0');

DROP TABLE IF EXISTS #__tags;
CREATE TABLE `#__tags` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(400) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(400) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` mediumtext NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` mediumtext NOT NULL,
  `urls` mediumtext NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `tag_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_path` (`path`(100)),
  KEY `idx_alias` (`alias`(100))
) AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;

INSERT INTO `#__tags` VALUES 
('1','0','0','15','0','','ROOT','root','','','1','0','0000-00-00 00:00:00','1','','','','','936','2011-01-01 00:00:01','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('7','1','2','3','0','ipsum','ipsum','ipsum','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 12:44:51','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('8','1','4','5','0','dolor','dolor','dolor','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 12:44:51','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('9','1','6','7','0','sit','sit','sit','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 12:44:51','','0','0000-00-00 00:00:00','','','1','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('10','1','8','9','0','amet','amet','amet','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 12:44:51','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('11','1','10','11','0','nec','nec','nec','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 13:18:57','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00'),
('12','1','12','13','0','quis','quis','quis','','','1','0','0000-00-00 00:00:00','1','','','','','936','2014-05-15 13:18:57','','0','0000-00-00 00:00:00','','','0','*','1','0000-00-00 00:00:00','0000-00-00 00:00:00');

DROP TABLE IF EXISTS #__template_styles;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` mediumtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;

INSERT INTO `#__template_styles` VALUES 
('4','beez3','0','0','Beez3 - Default','{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal","html5":"0"}'),
('5','hathor','1','0','Hathor - Default','{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
('7','protostar','0','0','protostar - Default','{"templateColor":"","logoFile":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}'),
('8','isis','1','1','isis - Default','{"templateColor":"","logoFile":""}'),
('9','jm-services','0','1','jm-services - Default','{"logo":"images\\/logo.png","logoText":"","siteDescription":"","favIconImg":"","fontSizeSwitcher":"0","backToTop":"1","offCanvas":"1","JMoffCanvasWidth":"300px","offCanvasPosition":"right","comingSoon":"0","comingSoonDate":"29-06-2015","error404article":"","responsiveLayout":"1","DisableComponentDisplay":["435"],"layout":"default","JMbaseFontSize":"16px","bodyFontType":"1;bodyGoogleWebFontUrl;bodyGoogleWebFontFamily","bodyFontFamily":"Arial, Helvetica, sans-serif","bodyGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Lato:400,300,300italic,400italic,700,700italic,900,900italic","bodyGoogleWebFontFamily":"Lato, sans-serif","JMtopmenuFontSize":"16px","djmenuFontType":"1;djmenuGoogleWebFontUrl;djmenuGoogleWebFontFamily","djmenuFontFamily":"Arial, Helvetica, sans-serif","djmenuGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Lato:400,300,300italic,400italic,700,700italic,900,900italic","djmenuGoogleWebFontFamily":"Lato, sans-serif","JMmoduleTitleFontSize":"20px","headingsFontType":"1;headingsGoogleWebFontUrl;headingsGoogleWebFontFamily","headingsFontFamily":"Arial, Helvetica, sans-serif","headingsGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Lato:400,300,300italic,400italic,700,700italic,900,900italic","headingsGoogleWebFontFamily":"Lato, sans-serif","JMblogTitleFontSize":"32px","blogFontType":"0;blogFontFamily","blogFontFamily":"Arial, Helvetica, sans-serif","blogGoogleWebFontUrl":"","blogGoogleWebFontFamily":"","JMarticleTitleFontSize":"32px","articlesFontType":"0;articlesFontFamily","articlesFontFamily":"Arial, Helvetica, sans-serif","articlesGoogleWebFontUrl":"http:\\/\\/fonts.googleapis.com\\/css?family=Lato:400,300,300italic,400italic,700,700italic,900,900italic","articlesGoogleWebFontFamily":"\'Lato\', \'sans-serif\'","advancedFontAwesome":"1","advancedFontSize":"50px","advancedFontType":"0;advancedFontFamily","advancedFontFamily":"Arial, Helvetica, sans-serif","advancedGoogleWebFontUrl":"","advancedGoogleWebFontFamily":"","advancedSelectors":"","themermode":"0","themerlogin":"0","themeradminaccess":"0","sourceMap":"0","codeInjection":"","cssCompress":"0","jsCompress":"0","htmlCompress":"0","skipCompress":"","jsDefer":"0","skipDefer":"","debug":"0","lazyLoading":"0","lazyExclude":"","lazyWidth":"50","lazyHeight":"50","facebookOpenGraph":"0","facebookOpenGraphAppID":"","config":"test.cfg.json","JMcolorVersion":"#017eba","JMpageBackground":"#f4f4f4","JMcomponentBackground":"#ffffff","JMcomponentBorder":"#e7e7e7","JMbaseFontColor":"#898989","JMarticleFontColor":"#2f2f2f","JMtopbarBackground":"#ffffff","JMtopbarBorder":"#e7e7e7","JMtopbarFontColor":"#898989","JMtopmenuBackground":"#ffffff","JMtopmenuBorder":"#e7e7e7","JMtopmenuFontColor":"#017eba","JMmoduleBackground":"#ffffff","JMmoduleBorder":"#e7e7e7","JMmoduleFontColor":"#898989","JMcolorBox1Background":"#017eba","JMcolorBox2Background":"#a0b046","JMcolorBox3Background":"#f78145","JMfooterBackground":"#e7e7e7","JMfooterBorder":"#dedede","JMfooterFontColor":"#898989","JMoffCanvasBackground":"#333333","JMoffCanvasFontColor":"#ffffff"}'),
('11','jm-services','0','0','jm-services - Culinary Theme','{"logo":"images\\/culinary\\/logo.png","logoText":"","siteDescription":"","favIconImg":"","fontSizeSwitcher":"0","backToTop":"1","offCanvas":"1","JMoffCanvasWidth":"300px","offCanvasPosition":"right","comingSoon":"0","comingSoonDate":"","error404article":"","responsiveLayout":"1","DisableComponentDisplay":["435"],"layout":"default","JMbaseFontSize":"16px","bodyFontType":"1;bodyGoogleWebFontUrl;bodyGoogleWebFontFamily","bodyFontFamily":"Arial, Helvetica, sans-serif","bodyGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Bitter:400,700,400italic&subset=latin,latin-ext","bodyGoogleWebFontFamily":"\'Bitter\', serif","JMtopmenuFontSize":"16px","djmenuFontType":"1;djmenuGoogleWebFontUrl;djmenuGoogleWebFontFamily","djmenuFontFamily":"Arial, Helvetica, sans-serif","djmenuGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Bitter:400,700,400italic&subset=latin,latin-ext","djmenuGoogleWebFontFamily":"\'Bitter\', serif","JMmoduleTitleFontSize":"20px","headingsFontType":"1;headingsGoogleWebFontUrl;headingsGoogleWebFontFamily","headingsFontFamily":"Arial, Helvetica, sans-serif","headingsGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Bitter:400,700,400italic&subset=latin,latin-ext","headingsGoogleWebFontFamily":"\'Bitter\', serif","JMblogTitleFontSize":"32px","blogFontType":"0;blogFontFamily","blogFontFamily":"Arial, Helvetica, sans-serif","blogGoogleWebFontUrl":"","blogGoogleWebFontFamily":"","JMarticleTitleFontSize":"32px","articlesFontType":"1;articlesGoogleWebFontUrl;articlesGoogleWebFontFamily","articlesFontFamily":"Arial, Helvetica, sans-serif","articlesGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Bitter:400,700,400italic&subset=latin,latin-ext","articlesGoogleWebFontFamily":"\'Bitter\', serif","advancedFontAwesome":"1","advancedFontSize":"50px","advancedFontType":"0;advancedFontFamily","advancedFontFamily":"Arial, Helvetica, sans-serif","advancedGoogleWebFontUrl":"","advancedGoogleWebFontFamily":"","advancedSelectors":"","themermode":"0","themerlogin":"0","themeradminaccess":"0","sourceMap":"0","codeInjection":"","cssCompress":"0","jsCompress":"0","htmlCompress":"0","skipCompress":"","jsDefer":"0","skipDefer":"","debug":"0","lazyLoading":"0","lazyExclude":"","lazyWidth":"50","lazyHeight":"50","facebookOpenGraph":"0","facebookOpenGraphAppID":"","config":"","JMcolorVersion":"#f47d56","JMpageBackground":"#ffffff","JMcomponentBackground":"#f1ead8","JMcomponentBorder":"#e1d6ba","JMbaseFontColor":"#898989","JMarticleFontColor":"#2f2f2f","JMtopbarBackground":"#ffffff","JMtopbarBorder":"#e7e7e7","JMtopbarFontColor":"#898989","JMtopmenuBackground":"#f1ead8","JMtopmenuBorder":"#e1d6ba","JMtopmenuFontColor":"#f47d56","JMmoduleBackground":"#f1ead8","JMmoduleBorder":"#e1d6ba","JMmoduleFontColor":"#898989","JMcolorBox1Background":"#f47d56","JMcolorBox2Background":"#ff9f80","JMcolorBox3Background":"#ffc48c","JMfooterBackground":"#f1ead8","JMfooterBorder":"#e1d6ba","JMfooterFontColor":"#898989","JMoffCanvasBackground":"#333333","JMoffCanvasFontColor":"#ffffff"}'),
('14','jm-services','0','0','jm-services - Dental Theme','{"logo":"images\\/dental\\/logo.png","logoText":"","siteDescription":"","favIconImg":"","fontSizeSwitcher":"0","backToTop":"1","offCanvas":"1","JMoffCanvasWidth":"300px","offCanvasPosition":"right","comingSoon":"0","comingSoonDate":"","error404article":"","responsiveLayout":"1","DisableComponentDisplay":["613"],"layout":"default","JMbaseFontSize":"16px","bodyFontType":"1;bodyGoogleWebFontUrl;bodyGoogleWebFontFamily","bodyFontFamily":"Arial, Helvetica, sans-serif","bodyGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Lato:400,300,300italic,400italic,700,700italic,900,900italic","bodyGoogleWebFontFamily":"\'Lato\', \'sans-serif\'","JMtopmenuFontSize":"16px","djmenuFontType":"1;djmenuGoogleWebFontUrl;djmenuGoogleWebFontFamily","djmenuFontFamily":"Arial, Helvetica, sans-serif","djmenuGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Oswald:400,700&subset=latin,latin-ext","djmenuGoogleWebFontFamily":"\'Oswald\', sans-serif","JMmoduleTitleFontSize":"20px","headingsFontType":"1;headingsGoogleWebFontUrl;headingsGoogleWebFontFamily","headingsFontFamily":"Arial, Helvetica, sans-serif","headingsGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Oswald:400,700&subset=latin,latin-ext","headingsGoogleWebFontFamily":"\'Oswald\', sans-serif","JMblogTitleFontSize":"32px","blogFontType":"0;blogFontFamily","blogFontFamily":"Arial, Helvetica, sans-serif","blogGoogleWebFontUrl":"","blogGoogleWebFontFamily":"","JMarticleTitleFontSize":"32px","articlesFontType":"1;articlesGoogleWebFontUrl;articlesGoogleWebFontFamily","articlesFontFamily":"Arial, Helvetica, sans-serif","articlesGoogleWebFontUrl":"\\/\\/fonts.googleapis.com\\/css?family=Oswald:400,700&subset=latin,latin-ext","articlesGoogleWebFontFamily":"\'Oswald\', sans-serif","advancedFontAwesome":"1","advancedFontSize":"50px","advancedFontType":"0;advancedFontFamily","advancedFontFamily":"Arial, Helvetica, sans-serif","advancedGoogleWebFontUrl":"","advancedGoogleWebFontFamily":"","advancedSelectors":"","themermode":"0","themerlogin":"0","themeradminaccess":"0","sourceMap":"0","codeInjection":"","cssCompress":"0","jsCompress":"0","htmlCompress":"0","skipCompress":"","jsDefer":"0","skipDefer":"","debug":"0","lazyLoading":"0","lazyExclude":"","lazyWidth":"50","lazyHeight":"50","facebookOpenGraph":"0","facebookOpenGraphAppID":"","config":"","JMcolorVersion":"#3b8686","JMpageBackground":"#ffffff","JMcomponentBackground":"#f3faf2","JMcomponentBorder":"#ddecda","JMbaseFontColor":"#898989","JMarticleFontColor":"#2f2f2f","JMtopbarBackground":"#3b8686","JMtopbarBorder":"#ffffff","JMtopbarFontColor":"#ffffff","JMtopmenuBackground":"#f3faf2","JMtopmenuBorder":"#ddecda","JMtopmenuFontColor":"#3b8686","JMmoduleBackground":"#f3faf2","JMmoduleBorder":"#ddecda","JMmoduleFontColor":"#898989","JMcolorBox1Background":"#3b8686","JMcolorBox2Background":"#59a980","JMcolorBox3Background":"#8cc68c","JMfooterBackground":"#8cc68c","JMfooterBorder":"#9ccb9c","JMfooterFontColor":"#ffffff","JMoffCanvasBackground":"#333333","JMoffCanvasFontColor":"#ffffff"}');

DROP TABLE IF EXISTS #__ucm_base;
CREATE TABLE `#__ucm_base` (
  `ucm_id` int(10) unsigned NOT NULL,
  `ucm_item_id` int(10) NOT NULL,
  `ucm_type_id` int(11) NOT NULL,
  `ucm_language_id` int(11) NOT NULL,
  PRIMARY KEY (`ucm_id`),
  KEY `idx_ucm_item_id` (`ucm_item_id`),
  KEY `idx_ucm_type_id` (`ucm_type_id`),
  KEY `idx_ucm_language_id` (`ucm_language_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO `#__ucm_base` VALUES 
('1','24','1','0'),
('3','71','1','0'),
('4','96','1','0'),
('5','97','1','0'),
('6','98','1','0'),
('7','99','1','0'),
('8','100','1','0'),
('9','101','1','0'),
('10','102','1','0'),
('11','103','1','0'),
('12','104','1','0'),
('13','105','1','0'),
('14','106','1','0'),
('15','107','1','0'),
('16','108','1','0'),
('17','109','1','0'),
('18','110','1','0'),
('19','113','1','0'),
('20','114','1','0'),
('21','115','1','0'),
('22','116','1','0'),
('23','117','1','0'),
('24','118','1','0'),
('25','119','1','0'),
('26','120','1','0'),
('27','122','1','0'),
('28','123','1','0'),
('29','124','1','0'),
('30','125','1','0'),
('31','126','1','0'),
('32','127','1','0'),
('33','128','1','0'),
('34','129','1','0');

DROP TABLE IF EXISTS #__ucm_content;
CREATE TABLE `#__ucm_content` (
  `core_content_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `core_type_alias` varchar(400) NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(400) NOT NULL DEFAULT '',
  `core_alias` varchar(400) NOT NULL DEFAULT '',
  `core_body` mediumtext NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_checked_out_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_access` int(10) unsigned NOT NULL DEFAULT '0',
  `core_params` text NOT NULL,
  `core_featured` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) NOT NULL DEFAULT '' COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) NOT NULL DEFAULT '',
  `core_publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_content_item_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ID from the individual type table',
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `core_images` text NOT NULL,
  `core_urls` text NOT NULL,
  `core_hits` int(10) unsigned NOT NULL DEFAULT '0',
  `core_version` int(10) unsigned NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` text NOT NULL,
  `core_metadesc` text NOT NULL,
  `core_catid` int(10) unsigned NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) NOT NULL DEFAULT '' COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`core_content_id`),
  KEY `tag_idx` (`core_state`,`core_access`),
  KEY `idx_access` (`core_access`),
  KEY `idx_language` (`core_language`),
  KEY `idx_modified_time` (`core_modified_time`),
  KEY `idx_created_time` (`core_created_time`),
  KEY `idx_core_modified_user_id` (`core_modified_user_id`),
  KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`),
  KEY `idx_core_created_user_id` (`core_created_user_id`),
  KEY `idx_core_type_id` (`core_type_id`),
  KEY `idx_alias` (`core_alias`(100)),
  KEY `idx_title` (`core_title`(100)),
  KEY `idx_content_type` (`core_type_alias`(100))
) AUTO_INCREMENT=35 DEFAULT CHARSET=utf8 COMMENT='Contains core content data in name spaced fields';

INSERT INTO `#__ucm_content` VALUES 
('1','com_content.article','Joomla! Testing','joomla','<p>Thanks for helping us to test Joomla!</p>\r\n<p>We\'re getting ready for the release of Joomla and we appreciate you helping us find and fix problems as we work.</p>\r\n<p>If you haven\'t done testing before here are some tips.</p>\r\n<ul>\r\n<li>Don\'t delete the installation folder when you finish installing! While we\'re working we turn that security feature off to make it easier to test.</li>\r\n<li>Go to global configuration and set Error Reporting to Development (that\'s on the server tab) and enable both debugging and language debugging (those are on the system tab). Don\'t worry when you see ** around words --that means Joomla translation is doing its job.</li>\r\n</ul>\r\n<p>How to test</p>\r\n<ul>\r\n<li>First, do the things you normally do and see if you spot any problems.</li>\r\n<li>Look at all of the front end views and record any problems</li>\r\n<li>Look at all the back end views and report any problems</li>\r\n<li>See more ideas below</li>\r\n</ul>\r\n<p>What to look for</p>\r\n<ul>\r\n<li>Any error messages that say things like Fatal Error or Strict or similar things that indicate that something is not working correctly.</li>\r\n<li>Untranslated strings. You will know these because they look like this: ?STRING_HERE?</li>\r\n<li>Problems of rendering--items not aligned correctly, missing or wrong images, pages that just don\'t look right.</li>\r\n<li>Unexpected behavior--anything that is working differently than it did in 2.5.</li>\r\n</ul>\r\n<p>Report problems</p>\r\n<p>If you find a problem please report it to the <a href="http://joomlacode.org/gf/project/joomla/tracker/?action=TrackerItemBrowse&amp;tracker_id=8103" target="_blank">CMS Issue Tracker</a>. You will need to register for a joomlacode.org account if you don\'t have one.</p>\r\n<p>More Testing Ideas</p>\r\n<ul>\r\n<li>Pick one module or view and test all of the parameters.</li>\r\n<li>Install an extension and see if anything breaks (report to the developer unless you are positive it is a core bug).</li>\r\n<li>Turn on caching with different options</li>\r\n<li>Try different session options</li>\r\n<li>Install a language and test all the layouts.</li>\r\n<li>Try different environments (like different servers which may have different version of PHP) or try you have IIS with MySQLi or SqlSrv. With millions of users Joomla needs to be ready for unusual environments.</li>\r\n<li>Try with SEF URLS on or off and also with Apache rewrite on or off (if you are on Apache).</li>\r\n<li>Try different combinations of browsers (Chrome, IE, FireFox, Opera to start) and operating systems (Mac, Windows, Linux).</li>\r\n<li>Yes grammar and spelling errors are bugs too -- just keep in mind that we use British spelling.</li>\r\n<li>Visit the <a href="http://joomlacode.org/gf/project/joomla/tracker/?action=TrackerItemBrowse&amp;tracker_id=8549" target="_blank">Feature Tracker</a> and test a new feature.</li>\r\n</ul>\r\n<p>Testing changes</p>\r\n<p>You can also help Joomla by testing bug fixes and new features.  A useful tool is the <a href="https://github.com/mbabker/patchtester/releases" target="_blank">patchtester component</a> which helps to simplify and automate the process.  Report your feedbak on the <span style="line-height: 1.3em;"> </span><a style="line-height: 1.3em;" href="http://joomlacode.org/gf/project/joomla/tracker/?action=TrackerItemBrowse&amp;tracker_id=8103" target="_blank">CMS Issue Tracker</a>. If you enjoy helping Joomla this way, you may want to join the <a href="http://docs.joomla.org/Bug_Squad" target="_blank">Joomla Bug Squad</a>.</p>\r\n<p> </p>','-2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":""}','1','{"robots":"","author":"","rights":"","xreference":""}','936','','2011-01-01 00:00:01','0','2013-10-15 14:57:20','*','2011-01-01 00:00:01','0000-00-00 00:00:00','24','180','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','59','3','2','','','19','','1'),
('3','com_content.article','Similar Tags','similar-tags','<p>The similar tags modules shows a list of items which have the same or a similar set of tags.</p>\r\n<p>{loadmodule tags_similar,Similar Tags}</p>','-2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2013-10-31 00:14:17','371','2013-10-31 00:39:09','*','2013-10-31 00:14:17','0000-00-00 00:00:00','71','179','{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','3','4','0','','','64','','1'),
('4','com_content.article','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:18:49','*','2014-05-15 12:44:15','0000-00-00 00:00:00','96','288','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','11','12','','','84','','1'),
('5','com_content.article','Consectetur Adipisc','consectetur-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-06-24 16:01:56','*','2014-05-15 12:44:15','0000-00-00 00:00:00','97','290','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','9','2','','','86','','1'),
('6','com_content.article','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:19:06','*','2014-05-15 12:44:15','0000-00-00 00:00:00','98','292','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','1','8','10','','','85','','1'),
('7','com_content.article','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:19:26','*','2014-05-15 12:44:15','0000-00-00 00:00:00','99','294','{"image_intro":"images\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','2','10','9','','','85','','1'),
('8','com_content.article','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:19:43','*','2014-05-15 12:44:15','0000-00-00 00:00:00','100','296','{"image_intro":"images\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','8','1','','','86','','1'),
('9','com_content.article','Malesuada Ultricies','malesuada-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:20:07','*','2014-05-15 12:44:15','0000-00-00 00:00:00','101','298','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','9','7','','','87','','1'),
('10','com_content.article','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-04 10:12:32','*','2014-05-15 12:44:15','0000-00-00 00:00:00','102','300','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','8','6','','','84','','1'),
('11','com_content.article','Quisque Vestibulum','quisque-vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 15:20:38','*','2014-05-15 12:44:15','0000-00-00 00:00:00','103','302','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','8','5','','','87','','1'),
('12','com_content.article','Cras Eleifend','cras-eleifend','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2013-12-15 12:44:15','800','2014-07-07 15:18:17','*','2013-12-15 12:44:15','0000-00-00 00:00:00','104','306','{"image_intro":"images\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','3','4','','','83','','1'),
('13','com_content.article','Fusce Eu Risus','fusce-eu-risus','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-01-15 12:44:15','800','2014-07-07 15:17:56','*','2014-01-15 12:44:15','0000-00-00 00:00:00','105','308','{"image_intro":"images\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','4','3','','','83','','1'),
('14','com_content.article','Pretium Pellentesque','pretium-pellentesque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-02-15 12:44:15','800','2014-07-07 15:17:19','*','2014-02-15 12:44:15','0000-00-00 00:00:00','106','310','{"image_intro":"images\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','4','4','2','','','83','','1'),
('15','com_content.article','Volutpat Vehicula','volutpat-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-03-15 12:44:15','800','2014-07-07 15:17:39','*','2014-03-15 12:44:15','0000-00-00 00:00:00','107','312','{"image_intro":"images\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','5','1','','','83','','1'),
('16','com_content.article','Auctor Justo','auctor-justo','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','2','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-04-15 12:44:15','164','2014-05-15 14:08:03','*','2014-04-15 12:44:15','0000-00-00 00:00:00','108','314','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','3','0','','','83','','1'),
('17','com_content.article','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:51:03','*','2014-05-15 12:44:15','0000-00-00 00:00:00','109','322','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','6','5','0','','','88','','1'),
('18','com_content.article','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:51:09','*','2014-05-15 12:44:15','0000-00-00 00:00:00','110','324','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','8','5','0','','','88','','1'),
('19','com_content.article','Quisque Vestibulum','quisque-vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','0','2014-05-15 14:10:42','*','2014-05-15 12:44:15','0000-00-00 00:00:00','113','336','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','6','5','','','90','','1'),
('20','com_content.article','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-06-24 16:00:34','*','2014-05-15 12:44:15','0000-00-00 00:00:00','114','338','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','7','6','','','90','','1'),
('21','com_content.article','Malesuada Ultricies','malesuada-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:49:56','*','2014-05-15 12:44:15','0000-00-00 00:00:00','115','340','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','8','7','','','90','','1'),
('22','com_content.article','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','0','2014-05-15 14:10:22','*','2014-05-15 12:44:15','0000-00-00 00:00:00','116','342','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','6','1','','','90','','1'),
('23','com_content.article','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','0','2014-05-15 14:10:02','*','2014-05-15 12:44:15','0000-00-00 00:00:00','117','344','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','2','8','9','','','90','','1'),
('24','com_content.article','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:50:34','*','2014-05-15 12:44:15','0000-00-00 00:00:00','118','346','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','1','7','10','','','90','','1'),
('25','com_content.article','Consectetur Adipisc','consectetur-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:50:26','*','2014-05-15 12:44:15','0000-00-00 00:00:00','119','348','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','10','2','','','90','','1'),
('26','com_content.article','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-07 14:49:38','*','2014-05-15 12:44:15','0000-00-00 00:00:00','120','350','{"image_intro":"images\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','10','12','','','90','','1'),
('27','com_content.article','Vestibulum','vestibulum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:19:33','*','2014-05-15 12:44:15','0000-00-00 00:00:00','122','364','{"image_intro":"images\\/culinary\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','10','5','','','93','','1'),
('28','com_content.article','Nunc Placerat','nunc-placerat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:19:19','*','2014-05-15 12:44:15','0000-00-00 00:00:00','123','366','{"image_intro":"images\\/culinary\\/blog\\/blog3.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','10','6','','','93','','1'),
('29','com_content.article','Males Ultricies','males-ultricies','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:19:06','*','2014-05-15 12:44:15','0000-00-00 00:00:00','124','368','{"image_intro":"images\\/culinary\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','11','7','','','93','','1'),
('30','com_content.article','Praesent Vehicula','praesent-vehicula','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:18:47','*','2014-05-15 12:44:15','0000-00-00 00:00:00','125','370','{"image_intro":"images\\/culinary\\/blog\\/blog4.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','10','1','','','93','','1'),
('31','com_content.article','Aliquam Feugiat','aliquam-feugiat','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:18:34','*','2014-05-15 12:44:15','0000-00-00 00:00:00','126','372','{"image_intro":"images\\/culinary\\/blog\\/blog6.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','2','12','9','','','93','','1'),
('32','com_content.article','Nulla Scelerisque','nulla-scelerisque','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:18:21','*','2014-05-15 12:44:15','0000-00-00 00:00:00','127','374','{"image_intro":"images\\/culinary\\/blog\\/blog5.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','1','10','10','','','93','','1'),
('33','com_content.article','Consec Adipisc','consec-adipisc','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:20:37','*','2014-05-15 12:44:15','0000-00-00 00:00:00','128','376','{"image_intro":"images\\/culinary\\/blog\\/blog1.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','0','11','2','','','93','','1'),
('34','com_content.article','Lorem Ipsum','lorem-ipsum','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n','1','','0','1','{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}','0','{"robots":"","author":"","rights":"","xreference":""}','936','','2014-05-15 12:44:15','800','2014-07-08 13:21:02','*','2014-05-15 12:44:15','0000-00-00 00:00:00','129','378','{"image_intro":"images\\/culinary\\/blog\\/blog2.jpg","float_intro":"left","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}','{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}','5','13','12','','','93','','1');

DROP TABLE IF EXISTS #__ucm_history;
CREATE TABLE `#__ucm_history` (
  `version_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ucm_item_id` int(10) unsigned NOT NULL,
  `ucm_type_id` int(10) unsigned NOT NULL,
  `version_note` varchar(255) NOT NULL DEFAULT '' COMMENT 'Optional version name',
  `save_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `character_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Number of characters in this version.',
  `sha1_hash` varchar(50) NOT NULL DEFAULT '' COMMENT 'SHA1 hash of the version_data column.',
  `version_data` longtext NOT NULL COMMENT 'json-encoded string of version data',
  `keep_forever` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0=auto delete; 1=keep',
  PRIMARY KEY (`version_id`),
  KEY `idx_ucm_item_id` (`ucm_type_id`,`ucm_item_id`),
  KEY `idx_save_date` (`save_date`)
) AUTO_INCREMENT=334 DEFAULT CHARSET=utf8;

INSERT INTO `#__ucm_history` VALUES 
('1','78','6','','2014-04-28 14:33:56','936','533','9fb3b8592603adb4553a4f579bb2b80d5467e23e','{"id":78,"asset_id":181,"parent_id":"1","lft":"135","rgt":136,"level":1,"path":null,"extension":"com_content","title":"JM-Sample-Data","alias":"jm-sample-data","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-04-28 14:33:56","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('2','73','1','','2014-04-28 14:34:25','936','3156','a1966ad7ebe685999974dcd63db322c5b5d690c9','{"id":73,"asset_id":182,"title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.<\\/p>\\r\\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum ullamcorper sapien metus, a pharetra libero tristique eget. Vivamus facilisis erat nec elementum interdum. Suspendisse aliquet eros eu fringilla commodo. Praesent placerat nunc ac massa volutpat rutrum. Morbi non eros pulvinar, interdum quam facilisis, laoreet urna. Aenean mi dui, accumsan quis hendrerit eleifend, ullamcorper in purus. Donec eleifend lacus eu nibh ultricies molestie. In et molestie est, at porttitor nibh. Nunc sit amet dui faucibus, ultrices nibh quis, pellentesque tellus. In quis urna quis diam malesuada varius. Curabitur non lacus vel dui mattis facilisis vitae ac odio.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('16','73','1','','2014-05-07 16:08:53','936','3198','ea59918d20734ae57a784791edb66e80d00ad780','{"id":"73","asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.<\\/p>\\r\\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum ullamcorper sapien metus, a pharetra libero tristique eget. Vivamus facilisis erat nec elementum interdum. Suspendisse aliquet eros eu fringilla commodo. Praesent placerat nunc ac massa volutpat rutrum. Morbi non eros pulvinar, interdum quam facilisis, laoreet urna. Aenean mi dui, accumsan quis hendrerit eleifend, ullamcorper in purus. Donec eleifend lacus eu nibh ultricies molestie. In et molestie est, at porttitor nibh. Nunc sit amet dui faucibus, ultrices nibh quis, pellentesque tellus. In quis urna quis diam malesuada varius. Curabitur non lacus vel dui mattis facilisis vitae ac odio.<\\/p>","fulltext":"","state":"1","catid":79,"created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-07 16:08:53","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"1","ordering":"3","metakey":"","metadesc":"","access":"1","hits":"270","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('22','73','1','','2014-05-07 16:34:50','936','3196','7daaef7c128e9892c62f1f8bdfc8a184d94299e1','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.<\\/p>\\r\\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum ullamcorper sapien metus, a pharetra libero tristique eget. Vivamus facilisis erat nec elementum interdum. Suspendisse aliquet eros eu fringilla commodo. Praesent placerat nunc ac massa volutpat rutrum. Morbi non eros pulvinar, interdum quam facilisis, laoreet urna. Aenean mi dui, accumsan quis hendrerit eleifend, ullamcorper in purus. Donec eleifend lacus eu nibh ultricies molestie. In et molestie est, at porttitor nibh. Nunc sit amet dui faucibus, ultrices nibh quis, pellentesque tellus. In quis urna quis diam malesuada varius. Curabitur non lacus vel dui mattis facilisis vitae ac odio.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-07 16:34:50","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-07 16:34:42","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"271","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('93','83','6','','2014-05-15 12:32:13','936','513','7e27231d4f0101d8e4a3b5b8399f2a8d0c107c9d','{"id":83,"asset_id":286,"parent_id":"1","lft":"145","rgt":146,"level":1,"path":null,"extension":"com_content","title":"Blog","alias":"blog","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 12:32:13","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('97','96','1','','2014-05-15 12:44:15','936','6886','db8873ff41fcfec2839253288dfd9c5be61f5817','{"id":96,"asset_id":287,"title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('98','6','10','','2014-05-15 12:44:51','936','555','725cec5aad74d2e1e61b5d493a1136566edb832e','{"id":6,"parent_id":"1","lft":"1","rgt":2,"level":1,"path":"lorem","title":"lorem","alias":"lorem","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 12:44:51","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('99','7','10','','2014-05-15 12:44:51','936','555','24e016411fca9d48cd8523c5aab9ca5e5f9a5e4a','{"id":7,"parent_id":"1","lft":"3","rgt":4,"level":1,"path":"ipsum","title":"ipsum","alias":"ipsum","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 12:44:51","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('100','8','10','','2014-05-15 12:44:51','936','555','62ed551d7b1168c69957fc05f54b2a0c90484f54','{"id":8,"parent_id":"1","lft":"5","rgt":6,"level":1,"path":"dolor","title":"dolor","alias":"dolor","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 12:44:51","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('101','9','10','','2014-05-15 12:44:51','936','549','b1108675f4f6d2463c1ae04c51a93ffb2f530e71','{"id":9,"parent_id":"1","lft":"7","rgt":8,"level":1,"path":"sit","title":"sit","alias":"sit","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 12:44:51","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('102','10','10','','2014-05-15 12:44:51','936','554','f9cfa6af25981df0c97d2e61cacdda7c36109c7a','{"id":10,"parent_id":"1","lft":"9","rgt":10,"level":1,"path":"amet","title":"amet","alias":"amet","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 12:44:51","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('103','97','1','','2014-05-15 12:45:12','936','6903','f77ff5967109f02819d8eb95519ecaac0a65da8c','{"id":97,"asset_id":289,"title":"Consectetur Adipiscing (2)","alias":"lorem-ipsum-2","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:44:51","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('104','97','1','','2014-05-15 12:45:24','936','6946','546e8acc1a2a6d0c226f8016ba416f0ac2e7bb00','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:45:24","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:45:12","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('105','98','1','','2014-05-15 12:45:38','936','6898','f5033ea417f9a0b84fc7766c4c44eabba6dba8fc','{"id":98,"asset_id":291,"title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:45:24","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('106','99','1','','2014-05-15 12:45:56','936','6894','3f6034e777f317383f6ef5e9aa917b103f243aee','{"id":99,"asset_id":293,"title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:45:24","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('107','99','1','','2014-05-15 12:46:09','936','6932','c252d789b4a9355a5e1197f34497153f48c04d02','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:46:09","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:45:56","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('108','100','1','','2014-05-15 12:46:23','936','6899','9d1a13cf8b59175f21c739e8fcc7f77a8f6d0684','{"id":100,"asset_id":295,"title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:46:09","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('109','100','1','','2014-05-15 12:46:28','936','6937','a3c17ae878fd77b9c32a1bf456bffb48322696ba','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:46:28","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:46:23","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('110','101','1','','2014-05-15 12:46:54','936','6903','283036a5cc724fcbd591aca03b9819eff325ae77','{"id":101,"asset_id":297,"title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:46:28","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('111','101','1','','2014-05-15 12:47:02','936','6941','dcf3092aa0ea91fb309d77621ad1fd75c82f10f2','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:47:02","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:46:54","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('112','102','1','','2014-05-15 12:47:19','936','6907','40528337db1d577999d11f8a8ecc40479bb3a494','{"id":102,"asset_id":299,"title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:47:02","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('113','102','1','','2014-05-15 12:47:23','936','6945','34bac2533a445181d28b2051d2832213d112379b','{"id":102,"asset_id":"299","title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:47:23","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:47:19","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('114','103','1','','2014-05-15 12:47:53','936','6901','1edb9d75b90a16aa72add1edc2ee7b74e9bb70b4','{"id":103,"asset_id":301,"title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:46:28","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('115','103','1','','2014-05-15 12:47:59','936','6939','432f930bee332597b3460d4e9f2b7b5749a5d326','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 12:47:59","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 12:47:53","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('116','96','1','','2014-05-15 13:02:22','936','6955','1fe5cbf5cc50aff3afd97708472b4f536e9fe816','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum.<\\/strong><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:02:22","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:02:07","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('117','96','1','','2014-05-15 13:05:31','936','6651','950d97b74a512879323b52b7ba6c1354e6740535','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris www.joomla-monster.com nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:05:31","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:02:22","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('118','96','1','','2014-05-15 13:06:56','936','6642','1b88741e5a2929a5564723ea64b2b173b05b6cda','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:06:56","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:05:31","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('119','99','1','','2014-05-15 13:07:16','936','6650','ba2828fdd364f090179b2552cac37593ab50b3f8','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:07:16","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:07:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"4","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('120','97','1','','2014-05-15 13:07:32','936','6660','7c430a1df226a4ec8c9e3d93b097b2382f8366a7','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:07:32","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:07:19","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('121','97','1','','2014-05-15 13:07:41','936','6664','ca7ccc961dad03fef2ee0aab25f17d8bf2bf8b11','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:07:41","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:07:35","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('122','101','1','','2014-05-15 13:07:59','936','6659','bf431d2a548cf2b5137d6e666c50b427dfd15fad','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:07:59","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:07:45","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('123','98','1','','2014-05-15 13:08:20','936','6654','dc4f07b86cb05f9ce37184dc2cc41552946d6308','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>t enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:08:20","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:08:03","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('124','98','1','','2014-05-15 13:08:54','936','6655','b18b311a0f21b7d4f8eff9f2ec1add5b7dcba50b','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:08:54","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:08:44","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('125','99','1','','2014-05-15 13:09:02','936','6651','68c545daee2a16e7782b9bc4b28711950ade5b5e','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:09:02","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:08:40","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"4","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('126','97','1','','2014-05-15 13:09:08','936','6665','2f6b8ff9b5f216998b4b491bfe34368344100068','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:09:08","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:08:41","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('127','101','1','','2014-05-15 13:09:27','936','6660','46b68a3a07f94e750d1b77e0235c056926e562fa','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:09:27","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:09:18","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('128','96','1','','2014-05-15 13:10:09','936','6643','712d25dd23eb174cce5ff380db9bad0a6f0169e6','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:10:09","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:10:01","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('129','100','1','','2014-05-15 13:10:30','936','6656','04d004e8cd09270ecab72ada337a585edb30ee91','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:10:30","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:10:02","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('130','103','1','','2014-05-15 13:10:51','936','6658','36828c5837fea9fa3eba0936f5f0e0cd53ed8210','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:10:51","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:10:34","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('131','102','1','','2014-05-15 13:11:28','936','6664','3e0d3ab9987726dcff139ad8d0aa5c3716946d75','{"id":102,"asset_id":"299","title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:11:28","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:11:11","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('132','11','10','','2014-05-15 13:18:57','936','552','764c9075b2aecbb47b8c6fdfa34aa149fef52b13','{"id":11,"parent_id":"1","lft":"11","rgt":12,"level":1,"path":"nec","title":"nec","alias":"nec","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 13:18:57","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('133','12','10','','2014-05-15 13:18:57','936','555','47d0582c0d2560ce66be7b1257c414a53fb2bec5','{"id":12,"parent_id":"1","lft":"13","rgt":14,"level":1,"path":"quis","title":"quis","alias":"quis","note":"","description":null,"published":1,"checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":1,"params":null,"metadesc":null,"metakey":null,"metadata":null,"created_user_id":"164","created_time":"2014-05-15 13:18:57","created_by_alias":"","modified_user_id":"0","modified_time":"0000-00-00 00:00:00","images":null,"urls":null,"hits":"0","language":"*","version":"1","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00"}','0'),
('134','104','1','','2014-05-15 13:41:19','936','6610','73f6137ad3aed09db386793c009ae7ceaf47f115','{"id":104,"asset_id":305,"title":"Cras Eleifend","alias":"cras-eleifend","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2013-12-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:10:51","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2013-12-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('135','105','1','','2014-05-15 13:41:59','936','6612','72a594925e0ca64b8134425619e3662d2800de20','{"id":105,"asset_id":307,"title":"Fusce Eu Risus","alias":"fusce-eu-risus","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-01-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:10:51","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-01-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('136','105','1','','2014-05-15 13:42:05','936','6650','b09db5e50d2900b25d080a59147110ac7ff67fde','{"id":105,"asset_id":"307","title":"Fusce Eu Risus","alias":"fusce-eu-risus","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-01-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:42:05","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:41:59","publish_up":"2014-01-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('137','106','1','','2014-05-15 13:42:26','936','6624','9b8958be560c597675ffde8fee0e15f2c80c9a83','{"id":106,"asset_id":309,"title":"Pretium Pellentesque","alias":"pretium-pellentesque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-02-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:42:05","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-02-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('138','106','1','','2014-05-15 13:42:34','936','6662','85923302e40fe73a096cb26cc39ff854a2aee93f','{"id":106,"asset_id":"309","title":"Pretium Pellentesque","alias":"pretium-pellentesque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-02-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:42:34","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:42:26","publish_up":"2014-02-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('139','107','1','','2014-05-15 13:42:55','936','6618','ace1773dccb42ba625631a2531239ab7c3fc7a95','{"id":107,"asset_id":311,"title":"Volutpat Vehicula","alias":"volutpat-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-03-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:42:34","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-03-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('140','107','1','','2014-05-15 13:43:01','936','6656','95e812cf6e8993e2ea248a51a70aa173afc9a053','{"id":107,"asset_id":"311","title":"Volutpat Vehicula","alias":"volutpat-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-03-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:43:01","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:42:55","publish_up":"2014-03-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('141','108','1','','2014-05-15 13:43:38','936','6608','d8239b0491e43f645af153340a773562b15a3707','{"id":108,"asset_id":313,"title":"Auctor Justo","alias":"auctor-justo","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"83","created":"2014-04-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:43:18","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-04-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0');
INSERT INTO `#__ucm_history` VALUES 
('142','108','1','','2014-05-15 13:43:44','936','6646','14a4f50f5b137c2ffa1968211f686bf871b2b63a','{"id":108,"asset_id":"313","title":"Auctor Justo","alias":"auctor-justo","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"83","created":"2014-04-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:43:44","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:43:38","publish_up":"2014-04-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('143','84','6','','2014-05-15 13:46:25','936','536','a6f8b76d42be12b61bc8730be2bb2e176725e126','{"id":84,"asset_id":315,"parent_id":"83","lft":"146","rgt":147,"level":2,"path":null,"extension":"com_content","title":"Blog Category 1","alias":"blog-category-1","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:25","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('144','85','6','','2014-05-15 13:46:29','936','538','ab3799391f9b73035137f90feee2c0ed69eeb2b2','{"id":85,"asset_id":316,"parent_id":"83","lft":"148","rgt":149,"level":2,"path":null,"extension":"com_content","title":"Blog Category 2 (2)","alias":"blog-category-2","note":"","description":"","published":0,"checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:29","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('145','85','6','','2014-05-15 13:46:36','936','596','ffa7c448ed272822e4f613d33742258cb58aa9d6','{"id":85,"asset_id":"316","parent_id":"83","lft":"148","rgt":"149","level":"2","path":"blog\\/blog-category-2","extension":"com_content","title":"Blog Category 2","alias":"blog-category-2","note":"","description":"","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:46:29","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:29","modified_user_id":"164","modified_time":"2014-05-15 13:46:36","hits":"0","language":"*","version":"1"}','0'),
('146','86','6','','2014-05-15 13:46:41','936','538','bcf54a888536eebe81efd73fdb152c75d2c076e6','{"id":86,"asset_id":317,"parent_id":"83","lft":"150","rgt":151,"level":2,"path":null,"extension":"com_content","title":"Blog Category 3 (2)","alias":"blog-category-3","note":"","description":"","published":0,"checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:41","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('147','86','6','','2014-05-15 13:46:47','936','596','656cf2544934d9ce9d4fe8a21fa7adfea1b5bfff','{"id":86,"asset_id":"317","parent_id":"83","lft":"150","rgt":"151","level":"2","path":"blog\\/blog-category-3","extension":"com_content","title":"Blog Category 3","alias":"blog-category-3","note":"","description":"","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:46:41","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:41","modified_user_id":"164","modified_time":"2014-05-15 13:46:47","hits":"0","language":"*","version":"1"}','0'),
('148','87','6','','2014-05-15 13:46:53','936','538','47ddb7aff9932243fc5485c082f2fd8e3506a4d3','{"id":87,"asset_id":318,"parent_id":"83","lft":"152","rgt":153,"level":2,"path":null,"extension":"com_content","title":"Blog Category 4 (2)","alias":"blog-category-4","note":"","description":"","published":0,"checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:53","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('149','87','6','','2014-05-15 13:46:59','936','596','83ecdd52f302d36a4d5702d2d9d591baa0dfa72f','{"id":87,"asset_id":"318","parent_id":"83","lft":"152","rgt":"153","level":"2","path":"blog\\/blog-category-4","extension":"com_content","title":"Blog Category 4","alias":"blog-category-4","note":"","description":"","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:46:53","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:53","modified_user_id":"164","modified_time":"2014-05-15 13:46:59","hits":"0","language":"*","version":"1"}','0'),
('150','87','6','','2014-05-15 13:48:35','936','661','dddd2a54c6441a3314cc6eeec402d282bca48893','{"id":87,"asset_id":"318","parent_id":"83","lft":"152","rgt":"153","level":"2","path":"blog\\/blog-category-4","extension":"com_content","title":"Blog Category 4","alias":"blog-category-4","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.<\\/p>","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:46:59","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:53","modified_user_id":"164","modified_time":"2014-05-15 13:48:35","hits":"0","language":"*","version":"1"}','0'),
('151','87','6','','2014-05-15 13:49:16','936','677','7aefae3cc9daa0a0339524789c49e3fa246c16a4','{"id":87,"asset_id":"318","parent_id":"83","lft":"152","rgt":"153","level":"2","path":"blog\\/blog-category-4","extension":"com_content","title":"Blog Category 4","alias":"blog-category-4","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod.<\\/p>","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:49:09","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:53","modified_user_id":"164","modified_time":"2014-05-15 13:49:16","hits":"0","language":"*","version":"1"}','0'),
('152','84','6','','2014-05-15 13:49:39','936','677','57afa737e13f1c5a7db07ed315ee0b62ef22719e','{"id":84,"asset_id":"315","parent_id":"83","lft":"146","rgt":"147","level":"2","path":"blog\\/blog-category-1","extension":"com_content","title":"Blog Category 1","alias":"blog-category-1","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod.<\\/p>","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:49:35","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:25","modified_user_id":"164","modified_time":"2014-05-15 13:49:39","hits":"0","language":"*","version":"1"}','0'),
('153','85','6','','2014-05-15 13:49:49','936','677','139bb771eec86e365a38ceb80c30b4cb80fda296','{"id":85,"asset_id":"316","parent_id":"83","lft":"148","rgt":"149","level":"2","path":"blog\\/blog-category-2","extension":"com_content","title":"Blog Category 2","alias":"blog-category-2","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod.<\\/p>","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:49:45","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:29","modified_user_id":"164","modified_time":"2014-05-15 13:49:49","hits":"0","language":"*","version":"1"}','0'),
('154','86','6','','2014-05-15 13:49:56','936','677','951792b8fd8237b50fcbb50470095ef8c13eeef1','{"id":86,"asset_id":"317","parent_id":"83","lft":"150","rgt":"151","level":"2","path":"blog\\/blog-category-3","extension":"com_content","title":"Blog Category 3","alias":"blog-category-3","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod.<\\/p>","published":"1","checked_out":"164","checked_out_time":"2014-05-15 13:49:52","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 13:46:41","modified_user_id":"164","modified_time":"2014-05-15 13:49:56","hits":"0","language":"*","version":"1"}','0'),
('155','96','1','','2014-05-15 13:51:39','936','6644','8e008fe0670688f23319f723df23676a4c889558','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:51:39","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:51:32","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('156','99','1','','2014-05-15 13:51:52','936','6651','0f07ea266dd1fe15e35bc8025ef98e612655e173','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:51:52","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:51:45","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('157','97','1','','2014-05-15 13:52:01','936','6666','2083d193025caf9eff08d679599d0e67fdc34de7','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:01","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:51:55","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"11","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('158','101','1','','2014-05-15 13:52:12','936','6660','f5cd34126b2fa01af02017437cf060ea565a6c1c','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:12","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:52:06","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('159','102','1','','2014-05-15 13:52:20','936','6664','23659cc4e1eb8ec24a556daccd08328f39668609','{"id":102,"asset_id":"299","title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:20","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:52:15","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('160','98','1','','2014-05-15 13:52:29','936','6656','90b8e6736fe5cd15a7b6c95b84c63548e88c5ce7','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:29","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:52:24","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('161','100','1','','2014-05-15 13:52:44','936','6656','cd3c4e2a001d2a717f4459600313fa5a6a55a85e','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:44","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:52:39","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"8","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('162','103','1','','2014-05-15 13:52:55','936','6658','975872b77fc4c87dad63fae8b5cbea46aa884a29','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:55","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 13:52:48","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('163','88','6','','2014-05-15 14:00:02','936','523','25bd5ea771c4ee137377fc064d2dbfab95880cd0','{"id":88,"asset_id":320,"parent_id":"1","lft":"155","rgt":156,"level":1,"path":null,"extension":"com_content","title":"Newsflash","alias":"newsflash","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 14:00:02","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('164','109','1','','2014-05-15 14:00:33','936','6606','0baf7fd05a1118ff33e515995d266f46be2651f5','{"id":109,"asset_id":321,"title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:51:39","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('165','109','1','','2014-05-15 14:00:41','936','6644','c157b7e10b1f16304958f277938832a75ad88004','{"id":109,"asset_id":"321","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:00:41","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:00:33","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('166','110','1','','2014-05-15 14:01:02','936','6606','4d3644377c5c2471e367cba74ea5dfab59ec3dd6','{"id":110,"asset_id":323,"title":"Praesent Vehicula (2)","alias":"praesent-vehicula-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":0,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 13:52:44","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-05-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('167','110','1','','2014-05-15 14:01:15','936','6638','939d5c643dc49f12bacccf2d54d4fa3afb9700c8','{"id":110,"asset_id":"323","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:01:15","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:01:02","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('168','96','1','','2014-05-15 14:01:31','936','6626','e84f9258ce980d2bf2fe8d5e8f91770285ba243e','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:01:31","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:01:23","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('169','97','1','','2014-05-15 14:01:45','936','6647','27a77c2c0ce163e8cdad638c53e8efdbf7a46eee','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:01:45","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:01:34","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('170','102','1','','2014-05-15 14:02:02','936','6646','69e7dc719a8a863d1cd2706ddf04b5a354fa608b','{"id":102,"asset_id":"299","title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:02:02","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:01:52","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('171','98','1','','2014-05-15 14:02:14','936','6638','de5bc1c1fe0f066f3fa65e05b3e4c04f78c2d584','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:02:14","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:02:06","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('172','99','1','','2014-05-15 14:02:26','936','6633','5d645e456460cda010fb1633d411d4651bf8ac48','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:02:26","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:02:17","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('173','100','1','','2014-05-15 14:02:47','936','6638','091be793b2a6304e83a1f2da13cfcad6a609f187','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:02:47","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:02:39","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('174','101','1','','2014-05-15 14:03:08','936','6642','8de1d2bea425630fd22d530b2c1317ddd7efc3e6','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:03:08","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:02:59","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('175','103','1','','2014-05-15 14:03:20','936','6640','bf64a6a201049fbbae460ac2f268bd91f54d5b10','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:03:20","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:03:12","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('176','109','1','','2014-05-15 14:06:07','936','6582','d9eb1e4f7e62b4dc9b2e9f42566b42a87b42ac0f','{"id":109,"asset_id":"321","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:06:07","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:05:53","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('177','110','1','','2014-05-15 14:06:22','936','6594','ce832eb399602e661485d27fa89b99953d4f7dfb','{"id":110,"asset_id":"323","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:06:22","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:10","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('178','108','1','','2014-05-15 14:08:03','936','6591','2959a9a80b535b975b723298e30469958548ac04','{"id":108,"asset_id":"313","title":"Auctor Justo","alias":"auctor-justo","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-04-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:08:03","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:43","publish_up":"2014-04-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('179','107','1','','2014-05-15 14:08:15','936','6601','f0c74d7131f3172fac869f9d3de44072abd59d67','{"id":107,"asset_id":"311","title":"Volutpat Vehicula","alias":"volutpat-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-03-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:08:15","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:43","publish_up":"2014-03-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('180','106','1','','2014-05-15 14:08:30','936','6607','f253d99d5a859d2ac5bcdc7e5d1100b75d4ff4fa','{"id":106,"asset_id":"309","title":"Pretium Pellentesque","alias":"pretium-pellentesque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-02-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:08:30","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:42","publish_up":"2014-02-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('181','105','1','','2014-05-15 14:08:43','936','6595','0583bd821f15eae0eebaec7281a49e17eb9180de','{"id":105,"asset_id":"307","title":"Fusce Eu Risus","alias":"fusce-eu-risus","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-01-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:08:43","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:41","publish_up":"2014-01-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('182','104','1','','2014-05-15 14:08:54','936','6593','82c925705454c40f2a13e0536234015ae9f6add0','{"id":104,"asset_id":"305","title":"Cras Eleifend","alias":"cras-eleifend","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2013-12-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:08:54","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:06:40","publish_up":"2013-12-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"4","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('183','96','1','','2014-05-15 14:09:36','936','6608','c84192295ffcac7c41be6b0d4a81da7705385162','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:09:36","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:19","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('184','102','1','','2014-05-15 14:09:46','936','6628','88d962a03529c5997edcff342aa3cfceca864ab2','{"id":102,"asset_id":"299","title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:09:46","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:20","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('185','99','1','','2014-05-15 14:10:02','936','6615','4266beafab3a7489dc4955edcbcf1b908b8e2912','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:10:02","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:21","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('186','97','1','','2014-05-15 14:10:12','936','6629','1b03cfbf6f2d2206b2a30ebf9607856524494e4b','{"id":97,"asset_id":"289","title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:10:12","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:23","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('187','100','1','','2014-05-15 14:10:22','936','6620','a0a68680fef9a26fd94802aab9f15d978f65ece0','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:10:22","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:24","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('188','101','1','','2014-05-15 14:10:31','936','6624','bfa8735d11a4ba38ed84d635e646cced9e6c444f','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:10:31","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:25","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('189','103','1','','2014-05-15 14:10:42','936','6622','e4dffefc3abf396b1da2b37e5bc5530f92c1a839','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:10:42","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:09:26","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('190','98','1','','2014-05-15 14:12:25','936','6620','8f17110f0dd3999c3028e0a22be8a9a19d94ced3','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:12:25","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:12:15","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('191','109','1','','2014-05-15 14:12:45','936','6564','eb25e2e4ebdfa6c1db30289bc553c95e938342a9','{"id":109,"asset_id":"321","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:12:45","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:12:36","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0');
INSERT INTO `#__ucm_history` VALUES 
('192','110','1','','2014-05-15 14:12:57','936','6576','693fae310e798a838309af9f1b96338533dee697','{"id":110,"asset_id":"323","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:12:57","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:12:48","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('193','89','7','','2014-05-15 14:24:12','936','537','5c9b725d5abc31a54fb4951e00e520c8f50062ea','{"id":89,"asset_id":326,"parent_id":"1","lft":"157","rgt":158,"level":1,"path":null,"extension":"com_contact","title":"Contact Category","alias":"contact-category","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"164","created_time":"2014-05-15 14:24:12","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('194','9','3','','2014-05-15 14:25:32','936','1659','15ecb21e1b5e9d43d845b3334401b921d57afea9','{"id":9,"name":"Contact","alias":"contact","con_position":"","address":"","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"","telephone":"","fax":"","misc":"","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":null,"checked_out_time":null,"ordering":3,"params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"plain\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-05-15 14:25:32","created_by":"164","created_by_alias":"","modified":"","modified_by":null,"metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":1,"hits":null}','0'),
('195','9','3','','2014-05-15 14:28:30','936','1729','cf7953b7e8674da31cd1e303549d34a885fb6d4a','{"id":9,"name":"Contact","alias":"contact","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":"164","checked_out_time":"2014-05-15 14:26:56","ordering":"3","params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"plain\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-05-15 14:25:32","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:28:30","modified_by":"164","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":2,"hits":"1"}','0'),
('196','9','3','','2014-05-15 14:29:19','936','1741','deec4a018d10fba94ec1abf1a53683d4eaad1e4c','{"id":9,"name":"Contact","alias":"contact","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":"164","checked_out_time":"2014-05-15 14:28:30","ordering":"3","params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"plain\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"0\\",\\"show_position\\":\\"0\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"0\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"0\\",\\"show_fax\\":\\"0\\",\\"show_webpage\\":\\"0\\",\\"show_misc\\":\\"0\\",\\"show_image\\":\\"0\\",\\"allow_vcard\\":\\"0\\",\\"show_articles\\":\\"0\\",\\"show_profile\\":\\"0\\",\\"show_links\\":\\"0\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-05-15 14:25:32","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:29:19","modified_by":"164","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":3,"hits":"2"}','0'),
('197','73','1','','2014-05-15 14:46:05','936','2938','aadf194e2bf752835d9cd9da5441e9433d720a8e','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.<\\/p>\\r\\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum ullamcorper sapien metus, a pharetra libero tristique eget. Vivamus facilisis erat nec elementum interdum. Suspendisse aliquet eros eu fringilla commodo. Praesent placerat nunc ac massa volutpat rutrum. Morbi non eros pulvinar, interdum quam facilisis, laoreet urna. Aenean mi dui, accumsan quis hendrerit eleifend, ullamcorper in purus.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:46:05","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:45:58","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"540","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('198','73','1','','2014-05-15 14:46:24','936','2492','1671c54bc54535b94433cdf4b0a97190d9fb01df','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:46:24","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:46:05","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"541","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('199','73','1','','2014-05-15 14:46:42','936','2633','72593f259f8db0511bf412485702f55723f4a6d2','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:46:42","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:46:24","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"542","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('200','73','1','','2014-05-15 14:47:05','936','2717','aa72c136ffb54f245744f3661faa504c540644e2','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"164","created_by_alias":"","modified":"2014-05-15 14:47:05","modified_by":"164","checked_out":"164","checked_out_time":"2014-05-15 14:46:42","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"543","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('210','111','1','','2014-06-24 13:38:25','936','6586','ac7835ce06598e56b5245fa72bce62916f3b24c1','{"id":111,"asset_id":328,"title":"Single Article","alias":"single-article","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/strong><\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-24 13:38:25","created_by":"800","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-24 13:38:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('211','112','1','','2014-06-24 14:46:59','936','4194','d611d0cc5d3e205cc6f4f1245e640dbe777a4850','{"id":112,"asset_id":329,"title":"Tabs","alias":"tabs","introtext":"<hr title=\\"Tab 1\\" class=\\"system-pagebreak\\" \\/>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo.<\\/p>\\r\\n<p>Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt. Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat.<\\/p>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<hr title=\\"Tab 2\\" class=\\"system-pagebreak\\" \\/>\\r\\n<p>Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<hr title=\\"Tab 3\\" class=\\"system-pagebreak\\" \\/>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus.<\\/p>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec accumsan.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-24 14:46:59","created_by":"800","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-24 14:46:59","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('212','10','3','','2014-06-24 15:03:23','936','1728','d7185be05adf787855e78596df7774a45efe81a5','{"id":10,"name":"Contact (2)","alias":"contact-2","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":0,"checked_out":null,"checked_out_time":null,"ordering":4,"params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"sliders\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"0\\",\\"show_position\\":\\"0\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"0\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"0\\",\\"show_fax\\":\\"0\\",\\"show_webpage\\":\\"0\\",\\"show_misc\\":\\"0\\",\\"show_image\\":\\"0\\",\\"allow_vcard\\":\\"0\\",\\"show_articles\\":\\"0\\",\\"show_profile\\":\\"0\\",\\"show_links\\":\\"0\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-06-24 15:03:23","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:29:19","modified_by":null,"metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":1,"hits":null}','0'),
('213','10','3','','2014-06-24 15:05:22','936','1747','26172430a307594d3710d2ce87a337b82496260c','{"id":10,"name":"Contact 2","alias":"contact-2","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":"800","checked_out_time":"2014-06-24 15:04:58","ordering":"4","params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"sliders\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"0\\",\\"show_position\\":\\"0\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"0\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"0\\",\\"show_fax\\":\\"0\\",\\"show_webpage\\":\\"0\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"0\\",\\"allow_vcard\\":\\"0\\",\\"show_articles\\":\\"0\\",\\"show_profile\\":\\"0\\",\\"show_links\\":\\"0\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-06-24 15:03:23","created_by":"800","created_by_alias":"","modified":"2014-06-24 15:05:22","modified_by":"800","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":2,"hits":"1"}','0'),
('214','10','3','','2014-06-24 15:07:02','936','2516','f7990720b56e02ef8e148819970fc78246d7a9f9','{"id":10,"name":"Contact 2","alias":"contact-2","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"<p><span class=\\"contact-misc\\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula, nunc quis aliquet tincidunt, massa arcu eleifend velit, posuere gravida nisl mi et magna.<\\/span><\\/p>","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":"800","checked_out_time":"2014-06-24 15:05:22","ordering":"4","params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"sliders\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"0\\",\\"show_position\\":\\"0\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"0\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"0\\",\\"show_fax\\":\\"0\\",\\"show_webpage\\":\\"0\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"0\\",\\"allow_vcard\\":\\"0\\",\\"show_articles\\":\\"0\\",\\"show_profile\\":\\"0\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"Facebook\\",\\"linka\\":\\"https:\\\\\\/\\\\\\/www.facebook.com\\\\\\/JoomlaMonster\\",\\"linkb_name\\":\\"Twitter\\",\\"linkb\\":\\"https:\\\\\\/\\\\\\/twitter.com\\\\\\/Joomlamonster\\",\\"linkc_name\\":\\"Google Plus\\",\\"linkc\\":\\"https:\\\\\\/\\\\\\/plus.google.com\\\\\\/+Joomlamonstercom\\\\\\/posts\\",\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-06-24 15:03:23","created_by":"800","created_by_alias":"","modified":"2014-06-24 15:07:02","modified_by":"800","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":3,"hits":"2"}','0'),
('215','10','3','','2014-06-24 15:07:22','936','2517','a04c11bed9edc58a8ccbd2dc39229568ac9abe0b','{"id":10,"name":"Contact 2","alias":"contact-2","con_position":"","address":"7 Green Lane","suburb":"Peterborough","state":"","country":"United Kingdom","postcode":"PE13BA","telephone":"0 123 456 789","fax":"","misc":"<p><span class=\\"contact-misc\\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar. Fusce felis ante, pulvinar ac metus et, adipiscing consequat lectus. Integer quam nibh, varius nec lacus elementum, bibendum posuere ante. Mauris vehicula, nunc quis aliquet tincidunt, massa arcu eleifend velit, posuere gravida nisl mi et magna.<\\/span><\\/p>","image":"","email_to":"templates@joomla-monster.com","default_con":0,"published":"1","checked_out":"800","checked_out_time":"2014-06-24 15:07:02","ordering":"4","params":"{\\"show_contact_category\\":\\"hide\\",\\"show_contact_list\\":\\"0\\",\\"presentation_style\\":\\"sliders\\",\\"show_tags\\":\\"0\\",\\"show_name\\":\\"0\\",\\"show_position\\":\\"0\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"0\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"0\\",\\"show_fax\\":\\"0\\",\\"show_webpage\\":\\"0\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"0\\",\\"allow_vcard\\":\\"0\\",\\"show_articles\\":\\"0\\",\\"show_profile\\":\\"0\\",\\"show_links\\":\\"1\\",\\"linka_name\\":\\"Facebook\\",\\"linka\\":\\"https:\\\\\\/\\\\\\/www.facebook.com\\\\\\/JoomlaMonster\\",\\"linkb_name\\":\\"Twitter\\",\\"linkb\\":\\"https:\\\\\\/\\\\\\/twitter.com\\\\\\/Joomlamonster\\",\\"linkc_name\\":\\"Google Plus\\",\\"linkc\\":\\"https:\\\\\\/\\\\\\/plus.google.com\\\\\\/+Joomlamonstercom\\\\\\/posts\\",\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"0","catid":"89","access":"1","mobile":"","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-06-24 15:03:23","created_by":"800","created_by_alias":"","modified":"2014-06-24 15:07:22","modified_by":"800","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"0","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":4,"hits":"3"}','0'),
('216','90','6','','2014-06-24 15:32:40','936','513','196166fd937b8ef0d9ee7c4c3a5e6f2730cb9064','{"id":90,"asset_id":334,"parent_id":"1","lft":"159","rgt":160,"level":1,"path":null,"extension":"com_content","title":"List","alias":"list","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-06-24 15:32:40","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('217','113','1','','2014-06-24 15:33:41','936','6620','4e0919e0558dbb1badc33f4cd00bda5e0a4befc2','{"id":113,"asset_id":335,"title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:10:42","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('218','114','1','','2014-06-24 15:33:41','936','6626','dabe9c235abcdda3de29784636dabc6ac474647f','{"id":114,"asset_id":337,"title":"Nunc Placerat Egestas","alias":"nunc-placerat-egestas","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:09:46","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('219','115','1','','2014-06-24 15:33:41','936','6622','e947687c110e99a463755f9e089b509cdf3ff92a','{"id":115,"asset_id":339,"title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:10:31","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('220','116','1','','2014-06-24 15:33:41','936','6618','fa5e4b205b243a3b6c105b99e67d34f69a72be5e','{"id":116,"asset_id":341,"title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:10:22","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('221','117','1','','2014-06-24 15:33:41','936','6614','5ce2485251bcaa6922a850b35a2fac433dde1937','{"id":117,"asset_id":343,"title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:10:02","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('222','118','1','','2014-06-24 15:33:41','936','6619','81223c13b23ffc37e71dbf6de17c64f05bf22ca3','{"id":118,"asset_id":345,"title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:12:25","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('223','119','1','','2014-06-24 15:33:41','936','6628','aeef56d87284139af0552d5b1e12e2ba4e703184','{"id":119,"asset_id":347,"title":"Consectetur Adipiscing","alias":"consectetur-adipiscing","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:10:12","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('224','120','1','','2014-06-24 15:33:41','936','6607','909056da1568a36ca32c5e816881aeacca956dd6','{"id":120,"asset_id":349,"title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":90,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-05-15 14:09:36","modified_by":"164","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('225','114','1','','2014-06-24 16:00:34','936','6612','c23967683b5ae2011185b8183cfd3f057c800a79','{"id":114,"asset_id":"337","title":"Nunc Placerat","alias":"nunc-placerat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"90","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-06-24 16:00:34","modified_by":"800","checked_out":"800","checked_out_time":"2014-06-24 16:00:25","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('226','102','1','','2014-06-24 16:01:13','936','6612','49d3c3d95904d2ba15f27551bcc457b411388a96','{"id":102,"asset_id":"299","title":"Nunc Placerat","alias":"nunc-placerat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-06-24 16:01:13","modified_by":"800","checked_out":"800","checked_out_time":"2014-06-24 16:01:04","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('227','97','1','','2014-06-24 16:01:56','936','6623','0b7bd7b2e92de5b1d1d49d76ea4dff817c147f7e','{"id":97,"asset_id":"289","title":"Consectetur Adipisc","alias":"consectetur-adipisc","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-06-24 16:01:56","modified_by":"800","checked_out":"800","checked_out_time":"2014-06-24 16:01:47","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('228','119','1','','2014-06-24 16:02:33','936','6624','7f4c4b63ce36a99547fb2c95b186f386b6c38afb','{"id":119,"asset_id":"347","title":"Consectetur Adipisc","alias":"consectetur-adipisc","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"90","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-06-24 16:02:33","modified_by":"800","checked_out":"800","checked_out_time":"2014-06-24 16:02:25","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('229','121','1','','2014-06-25 09:42:57','936','1678','a596345e782285989adf8f16781e2abca89080b8','{"id":121,"asset_id":351,"title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>Module Suffixes<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('230','103','1','','2014-07-04 10:11:35','936','6622','60f44cda1759f7d6c65ac32689a3715d4b3da961','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:11:35","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:11:24","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('231','101','1','','2014-07-04 10:12:43','936','6624','5b13850fc517eedb38bdc18012fc17b3f909bb2e','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:12:43","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:12:35","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('232','100','1','','2014-07-04 10:13:13','936','6620','0bfcba8953d793c27b26164037631dcd0202d878','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:13:13","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:13:06","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('233','99','1','','2014-07-04 10:13:30','936','6615','dda9ca1a9dc02688ca5bdb8578330bfbd768bdcd','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:13:30","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:13:07","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('234','98','1','','2014-07-04 10:13:40','936','6620','0c2e1bbc1ebdeb65216d2587c7d82c58ad34377a','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:13:40","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:13:07","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('235','96','1','','2014-07-04 10:13:50','936','6609','b7d42e7045cc4ac40a8685bbcd6cf11ac85a074b','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:13:50","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-04 10:13:08","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('236','84','6','','2014-07-07 14:16:47','936','661','a4f567b36d65b6b695896a34975f8a9e5f8858c0','{"id":84,"asset_id":"315","parent_id":"83","lft":"146","rgt":"147","level":"2","path":"blog\\/blog-category-1","extension":"com_content","title":"Blog Category 1","alias":"blog-category-1","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.<\\/p>","published":"1","checked_out":"800","checked_out_time":"2014-07-07 14:16:40","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-05-15 13:46:25","modified_user_id":"800","modified_time":"2014-07-07 14:16:47","hits":"0","language":"*","version":"1"}','0'),
('237','85','6','','2014-07-07 14:16:57','936','661','eb70214b4ebd1075ce7c2463160205cd11c93e6f','{"id":85,"asset_id":"316","parent_id":"83","lft":"148","rgt":"149","level":"2","path":"blog\\/blog-category-2","extension":"com_content","title":"Blog Category 2","alias":"blog-category-2","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.<\\/p>","published":"1","checked_out":"800","checked_out_time":"2014-07-07 14:16:50","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-05-15 13:46:29","modified_user_id":"800","modified_time":"2014-07-07 14:16:57","hits":"0","language":"*","version":"1"}','0'),
('238','86','6','','2014-07-07 14:17:07','936','661','06ed60d62c161b678316419f6b40832394dca368','{"id":86,"asset_id":"317","parent_id":"83","lft":"150","rgt":"151","level":"2","path":"blog\\/blog-category-3","extension":"com_content","title":"Blog Category 3","alias":"blog-category-3","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.<\\/p>","published":"1","checked_out":"800","checked_out_time":"2014-07-07 14:17:00","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-05-15 13:46:41","modified_user_id":"800","modified_time":"2014-07-07 14:17:07","hits":"0","language":"*","version":"1"}','0'),
('239','87','6','','2014-07-07 14:17:16','936','661','7585f2b7e1b18b13b99962ac0cb66e60d1208add','{"id":87,"asset_id":"318","parent_id":"83","lft":"152","rgt":"153","level":"2","path":"blog\\/blog-category-4","extension":"com_content","title":"Blog Category 4","alias":"blog-category-4","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.<\\/p>","published":"1","checked_out":"800","checked_out_time":"2014-07-07 14:17:10","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-05-15 13:46:53","modified_user_id":"800","modified_time":"2014-07-07 14:17:16","hits":"0","language":"*","version":"1"}','0'),
('240','109','1','','2014-07-07 14:51:03','936','6564','d8247661d963650a9f2eed6b07bba1cb9d52e91a','{"id":109,"asset_id":"321","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 14:51:03","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 14:50:51","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"6","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('241','110','1','','2014-07-07 14:51:09','936','6576','fcc6ee9078e90ccf92313865888ffd88f25f027e','{"id":110,"asset_id":"323","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"88","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 14:51:09","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 14:50:54","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"8","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('242','106','1','','2014-07-07 15:17:19','936','6607','0b8c26c34a3b3c6084bb3320fb8c733ad3018b33','{"id":106,"asset_id":"309","title":"Pretium Pellentesque","alias":"pretium-pellentesque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-02-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:17:19","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:17:08","publish_up":"2014-02-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('243','107','1','','2014-07-07 15:17:39','936','6601','993d9747eec4249d3b895dd477161cf0dd38f490','{"id":107,"asset_id":"311","title":"Volutpat Vehicula","alias":"volutpat-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-03-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:17:39","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:17:30","publish_up":"2014-03-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('244','105','1','','2014-07-07 15:17:56','936','6595','4669a349fa27e229ad62ce3b894b5331cf5ff259','{"id":105,"asset_id":"307","title":"Fusce Eu Risus","alias":"fusce-eu-risus","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2014-01-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:17:56","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:17:45","publish_up":"2014-01-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog4.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('245','104','1','','2014-07-07 15:18:17','936','6593','b777748b6be7a63dc1301ef245e237600949b887','{"id":104,"asset_id":"305","title":"Cras Eleifend","alias":"cras-eleifend","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":2,"catid":"83","created":"2013-12-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:18:17","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:18:07","publish_up":"2013-12-15 12:44:15","publish_down":"","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog5.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"4","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('246','96','1','','2014-07-07 15:18:49','936','6609','771f558b23e59fb5c19c8f206c3cd29ed70636b4','{"id":96,"asset_id":"287","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"84","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:18:49","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:18:40","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('247','98','1','','2014-07-07 15:19:06','936','6620','077d19cb5e2a2bf820370e491673fbf15a342192','{"id":98,"asset_id":"291","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:06","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:18:55","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('248','99','1','','2014-07-07 15:19:26','936','6616','1436c9bd83040a3142a689a0758a67553d279b20','{"id":99,"asset_id":"293","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"85","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:26","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:19:17","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog4.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('249','100','1','','2014-07-07 15:19:43','936','6620','ef8d4439b50925b03adb116d1f5d824966b0c45a','{"id":100,"asset_id":"295","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"86","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:43","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:19:32","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog5.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('250','101','1','','2014-07-07 15:20:07','936','6624','7a3919e4d81ce47b8892dc6f2e7a420bdca9ba65','{"id":101,"asset_id":"297","title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:20:07","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:19:56","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0');
INSERT INTO `#__ucm_history` VALUES 
('251','103','1','','2014-07-07 15:20:38','936','6622','67f1069c10fb42334192204f3a61be0b626f886b','{"id":103,"asset_id":"301","title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"87","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:20:38","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-07 15:20:26","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('252','93','6','','2014-07-08 13:08:18','936','519','947c4595a6a5fd489c2856e4421bd46c2428284b','{"id":93,"asset_id":362,"parent_id":"1","lft":"165","rgt":166,"level":1,"path":null,"extension":"com_content","title":"Recipes","alias":"recipes","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"800","created_time":"2014-07-08 13:08:18","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('253','122','1','','2014-07-08 13:09:00','936','6620','f884cf34186637b1200a9a2d95dfd97cfa6e9c6a','{"id":122,"asset_id":363,"title":"Quisque Vestibulum","alias":"quisque-vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:20:38","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('254','123','1','','2014-07-08 13:09:00','936','6610','240dcb6be6933aba99d3a07643b5bdce844a3ff0','{"id":123,"asset_id":365,"title":"Nunc Placerat","alias":"nunc-placerat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-04 10:12:32","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('255','124','1','','2014-07-08 13:09:00','936','6622','96251e4a7174124506bd20ebcb8cbeecea31973f','{"id":124,"asset_id":367,"title":"Malesuada Ultricies","alias":"malesuada-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:20:07","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('256','125','1','','2014-07-08 13:09:00','936','6618','75327c369d2b21281aa5dd7760c1cbf9d7251e34','{"id":125,"asset_id":369,"title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:43","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog5.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('257','126','1','','2014-07-08 13:09:00','936','6615','265b26938f3dd5c801d72fb5b77ff9527c34f46d','{"id":126,"asset_id":371,"title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:26","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog4.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"10","ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('258','127','1','','2014-07-08 13:09:00','936','6619','826f2695dc9cfee9283b0740a303f2143f9d4a86','{"id":127,"asset_id":373,"title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:19:06","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('259','128','1','','2014-07-08 13:09:00','936','6622','ca7b343885732235b85de9e4a76f9aa81b4a3225','{"id":128,"asset_id":375,"title":"Consectetur Adipisc","alias":"consectetur-adipisc","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-06-24 16:01:56","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('260','129','1','','2014-07-08 13:09:00','936','6608','fb25e2ad98389219075adcfc7ed596865c332f22','{"id":129,"asset_id":377,"title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":"1","catid":93,"created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-07 15:18:49","modified_by":"800","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"11","ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('261','122','1','','2014-07-08 13:11:26','936','6618','63317b7c52cab90dd52b8bd816bad38511d2099c','{"id":122,"asset_id":"363","title":"Vestibulum","alias":"vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:11:26","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:10:49","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('262','124','1','','2014-07-08 13:12:50','936','6629','24f63d1a57a06a99e5b8e6c21fd3bb47a95a111f','{"id":124,"asset_id":"367","title":"Males Ultricies","alias":"males-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:12:50","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:11:38","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('263','123','1','','2014-07-08 13:13:21','936','6624','1fe4310df4513da28862ed797adfc557c3c2a431','{"id":123,"asset_id":"365","title":"Nunc Placerat","alias":"nunc-placerat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:13:21","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:12:58","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('264','125','1','','2014-07-08 13:13:54','936','6632','d2b4b052f11efbfee4d7284f35193bf79734df02','{"id":125,"asset_id":"369","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:13:54","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:13:28","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog4.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('265','126','1','','2014-07-08 13:15:58','936','6629','2deaf0d67a4343ede569253ec5274d268558e6c5','{"id":126,"asset_id":"371","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:15:58","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:15:27","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog6.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('266','127','1','','2014-07-08 13:16:28','936','6633','7ec680099c7eb3647f74dd1d386933c8ee941176','{"id":127,"asset_id":"373","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:16:28","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:16:06","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog5.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('267','129','1','','2014-07-08 13:17:54','936','6374','e5261818deabef99e9b19b94fb765201aad9c696','{"id":129,"asset_id":"377","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:17:54","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:17:44","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":12,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('268','128','1','','2014-07-08 13:18:07','936','6389','db25c3a51103c00d7de9245bb7f56feddc4a6f01','{"id":128,"asset_id":"375","title":"Consectetur Adipisc","alias":"consectetur-adipisc","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:18:07","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:17:59","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('269','127','1','','2014-07-08 13:18:21','936','6398','be3f4a2013718b2dfdcf9d82a977538547f80ec1','{"id":127,"asset_id":"373","title":"Nulla Scelerisque","alias":"nulla-scelerisque","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:18:21","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:18:12","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog5.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"10","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('270','126','1','','2014-07-08 13:18:34','936','6393','6f1329285217970ccdd51b8ab0eed847002166a6','{"id":126,"asset_id":"371","title":"Aliquam Feugiat","alias":"aliquam-feugiat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:18:34","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:18:26","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog6.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":12,"ordering":"9","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('271','125','1','','2014-07-08 13:18:47','936','6397','cba105aadcb5047dea1499f72d0f92f2c97bb7ef','{"id":125,"asset_id":"369","title":"Praesent Vehicula","alias":"praesent-vehicula","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:18:47","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:18:38","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog4.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('272','124','1','','2014-07-08 13:19:06','936','6393','da1d75860edb92389e8551df620546bab14e952c','{"id":124,"asset_id":"367","title":"Males Ultricies","alias":"males-ultricies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:19:06","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:18:54","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('273','123','1','','2014-07-08 13:19:19','936','6389','f2ccb14920460e934497eb87dc26c872d1578bff','{"id":123,"asset_id":"365","title":"Nunc Placerat","alias":"nunc-placerat","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:19:19","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:19:11","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog3.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('274','122','1','','2014-07-08 13:19:33','936','6383','b871a50c58013a80788cbf2626925b76dc0f3090','{"id":122,"asset_id":"363","title":"Vestibulum","alias":"vestibulum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:19:33","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:19:25","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"5","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('275','128','1','','2014-07-08 13:20:37','936','6391','3971c5123e51425f0c1639b2337a79bc862d397f','{"id":128,"asset_id":"375","title":"Consec Adipisc","alias":"consec-adipisc","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:20:37","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:20:09","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('276','129','1','','2014-07-08 13:21:02','936','6386','84b2524d4d35d759f66a285b7e5b02c7d5c4e1cf','{"id":129,"asset_id":"377","title":"Lorem Ipsum","alias":"lorem-ipsum","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>","state":1,"catid":"93","created":"2014-05-15 12:44:15","created_by":"800","created_by_alias":"","modified":"2014-07-08 13:21:02","modified_by":"800","checked_out":"800","checked_out_time":"2014-07-08 13:20:45","publish_up":"2014-05-15 12:44:15","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/culinary\\\\\\/blog\\\\\\/blog2.jpg\\",\\"float_intro\\":\\"left\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":13,"ordering":"12","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('281','121','1','','2014-09-09 11:55:49','936','1940','41e5acd173e04a8240287b01f9190468b364ca04','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 11:55:49","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 11:47:23","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"3","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('282','121','1','','2014-09-09 11:56:33','936','1979','cf65e67918ff7c49444333371190ff478faa0c9a','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 11:56:33","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 11:55:49","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('283','121','1','','2014-09-09 12:44:26','936','2252','31ceddfe811cef751ff50bc5c0474de07ca8d4bf','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>2. Use the following suffix for DJ-ImageSlider module if you want to get the following view for slides. Otherwise the module will use the default css styles.<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:44:26","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 11:56:33","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('284','121','1','','2014-09-09 12:45:37','936','2324','577ee78697d61ecd9c0f62ad9b70c1de4dc13fdc','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>2. Use the following suffix for DJ-ImageSlider module if you want to get the following view for slides. Otherwise the module will use the default css styles.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:45:37","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 12:44:26","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"6","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('285','121','1','','2014-09-09 12:46:33','936','2322','fe4567c6242855b9f6df54e84480e71299997bab','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>2. Use the following suffix for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:46:33","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 12:45:37","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"7","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('286','121','1','','2014-09-09 12:49:49','936','2588','72e745e012f6bcbb3bea19c4e6a124bd87625919','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> slider1-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes2.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> slider1-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:49:49","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 12:46:33","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"7","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('287','121','1','','2014-09-09 12:53:25','936','2806','53a9ea5511c4410a6396b427cde69e3d4dd9e519','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> slider1-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes2.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> testimonials-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes3.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> testimonials-ms alternative-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:53:25","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 12:49:49","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"7","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('288','121','1','','2014-09-09 12:55:04','936','2882','f641fcb5274489825ffbc90349178cc4b9613d98','{"id":121,"asset_id":"351","title":"Module Suffixes","alias":"module-suffixes","introtext":"<p>There are additional module designs available that you can control by entering a correct suffix name as a module parameter.<br \\/>Let\'s check them all.<\\/p>\\r\\n<p>1. Available module designs<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/module-suffixes.png\\" alt=\\"Module Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>2. Use the following suffixes for DJ-ImageSlider module if you want to get the following view for slides. Otherwise a module will use the default css styles.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><strong>Suffix name:<\\/strong> slider1-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes1.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p><strong>Suffix name:<\\/strong> testimonials-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes2.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p><strong>Suffix name:<\\/strong> testimonials-ms alternative-ms<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img src=\\"images\\/sample\\/djimageslider-suffixes3.jpg\\" alt=\\"DJ-ImageSlider Suffixes\\" \\/><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:55:04","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-09 12:53:25","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"8","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('289','130','1','','2014-09-11 11:41:33','936','1693','67030ecd865d8bee4f7053029beb48bdef5ff326','{"id":130,"asset_id":395,"title":"All Template Positions","alias":"all-template-positions","introtext":"<p>Module positions<\\/p>","fulltext":"","state":0,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:55:04","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-25 09:42:57","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('290','131','1','','2014-09-11 12:16:11','936','2746','1d15cdf1ec6868e1ee8f1cb20cd155f3b7018e15','{"id":131,"asset_id":396,"title":"Error 404","alias":"error-404","introtext":"<p>\\u00a0<\\/p>\\r\\n<div class=\\"jm-error-page\\">\\r\\n<h1>404 OOPS!<\\/h1>\\r\\n<h2>page Not found!<\\/h2>\\r\\n<p>\\"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br \\/>Please try your luck again.\\"<\\/p>\\r\\n{loadposition error404-search} <a class=\\"btn\\" href=\\"index.php\\">Take me home<\\/a>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<p>This is a Joomla! article displayed as custom 404 page.<\\/p>\\r\\n<p><strong>How to modify this page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to Content -&gt; Article Manager.<br \\/> <strong>Step 2:<\\/strong> Find and edit the \\"Error 404\\" article.<\\/p>\\r\\n<p><strong>How is the search module displayed?<\\/strong><br \\/> It is displayed using the \\"Content - Load Modules\\" plugin. It allows to display a module in a Joomla article. The module is published on the following position: error404-search<\\/p>\\r\\n<p><strong>How to display a different article as custom 404 page?<\\/strong><br \\/>If you want to display other article, you need to change the article ID in the following location: \\/templates\\/jm-services\\/error.php<\\/p>","fulltext":"","state":0,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-09 12:55:04","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-25 09:42:57","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('291','131','1','','2014-09-11 12:16:20','936','2784','b97ddbaf11cfc737ac85e0c5f9e103d6fe5eb802','{"id":131,"asset_id":"396","title":"Error 404","alias":"error-404","introtext":"<p>\\u00a0<\\/p>\\r\\n<div class=\\"jm-error-page\\">\\r\\n<h1>404 OOPS!<\\/h1>\\r\\n<h2>page Not found!<\\/h2>\\r\\n<p>\\"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br \\/>Please try your luck again.\\"<\\/p>\\r\\n{loadposition error404-search} <a class=\\"btn\\" href=\\"index.php\\">Take me home<\\/a>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<p>This is a Joomla! article displayed as custom 404 page.<\\/p>\\r\\n<p><strong>How to modify this page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to Content -&gt; Article Manager.<br \\/> <strong>Step 2:<\\/strong> Find and edit the \\"Error 404\\" article.<\\/p>\\r\\n<p><strong>How is the search module displayed?<\\/strong><br \\/> It is displayed using the \\"Content - Load Modules\\" plugin. It allows to display a module in a Joomla article. The module is published on the following position: error404-search<\\/p>\\r\\n<p><strong>How to display a different article as custom 404 page?<\\/strong><br \\/>If you want to display other article, you need to change the article ID in the following location: \\/templates\\/jm-services\\/error.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 12:16:20","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 12:16:11","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('292','131','1','','2014-09-11 12:19:16','936','2790','962eca28a2d47cd6867fb5084e075dcab5ef6949','{"id":131,"asset_id":"396","title":"Error 404","alias":"error-404","introtext":"<p>\\u00a0<\\/p>\\r\\n<div class=\\"jm-error-page\\">\\r\\n<h1>404 OOPS!<\\/h1>\\r\\n<h2>Page not found!<\\/h2>\\r\\n<p>\\"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br \\/>Please try your luck again.\\"<\\/p>\\r\\n{loadposition error404-search} <a class=\\"btn\\" href=\\"index.php\\">Take me home<\\/a>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<p>This is a Joomla! article displayed as custom 404 page.<\\/p>\\r\\n<p><strong>How to modify this page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to Content -&gt; Article Manager.<br \\/> <strong>Step 2:<\\/strong> Find and edit the \\"Error 404\\" article.<\\/p>\\r\\n<p><strong>How is the search module displayed?<\\/strong><br \\/> It is displayed using the \\"Content - Load Modules\\" plugin. It allows to display a module in a Joomla article.<br \\/>The module is published on the following position: error404-search<\\/p>\\r\\n<p><strong>How to display a different article as custom 404 page?<\\/strong><br \\/>If you want to display other article, you need to change the article ID in the following location: \\/templates\\/jm-services\\/error.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 12:19:16","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 12:18:53","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"3","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('293','131','1','','2014-09-11 12:37:55','936','2796','3c29df229116cb6aca58a2357c1aca14872f4dde','{"id":131,"asset_id":"396","title":"Error 404","alias":"error-404","introtext":"<p>\\u00a0<\\/p>\\r\\n<div class=\\"jm-error-page\\">\\r\\n<h1>404 OOPS!<\\/h1>\\r\\n<h2>Page not found!<\\/h2>\\r\\n<p>\\"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br \\/>Please try your luck again.\\"<\\/p>\\r\\n{loadposition error404-search} <a class=\\"btn large\\" href=\\"index.php\\">Take me home<\\/a>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<p>This is a Joomla! article displayed as custom 404 page.<\\/p>\\r\\n<p><strong>How to modify this page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to Content -&gt; Article Manager.<br \\/> <strong>Step 2:<\\/strong> Find and edit the \\"Error 404\\" article.<\\/p>\\r\\n<p><strong>How is the search module displayed?<\\/strong><br \\/> It is displayed using the \\"Content - Load Modules\\" plugin. It allows to display a module in a Joomla article.<br \\/>The module is published on the following position: error404-search<\\/p>\\r\\n<p><strong>How to display a different article as custom 404 page?<\\/strong><br \\/>If you want to display other article, you need to change the article ID in the following location: \\/templates\\/jm-services\\/error.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 12:37:55","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 12:19:16","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"9","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('294','131','1','','2014-09-11 12:39:34','936','2801','2425e3aff394003d0522db55d338c555c9711d01','{"id":131,"asset_id":"396","title":"Error 404","alias":"error-404","introtext":"<p>\\u00a0<\\/p>\\r\\n<div class=\\"jm-error-page\\">\\r\\n<h1>404 OOPS!<\\/h1>\\r\\n<h2>Page not found!<\\/h2>\\r\\n<p>\\"Sorry, it appears the page you were looking for does not exist anymore or might have been moved.<br \\/>Please try your luck again.\\"<\\/p>\\r\\n{loadposition error404-search} <a class=\\"btn btn-large\\" href=\\"index.php\\">Take me home<\\/a>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<p>This is a Joomla! article displayed as custom 404 page.<\\/p>\\r\\n<p><strong>How to modify this page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to Content -&gt; Article Manager.<br \\/> <strong>Step 2:<\\/strong> Find and edit the \\"Error 404\\" article.<\\/p>\\r\\n<p><strong>How is the search module displayed?<\\/strong><br \\/> It is displayed using the \\"Content - Load Modules\\" plugin. It allows to display a module in a Joomla article.<br \\/>The module is published on the following position: error404-search<\\/p>\\r\\n<p><strong>How to display a different article as custom 404 page?<\\/strong><br \\/>If you want to display other article, you need to change the article ID in the following location: \\/templates\\/jm-services\\/error.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 12:39:34","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 12:37:55","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"10","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('295','132','1','','2014-09-11 13:46:17','936','2414','44ac72a5051e39a3898302a31adf96b742231dec','{"id":132,"asset_id":398,"title":"Offline Page","alias":"offline-page","introtext":"<p style=\\"text-align: center;\\"><img src=\\"images\\/features\\/offline.jpg\\" alt=\\"Offline Page\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>You can make your Joomla! website unavailable to visitors. To enable this option login to Administrator back-end.<\\/p>\\r\\n<p>1. Click the <strong>System \\u2192 Global Configuration<\\/strong> menu item<\\/p>\\r\\n<p>2. Find field <strong>Site Offline<\\/strong> and click Yes button.<\\/p>\\r\\n<p>3. You can also change the <strong>Offline Message<\\/strong> to give your visitors some explanation about why your website is unavailable.<\\/p>\\r\\n<p>Click the Save button to implement the new settings.<\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>Offline page can be easily customised in file - <strong>\\/templates\\/jm-beauty-center\\/offline.php<\\/strong><\\/p>","fulltext":"","state":0,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 12:39:34","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-06-25 09:42:57","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('296','132','1','','2014-09-11 13:55:30','936','2462','5b58b5d0956b02f6d6db3b727d018aad73d34540','{"id":132,"asset_id":"398","title":"Offline Page","alias":"offline-page","introtext":"<p style=\\"text-align: center;\\"><img src=\\"images\\/features\\/offline.jpg\\" alt=\\"Offline Page\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>There is a possibility to disable access to the front of your site.<\\/p>\\r\\n<p><strong>How to enable the offline page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to \\"System -&gt; Global Configuration -&gt; Site\\". <strong>Step 2:<\\/strong> Click on \\"Yes\\" for \\"Site Offline\\" option.<br \\/> <strong>Step 3:<\\/strong> Fill in a text for \\"Offline Message\\" to give your visitors some explanation about why your website is unavailable.<br \\/> <strong>Step 4:<\\/strong> Click on \\"Save\\" to save your settings.<\\/p>\\r\\n<p><strong>How to customize the offline page?<\\/strong><br \\/> You need to edit the following file: \\/templates\\/jm-services\\/offline.php<\\/p>","fulltext":"","state":0,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 13:55:30","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 13:46:17","publish_up":"2014-06-25 09:42:57","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('297','132','1','','2014-09-11 13:58:22','936','2460','682e617b48f19be5e75599390a32d345396176d3','{"id":132,"asset_id":"398","title":"Offline Page","alias":"offline-page","introtext":"<p style=\\"text-align: center;\\"><img src=\\"images\\/sample\\/offline.png\\" alt=\\"Offline Page\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>There is a possibility to disable access to the front of your site.<\\/p>\\r\\n<p><strong>How to enable the offline page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to \\"System -&gt; Global Configuration -&gt; Site\\". <strong>Step 2:<\\/strong> Click on \\"Yes\\" for \\"Site Offline\\" option.<br \\/> <strong>Step 3:<\\/strong> Fill in a text for \\"Offline Message\\" to give your visitors some explanation about why your website is unavailable.<br \\/> <strong>Step 4:<\\/strong> Click on \\"Save\\" to save your settings.<\\/p>\\r\\n<p><strong>How to customize the offline page?<\\/strong><br \\/> You need to edit the following file: \\/templates\\/jm-services\\/offline.php<\\/p>","fulltext":"","state":0,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 13:58:22","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 13:55:30","publish_up":"2014-06-25 09:42:57","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('298','132','1','','2014-09-11 14:00:20','936','2479','f65822cd720181e9401ba22a765f9466153e5284','{"id":132,"asset_id":"398","title":"Offline Page","alias":"offline-page","introtext":"<p style=\\"text-align: center;\\"><img src=\\"images\\/sample\\/offline.png\\" alt=\\"Offline Page\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>There is a possibility to disable access to the front of your site.<\\/p>\\r\\n<p><strong>How to enable the offline page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to \\"System -&gt; Global Configuration -&gt; Site\\". <strong>Step 2:<\\/strong> Click on \\"Yes\\" for \\"Site Offline\\" option.<br \\/> <strong>Step 3:<\\/strong> Fill in a text for \\"Offline Message\\" to give your visitors some explanation about why your website is unavailable.<br \\/> <strong>Step 4:<\\/strong> Click on \\"Save\\" to save your settings.<\\/p>\\r\\n<p><strong>How to customize the offline page?<\\/strong><br \\/> You need to edit the following file: \\/templates\\/jm-services\\/offline.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 14:00:20","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 13:58:22","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('299','132','1','','2014-09-11 14:02:52','936','2485','9b90fb82fac04c4de1358f1a611173c63a1d4758','{"id":132,"asset_id":"398","title":"Offline Page","alias":"offline-page","introtext":"<p style=\\"text-align: center;\\"><img src=\\"images\\/sample\\/offline.png\\" alt=\\"Offline Page\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p>There is a possibility to disable access to the front of your site.<\\/p>\\r\\n<p><strong>How to enable the offline page?<\\/strong><br \\/> <strong>Step 1:<\\/strong> Go to \\"System -&gt; Global Configuration -&gt; Site\\".<br \\/><strong>Step 2:<\\/strong> Click on \\"Yes\\" for \\"Site Offline\\" option.<br \\/> <strong>Step 3:<\\/strong> Fill in a text for \\"Offline Message\\" to give your visitors some explanation about why your website is unavailable.<br \\/> <strong>Step 4:<\\/strong> Click on \\"Save\\" to save your settings.<\\/p>\\r\\n<p><strong>How to customize the offline page?<\\/strong><br \\/> You need to edit the following file: \\/templates\\/jm-services\\/offline.php<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-11 14:02:52","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-11 14:00:20","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('300','130','1','','2014-09-15 14:40:55','936','3237','f23a19e991299df138184853ff72818273015869','{"id":130,"asset_id":"395","title":"All Template Positions","alias":"all-template-positions","introtext":"<p><a title=\\"JM Services\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-lifestyle&amp;cid=32:free&amp;Itemid=471\\" target=\\"_blank\\">JM Services<\\/a> Joomla template uses fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br \\/>The template uses default width values specified at <a title=\\"Template layout positions\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=897&amp;view=article&amp;Itemid=1027\\" target=\\"_blank\\">the template configuration<\\/a>.<\\/p>\\r\\n","fulltext":"\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for desktop and tablet landscape<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><img title=\\"Module positions for desktop and tablet landscape\\" src=\\"images\\/sample\\/desktop-positions.jpg\\" alt=\\"Module positions for desktop and tablet landscape\\" border=\\"0\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for tablet portrait<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><img title=\\"Module positions for tablet portrait\\" src=\\"images\\/sample\\/tablet-positions.jpg\\" alt=\\"Module positions for tablet portrait\\" border=\\"0\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for mobile<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p><img title=\\"Module positions for mobile\\" src=\\"images\\/sample\\/mobile-positions.jpg\\" alt=\\"Module positions for mobile\\" border=\\"0\\" \\/><\\/p>","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-15 14:40:55","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-15 14:24:45","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('301','130','1','','2014-09-15 14:41:47','936','3267','58fe15ff00a333f9418f461e9d2a84adfe8bd62c','{"id":130,"asset_id":"395","title":"All Template Positions","alias":"all-template-positions","introtext":"<p><a title=\\"JM Services\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-lifestyle&amp;cid=32:free&amp;Itemid=471\\" target=\\"_blank\\">JM Services<\\/a> Joomla template uses fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br \\/>The template uses default width values specified at <a title=\\"Template layout positions\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=897&amp;view=article&amp;Itemid=1027\\" target=\\"_blank\\">the template configuration<\\/a>.<\\/p>\\r\\n","fulltext":"\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for desktop and tablet landscape<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><img title=\\"Module positions for desktop and tablet landscape\\" src=\\"images\\/sample\\/desktop-positions.jpg\\" alt=\\"Module positions for desktop and tablet landscape\\" border=\\"0\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for tablet portrait<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><img title=\\"Module positions for tablet portrait\\" src=\\"images\\/sample\\/tablet-positions.jpg\\" alt=\\"Module positions for tablet portrait\\" border=\\"0\\" \\/><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for mobile<\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><img title=\\"Module positions for mobile\\" src=\\"images\\/sample\\/mobile-positions.jpg\\" alt=\\"Module positions for mobile\\" border=\\"0\\" \\/><\\/p>","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"800","created_by_alias":"","modified":"2014-09-15 14:41:47","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-15 14:40:55","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"2","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('312','87','1','','2014-09-16 10:26:39','936','50340','9a6d0c2bf662b79bbfa5190d4e80898631ad2f40','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>    &lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>    &lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>    &lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;<br \\/>JUST FEW WORDS<br \\/>&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;<br \\/>&lt;a class=\\"btn\\" href=\\"#\\"&gt;<br \\/>read more<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:26:39","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:25:07","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":53,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"139","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('313','87','1','','2014-09-16 10:31:11','936','50331','f469d36f6d056ccf549fc238525c55186566b911','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/> &lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/> &lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/> &lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;<br \\/>JUST FEW WORDS<br \\/>&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;<br \\/>&lt;a class=\\"btn\\" href=\\"#\\"&gt;<br \\/>read more<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:31:11","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:26:39","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":54,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"144","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('314','87','1','','2014-09-16 10:31:36','936','50328','65513c17265d5c5713ca69dc6aaac5f3c2cfa6e9','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;<br \\/>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<br \\/>&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;<br \\/>JUST FEW WORDS<br \\/>&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;<br \\/>&lt;a class=\\"btn\\" href=\\"#\\"&gt;<br \\/>read more<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:31:36","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:31:11","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":55,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"145","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0');
INSERT INTO `#__ucm_history` VALUES 
('315','87','1','','2014-09-16 10:33:54','936','50244','a3aa87d8b536d111b5bd103c2b4def923cbaa962','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:33:54","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:31:36","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":56,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"146","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('316','87','1','','2014-09-16 10:38:18','936','50253','a43472fd83f03dd5bda4276b5b31b378d2e4f408','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearifx\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:38:18","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:33:54","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":57,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"147","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('317','87','1','','2014-09-16 10:38:57','936','50253','55a44e3519f403274f6f2068e8d21681a4cdffad','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearfix\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:38:57","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:38:18","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":58,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"148","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('318','87','1','','2014-09-16 10:45:52','936','51151','51f55d8f9d255d7404e44659ddaf26d1941c2775','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p>\\u00a0<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\">\\u00a0<\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\">\\u00a0<\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\">\\u00a0<\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\">\\u00a0<\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\">\\u00a0<\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\">\\u00a0<\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\">\\u00a0<\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\">\\u00a0<\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\">\\u00a0<\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\">\\u00a0<\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\">\\u00a0<\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\">\\u00a0<\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\">\\u00a0<\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\">\\u00a0<\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\">\\u00a0<\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\">\\u00a0<\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\">\\u00a0<\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\">\\u00a0<\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\">\\u00a0<\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\">\\u00a0<\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\">\\u00a0<\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\">\\u00a0<\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\">\\u00a0<\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\">\\u00a0<\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\">\\u00a0<\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\">\\u00a0<\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\">\\u00a0<\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\">\\u00a0<\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\">\\u00a0<\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\">\\u00a0<\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\">\\u00a0<\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\">\\u00a0<\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\">\\u00a0<\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\">\\u00a0<\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\">\\u00a0<\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\">\\u00a0<\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\">\\u00a0<\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\">\\u00a0<\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\">\\u00a0<\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\">\\u00a0<\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\">\\u00a0<\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\">\\u00a0<\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\">\\u00a0<\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\">\\u00a0<\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\">\\u00a0<\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\">\\u00a0<\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\">\\u00a0<\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\">\\u00a0<\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\">\\u00a0<\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\">\\u00a0<\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\">\\u00a0<\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\">\\u00a0<\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\">\\u00a0<\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\">\\u00a0<\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\">\\u00a0<\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\">\\u00a0<\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\">\\u00a0<\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\">\\u00a0<\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\">\\u00a0<\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\">\\u00a0<\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\">\\u00a0<\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\">\\u00a0<\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\">\\u00a0<\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\">\\u00a0<\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\">\\u00a0<\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\">\\u00a0<\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\">\\u00a0<\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\">\\u00a0<\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\">\\u00a0<\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\">\\u00a0<\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\">\\u00a0<\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\">\\u00a0<\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\">\\u00a0<\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\">\\u00a0<\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\">\\u00a0<\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\">\\u00a0<\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\">\\u00a0<\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\">\\u00a0<\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\">\\u00a0<\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\">\\u00a0<\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\">\\u00a0<\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\">\\u00a0<\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\">\\u00a0<\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\">\\u00a0<\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\">\\u00a0<\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\">\\u00a0<\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\">\\u00a0<\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\">\\u00a0<\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\">\\u00a0<\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\">\\u00a0<\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\">\\u00a0<\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\">\\u00a0<\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\">\\u00a0<\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\">\\u00a0<\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\">\\u00a0<\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\">\\u00a0<\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\">\\u00a0<\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\">\\u00a0<\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\">\\u00a0<\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\">\\u00a0<\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\">\\u00a0<\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\">\\u00a0<\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\">\\u00a0<\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\">\\u00a0<\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\">\\u00a0<\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\">\\u00a0<\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\">\\u00a0<\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\">\\u00a0<\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\">\\u00a0<\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\">\\u00a0<\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\">\\u00a0<\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\">\\u00a0<\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\">\\u00a0<\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\">\\u00a0<\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\">\\u00a0<\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\">\\u00a0<\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\">\\u00a0<\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\">\\u00a0<\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\">\\u00a0<\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\">\\u00a0<\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\">\\u00a0<\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\">\\u00a0<\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\">\\u00a0<\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\">\\u00a0<\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\">\\u00a0<\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\">\\u00a0<\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\">\\u00a0<\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\">\\u00a0<\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\">\\u00a0<\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\">\\u00a0<\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\">\\u00a0<\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\">\\u00a0<\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\">\\u00a0<\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\">\\u00a0<\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\">\\u00a0<\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\">\\u00a0<\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\">\\u00a0<\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\">\\u00a0<\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\">\\u00a0<\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\">\\u00a0<\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\">\\u00a0<\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\">\\u00a0<\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\">\\u00a0<\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\">\\u00a0<\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\">\\u00a0<\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\">\\u00a0<\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\">\\u00a0<\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\">\\u00a0<\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\">\\u00a0<\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\">\\u00a0<\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\">\\u00a0<\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\">\\u00a0<\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\">\\u00a0<\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\">\\u00a0<\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\">\\u00a0<\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\">\\u00a0<\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\">\\u00a0<\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\">\\u00a0<\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\">\\u00a0<\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\">\\u00a0<\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\">\\u00a0<\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\">\\u00a0<\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\">\\u00a0<\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\">\\u00a0<\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\">\\u00a0<\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\">\\u00a0<\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\">\\u00a0<\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\">\\u00a0<\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\">\\u00a0<\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\">\\u00a0<\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\">\\u00a0<\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\">\\u00a0<\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\">\\u00a0<\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\">\\u00a0<\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\">\\u00a0<\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\">\\u00a0<\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\">\\u00a0<\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\">\\u00a0<\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\">\\u00a0<\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\">\\u00a0<\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\">\\u00a0<\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\">\\u00a0<\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\">\\u00a0<\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\">\\u00a0<\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\">\\u00a0<\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\">\\u00a0<\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\">\\u00a0<\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\">\\u00a0<\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\">\\u00a0<\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\">\\u00a0<\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\">\\u00a0<\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\">\\u00a0<\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\">\\u00a0<\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\">\\u00a0<\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\">\\u00a0<\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\">\\u00a0<\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\">\\u00a0<\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\">\\u00a0<\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\">\\u00a0<\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\">\\u00a0<\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\">\\u00a0<\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\">\\u00a0<\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\">\\u00a0<\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\">\\u00a0<\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\">\\u00a0<\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\">\\u00a0<\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\">\\u00a0<\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\">\\u00a0<\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\">\\u00a0<\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\">\\u00a0<\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\">\\u00a0<\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\">\\u00a0<\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\">\\u00a0<\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\">\\u00a0<\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\">\\u00a0<\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\">\\u00a0<\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\">\\u00a0<\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\">\\u00a0<\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\">\\u00a0<\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\">\\u00a0<\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\">\\u00a0<\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\">\\u00a0<\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\">\\u00a0<\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\">\\u00a0<\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\">\\u00a0<\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\">\\u00a0<\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\">\\u00a0<\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\">\\u00a0<\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\">\\u00a0<\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\">\\u00a0<\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\">\\u00a0<\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\">\\u00a0<\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\">\\u00a0<\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\">\\u00a0<\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\">\\u00a0<\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\">\\u00a0<\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\">\\u00a0<\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\">\\u00a0<\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\">\\u00a0<\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\">\\u00a0<\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\">\\u00a0<\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\">\\u00a0<\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\">\\u00a0<\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\">\\u00a0<\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\">\\u00a0<\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\">\\u00a0<\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\">\\u00a0<\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\">\\u00a0<\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\">\\u00a0<\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\">\\u00a0<\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\">\\u00a0<\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\">\\u00a0<\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\">\\u00a0<\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\">\\u00a0<\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\">\\u00a0<\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\">\\u00a0<\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\">\\u00a0<\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\">\\u00a0<\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\">\\u00a0<\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\">\\u00a0<\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\">\\u00a0<\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\">\\u00a0<\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\">\\u00a0<\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\">\\u00a0<\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\">\\u00a0<\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\">\\u00a0<\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\">\\u00a0<\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\">\\u00a0<\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\">\\u00a0<\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\">\\u00a0<\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\">\\u00a0<\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\">\\u00a0<\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\">\\u00a0<\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\">\\u00a0<\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\">\\u00a0<\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\">\\u00a0<\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\">\\u00a0<\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\">\\u00a0<\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\">\\u00a0<\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\">\\u00a0<\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\">\\u00a0<\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\">\\u00a0<\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\">\\u00a0<\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\">\\u00a0<\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\">\\u00a0<\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\">\\u00a0<\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\">\\u00a0<\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\">\\u00a0<\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\">\\u00a0<\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\">\\u00a0<\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\">\\u00a0<\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearfix\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Social Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<div class=\\"jm-socials\\">\\r\\n<pre>&lt;div class=\\"jm-socials\\"&gt;<br \\/>&lt;a class=\\"facebook\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"googleplus\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"twitter\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"linkedin\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"skype\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"vimeo\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<a class=\\"facebook\\" href=\\"#\\">\\u00a0<\\/a> <a class=\\"googleplus\\" href=\\"#\\">\\u00a0<\\/a> <a class=\\"twitter\\" href=\\"#\\">\\u00a0<\\/a> <a class=\\"linkedin\\" href=\\"#\\">\\u00a0<\\/a> <a class=\\"skype\\" href=\\"#\\">\\u00a0<\\/a> <a class=\\"vimeo\\" href=\\"#\\">\\u00a0<\\/a><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"800","created_by_alias":"","modified":"2014-09-16 10:45:52","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-16 10:38:57","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":59,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"149","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('319','133','1','','2014-09-17 13:16:51','936','2241','9bc31e2c431ddd36e89f95186ab83e53ff0b3e6a','{"id":133,"asset_id":399,"title":"Examples","alias":"examples","introtext":"<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<h3>Business Theme<\\/h3>\\r\\n<a title=\\"JM-Services Business\\" href=\\"#\\"><img src=\\"images\\/sample\\/jmservices-business.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<h3>Culinary Theme<\\/h3>\\r\\n<a title=\\"JM-Services Culinary\\" href=\\"#\\"><img src=\\"images\\/sample\\/jmservices-culinary.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<h3>Dental Theme<\\/h3>\\r\\n<a title=\\"JM-Services Dental\\" href=\\"#\\"><img src=\\"images\\/sample\\/jmservices-dental.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-09-17 13:16:51","created_by":"800","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-09-17 13:16:51","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('320','133','1','','2014-09-17 13:20:12','936','2506','7164250d84fd03cfafee7727623fbb3f3d87d1eb','{"id":133,"asset_id":"399","title":"Examples","alias":"examples","introtext":"<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<h3>Business Theme<\\/h3>\\r\\n<a title=\\"JM-Services Business\\" href=\\"index.php?option=com_content&amp;view=article&amp;id=73&amp;Itemid=435\\"><img src=\\"images\\/sample\\/jm-services-business.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<h3>Culinary Theme<\\/h3>\\r\\n<a title=\\"JM-Services Culinary\\" href=\\"index.php?option=com_content&amp;view=category&amp;layout=blog&amp;id=93&amp;Itemid=568\\"><img src=\\"images\\/sample\\/jm-services-culinary.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<h3>Dental Theme<\\/h3>\\r\\n<a title=\\"JM-Services Dental\\" href=\\"index.php?option=com_content&amp;view=article&amp;id=73&amp;Itemid=613\\"><img src=\\"images\\/sample\\/jm-services-dental.jpg\\" alt=\\"JM Services\\" \\/><\\/a><\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-09-17 13:16:51","created_by":"800","created_by_alias":"","modified":"2014-09-17 13:20:12","modified_by":"800","checked_out":"800","checked_out_time":"2014-09-17 13:19:21","publish_up":"2014-09-17 13:16:51","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('323','97','8','','2014-11-28 12:55:32','936','529','a916edd7c647298a40f74a900b268cf787b2b09a','{"id":97,"asset_id":405,"parent_id":"1","lft":"41","rgt":42,"level":1,"path":null,"extension":"com_newsfeeds","title":"JMSampleData","alias":"jmsampledata","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"941","created_time":"2014-11-28 12:55:32","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}','0'),
('324','5','4','','2014-11-28 12:58:38','936','920','b5be9ada624e4cd367f9f46c20581643e8f666ec','{"catid":"97","id":5,"name":"News Feed","alias":"news-feed","link":"http:\\/\\/www.cbc.ca\\/cmlink\\/rss-world","published":"1","numarticles":"5","cache_time":"3600","checked_out":null,"checked_out_time":null,"ordering":1,"rtl":"0","access":"1","language":"*","params":"{\\"show_feed_image\\":\\"\\",\\"show_feed_description\\":\\"\\",\\"show_item_description\\":\\"\\",\\"feed_character_count\\":\\"0\\",\\"newsfeed_layout\\":\\"\\",\\"feed_display_order\\":\\"\\"}","created":"2014-11-28 12:58:38","created_by":"941","created_by_alias":"","modified":"","modified_by":null,"metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","xreference":"","publish_up":"","publish_down":"","description":"","version":1,"hits":null,"images":"{\\"image_first\\":\\"\\",\\"float_first\\":\\"\\",\\"image_first_alt\\":\\"\\",\\"image_first_caption\\":\\"\\",\\"image_second\\":\\"\\",\\"float_second\\":\\"\\",\\"image_second_alt\\":\\"\\",\\"image_second_caption\\":\\"\\"}"}','0'),
('325','87','1','','2014-11-28 13:03:17','936','51251','66c3e2aff6ed8365348f15814d39698333b20348','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">IcoMoon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-joomla\\"> <\\/span> .icon-joomla<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\"> <\\/span> .icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-uparrow\\"> <\\/span> .icon-uparrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\"> <\\/span> .icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\"> <\\/span> .icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-rightarrow\\"> <\\/span> .icon-rightarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\"> <\\/span> .icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\"> <\\/span> .icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-downarrow\\"> <\\/span> .icon-downarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\"> <\\/span> .icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\"> <\\/span> .icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leftarrow\\"> <\\/span> .icon-leftarrow<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\"> <\\/span> .icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-first\\"> <\\/span> .icon-arrow-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-last\\"> <\\/span> .icon-arrow-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-2\\"> <\\/span> .icon-arrow-up-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-2\\"> <\\/span> .icon-arrow-right-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-2\\"> <\\/span> .icon-arrow-down-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-2\\"> <\\/span> .icon-arrow-left-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-3\\"> <\\/span> .icon-arrow-up-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-3\\"> <\\/span> .icon-arrow-right-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-3\\"> <\\/span> .icon-arrow-down-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-3\\"> <\\/span> .icon-arrow-left-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-2\\"> <\\/span> .icon-menu-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up-4\\"> <\\/span> .icon-arrow-up-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right-4\\"> <\\/span> .icon-arrow-right-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down-4\\"> <\\/span> .icon-arrow-down-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left-4\\"> <\\/span> .icon-arrow-left-4<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\"> <\\/span> .icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo\\"> <\\/span> .icon-redo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo\\"> <\\/span> .icon-undo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-2\\"> <\\/span> .icon-forward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-2\\"> <\\/span> .icon-backward-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-reply\\"> <\\/span> .icon-reply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unblock\\"> <\\/span> .icon-unblock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\"> <\\/span> .icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-redo-2\\"> <\\/span> .icon-redo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-undo-2\\"> <\\/span> .icon-undo-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\"> <\\/span> .icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\"> <\\/span> .icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract\\"> <\\/span> .icon-contract<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand-2\\"> <\\/span> .icon-expand-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-contract-2\\"> <\\/span> .icon-contract-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\"> <\\/span> .icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\"> <\\/span> .icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\"> <\\/span> .icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-previous\\"> <\\/span> .icon-previous<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\"> <\\/span> .icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-next\\"> <\\/span> .icon-next<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\"> <\\/span> .icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-first\\"> <\\/span> .icon-first<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-last\\"> <\\/span> .icon-last<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\"> <\\/span> .icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause-circle\\"> <\\/span> .icon-pause-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop-circle\\"> <\\/span> .icon-stop-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward-circle\\"> <\\/span> .icon-backward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward-circle\\"> <\\/span> .icon-forward-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-loop\\"> <\\/span> .icon-loop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shuffle\\"> <\\/span> .icon-shuffle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\"> <\\/span> .icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\"> <\\/span> .icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\"> <\\/span> .icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-apply\\"> <\\/span> .icon-apply<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\"> <\\/span> .icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\"> <\\/span> .icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil-2\\"> <\\/span> .icon-pencil-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-brush\\"> <\\/span> .icon-brush<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-new\\"> <\\/span> .icon-save-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-2\\"> <\\/span> .icon-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\"> <\\/span> .icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\"> <\\/span> .icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-2\\"> <\\/span> .icon-minus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-delete\\"> <\\/span> .icon-delete<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\"> <\\/span> .icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-2\\"> <\\/span> .icon-cancel-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-publish\\"> <\\/span> .icon-publish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\"> <\\/span> .icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\"> <\\/span> .icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark\\"> <\\/span> .icon-checkmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new\\"> <\\/span> .icon-new<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\"> <\\/span> .icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-circle\\"> <\\/span> .icon-plus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\"> <\\/span> .icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-not-ok\\"> <\\/span> .icon-not-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-circle\\"> <\\/span> .icon-minus-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unpublish\\"> <\\/span> .icon-unpublish<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel\\"> <\\/span> .icon-cancel<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cancel-circle\\"> <\\/span> .icon-cancel-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-2\\"> <\\/span> .icon-checkmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkmark-circle\\"> <\\/span> .icon-checkmark-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info\\"> <\\/span> .icon-info<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-2\\"> <\\/span> .icon-info-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-circle\\"> <\\/span> .icon-info-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question\\"> <\\/span> .icon-question<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\"> <\\/span> .icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-help\\"> <\\/span> .icon-help<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-2\\"> <\\/span> .icon-question-2<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-circle\\"> <\\/span> .icon-question-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification\\"> <\\/span> .icon-notification<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-2\\"> <\\/span> .icon-notification-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-notification-circle\\"> <\\/span> .icon-notification-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pending\\"> <\\/span> .icon-pending<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning\\"> <\\/span> .icon-warning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-2\\"> <\\/span> .icon-warning-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-circle\\"> <\\/span> .icon-warning-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-unchecked\\"> <\\/span> .icon-checkbox-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkin\\"> <\\/span> .icon-checkin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox\\"> <\\/span> .icon-checkbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-checked\\"> <\\/span> .icon-checkbox-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkbox-partial\\"> <\\/span> .icon-checkbox-partial<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-square\\"> <\\/span> .icon-square<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-unchecked\\"> <\\/span> .icon-radio-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-radio-checked\\"> <\\/span> .icon-radio-checked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle\\"> <\\/span> .icon-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signup\\"> <\\/span> .icon-signup<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid\\"> <\\/span> .icon-grid<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view\\"> <\\/span> .icon-grid-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-2\\"> <\\/span> .icon-grid-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-grid-view-2\\"> <\\/span> .icon-grid-view-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu\\"> <\\/span> .icon-menu<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\"> <\\/span> .icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-view\\"> <\\/span> .icon-list-view<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-2\\"> <\\/span> .icon-list-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-menu-3\\"> <\\/span> .icon-menu-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\"> <\\/span> .icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder\\"> <\\/span> .icon-folder<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\"> <\\/span> .icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-2\\"> <\\/span> .icon-folder-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus\\"> <\\/span> .icon-folder-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-minus\\"> <\\/span> .icon-folder-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-3\\"> <\\/span> .icon-folder-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-plus-2\\"> <\\/span> .icon-folder-plus-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-remove\\"> <\\/span> .icon-folder-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\"> <\\/span> .icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-2\\"> <\\/span> .icon-file-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-add\\"> <\\/span> .icon-file-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-plus\\"> <\\/span> .icon-file-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\"> <\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-minus\\"> <\\/span> .icon-file-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-check\\"> <\\/span> .icon-file-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file-remove\\"> <\\/span> .icon-file-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save-copy\\"> <\\/span> .icon-save-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copy\\"> <\\/span> .icon-copy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stack\\"> <\\/span> .icon-stack<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree\\"> <\\/span> .icon-tree<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-2\\"> <\\/span> .icon-tree-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-left\\"> <\\/span> .icon-paragraph-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-center\\"> <\\/span> .icon-paragraph-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-right\\"> <\\/span> .icon-paragraph-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paragraph-justify\\"> <\\/span> .icon-paragraph-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screen\\"> <\\/span> .icon-screen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tablet\\"> <\\/span> .icon-tablet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mobile\\"> <\\/span> .icon-mobile<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-add\\"> <\\/span> .icon-box-add<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-box-remove\\"> <\\/span> .icon-box-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\"> <\\/span> .icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\"> <\\/span> .icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\"> <\\/span> .icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home-2\\"> <\\/span> .icon-home-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-2\\"> <\\/span> .icon-out-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab\\"> <\\/span> .icon-new-tab<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out-3\\"> <\\/span> .icon-out-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-tab-2\\"> <\\/span> .icon-new-tab-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\"> <\\/span> .icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\"> <\\/span> .icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-image\\"> <\\/span> .icon-image<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pictures\\"> <\\/span> .icon-pictures<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-images\\"> <\\/span> .icon-images<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-palette\\"> <\\/span> .icon-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-color-palette\\"> <\\/span> .icon-color-palette<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\"> <\\/span> .icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera-2\\"> <\\/span> .icon-camera-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video\\"> <\\/span> .icon-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-2\\"> <\\/span> .icon-play-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-video-2\\"> <\\/span> .icon-video-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-youtube\\"> <\\/span> .icon-youtube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\"> <\\/span> .icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\"> <\\/span> .icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-users\\"> <\\/span> .icon-users<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-vcard\\"> <\\/span> .icon-vcard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-address\\"> <\\/span> .icon-address<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\"> <\\/span> .icon-share-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-out\\"> <\\/span> .icon-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-enter\\"> <\\/span> .icon-enter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exit\\"> <\\/span> .icon-exit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\"> <\\/span> .icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments\\"> <\\/span> .icon-comments<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comments-2\\"> <\\/span> .icon-comments-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote\\"> <\\/span> .icon-quote<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-left\\"> <\\/span> .icon-quotes-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-2\\"> <\\/span> .icon-quote-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quotes-right\\"> <\\/span> .icon-quotes-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-quote-3\\"> <\\/span> .icon-quote-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bubble-quote\\"> <\\/span> .icon-bubble-quote<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\"> <\\/span> .icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-2\\"> <\\/span> .icon-phone-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\"> <\\/span> .icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail\\"> <\\/span> .icon-mail<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope-opened\\"> <\\/span> .icon-envelope-opened<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-mail-2\\"> <\\/span> .icon-mail-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unarchive\\"> <\\/span> .icon-unarchive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer\\"> <\\/span> .icon-drawer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-archive\\"> <\\/span> .icon-archive<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-drawer-2\\"> <\\/span> .icon-drawer-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\"> <\\/span> .icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\"> <\\/span> .icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag-2\\"> <\\/span> .icon-tag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\"> <\\/span> .icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags-2\\"> <\\/span> .icon-tags-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-options\\"> <\\/span> .icon-options<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\"> <\\/span> .icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cogs\\"> <\\/span> .icon-cogs<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screwdriver\\"> <\\/span> .icon-screwdriver<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tools\\"> <\\/span> .icon-tools<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\"> <\\/span> .icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-equalizer\\"> <\\/span> .icon-equalizer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\"> <\\/span> .icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-switch\\"> <\\/span> .icon-switch<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\"> <\\/span> .icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-purge\\"> <\\/span> .icon-purge<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\"> <\\/span> .icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-checkedout\\"> <\\/span> .icon-checkedout<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\"> <\\/span> .icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-locked\\"> <\\/span> .icon-locked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unlock\\"> <\\/span> .icon-unlock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-key\\"> <\\/span> .icon-key<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-support\\"> <\\/span> .icon-support<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-database\\"> <\\/span> .icon-database<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-scissors\\"> <\\/span> .icon-scissors<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-health\\"> <\\/span> .icon-health<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wand\\"> <\\/span> .icon-wand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\"> <\\/span> .icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye\\"> <\\/span> .icon-eye<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\"> <\\/span> .icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-blocked\\"> <\\/span> .icon-eye-blocked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-2\\"> <\\/span> .icon-eye-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-clock\\"> <\\/span> .icon-clock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compass\\"> <\\/span> .icon-compass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-broadcast\\"> <\\/span> .icon-broadcast<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-connection\\"> <\\/span> .icon-connection<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wifi\\"> <\\/span> .icon-wifi<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\"> <\\/span> .icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lightning\\"> <\\/span> .icon-lightning<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\"> <\\/span> .icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\"> <\\/span> .icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-printer\\"> <\\/span> .icon-printer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-feed\\"> <\\/span> .icon-feed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\"> <\\/span> .icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-2\\"> <\\/span> .icon-calendar-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar-3\\"> <\\/span> .icon-calendar-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pie\\"> <\\/span> .icon-pie<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bars\\"> <\\/span> .icon-bars<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chart\\"> <\\/span> .icon-chart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-power-cord\\"> <\\/span> .icon-power-cord<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cube\\"> <\\/span> .icon-cube<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-puzzle\\"> <\\/span> .icon-puzzle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-attachment\\"> <\\/span> .icon-attachment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\"> <\\/span> .icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-2\\"> <\\/span> .icon-flag-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lamp\\"> <\\/span> .icon-lamp<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pin\\"> <\\/span> .icon-pin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\"> <\\/span> .icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-location\\"> <\\/span> .icon-location<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shield\\"> <\\/span> .icon-shield<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\"> <\\/span> .icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag-3\\"> <\\/span> .icon-flag-3<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\"> <\\/span> .icon-bookmark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark-2\\"> <\\/span> .icon-bookmark-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\"> <\\/span> .icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-2\\"> <\\/span> .icon-heart-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\"> <\\/span> .icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\"> <\\/span> .icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unfeatured\\"> <\\/span> .icon-unfeatured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\"> <\\/span> .icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\"> <\\/span> .icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-2\\"> <\\/span> .icon-star-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-featured\\"> <\\/span> .icon-featured<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-default\\"> <\\/span> .icon-default<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\"> <\\/span> .icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley\\"> <\\/span> .icon-smiley<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy\\"> <\\/span> .icon-smiley-happy<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-2\\"> <\\/span> .icon-smiley-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-happy-2\\"> <\\/span> .icon-smiley-happy-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad\\"> <\\/span> .icon-smiley-sad<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-sad-2\\"> <\\/span> .icon-smiley-sad-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral\\"> <\\/span> .icon-smiley-neutral<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-smiley-neutral-2\\"> <\\/span> .icon-smiley-neutral-2<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cart\\"> <\\/span> .icon-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-basket\\"> <\\/span> .icon-basket<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit\\"> <\\/span> .icon-credit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-2\\"> <\\/span> .icon-credit-2<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearfix\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Social Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<div class=\\"jm-socials\\">\\r\\n<pre>&lt;div class=\\"jm-socials\\"&gt;<br \\/>&lt;a class=\\"facebook\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"googleplus\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"twitter\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"linkedin\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"skype\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"vimeo\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<a class=\\"facebook\\" href=\\"#\\"> <\\/a> <a class=\\"googleplus\\" href=\\"#\\"> <\\/a> <a class=\\"twitter\\" href=\\"#\\"> <\\/a> <a class=\\"linkedin\\" href=\\"#\\"> <\\/a> <a class=\\"skype\\" href=\\"#\\"> <\\/a> <a class=\\"vimeo\\" href=\\"#\\"> <\\/a><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Our Cooks Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Greg Amaro&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Jimmy Gessler&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Greg Amaro<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Jimmy Gessler<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"941","created_by_alias":"","modified":"2014-11-28 13:03:17","modified_by":"941","checked_out":"941","checked_out_time":"2014-11-28 13:02:57","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":60,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"155","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('326','87','1','','2014-11-28 13:05:58','936','42553','54022d16e41c15fa2f970d29063867793b40feca','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\" style=\\"margin-bottom: 30px;\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">Glyphicon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\"> <\\/span> icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\"> <\\/span> icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-euro\\"> <\\/span> icon-euro<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\"> <\\/span> icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud\\"> <\\/span> icon-cloud<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\"> <\\/span> icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\"> <\\/span> icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-glass\\"> <\\/span> icon-glass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\"> <\\/span> icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\"> <\\/span> icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\"> <\\/span> icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\"> <\\/span> icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\"> <\\/span> icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\"> <\\/span> icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-film\\"> <\\/span> icon-film<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th-large\\"> <\\/span> icon-th-large<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th\\"> <\\/span> icon-th<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th-list\\"> <\\/span> icon-th-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\"> <\\/span> icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\"> <\\/span> icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\"> <\\/span> icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\"> <\\/span> icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-off\\"> <\\/span> icon-off<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signal\\"> <\\/span> icon-signal<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\"> <\\/span> icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\"> <\\/span> icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\"> <\\/span> icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\"> <\\/span> icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-time\\"> <\\/span> icon-time<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-road\\"> <\\/span> icon-road<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download-alt\\"> <\\/span> icon-download-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\"> <\\/span> icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\"> <\\/span> icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-inbox\\"> <\\/span> icon-inbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\"> <\\/span> icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-repeat\\"> <\\/span> icon-repeat<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\"> <\\/span> icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-alt\\"> <\\/span> icon-list-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\"> <\\/span> icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\"> <\\/span> icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-headphones\\"> <\\/span> icon-headphones<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-off\\"> <\\/span> icon-volume-off<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-down\\"> <\\/span> icon-volume-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-up\\"> <\\/span> icon-volume-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-qrcode\\"> <\\/span> icon-qrcode<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-barcode\\"> <\\/span> icon-barcode<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\"> <\\/span> icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\"> <\\/span> icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\"> <\\/span> icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\"> <\\/span> icon-bookmark<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\"> <\\/span> icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\"> <\\/span> icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-font\\"> <\\/span> icon-font<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bold\\"> <\\/span> icon-bold<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-italic\\"> <\\/span> icon-italic<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-text-height\\"> <\\/span> icon-text-height<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-text-width\\"> <\\/span> icon-text-width<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-left\\"> <\\/span> icon-align-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-center\\"> <\\/span> icon-align-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-right\\"> <\\/span> icon-align-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-justify\\"> <\\/span> icon-align-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\"> <\\/span> icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-indent-left\\"> <\\/span> icon-indent-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-indent-right\\"> <\\/span> icon-indent-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-facetime-video\\"> <\\/span> icon-facetime-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\"> <\\/span> icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-map-marker\\"> <\\/span> icon-map-marker<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-adjust\\"> <\\/span> icon-adjust<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tint\\"> <\\/span> icon-tint<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\"> <\\/span> icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\"> <\\/span> icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-check\\"> <\\/span> icon-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\"> <\\/span> icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-step-backward\\"> <\\/span> icon-step-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fast-backward\\"> <\\/span> icon-fast-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\"> <\\/span> icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\"> <\\/span> icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\"> <\\/span> icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\"> <\\/span> icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\"> <\\/span> icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fast-forward\\"> <\\/span> icon-fast-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-step-forward\\"> <\\/span> icon-step-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eject\\"> <\\/span> icon-eject<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\"> <\\/span> icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\"> <\\/span> icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-sign\\"> <\\/span> icon-plus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\"> <\\/span> icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove-sign\\"> <\\/span> icon-remove-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok-sign\\"> <\\/span> icon-ok-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\"> <\\/span> icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-sign\\"> <\\/span> icon-info-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screenshot\\"> <\\/span> icon-screenshot<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove-circle\\"> <\\/span> icon-remove-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok-circle\\"> <\\/span> icon-ok-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\"> <\\/span> icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\"> <\\/span> icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\"> <\\/span> icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\"> <\\/span> icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\"> <\\/span> icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\"> <\\/span> icon-share-alt<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-full\\"> <\\/span> icon-resize-full<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-small\\"> <\\/span> icon-resize-small<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exclamation-sign\\"> <\\/span> icon-exclamation-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-gift\\"> <\\/span> icon-gift<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leaf\\"> <\\/span> icon-leaf<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fire\\"> <\\/span> icon-fire<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\"> <\\/span> icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\"> <\\/span> icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-sign\\"> <\\/span> icon-warning-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plane\\"> <\\/span> icon-plane<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\"> <\\/span> icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-random\\"> <\\/span> icon-random<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\"> <\\/span> icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-magnet\\"> <\\/span> icon-magnet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\"> <\\/span> icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\"> <\\/span> icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-retweet\\"> <\\/span> icon-retweet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shopping-cart\\"> <\\/span> icon-shopping-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\"> <\\/span> icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\"> <\\/span> icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-vertical\\"> <\\/span> icon-resize-vertical<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-horizontal\\"> <\\/span> icon-resize-horizontal<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hdd\\"> <\\/span> icon-hdd<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bullhorn\\"> <\\/span> icon-bullhorn<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bell\\"> <\\/span> icon-bell<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-certificate\\"> <\\/span> icon-certificate<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\"> <\\/span> icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\"> <\\/span> icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-right\\"> <\\/span> icon-hand-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-left\\"> <\\/span> icon-hand-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-up\\"> <\\/span> icon-hand-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-down\\"> <\\/span> icon-hand-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-right\\"> <\\/span> icon-circle-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-left\\"> <\\/span> icon-circle-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-up\\"> <\\/span> icon-circle-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-down\\"> <\\/span> icon-circle-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-globe\\"> <\\/span> icon-globe<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\"> <\\/span> icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tasks\\"> <\\/span> icon-tasks<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\"> <\\/span> icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\"> <\\/span> icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fullscreen\\"> <\\/span> icon-fullscreen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\"> <\\/span> icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\"> <\\/span> icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-empty\\"> <\\/span> icon-heart-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\"> <\\/span> icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\"> <\\/span> icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\"> <\\/span> icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-usd\\"> <\\/span> icon-usd<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-gbp\\"> <\\/span> icon-gbp<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort\\"> <\\/span> icon-sort<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-alphabet\\"> <\\/span> icon-sort-by-alphabet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-alphabet-alt\\"> <\\/span> icon-sort-by-alphabet-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-order\\"> <\\/span> icon-sort-by-order<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-order-alt\\"> <\\/span> icon-sort-by-order-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-attributes\\"> <\\/span> icon-sort-by-attributes<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-attributes-alt\\"> <\\/span> icon-sort-by-attributes-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unchecked\\"> <\\/span> icon-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\"> <\\/span> icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-collapse-down\\"> <\\/span> icon-collapse-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-collapse-up\\"> <\\/span> icon-collapse-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-log-in\\"> <\\/span> icon-log-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\"> <\\/span> icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-log-out\\"> <\\/span> icon-log-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-window\\"> <\\/span> icon-new-window<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-record\\"> <\\/span> icon-record<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\"> <\\/span> icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-open\\"> <\\/span> icon-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-saved\\"> <\\/span> icon-saved<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-import\\"> <\\/span> icon-import<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-export\\"> <\\/span> icon-export<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-send\\"> <\\/span> icon-send<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-disk\\"> <\\/span> icon-floppy-disk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-saved\\"> <\\/span> icon-floppy-saved<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-remove\\"> <\\/span> icon-floppy-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-save\\"> <\\/span> icon-floppy-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-open\\"> <\\/span> icon-floppy-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-card\\"> <\\/span> icon-credit-card<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-transfer\\"> <\\/span> icon-transfer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cutlery\\"> <\\/span> icon-cutlery<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-header\\"> <\\/span> icon-header<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compressed\\"> <\\/span> icon-compressed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-earphone\\"> <\\/span> icon-earphone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-alt\\"> <\\/span> icon-phone-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tower\\"> <\\/span> icon-tower<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stats\\"> <\\/span> icon-stats<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sd-video\\"> <\\/span> icon-sd-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hd-video\\"> <\\/span> icon-hd-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-subtitles\\"> <\\/span> icon-subtitles<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-stereo\\"> <\\/span> icon-sound-stereo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-dolby\\"> <\\/span> icon-sound-dolby<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-5-1\\"> <\\/span> icon-sound-5-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-6-1\\"> <\\/span> icon-sound-6-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-7-1\\"> <\\/span> icon-sound-7-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copyright-mark\\"> <\\/span> icon-copyright-mark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-registration-mark\\"> <\\/span> icon-registration-mark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud-download\\"> <\\/span> icon-cloud-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud-upload\\"> <\\/span> icon-cloud-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-conifer\\"> <\\/span> icon-tree-conifer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-deciduous\\"> <\\/span> icon-tree-deciduous<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearfix\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Social Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<div class=\\"jm-socials\\">\\r\\n<pre>&lt;div class=\\"jm-socials\\"&gt;<br \\/>&lt;a class=\\"facebook\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"googleplus\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"twitter\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"linkedin\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"skype\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"vimeo\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<a class=\\"facebook\\" href=\\"#\\"> <\\/a> <a class=\\"googleplus\\" href=\\"#\\"> <\\/a> <a class=\\"twitter\\" href=\\"#\\"> <\\/a> <a class=\\"linkedin\\" href=\\"#\\"> <\\/a> <a class=\\"skype\\" href=\\"#\\"> <\\/a> <a class=\\"vimeo\\" href=\\"#\\"> <\\/a><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Our Cooks Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Greg Amaro&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Jimmy Gessler&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Greg Amaro<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Jimmy Gessler<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"941","created_by_alias":"","modified":"2014-11-28 13:05:58","modified_by":"941","checked_out":"941","checked_out_time":"2014-11-28 13:03:17","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":61,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"156","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('327','130','1','','2014-11-28 14:01:27','936','5934','f2fb249eace3106f7e49b2a219227a18fa5de319','{"id":130,"asset_id":"395","title":"All Template Positions","alias":"all-template-positions","introtext":"<p><a title=\\"JM Services\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-services&amp;cid=32:free&amp;Itemid=471\\" target=\\"_blank\\">JM Services<\\/a> Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br \\/><a title=\\"EF4 Framework\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;id=137&amp;view=category&amp;Itemid=548\\" target=\\"_blank\\">EF4 Framework<\\/a> includes <a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Layout Builder<\\/a> tool which allows you to customize template layout for different screen dimensions.<\\/p>\\r\\n","fulltext":"\\r\\n<p><\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for normal and large screen <small>usually desktop and tablet landscape (980px and higher)<\\/small><\\/h3>\\r\\n<p><\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for normal and large screen\\" src=\\"images\\/sample\\/normal-positions.jpg\\" alt=\\"Module positions for normal and large screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p><\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for medium screen <small>usually tablet (768px-979px)<\\/small><\\/h3>\\r\\n<p><\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for medium screen\\" src=\\"images\\/sample\\/medium-positions.jpg\\" alt=\\"Module positions for medium screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p><\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for small screen <small>usually tablet portrait and mobile landscape (481px-767px)<\\/small><\\/h3>\\r\\n<p><\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for small screen\\" src=\\"images\\/sample\\/small-positions.jpg\\" alt=\\"Module positions for small screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p><\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for extra small screen <small>usually mobile portrait (480px and smaller)<\\/small><\\/h3>\\r\\n<p><\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for extra small screen\\" src=\\"images\\/sample\\/extrasmall-positions.jpg\\" alt=\\"Module positions for extra small screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"941","created_by_alias":"","modified":"2014-11-28 14:01:27","modified_by":"941","checked_out":"941","checked_out_time":"2014-11-28 14:01:11","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('328','130','1','','2014-11-28 14:45:39','936','5982','292e37b313d512e5d007df85bafa99bc9dca6998','{"id":130,"asset_id":"395","title":"All Template Positions","alias":"all-template-positions","introtext":"<p><a title=\\"JM Services\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_djcatalog2&amp;view=item&amp;id=122:jm-services&amp;cid=32:free&amp;Itemid=471\\" target=\\"_blank\\">JM Services<\\/a> Joomla template is using fully responsive layout that adjusts to various screens: desktops, tablets or mobiles.<br \\/><a title=\\"EF4 Framework\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;id=137&amp;view=category&amp;Itemid=548\\" target=\\"_blank\\">EF4 Framework<\\/a> includes <a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Layout Builder<\\/a> tool which allows you to customize template layout for different screen dimensions.<\\/p>\\r\\n","fulltext":"\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for normal and large screen <small>usually desktop and tablet landscape (980px and higher)<\\/small><\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for normal and large screen\\" src=\\"images\\/sample\\/normal-positions.jpg\\" alt=\\"Module positions for normal and large screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for medium screen <small>usually tablet (768px-979px)<\\/small><\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for medium screen\\" src=\\"images\\/sample\\/medium-positions.jpg\\" alt=\\"Module positions for medium screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for small screen <small>usually tablet portrait and mobile landscape (481px-767px)<\\/small><\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for small screen\\" src=\\"images\\/sample\\/small-positions.jpg\\" alt=\\"Module positions for small screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>\\r\\n<p>\\u00a0<\\/p>\\r\\n<h3 style=\\"text-align: center;\\">Module positions for extra small screen <small>usually mobile portrait (480px and smaller)<\\/small><\\/h3>\\r\\n<p>\\u00a0<\\/p>\\r\\n<p style=\\"text-align: center;\\"><a title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\"><img title=\\"Module positions for extra small screen\\" src=\\"images\\/sample\\/extrasmall-positions.jpg\\" alt=\\"Module positions for extra small screen\\" border=\\"0\\" \\/><\\/a><\\/p>\\r\\n<p class=\\"readmore\\" style=\\"text-align: center;\\"><a class=\\"btn\\" title=\\"Layout Builder\\" href=\\"http:\\/\\/www.joomla-monster.com\\/index.php?option=com_content&amp;catid=137&amp;id=901&amp;view=article&amp;Itemid=1034\\" target=\\"_blank\\">Check out more details about layout customization!<\\/a><\\/p>","state":1,"catid":"78","created":"2014-06-25 09:42:57","created_by":"941","created_by_alias":"","modified":"2014-11-28 14:45:39","modified_by":"941","checked_out":"941","checked_out_time":"2014-11-28 14:01:27","publish_up":"2014-06-25 09:42:57","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"3","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('329','87','1','','2015-05-28 09:29:17','936','42522','aa383b7c3ad181dce10231e665f08fab5b9874d5','{"id":87,"asset_id":"276","title":"Typography","alias":"typography","introtext":"<h3 class=\\"jm-typo-title\\">Image Borders<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-rounded\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-rounded\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-circle\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-circle\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<p><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;img class=\\"img-polaroid\\" src=\\"image.jpg\\" \\/&gt;<\\/pre>\\r\\n<div style=\\"text-align: center;\\"><img class=\\"img-polaroid\\" src=\\"images\\/bootstrap_sample\\/sample140x140.png\\" alt=\\"Typography\\" border=\\"0\\" \\/><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Headings<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<h1>This is Heading One (h1)<\\/h1>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h2>This is Heading Two (h2)<\\/h2>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h3>This is Heading Three (h3)<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<h4>This is Heading Four (h4)<\\/h4>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h5>This is Heading Five (h5)<\\/h5>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<br \\/>\\r\\n<h6>This is Heading Six (h6)<\\/h6>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Numered blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block\\"&gt;&lt;span class=\\"jm\\"&gt;01&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">01<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">02<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block\\"><span class=\\"jm\\">03<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;p class=\\"jm-block second\\"&gt;&lt;span class=\\"jm\\"&gt;a&lt;\\/span&gt;Text goes here&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">a<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">b<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">c<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Colored Blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert\\">&lt;div class=\\"alert\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-error\\">&lt;div class=\\"alert alert-error\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<div class=\\"alert alert-success\\">&lt;div class=\\"alert alert-success\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<div class=\\"alert alert-info\\">&lt;div class=\\"alert alert-info\\"&gt;Text goes here&lt;\\/div&gt;<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Icon blocks<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-badge\\">&lt;p class=\\"jm-badge\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-calendar\\">&lt;p class=\\"jm-calendar\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-chat\\">&lt;p class=\\"jm-chat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-check\\">&lt;p class=\\"jm-check\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-cloud\\">&lt;p class=\\"jm-cloud\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-direction\\">&lt;p class=\\"jm-direction\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-divide\\">&lt;p class=\\"jm-divide\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-error\\">&lt;p class=\\"jm-error\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-fire\\">&lt;p class=\\"jm-fire\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<p class=\\"jm-flag\\">&lt;p class=\\"jm-flag\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-heart\\">&lt;p class=\\"jm-heart\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-home\\">&lt;p class=\\"jm-home\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-info\\">&lt;p class=\\"jm-info\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-list\\">&lt;p class=\\"jm-list\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-mail\\">&lt;p class=\\"jm-mail\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-people\\">&lt;p class=\\"jm-people\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-star\\">&lt;p class=\\"jm-star\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<p class=\\"jm-stat\\">&lt;p class=\\"jm-stat\\" &gt;Text goes here&lt;\\/p&gt;<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Blockquote<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;blockquote class=\\"pull-right\\"&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.&lt;\\/p&gt;<br \\/>&lt;small&gt;John Doe&lt;\\/small&gt;<br \\/>&lt;\\/blockquote&gt;<\\/pre>\\r\\n<blockquote class=\\"pull-right\\">\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<\\/p>\\r\\n<small>John Doe<\\/small><\\/blockquote>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Unordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-color-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-color-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ul class=\\"jm-light-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-light-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<div class=\\"span6\\">\\r\\n<pre>&lt;ul class=\\"jm-custom-list green\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-custom-list green\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ul>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ul>\\r\\n<\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Ordered lists<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-roman\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-roman\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;ol class=\\"jm-alpha\\"&gt;<br \\/>&lt;-- list goes here --&gt;<br \\/>&lt;\\/ol&gt;<\\/pre>\\r\\n<ol class=\\"jm-alpha\\">\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum\\r\\n<ol>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<li>Duis tincidunt nunc sit amet ipsum<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/li>\\r\\n<\\/ol>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Read More Button<\\/h3>\\r\\n<pre>&lt;p class=\\"readmore\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;Read more&lt;\\/a&gt;&lt;\\/p&gt;<\\/pre>\\r\\n<p class=\\"readmore\\"><a class=\\"btn\\" href=\\"#\\">Read more<\\/a><\\/p>\\r\\n<h3 class=\\"jm-typo-title\\">Glyphicon Font<\\/h3>\\r\\n<div>\\r\\n<pre>&lt;span class=\\"icon-joomla\\"&gt;&amp;nbsp&lt;\\/span&gt;<\\/pre>\\r\\n<\\/div>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-asterisk\\"> <\\/span> icon-asterisk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus\\"> <\\/span> icon-plus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-euro\\"> <\\/span> icon-euro<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus\\"> <\\/span> icon-minus<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud\\"> <\\/span> icon-cloud<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-envelope\\"> <\\/span> icon-envelope<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pencil\\"> <\\/span> icon-pencil<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-glass\\"> <\\/span> icon-glass<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-music\\"> <\\/span> icon-music<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-search\\"> <\\/span> icon-search<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart\\"> <\\/span> icon-heart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star\\"> <\\/span> icon-star<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-star-empty\\"> <\\/span> icon-star-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-user\\"> <\\/span> icon-user<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-film\\"> <\\/span> icon-film<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th-large\\"> <\\/span> icon-th-large<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th\\"> <\\/span> icon-th<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-th-list\\"> <\\/span> icon-th-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok\\"> <\\/span> icon-ok<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove\\"> <\\/span> icon-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-in\\"> <\\/span> icon-zoom-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-zoom-out\\"> <\\/span> icon-zoom-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-off\\"> <\\/span> icon-off<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-signal\\"> <\\/span> icon-signal<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cog\\"> <\\/span> icon-cog<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-trash\\"> <\\/span> icon-trash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-home\\"> <\\/span> icon-home<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-file\\"> <\\/span> icon-file<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-time\\"> <\\/span> icon-time<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-road\\"> <\\/span> icon-road<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download-alt\\"> <\\/span> icon-download-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-download\\"> <\\/span> icon-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-upload\\"> <\\/span> icon-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-inbox\\"> <\\/span> icon-inbox<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play-circle\\"> <\\/span> icon-play-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-repeat\\"> <\\/span> icon-repeat<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-refresh\\"> <\\/span> icon-refresh<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list-alt\\"> <\\/span> icon-list-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-lock\\"> <\\/span> icon-lock<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flag\\"> <\\/span> icon-flag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-headphones\\"> <\\/span> icon-headphones<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-off\\"> <\\/span> icon-volume-off<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-down\\"> <\\/span> icon-volume-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-volume-up\\"> <\\/span> icon-volume-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-qrcode\\"> <\\/span> icon-qrcode<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-barcode\\"> <\\/span> icon-barcode<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tag\\"> <\\/span> icon-tag<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tags\\"> <\\/span> icon-tags<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-book\\"> <\\/span> icon-book<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bookmark\\"> <\\/span> icon-bookmark<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-print\\"> <\\/span> icon-print<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-camera\\"> <\\/span> icon-camera<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-font\\"> <\\/span> icon-font<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bold\\"> <\\/span> icon-bold<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-italic\\"> <\\/span> icon-italic<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-text-height\\"> <\\/span> icon-text-height<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-text-width\\"> <\\/span> icon-text-width<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-left\\"> <\\/span> icon-align-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-center\\"> <\\/span> icon-align-center<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-right\\"> <\\/span> icon-align-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-align-justify\\"> <\\/span> icon-align-justify<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-list\\"> <\\/span> icon-list<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-indent-left\\"> <\\/span> icon-indent-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-indent-right\\"> <\\/span> icon-indent-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-facetime-video\\"> <\\/span> icon-facetime-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-picture\\"> <\\/span> icon-picture<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-map-marker\\"> <\\/span> icon-map-marker<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-adjust\\"> <\\/span> icon-adjust<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tint\\"> <\\/span> icon-tint<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-edit\\"> <\\/span> icon-edit<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share\\"> <\\/span> icon-share<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-check\\"> <\\/span> icon-check<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-move\\"> <\\/span> icon-move<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-step-backward\\"> <\\/span> icon-step-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fast-backward\\"> <\\/span> icon-fast-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-backward\\"> <\\/span> icon-backward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-play\\"> <\\/span> icon-play<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pause\\"> <\\/span> icon-pause<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stop\\"> <\\/span> icon-stop<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-forward\\"> <\\/span> icon-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fast-forward\\"> <\\/span> icon-fast-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-step-forward\\"> <\\/span> icon-step-forward<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eject\\"> <\\/span> icon-eject<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-left\\"> <\\/span> icon-chevron-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-right\\"> <\\/span> icon-chevron-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plus-sign\\"> <\\/span> icon-plus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-minus-sign\\"> <\\/span> icon-minus-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove-sign\\"> <\\/span> icon-remove-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok-sign\\"> <\\/span> icon-ok-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-question-sign\\"> <\\/span> icon-question-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-info-sign\\"> <\\/span> icon-info-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-screenshot\\"> <\\/span> icon-screenshot<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-remove-circle\\"> <\\/span> icon-remove-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ok-circle\\"> <\\/span> icon-ok-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-ban-circle\\"> <\\/span> icon-ban-circle<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-left\\"> <\\/span> icon-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-right\\"> <\\/span> icon-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-up\\"> <\\/span> icon-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-arrow-down\\"> <\\/span> icon-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-share-alt\\"> <\\/span> icon-share-alt<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-full\\"> <\\/span> icon-resize-full<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-small\\"> <\\/span> icon-resize-small<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-exclamation-sign\\"> <\\/span> icon-exclamation-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-gift\\"> <\\/span> icon-gift<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-leaf\\"> <\\/span> icon-leaf<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fire\\"> <\\/span> icon-fire<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-open\\"> <\\/span> icon-eye-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-eye-close\\"> <\\/span> icon-eye-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-warning-sign\\"> <\\/span> icon-warning-sign<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-plane\\"> <\\/span> icon-plane<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-calendar\\"> <\\/span> icon-calendar<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-random\\"> <\\/span> icon-random<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-comment\\"> <\\/span> icon-comment<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-magnet\\"> <\\/span> icon-magnet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-up\\"> <\\/span> icon-chevron-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-chevron-down\\"> <\\/span> icon-chevron-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-retweet\\"> <\\/span> icon-retweet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-shopping-cart\\"> <\\/span> icon-shopping-cart<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-close\\"> <\\/span> icon-folder-close<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-folder-open\\"> <\\/span> icon-folder-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-vertical\\"> <\\/span> icon-resize-vertical<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-resize-horizontal\\"> <\\/span> icon-resize-horizontal<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hdd\\"> <\\/span> icon-hdd<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bullhorn\\"> <\\/span> icon-bullhorn<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-bell\\"> <\\/span> icon-bell<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-certificate\\"> <\\/span> icon-certificate<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-up\\"> <\\/span> icon-thumbs-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-thumbs-down\\"> <\\/span> icon-thumbs-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-right\\"> <\\/span> icon-hand-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-left\\"> <\\/span> icon-hand-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-up\\"> <\\/span> icon-hand-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hand-down\\"> <\\/span> icon-hand-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-right\\"> <\\/span> icon-circle-arrow-right<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-left\\"> <\\/span> icon-circle-arrow-left<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-up\\"> <\\/span> icon-circle-arrow-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-circle-arrow-down\\"> <\\/span> icon-circle-arrow-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-globe\\"> <\\/span> icon-globe<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-wrench\\"> <\\/span> icon-wrench<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tasks\\"> <\\/span> icon-tasks<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-filter\\"> <\\/span> icon-filter<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-briefcase\\"> <\\/span> icon-briefcase<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-fullscreen\\"> <\\/span> icon-fullscreen<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-dashboard\\"> <\\/span> icon-dashboard<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-paperclip\\"> <\\/span> icon-paperclip<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-heart-empty\\"> <\\/span> icon-heart-empty<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-link\\"> <\\/span> icon-link<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone\\"> <\\/span> icon-phone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-pushpin\\"> <\\/span> icon-pushpin<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-usd\\"> <\\/span> icon-usd<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-gbp\\"> <\\/span> icon-gbp<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"span3\\">\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort\\"> <\\/span> icon-sort<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-alphabet\\"> <\\/span> icon-sort-by-alphabet<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-alphabet-alt\\"> <\\/span> icon-sort-by-alphabet-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-order\\"> <\\/span> icon-sort-by-order<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-order-alt\\"> <\\/span> icon-sort-by-order-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-attributes\\"> <\\/span> icon-sort-by-attributes<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sort-by-attributes-alt\\"> <\\/span> icon-sort-by-attributes-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-unchecked\\"> <\\/span> icon-unchecked<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-expand\\"> <\\/span> icon-expand<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-collapse-down\\"> <\\/span> icon-collapse-down<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-collapse-up\\"> <\\/span> icon-collapse-up<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-log-in\\"> <\\/span> icon-log-in<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-flash\\"> <\\/span> icon-flash<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-log-out\\"> <\\/span> icon-log-out<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-new-window\\"> <\\/span> icon-new-window<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-record\\"> <\\/span> icon-record<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-save\\"> <\\/span> icon-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-open\\"> <\\/span> icon-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-saved\\"> <\\/span> icon-saved<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-import\\"> <\\/span> icon-import<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-export\\"> <\\/span> icon-export<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-send\\"> <\\/span> icon-send<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-disk\\"> <\\/span> icon-floppy-disk<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-saved\\"> <\\/span> icon-floppy-saved<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-remove\\"> <\\/span> icon-floppy-remove<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-save\\"> <\\/span> icon-floppy-save<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-floppy-open\\"> <\\/span> icon-floppy-open<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-credit-card\\"> <\\/span> icon-credit-card<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-transfer\\"> <\\/span> icon-transfer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cutlery\\"> <\\/span> icon-cutlery<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-header\\"> <\\/span> icon-header<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-compressed\\"> <\\/span> icon-compressed<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-earphone\\"> <\\/span> icon-earphone<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-phone-alt\\"> <\\/span> icon-phone-alt<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tower\\"> <\\/span> icon-tower<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-stats\\"> <\\/span> icon-stats<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sd-video\\"> <\\/span> icon-sd-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-hd-video\\"> <\\/span> icon-hd-video<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-subtitles\\"> <\\/span> icon-subtitles<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-stereo\\"> <\\/span> icon-sound-stereo<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-dolby\\"> <\\/span> icon-sound-dolby<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-5-1\\"> <\\/span> icon-sound-5-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-6-1\\"> <\\/span> icon-sound-6-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-sound-7-1\\"> <\\/span> icon-sound-7-1<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-copyright-mark\\"> <\\/span> icon-copyright-mark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-registration-mark\\"> <\\/span> icon-registration-mark<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud-download\\"> <\\/span> icon-cloud-download<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-cloud-upload\\"> <\\/span> icon-cloud-upload<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-conifer\\"> <\\/span> icon-tree-conifer<\\/div>\\r\\n<div style=\\"padding: 2px 0;\\"><span class=\\"icon-tree-deciduous\\"> <\\/span> icon-tree-deciduous<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Top Contact Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;ul class=\\"jm-contact-icons\\"&gt;<br \\/>&lt;li class=\\"jm-direction\\"&gt;&lt;img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Peterborough, UK&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-email\\"&gt;&lt;img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;Email&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;li class=\\"jm-phone\\"&gt;&lt;img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/&gt;&lt;a title=\\"Contact\\" href=\\"#\\"&gt;+44 7837 383 484&lt;\\/a&gt;&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<\\/pre>\\r\\n<ul class=\\"jm-contact-icons\\">\\r\\n<li class=\\"jm-direction\\"><img src=\\"images\\/modules\\/direction.png\\" alt=\\"Direction\\" \\/><a title=\\"Contact\\" href=\\"#\\">Peterborough, UK<\\/a><\\/li>\\r\\n<li class=\\"jm-email\\"><img src=\\"images\\/modules\\/email.png\\" alt=\\"Email\\" \\/><a title=\\"Contact\\" href=\\"#\\">Email<\\/a><\\/li>\\r\\n<li class=\\"jm-phone\\"><img src=\\"images\\/modules\\/phone.png\\" alt=\\"Phone\\" \\/><a title=\\"Contact\\" href=\\"#\\">+44 7837 383 484<\\/a><\\/li>\\r\\n<\\/ul>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Color Boxes<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box1 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>TIME MACHINE<br \\/>&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt; <br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt; <br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box1 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">TIME MACHINE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box2 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>ANALYTICS<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box2 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">ANALYTICS<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<div class=\\"span4\\">\\r\\n<pre>&lt;p style=\\"margin: 0;\\"&gt;<br \\/>&lt;a class=\\"jm-color-box3 text-center\\" href=\\"#\\"&gt;<br \\/>&lt;span class=\\"jm-icon-title\\"&gt;<br \\/>WORLDWIDE SERVICE<br \\/>&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-image\\"&gt;&amp;nbsp;&lt;\\/span&gt;<br \\/>&lt;span class=\\"jm-icon-desc\\"&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&lt;\\/span&gt;<br \\/>&lt;\\/a&gt;<br \\/>&lt;\\/p&gt;<\\/pre>\\r\\n<p style=\\"margin: 0;\\"><a class=\\"jm-color-box3 text-center\\" href=\\"#\\"> <span class=\\"jm-icon-title\\">WORLDWIDE SERVICE<\\/span> <span class=\\"jm-icon-image\\"> <\\/span> <span class=\\"jm-icon-desc\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/span> <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Just Few Words Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"pull-left visible-desktop\\"&gt;<br \\/>&lt;img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"jm-table\\"&gt;<br \\/>&lt;h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\"&gt;JUST FEW WORDS&lt;\\/h3&gt;<br \\/>&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.&lt;\\/p&gt;<br \\/>&lt;ul class=\\"jm-custom-list\\"&gt;<br \\/>&lt;li&gt;Ut enim ad minim veniam, quis nostrud&lt;\\/li&gt;<br \\/>&lt;li&gt;Exercitation ullamco laboris nisi&lt;\\/li&gt;<br \\/>&lt;li&gt;Ut aliquip ex ea commodo consequat.&lt;\\/li&gt;<br \\/>&lt;li&gt;Duis aute irure dolor in reprehenderit&lt;\\/li&gt;<br \\/>&lt;\\/ul&gt;<br \\/>&lt;p class=\\"readmore text-right\\"&gt;&lt;a class=\\"btn\\" href=\\"#\\"&gt;read more&lt;\\/a&gt;&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"jm-module clearfix\\">\\r\\n<div class=\\"pull-left visible-desktop\\"><img class=\\"jm-image-margin\\" src=\\"images\\/modules\\/custom1.jpg\\" alt=\\"Custom\\" \\/><\\/div>\\r\\n<div class=\\"jm-table\\">\\r\\n<h3 class=\\"jm-title\\" style=\\"margin-bottom: 20px;\\">JUST FEW WORDS<\\/h3>\\r\\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.<\\/p>\\r\\n<ul class=\\"jm-custom-list\\">\\r\\n<li>Ut enim ad minim veniam, quis nostrud<\\/li>\\r\\n<li>Exercitation ullamco laboris nisi<\\/li>\\r\\n<li>Ut aliquip ex ea commodo consequat.<\\/li>\\r\\n<li>Duis aute irure dolor in reprehenderit<\\/li>\\r\\n<\\/ul>\\r\\n<p class=\\"readmore text-right\\"><a class=\\"btn\\" href=\\"#\\"> read more <\\/a><\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Social Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<div class=\\"jm-socials\\">\\r\\n<pre>&lt;div class=\\"jm-socials\\"&gt;<br \\/>&lt;a class=\\"facebook\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"googleplus\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"twitter\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"linkedin\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"skype\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;a class=\\"vimeo\\" href=\\"#\\"&gt;&amp;nbsp;&lt;\\/a&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<a class=\\"facebook\\" href=\\"#\\"> <\\/a> <a class=\\"googleplus\\" href=\\"#\\"> <\\/a> <a class=\\"twitter\\" href=\\"#\\"> <\\/a> <a class=\\"linkedin\\" href=\\"#\\"> <\\/a> <a class=\\"skype\\" href=\\"#\\"> <\\/a> <a class=\\"vimeo\\" href=\\"#\\"> <\\/a><\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<h3 class=\\"jm-typo-title\\">Our Cooks Module<\\/h3>\\r\\n<div class=\\"row-fluid\\">\\r\\n<div class=\\"span12\\">\\r\\n<pre>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Greg Amaro&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;div class=\\"media\\"&gt;<br \\/>&lt;a class=\\"pull-left\\" href=\\"#\\"&gt; &lt;img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/&gt; &lt;\\/a&gt;<br \\/>&lt;div class=\\"media-body\\"&gt;<br \\/>&lt;h5 class=\\"media-heading\\"&gt;&lt;a href=\\"#\\"&gt;Jimmy Gessler&lt;\\/a&gt;&lt;\\/h5&gt;<br \\/>&lt;p&gt;Consectetur adipisicing elit sed do eimod tempor.&lt;\\/p&gt;<br \\/>&lt;\\/div&gt;<br \\/>&lt;\\/div&gt;<\\/pre>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook1.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Greg Amaro<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<div class=\\"media\\"><a class=\\"pull-left\\" href=\\"#\\"> <img src=\\"images\\/culinary\\/modules\\/cooks\\/cook2.png\\" alt=\\"\\" \\/> <\\/a>\\r\\n<div class=\\"media-body\\">\\r\\n<h5 class=\\"media-heading\\"><a href=\\"#\\">Jimmy Gessler<\\/a><\\/h5>\\r\\n<p>Consectetur adipisicing elit sed do eimod tempor.<\\/p>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>\\r\\n<\\/div>","fulltext":"","state":1,"catid":"78","created":"2014-05-14 12:40:26","created_by":"755","created_by_alias":"","modified":"2015-05-28 09:29:17","modified_by":"755","checked_out":"755","checked_out_time":"2015-05-28 09:27:55","publish_up":"2014-05-14 12:40:26","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":62,"ordering":"7","metakey":"","metadesc":"","access":"1","hits":"160","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('330','111','1','','2016-08-18 10:05:37','936','6690','c97ad02b808ec9aa1c6f487b6d0042e22bd73d33','{"id":111,"asset_id":"328","title":"Single Article","alias":"single-article","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/strong><\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>\\r\\n<h4>Font Awesome example<\\/h4>","fulltext":"","state":1,"catid":"78","created":"2014-06-24 13:38:25","created_by":"936","created_by_alias":"","modified":"2016-08-18 10:05:37","modified_by":"936","checked_out":"936","checked_out_time":"2016-08-18 10:02:23","publish_up":"2014-06-24 13:38:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"info_block_show_title\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"35","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('331','111','1','','2016-08-18 10:08:46','936','6893','12e25374a27ec9df1729cc9bfbf7b44b00a042fb','{"id":111,"asset_id":"328","title":"Single Article","alias":"single-article","introtext":"<p><strong>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.<\\/strong><\\/p>\\r\\n<p>Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris sit amet nibh nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec. Duis id erat nunc.<\\/p>\\r\\n<h4>Lorem ipsum dolor<\\/h4>\\r\\n<p>Nunc placerat egestas vehicula. Fusce eu risus sit amet metus sagittis volutpat vehicula porttitor elit. Sed fringilla purus sed mi scelerisque scelerisque. Donec vel enim ligula. Phasellus vulputate ac dui aliquet dapibus. Suspendisse ut vestibulum tellus, sed gravida arcu. Aliquam erat volutpat. Cras eu quam vitae magna cursus adipiscing. Etiam quis mi lacus. Proin fermentum velit non ligula malesuada imperdiet. Sed sapien enim, porta vel tempus sed, suscipit quis nisl. In vestibulum ut massa eu feugiat.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">1<\\/span>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">2<\\/span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla scelerisque magna et orci porttitor ullamcorper. Proin euismod pretium dolor non consectetur. Aliquam feugiat nunc ac justo hendrerit, non lobortis lacus condimentum. Duis id erat nunc. Nam eu aliquam velit. Donec pretium sed quam quis pulvinar.<\\/p>\\r\\n<p class=\\"jm-block second\\"><span class=\\"jm\\">3<\\/span>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu.<\\/p>\\r\\n<p>Nulla vestibulum ultrices felis sit amet dapibus. Suspendisse et ligula hendrerit, auctor justo vel, sagittis metus. Mauris tincidunt quam eu pulvinar sagittis. Pellentesque imperdiet, purus vel feugiat pharetra, lectus velit scelerisque nisi, a aliquam nibh augue vel urna. In volutpat tellus et pulvinar varius. Aenean ultricies euismod rhoncus. Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur.<\\/p>\\r\\n<h4>Consectetur adipiscing elit<\\/h4>\\r\\n<p>Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Vivamus blandit tellus risus, et hendrerit nisi aliquet ut. Ut imperdiet orci tellus, in tristique urna mattis eu. Pellentesque ligula nisl, hendrerit nec facilisis sit amet, faucibus ac nulla. Morbi et consectetur ante. Etiam eu sodales tortor, ac dapibus lectus. In laoreet tempor felis, in ornare urna consequat sit amet. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Quisque vestibulum tempus felis. Nulla interdum varius arcu nec.<\\/p>\\r\\n<p class=\\"jmpeople\\">Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Praesent vehicula libero ac tellus rutrum ultrices. Sed eu consectetur libero, id varius massa. Nulla interdum varius arcu nec accumsan.<\\/p>\\r\\n<p class=\\"jmmail\\">Cras eleifend iaculis purus sed hendrerit. Nulla facilisi. Sed congue semper consequat. Nam viverra semper libero, a luctus eros. Nulla porttitor commodo velit nec rhoncus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac. Nulla porttitor commodo velit nec rhoncus.<\\/p>\\r\\n<p>Ut lectus felis, facilisis nec erat at, pretium pellentesque lectus. Donec sit amet nibh est. Morbi augue libero, pretium vitae nulla ac, malesuada ultricies neque. Donec eget neque erat. Nam dictum justo sit amet placerat consectetur. Maecenas laoreet, ligula vel scelerisque ultricies, lorem urna luctus odio, eget convallis urna erat quis justo. Morbi vel placerat nisl, ut tempor odio. Sed lacinia purus sit amet lorem dictum tincidunt.<\\/p>\\r\\n<h4>Font Awesome example<\\/h4>\\r\\n<p><span class=\\"fa fa-joomla fa-5x\\" aria-hidden=\\"true\\"><\\/span> <span class=\\"fa fa-html5 fa-5x\\" aria-hidden=\\"true\\"><\\/span> <span class=\\"fa fa-css3 fa-5x\\" aria-hidden=\\"true\\"><\\/span><\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-06-24 13:38:25","created_by":"936","created_by_alias":"","modified":"2016-08-18 10:08:46","modified_by":"936","checked_out":"936","checked_out_time":"2016-08-18 10:05:37","publish_up":"2014-06-24 13:38:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/blog\\\\\\/blog1.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"info_block_show_title\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"6","metakey":"","metadesc":"","access":"1","hits":"36","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('332','73','1','','2017-05-15 07:10:49','936','2804','2877d152d94383d6e6a78e261b88e1f4b9c3acb9','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"936","created_by_alias":"","modified":"2017-05-15 07:10:49","modified_by":"936","checked_out":"936","checked_out_time":"2017-05-15 07:10:38","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"article_layout\\":\\"\\",\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"info_block_show_title\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_associations\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_page_title\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"8","metakey":"","metadesc":"","access":"1","hits":"4774","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0'),
('333','73','1','','2017-05-15 07:11:03','936','2806','684c3e8a422581dc79c77bc4385829e04de74fa7','{"id":73,"asset_id":"182","title":"Subpage","alias":"subpage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Vestibulum commodo, ligula non iaculis tristique, erat sem luctus sapien, sed auctor felis nisi sed mauris. Maecenas eu iaculis tortor, ac volutpat ipsum. In eget lacus erat. Nullam nec magna tellus. Vestibulum rutrum velit et nulla tristique, ac sodales risus tempor. Phasellus sed nisi ut nibh accumsan commodo sed a libero. In ut semper felis, a vestibulum mi. Ut et lacus lectus. Vivamus tempus erat et augue bibendum posuere. In mauris metus, ultrices vel vulputate nec, dictum eget nulla. Etiam ac est metus. Mauris at orci pretium, congue erat vel, vulputate eros. In posuere venenatis lacinia. Mauris aliquam faucibus velit, vitae cursus tellus aliquam vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor. Mauris in augue mollis, semper est ac, aliquet turpis. Vestibulum ut dapibus dolor.yt<\\/p>","fulltext":"","state":1,"catid":"78","created":"2014-04-28 14:34:25","created_by":"936","created_by_alias":"","modified":"2017-05-15 07:11:03","modified_by":"936","checked_out":"936","checked_out_time":"2017-05-15 07:10:55","publish_up":"2014-04-28 14:34:25","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"article_layout\\":\\"\\",\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"info_block_show_title\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_associations\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_page_title\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"8","metakey":"","metadesc":"","access":"1","hits":"4774","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}','0');

DROP TABLE IF EXISTS #__update_sites;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` mediumtext NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  `extra_query` varchar(1000) DEFAULT '',
  PRIMARY KEY (`update_site_id`)
) AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='Update Sites';

INSERT INTO `#__update_sites` VALUES 
('1','Joomla! Core','collection','https://update.joomla.org/core/list.xml','1','1514379452',''),
('3','Accredited Joomla! Translations','collection','https://update.joomla.org/language/translationlist_3.xml','1','0',''),
('4','DJ-Menu Module','extension','http://dj-extensions.com/updates/djmenu.xml','1','0',''),
('5','DJ-ImageSlider Package','extension','http://dj-extensions.com/updates/djimageslider.xml','1','0',''),
('9','Joomla! Update Component Update Site','extension','https://update.joomla.org/core/extensions/com_joomlaupdate.xml','1','0',''),
('10','Weblinks Update Site','extension','https://raw.githubusercontent.com/joomla-extensions/weblinks/master/manifest.xml','1','0',''),
('12','EF4 Joomla Monster Framework','extension','http://www.joomla-monster.com/updates/ef4framework.xml','1','0',''),
('13','DJ-jQueryMonster Plugin','extension','http://dj-extensions.com/updates/djjquerymonster.xml','1','0',''),
('14','DJ-MegaMenu','extension','https://dj-extensions.com/api/getUpdateInfo?extension=djmegamenu_light.xml','1','0','');

DROP TABLE IF EXISTS #__update_sites_extensions;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

INSERT INTO `#__update_sites_extensions` VALUES 
('1','700'),
('3','802'),
('4','10002'),
('5','10005'),
('9','28'),
('10','801'),
('12','10020'),
('13','10021'),
('14','10025');

DROP TABLE IF EXISTS #__user_keys;
CREATE TABLE `#__user_keys` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` varchar(150) NOT NULL,
  `token` varchar(255) NOT NULL,
  `series` varchar(191) NOT NULL,
  `invalid` tinyint(4) NOT NULL,
  `time` varchar(200) NOT NULL,
  `uastring` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `series` (`series`),
  UNIQUE KEY `series_2` (`series`),
  UNIQUE KEY `series_3` (`series`),
  KEY `user_id` (`user_id`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__user_notes;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS #__user_profiles;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` mediumtext NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';


DROP TABLE IF EXISTS #__utf8_conversion;
CREATE TABLE `#__utf8_conversion` (
  `converted` tinyint(4) NOT NULL DEFAULT '0'
) DEFAULT CHARSET=utf8;

INSERT INTO `#__utf8_conversion` VALUES 
('2');

DROP TABLE IF EXISTS #__viewlevels;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

INSERT INTO `#__viewlevels` VALUES 
('1','Public','0','[1]'),
('2','Registered','1','[6,2,8]'),
('3','Special','2','[6,3,8]'),
('5','Guest','0','[9]'),
('6','Super Users','0','[8]');

DROP TABLE IF EXISTS #__weblinks;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(400) NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` mediumtext NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` mediumtext NOT NULL,
  `metadesc` mediumtext NOT NULL,
  `metadata` mediumtext NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` mediumtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) DEFAULT CHARSET=utf8;


